--
-- PostgreSQL database dump
--

-- Dumped from database version 9.2.4
-- Dumped by pg_dump version 9.2.4
-- Started on 2014-12-09 21:51:54

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- TOC entry 7 (class 2615 OID 133710)
-- Name: sc_portalsinase; Type: SCHEMA; Schema: -; Owner: portal
--

CREATE SCHEMA sc_portalsinase;


ALTER SCHEMA sc_portalsinase OWNER TO portal;

SET search_path = sc_portalsinase, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 794 (class 1259 OID 137500)
-- Name: areaatuacao; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE areaatuacao (
    idareaatuacao integer NOT NULL,
    dcareaatuacao character varying(30) NOT NULL
);


ALTER TABLE sc_portalsinase.areaatuacao OWNER TO postgres;

--
-- TOC entry 795 (class 1259 OID 137503)
-- Name: areaatuacao_idareaatuacao_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE areaatuacao_idareaatuacao_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.areaatuacao_idareaatuacao_seq OWNER TO postgres;

--
-- TOC entry 4131 (class 0 OID 0)
-- Dependencies: 795
-- Name: areaatuacao_idareaatuacao_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE areaatuacao_idareaatuacao_seq OWNED BY areaatuacao.idareaatuacao;


--
-- TOC entry 796 (class 1259 OID 137505)
-- Name: condicao; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE condicao (
    idcondicao integer NOT NULL,
    idpesquisa integer NOT NULL,
    txcondicao character varying(300) NOT NULL,
    dtcriacao timestamp with time zone NOT NULL,
    idusuariocriacao integer NOT NULL,
    cotipopesquisa character(3) NOT NULL
);


ALTER TABLE sc_portalsinase.condicao OWNER TO postgres;

--
-- TOC entry 797 (class 1259 OID 137508)
-- Name: condicao_idcondicao_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE condicao_idcondicao_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.condicao_idcondicao_seq OWNER TO postgres;

--
-- TOC entry 4132 (class 0 OID 0)
-- Dependencies: 797
-- Name: condicao_idcondicao_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE condicao_idcondicao_seq OWNED BY condicao.idcondicao;


--
-- TOC entry 798 (class 1259 OID 137510)
-- Name: controleinscricao; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE controleinscricao (
    idprojeto integer NOT NULL,
    idcursomoodle integer NOT NULL,
    idquestionario integer NOT NULL,
    idusuario integer NOT NULL,
    idturma integer,
    dtinscricao timestamp with time zone NOT NULL,
    dtenturmado timestamp with time zone,
    dtdesenturmado timestamp with time zone,
    dtconfirmaenturmado timestamp with time zone,
    dtultimocontatoemail timestamp with time zone,
    insituacaoalunocurso character(1) DEFAULT 'C'::bpchar,
    dccriterioenturmado text,
    CONSTRAINT ckc_insituacaoalunocu_controle CHECK (((insituacaoalunocurso IS NULL) OR (insituacaoalunocurso = ANY (ARRAY['C'::bpchar, 'A'::bpchar, 'L'::bpchar]))))
);


ALTER TABLE sc_portalsinase.controleinscricao OWNER TO postgres;

--
-- TOC entry 4133 (class 0 OID 0)
-- Dependencies: 798
-- Name: COLUMN controleinscricao.insituacaoalunocurso; Type: COMMENT; Schema: sc_portalsinase; Owner: postgres
--

COMMENT ON COLUMN controleinscricao.insituacaoalunocurso IS 'Value	Label
----------------------------------
C	Cursando
A	Aprovado
L	Liberado o Certificado';


--
-- TOC entry 799 (class 1259 OID 137518)
-- Name: email; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE email (
    idemail integer NOT NULL,
    idemailtipoenvio smallint NOT NULL,
    dctitulo character varying(100) NOT NULL,
    dctitulonovo character varying(100),
    dccorpoemail text NOT NULL,
    inenviomanual boolean DEFAULT false NOT NULL,
    inativo boolean DEFAULT true NOT NULL
);


ALTER TABLE sc_portalsinase.email OWNER TO postgres;

--
-- TOC entry 800 (class 1259 OID 137526)
-- Name: email_idemail_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE email_idemail_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.email_idemail_seq OWNER TO postgres;

--
-- TOC entry 4134 (class 0 OID 0)
-- Dependencies: 800
-- Name: email_idemail_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE email_idemail_seq OWNED BY email.idemail;


--
-- TOC entry 801 (class 1259 OID 137528)
-- Name: emailgrupotag; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE emailgrupotag (
    idemail integer NOT NULL,
    idemailtag smallint NOT NULL
);


ALTER TABLE sc_portalsinase.emailgrupotag OWNER TO postgres;

--
-- TOC entry 802 (class 1259 OID 137531)
-- Name: emailtag; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE emailtag (
    idemailtag integer NOT NULL,
    idemailtipotag smallint NOT NULL,
    dcemailtitulo character varying(60) NOT NULL,
    dcemailtag character varying(40) NOT NULL,
    dcemailtagreplace character varying(40) NOT NULL,
    inativo smallint DEFAULT 1 NOT NULL
);


ALTER TABLE sc_portalsinase.emailtag OWNER TO postgres;

--
-- TOC entry 803 (class 1259 OID 137535)
-- Name: emailtag_idemailtag_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE emailtag_idemailtag_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.emailtag_idemailtag_seq OWNER TO postgres;

--
-- TOC entry 4135 (class 0 OID 0)
-- Dependencies: 803
-- Name: emailtag_idemailtag_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE emailtag_idemailtag_seq OWNED BY emailtag.idemailtag;


--
-- TOC entry 804 (class 1259 OID 137537)
-- Name: emailtipoenvio; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE emailtipoenvio (
    idemailtipoenvio smallint NOT NULL,
    dcemailtipoenvio character varying(60) NOT NULL
);


ALTER TABLE sc_portalsinase.emailtipoenvio OWNER TO postgres;

--
-- TOC entry 805 (class 1259 OID 137540)
-- Name: emailtipotag; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE emailtipotag (
    idemailtipotag smallint NOT NULL,
    dcemailtipotag character varying(60) NOT NULL
);


ALTER TABLE sc_portalsinase.emailtipotag OWNER TO postgres;

--
-- TOC entry 806 (class 1259 OID 137543)
-- Name: funcionalidade; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE funcionalidade (
    id_funcionalidade integer NOT NULL,
    dc_nome character varying(70) NOT NULL,
    nu_ordem integer NOT NULL,
    nu_nivel integer DEFAULT 1 NOT NULL,
    id_tipo_funcionalidade smallint NOT NULL,
    sg_sistema character varying(20) NOT NULL,
    id_funcionalidade_pai integer,
    in_ativo boolean NOT NULL
);


ALTER TABLE sc_portalsinase.funcionalidade OWNER TO postgres;

--
-- TOC entry 807 (class 1259 OID 137547)
-- Name: funcionalidade_id_funcionalidade_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE funcionalidade_id_funcionalidade_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.funcionalidade_id_funcionalidade_seq OWNER TO postgres;

--
-- TOC entry 4136 (class 0 OID 0)
-- Dependencies: 807
-- Name: funcionalidade_id_funcionalidade_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE funcionalidade_id_funcionalidade_seq OWNED BY funcionalidade.id_funcionalidade;


--
-- TOC entry 808 (class 1259 OID 137549)
-- Name: funcionalidadeperfil; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE funcionalidadeperfil (
    co_perfilacesso character varying(15) NOT NULL,
    id_funcionalidade integer NOT NULL,
    sg_sistema character varying(20) NOT NULL
);


ALTER TABLE sc_portalsinase.funcionalidadeperfil OWNER TO postgres;

--
-- TOC entry 809 (class 1259 OID 137552)
-- Name: grauinstrucao; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE grauinstrucao (
    idgrauinstrucao integer NOT NULL,
    dcgrauinstrucao character varying(20) NOT NULL
);


ALTER TABLE sc_portalsinase.grauinstrucao OWNER TO postgres;

--
-- TOC entry 810 (class 1259 OID 137555)
-- Name: grauinstrucao_idgrauinstrucao_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE grauinstrucao_idgrauinstrucao_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.grauinstrucao_idgrauinstrucao_seq OWNER TO postgres;

--
-- TOC entry 4137 (class 0 OID 0)
-- Dependencies: 810
-- Name: grauinstrucao_idgrauinstrucao_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE grauinstrucao_idgrauinstrucao_seq OWNED BY grauinstrucao.idgrauinstrucao;


--
-- TOC entry 811 (class 1259 OID 137557)
-- Name: grupoquestao; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE grupoquestao (
    idgrupoquestao integer NOT NULL,
    dcgrupoquestao character varying(30) NOT NULL
);


ALTER TABLE sc_portalsinase.grupoquestao OWNER TO postgres;

--
-- TOC entry 812 (class 1259 OID 137560)
-- Name: grupoquestao_idgrupoquestao_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE grupoquestao_idgrupoquestao_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.grupoquestao_idgrupoquestao_seq OWNER TO postgres;

--
-- TOC entry 4138 (class 0 OID 0)
-- Dependencies: 812
-- Name: grupoquestao_idgrupoquestao_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE grupoquestao_idgrupoquestao_seq OWNED BY grupoquestao.idgrupoquestao;


--
-- TOC entry 813 (class 1259 OID 137562)
-- Name: grupoquestionario; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE grupoquestionario (
    idgrupoquestionario integer NOT NULL,
    dcgrupo character varying(30) NOT NULL,
    inativo boolean DEFAULT true NOT NULL
);


ALTER TABLE sc_portalsinase.grupoquestionario OWNER TO postgres;

--
-- TOC entry 814 (class 1259 OID 137566)
-- Name: grupoquestionario_idgrupoquestionario_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE grupoquestionario_idgrupoquestionario_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.grupoquestionario_idgrupoquestionario_seq OWNER TO postgres;

--
-- TOC entry 4139 (class 0 OID 0)
-- Dependencies: 814
-- Name: grupoquestionario_idgrupoquestionario_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE grupoquestionario_idgrupoquestionario_seq OWNED BY grupoquestionario.idgrupoquestionario;


--
-- TOC entry 815 (class 1259 OID 137568)
-- Name: mensagem; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE mensagem (
    idmensagem integer NOT NULL,
    idprojeto integer,
    idcursomoodle integer,
    idturmamoodle integer,
    idusuariodestinatario integer,
    idusuariocriacao integer NOT NULL,
    dcassunto character varying(150) NOT NULL,
    dcmensagem text NOT NULL,
    dtcriacao timestamp with time zone NOT NULL,
    dtexpiracao timestamp with time zone,
    dtpublicacao timestamp with time zone
);


ALTER TABLE sc_portalsinase.mensagem OWNER TO postgres;

--
-- TOC entry 816 (class 1259 OID 137574)
-- Name: mensagem_idmensagem_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE mensagem_idmensagem_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.mensagem_idmensagem_seq OWNER TO postgres;

--
-- TOC entry 4140 (class 0 OID 0)
-- Dependencies: 816
-- Name: mensagem_idmensagem_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE mensagem_idmensagem_seq OWNED BY mensagem.idmensagem;


--
-- TOC entry 817 (class 1259 OID 137576)
-- Name: municipios; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE municipios (
    uf character(2) NOT NULL,
    municipios character varying(200) NOT NULL
);


ALTER TABLE sc_portalsinase.municipios OWNER TO postgres;

--
-- TOC entry 818 (class 1259 OID 137579)
-- Name: perfilacesso; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE perfilacesso (
    coperfilacesso character varying(15) NOT NULL,
    dcperfilacesso character varying(150) NOT NULL,
    dcperfilacessocurto character varying(20) NOT NULL,
    dtcadastro timestamp with time zone DEFAULT '2013-04-23 19:05:17.722593-03'::timestamp with time zone NOT NULL,
    idpapel integer,
    inativo boolean DEFAULT true NOT NULL,
    ordem integer DEFAULT 0 NOT NULL
);


ALTER TABLE sc_portalsinase.perfilacesso OWNER TO postgres;

--
-- TOC entry 819 (class 1259 OID 137584)
-- Name: pesquisa; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE pesquisa (
    idpesquisa integer NOT NULL,
    dctitulo character varying(100) NOT NULL,
    dtcriacao timestamp with time zone NOT NULL,
    idcurso integer NOT NULL,
    idusuariocriacao integer NOT NULL
);


ALTER TABLE sc_portalsinase.pesquisa OWNER TO postgres;

--
-- TOC entry 820 (class 1259 OID 137587)
-- Name: pesquisa_idpesquisa_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE pesquisa_idpesquisa_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.pesquisa_idpesquisa_seq OWNER TO postgres;

--
-- TOC entry 4141 (class 0 OID 0)
-- Dependencies: 820
-- Name: pesquisa_idpesquisa_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE pesquisa_idpesquisa_seq OWNED BY pesquisa.idpesquisa;


--
-- TOC entry 821 (class 1259 OID 137589)
-- Name: portalconfig; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE portalconfig (
    idportalconfig integer NOT NULL,
    txmensagemerro text,
    txmensagemprincipal text,
    txtmailtopo character varying(1000),
    txmailrodape character varying(1000),
    idusuarioresponsavel integer NOT NULL,
    dtcadastro timestamp with time zone DEFAULT now() NOT NULL,
    dtalteracao timestamp with time zone,
    idusuarioalteracao integer NOT NULL,
    inportalativo boolean NOT NULL,
    inativo boolean NOT NULL
);


ALTER TABLE sc_portalsinase.portalconfig OWNER TO postgres;

--
-- TOC entry 822 (class 1259 OID 137596)
-- Name: portalconfig_idportalconfig_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE portalconfig_idportalconfig_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.portalconfig_idportalconfig_seq OWNER TO postgres;

--
-- TOC entry 4142 (class 0 OID 0)
-- Dependencies: 822
-- Name: portalconfig_idportalconfig_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE portalconfig_idportalconfig_seq OWNED BY portalconfig.idportalconfig;


--
-- TOC entry 823 (class 1259 OID 137598)
-- Name: projeto; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE projeto (
    idprojeto integer NOT NULL,
    dcprojeto character varying(70) NOT NULL,
    dtinicio timestamp with time zone NOT NULL,
    dtfinal timestamp with time zone NOT NULL,
    inativo boolean NOT NULL
);


ALTER TABLE sc_portalsinase.projeto OWNER TO postgres;

--
-- TOC entry 824 (class 1259 OID 137601)
-- Name: projeto_idprojeto_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE projeto_idprojeto_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.projeto_idprojeto_seq OWNER TO postgres;

--
-- TOC entry 4143 (class 0 OID 0)
-- Dependencies: 824
-- Name: projeto_idprojeto_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE projeto_idprojeto_seq OWNED BY projeto.idprojeto;


--
-- TOC entry 825 (class 1259 OID 137603)
-- Name: projetocurso; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE projetocurso (
    idprojeto integer NOT NULL,
    idcursomoodle integer NOT NULL,
    idquestionario integer NOT NULL,
    dtinicioinscricao timestamp with time zone,
    dtfiminscricao timestamp with time zone,
    dtiniciocurso timestamp with time zone,
    dtfimcurso timestamp with time zone
);


ALTER TABLE sc_portalsinase.projetocurso OWNER TO postgres;

--
-- TOC entry 826 (class 1259 OID 137606)
-- Name: projetocursoquestionario; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE projetocursoquestionario (
    idprojeto integer NOT NULL,
    idcursomoodle integer NOT NULL,
    idquestionario integer NOT NULL,
    dtinicioresposta timestamp with time zone NOT NULL,
    dtfimresposta timestamp with time zone NOT NULL
);


ALTER TABLE sc_portalsinase.projetocursoquestionario OWNER TO postgres;

--
-- TOC entry 827 (class 1259 OID 137609)
-- Name: questao; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE questao (
    idquestao integer NOT NULL,
    idquestionario integer NOT NULL,
    idgrupoquestao integer NOT NULL,
    cotipoquestao character varying(10) NOT NULL,
    dcquestao character varying(1500) NOT NULL,
    dcorientacao text,
    inpermitetotalizar boolean,
    inobrigatorio boolean NOT NULL,
    nuordem integer NOT NULL
);


ALTER TABLE sc_portalsinase.questao OWNER TO postgres;

--
-- TOC entry 828 (class 1259 OID 137615)
-- Name: questao_idquestao_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE questao_idquestao_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.questao_idquestao_seq OWNER TO postgres;

--
-- TOC entry 4144 (class 0 OID 0)
-- Dependencies: 828
-- Name: questao_idquestao_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE questao_idquestao_seq OWNED BY questao.idquestao;


--
-- TOC entry 829 (class 1259 OID 137617)
-- Name: questionario; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE questionario (
    idquestionario integer NOT NULL,
    idgrupoquestionario integer NOT NULL,
    dcformulario character varying(100) NOT NULL,
    dcobjetivo text NOT NULL,
    dcconfirmacao character varying(100) NOT NULL,
    dtcriacao timestamp with time zone NOT NULL,
    inativo boolean DEFAULT false NOT NULL
);


ALTER TABLE sc_portalsinase.questionario OWNER TO postgres;

--
-- TOC entry 830 (class 1259 OID 137624)
-- Name: questionario_idquestionario_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE questionario_idquestionario_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.questionario_idquestionario_seq OWNER TO postgres;

--
-- TOC entry 4145 (class 0 OID 0)
-- Dependencies: 830
-- Name: questionario_idquestionario_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE questionario_idquestionario_seq OWNED BY questionario.idquestionario;


--
-- TOC entry 831 (class 1259 OID 137626)
-- Name: resposta; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE resposta (
    idresposta integer NOT NULL,
    idquestao integer NOT NULL,
    dcresposta character varying(1000) NOT NULL,
    nuordem integer NOT NULL
);


ALTER TABLE sc_portalsinase.resposta OWNER TO postgres;

--
-- TOC entry 832 (class 1259 OID 137632)
-- Name: resposta_idresposta_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE resposta_idresposta_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.resposta_idresposta_seq OWNER TO postgres;

--
-- TOC entry 4146 (class 0 OID 0)
-- Dependencies: 832
-- Name: resposta_idresposta_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE resposta_idresposta_seq OWNED BY resposta.idresposta;


--
-- TOC entry 833 (class 1259 OID 137634)
-- Name: rota; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE rota (
    id_rota integer NOT NULL,
    id_funcionalidade integer,
    dc_rota character varying(100) NOT NULL,
    in_principal boolean NOT NULL
);


ALTER TABLE sc_portalsinase.rota OWNER TO postgres;

--
-- TOC entry 834 (class 1259 OID 137637)
-- Name: rota_id_rota_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE rota_id_rota_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.rota_id_rota_seq OWNER TO postgres;

--
-- TOC entry 4147 (class 0 OID 0)
-- Dependencies: 834
-- Name: rota_id_rota_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE rota_id_rota_seq OWNED BY rota.id_rota;


--
-- TOC entry 835 (class 1259 OID 137639)
-- Name: sistema; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE sistema (
    sg_sistema character varying(20) NOT NULL,
    no_sistema character varying(50) NOT NULL,
    dc_url character varying(150) NOT NULL,
    in_ativo boolean DEFAULT true NOT NULL
);


ALTER TABLE sc_portalsinase.sistema OWNER TO postgres;

--
-- TOC entry 836 (class 1259 OID 137643)
-- Name: tipofuncionalidade; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE tipofuncionalidade (
    id_tipo_funcionalidade integer NOT NULL,
    dc_nome_tipo character varying(70) NOT NULL
);


ALTER TABLE sc_portalsinase.tipofuncionalidade OWNER TO postgres;

--
-- TOC entry 4148 (class 0 OID 0)
-- Dependencies: 836
-- Name: TABLE tipofuncionalidade; Type: COMMENT; Schema: sc_portalsinase; Owner: postgres
--

COMMENT ON TABLE tipofuncionalidade IS '1 - Menu MF3dulo
2 - Menu SubMF3dulo
3 - Funcionalidades
4 - BotE3o
---------------------------------------------
Sistema
   Menu
      submenu 01
      submenu 02
      submenu 03
          submenu 01

';


--
-- TOC entry 837 (class 1259 OID 137646)
-- Name: tipofuncionalidade_id_tipo_funcionalidade_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE tipofuncionalidade_id_tipo_funcionalidade_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.tipofuncionalidade_id_tipo_funcionalidade_seq OWNER TO postgres;

--
-- TOC entry 4149 (class 0 OID 0)
-- Dependencies: 837
-- Name: tipofuncionalidade_id_tipo_funcionalidade_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE tipofuncionalidade_id_tipo_funcionalidade_seq OWNED BY tipofuncionalidade.id_tipo_funcionalidade;


--
-- TOC entry 838 (class 1259 OID 137648)
-- Name: tipopesquisa; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE tipopesquisa (
    cotipopesquisa character(3) NOT NULL,
    dctipopesquisa character varying(100) NOT NULL
);


ALTER TABLE sc_portalsinase.tipopesquisa OWNER TO postgres;

--
-- TOC entry 839 (class 1259 OID 137651)
-- Name: tipoquestao; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE tipoquestao (
    cotipoquestao character varying(10) NOT NULL,
    dctipoquestao character varying(30) NOT NULL
);


ALTER TABLE sc_portalsinase.tipoquestao OWNER TO postgres;

--
-- TOC entry 870 (class 1259 OID 507940)
-- Name: turma; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE turma (
    idturma integer NOT NULL,
    qtselecionados integer DEFAULT 0 NOT NULL,
    indqualitativo numeric(38,8) DEFAULT 0 NOT NULL
);


ALTER TABLE sc_portalsinase.turma OWNER TO postgres;

--
-- TOC entry 840 (class 1259 OID 137654)
-- Name: uf; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE uf (
    couf character(2) NOT NULL,
    dcuf character varying(30) NOT NULL
);


ALTER TABLE sc_portalsinase.uf OWNER TO postgres;

--
-- TOC entry 841 (class 1259 OID 137657)
-- Name: usuario; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE usuario (
    idusuario integer NOT NULL,
    idmoodle numeric(10,0),
    idgrauinstrucao integer,
    idusuariostatus smallint NOT NULL,
    nucpf character(11) NOT NULL,
    dcnome character varying(50) NOT NULL,
    dtnascimento timestamp with time zone NOT NULL,
    dcsexo character(1) NOT NULL,
    dcemail character varying(60) NOT NULL,
    nutelefoneparticular character(15),
    nutelefonecomercial character(15),
    nutelefonecelular character(15),
    dcnomepai character varying(50),
    dcnomemae character varying(50),
    dcendereco character varying(70),
    nuendereco character varying(10),
    dccomplemento character varying(30),
    couf character(2),
    idareaatuacao integer,
    dcbairro character varying(30),
    dccidade character varying(50),
    nucep character(8),
    dcoutraareaatuacao character varying(50),
    dccurriculolattes character varying(160),
    inreceberinformacao boolean,
    indeclaracao boolean,
    dcusuario character varying(30) NOT NULL,
    dcsenha character varying(128) NOT NULL,
    dtcadastro timestamp with time zone DEFAULT '2013-04-23 19:05:17.722593-03'::timestamp with time zone NOT NULL,
    dtatualizacao timestamp with time zone NOT NULL,
    dctokenmoodle character varying(128),
    dckeyloginrecover character varying(128),
    dtloginrecoverexp timestamp with time zone
);


ALTER TABLE sc_portalsinase.usuario OWNER TO postgres;

--
-- TOC entry 4150 (class 0 OID 0)
-- Dependencies: 841
-- Name: COLUMN usuario.nutelefoneparticular; Type: COMMENT; Schema: sc_portalsinase; Owner: postgres
--

COMMENT ON COLUMN usuario.nutelefoneparticular IS '55-61-123456789';


--
-- TOC entry 842 (class 1259 OID 137664)
-- Name: usuario_idusuario_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE usuario_idusuario_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.usuario_idusuario_seq OWNER TO postgres;

--
-- TOC entry 4151 (class 0 OID 0)
-- Dependencies: 842
-- Name: usuario_idusuario_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE usuario_idusuario_seq OWNED BY usuario.idusuario;


--
-- TOC entry 843 (class 1259 OID 137666)
-- Name: usuariocursopesquisa; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE usuariocursopesquisa (
    idrespostausuario integer NOT NULL,
    idprojeto integer NOT NULL,
    idcursomoodle integer NOT NULL,
    idquestionario integer NOT NULL,
    idusuario integer NOT NULL,
    idquestao integer NOT NULL,
    idresposta integer,
    dcresposta character varying(200),
    txresposta text
);


ALTER TABLE sc_portalsinase.usuariocursopesquisa OWNER TO postgres;

--
-- TOC entry 844 (class 1259 OID 137672)
-- Name: usuariocursopesquisa_idrespostausuario_seq; Type: SEQUENCE; Schema: sc_portalsinase; Owner: postgres
--

CREATE SEQUENCE usuariocursopesquisa_idrespostausuario_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sc_portalsinase.usuariocursopesquisa_idrespostausuario_seq OWNER TO postgres;

--
-- TOC entry 4152 (class 0 OID 0)
-- Dependencies: 844
-- Name: usuariocursopesquisa_idrespostausuario_seq; Type: SEQUENCE OWNED BY; Schema: sc_portalsinase; Owner: postgres
--

ALTER SEQUENCE usuariocursopesquisa_idrespostausuario_seq OWNED BY usuariocursopesquisa.idrespostausuario;


--
-- TOC entry 845 (class 1259 OID 137674)
-- Name: usuariomensagemlida; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE usuariomensagemlida (
    idmensagem integer NOT NULL,
    idusuario integer NOT NULL,
    dtleitura timestamp with time zone NOT NULL
);


ALTER TABLE sc_portalsinase.usuariomensagemlida OWNER TO postgres;

--
-- TOC entry 846 (class 1259 OID 137677)
-- Name: usuarioperfilacesso; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE usuarioperfilacesso (
    idusuario integer NOT NULL,
    coperfilacesso character varying(15) NOT NULL,
    dtultimoacesso timestamp with time zone,
    dtcadastro timestamp with time zone DEFAULT '2013-04-23 19:05:17.722593-03'::timestamp with time zone NOT NULL
);


ALTER TABLE sc_portalsinase.usuarioperfilacesso OWNER TO postgres;

--
-- TOC entry 847 (class 1259 OID 137681)
-- Name: usuariostatus; Type: TABLE; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

CREATE TABLE usuariostatus (
    idusuariostatus smallint NOT NULL,
    dcusuariostatus character varying(30) NOT NULL
);


ALTER TABLE sc_portalsinase.usuariostatus OWNER TO postgres;

--
-- TOC entry 4153 (class 0 OID 0)
-- Dependencies: 847
-- Name: TABLE usuariostatus; Type: COMMENT; Schema: sc_portalsinase; Owner: postgres
--

COMMENT ON TABLE usuariostatus IS '1, ''Ativo''
2, ''Aguardando ConfirmaE7E3o de Email''
3, ''Cadastro de usuE1rio incompleto''
4, ''Aguardando renovaE7E3o de senha''
5, ''UsuE1rio bloqueado apF3s 3 tentativas de acesso''
6, ''UsuE1rio bloqueado''';


--
-- TOC entry 848 (class 1259 OID 137684)
-- Name: vw_categoria; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_categoria AS
    SELECT ct.id, ct.name, ct.description, ct.visible FROM public.mdl_course_categories ct;


ALTER TABLE sc_portalsinase.vw_categoria OWNER TO usr_sinase;

--
-- TOC entry 871 (class 1259 OID 507946)
-- Name: vw_curso; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_curso AS
    SELECT p.idprojeto, p.dcprojeto, p.dtinicio, p.dtfinal, p.inativo AS inprojetoinativo, c.id, c.category, ct.name AS categoryname, c.fullname, c.shortname, c.visible, c.summary, c.numsections, CASE c.summaryformat WHEN 0 THEN 'Formato  Automático'::text WHEN 1 THEN 'Formato HTML'::text WHEN 2 THEN 'Formato TEXT'::text WHEN 4 THEN 'Formato MARKDOWN'::text ELSE 'Sem Definição'::text END AS format, pc.idquestionario, pc.idcursomoodle, to_char(to_timestamp((c.startdate)::double precision), 'YYYY-MM-DD HH:MI:SS'::text) AS startdate, (to_char(pc.dtiniciocurso, 'YYYY-MM-DD HH:MI:SS'::text))::date AS dtiniciocurso, (to_char(pc.dtfimcurso, 'YYYY-MM-DD HH:MI:SS'::text))::date AS dtfimcurso, (to_char(pc.dtinicioinscricao, 'YYYY-MM-DD HH:MI:SS'::text))::date AS dtinicioinscricao, (to_char(pc.dtfiminscricao, 'YYYY-MM-DD HH:MI:SS'::text))::date AS dtfiminscricao, cx.id AS contextid, q.dcformulario FROM (((((public.mdl_course c JOIN public.mdl_context cx ON ((c.id = cx.instanceid))) JOIN public.mdl_course_categories ct ON ((c.category = ct.id))) LEFT JOIN projetocurso pc ON ((c.id = pc.idcursomoodle))) LEFT JOIN projeto p ON ((p.idprojeto = pc.idprojeto))) LEFT JOIN questionario q ON ((pc.idquestionario = q.idquestionario))) WHERE ((c.id > 1) AND (cx.contextlevel = 50)) ORDER BY c.shortname;


ALTER TABLE sc_portalsinase.vw_curso OWNER TO usr_sinase;

--
-- TOC entry 849 (class 1259 OID 137693)
-- Name: vw_cursoavaliacao; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursoavaliacao AS
    SELECT b.section AS idmodulo, c.section AS nummodulo, c.name AS dcmodulo, q.id AS idavaliacao, q.course AS idcurso, q.name AS descricao, CASE (q.timeopen)::double precision WHEN 0 THEN NULL::timestamp with time zone ELSE to_timestamp((q.timeopen)::double precision) END AS dtinicio, CASE (q.timeopen)::double precision WHEN 0 THEN NULL::timestamp with time zone ELSE to_timestamp((q.timeclose)::double precision) END AS dtlimite FROM (((public.mdl_quiz q JOIN public.mdl_course_modules b ON (((b.course = q.course) AND (b.instance = q.id)))) JOIN public.mdl_modules mo ON (((mo.id = b.module) AND ((mo.name)::text = 'quiz'::text)))) JOIN public.mdl_course_sections c ON (((c.course = b.course) AND (c.section = b.instance))));


ALTER TABLE sc_portalsinase.vw_cursoavaliacao OWNER TO usr_sinase;

--
-- TOC entry 850 (class 1259 OID 137698)
-- Name: vw_cursoavaliacaousuario; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursoavaliacaousuario AS
    SELECT qa.id AS idavaliacaousuario, qa.quiz AS idavaliacao, CASE qa.timemodified WHEN NULL::bigint THEN 'Não Realizada'::text ELSE 'Realizada'::text END AS realizada, qa.userid FROM public.mdl_quiz_attempts qa;


ALTER TABLE sc_portalsinase.vw_cursoavaliacaousuario OWNER TO usr_sinase;

--
-- TOC entry 851 (class 1259 OID 137702)
-- Name: vw_cursoforum; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursoforum AS
    SELECT c.section AS idmodulo, c.section AS nummodulo, c.name AS dcmodulo, f.id AS idforum, f.course AS idcurso, f.name AS descricao, CASE f.assesstimestart WHEN 0 THEN NULL::timestamp with time zone ELSE to_timestamp((f.assesstimestart)::double precision) END AS dtinicio, CASE f.assesstimefinish WHEN 0 THEN NULL::timestamp with time zone ELSE to_timestamp((f.assesstimefinish)::double precision) END AS dtlimite FROM (((public.mdl_forum f JOIN public.mdl_course_modules b ON (((b.course = f.course) AND (b.instance = f.id)))) JOIN public.mdl_modules mo ON (((mo.id = b.module) AND ((mo.name)::text = 'forum'::text)))) JOIN public.mdl_course_sections c ON ((c.id = b.section))) WHERE (f.assessed <> 0);


ALTER TABLE sc_portalsinase.vw_cursoforum OWNER TO usr_sinase;

--
-- TOC entry 852 (class 1259 OID 137707)
-- Name: vw_cursoforumpostusuario; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursoforumpostusuario AS
    SELECT mdl_forum_posts.id AS idforumpost, mdl_forum_posts.discussion AS idtopicoforum, CASE mdl_forum_posts.created WHEN 0 THEN NULL::timestamp with time zone ELSE to_timestamp((mdl_forum_posts.created)::double precision) END AS dtpost, mdl_forum_posts.userid FROM public.mdl_forum_posts WHERE (mdl_forum_posts.parent > 0);


ALTER TABLE sc_portalsinase.vw_cursoforumpostusuario OWNER TO usr_sinase;

--
-- TOC entry 853 (class 1259 OID 137711)
-- Name: vw_cursoforumtopico; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursoforumtopico AS
    SELECT d.id AS idtopicoforum, d.forum AS idforum, d.course AS idcurso, d.name AS descricao FROM public.mdl_forum_discussions d;


ALTER TABLE sc_portalsinase.vw_cursoforumtopico OWNER TO usr_sinase;

--
-- TOC entry 854 (class 1259 OID 137715)
-- Name: vw_cursomodulo; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursomodulo AS
    SELECT c.fullname, c.shortname, cs.id, cs.course, cs.section, cs.name, cs.summary, cs.summaryformat, cs.visible, cs.sequence, CASE cs.summaryformat WHEN 0 THEN 'Formato  Automático'::text WHEN 1 THEN 'Formato HTML'::text WHEN 2 THEN 'Formato TEXT'::text WHEN 4 THEN 'Formato MARKDOWN'::text ELSE 'Sem Definição'::text END AS format FROM (public.mdl_course_sections cs JOIN public.mdl_course c ON ((cs.course = c.id))) WHERE ((c.id > 1) AND (cs.section > 0)) ORDER BY c.shortname, cs.section;


ALTER TABLE sc_portalsinase.vw_cursomodulo OWNER TO usr_sinase;

--
-- TOC entry 855 (class 1259 OID 137720)
-- Name: vw_cursotarefa; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursotarefa AS
    SELECT c.section AS idmodulo, c.section AS nummodulo, c.name AS dcmodulo, a.id AS idtarefa, a.course AS idcurso, a.name AS descricao, CASE a.timedue WHEN 0 THEN NULL::timestamp without time zone ELSE ((to_timestamp((a.timedue)::double precision))::date + '-10 days'::interval) END AS dtinicio, CASE a.timedue WHEN 0 THEN NULL::timestamp with time zone ELSE to_timestamp((a.timedue)::double precision) END AS dtlimite FROM (((public.mdl_assignment a JOIN public.mdl_course_modules b ON (((b.course = a.course) AND (b.instance = a.id)))) JOIN public.mdl_modules mo ON (((mo.id = b.module) AND ((mo.name)::text = 'assignment'::text)))) JOIN public.mdl_course_sections c ON ((c.id = b.section)));


ALTER TABLE sc_portalsinase.vw_cursotarefa OWNER TO usr_sinase;

--
-- TOC entry 856 (class 1259 OID 137725)
-- Name: vw_cursomoduloatividade; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursomoduloatividade AS
    (SELECT ct.idmodulo, ct.nummodulo, ct.dcmodulo, ct.idtarefa, ct.idcurso, ct.descricao, ct.dtinicio, ct.dtlimite FROM vw_cursotarefa ct UNION SELECT ca.idmodulo, ca.nummodulo, ca.dcmodulo, ca.idavaliacao AS idtarefa, ca.idcurso, ca.descricao, ca.dtinicio, ca.dtlimite FROM vw_cursoavaliacao ca) UNION SELECT cf.idmodulo, cf.nummodulo, cf.dcmodulo, cf.idforum AS idtarefa, cf.idcurso, cf.descricao, cf.dtinicio, cf.dtlimite FROM vw_cursoforum cf;


ALTER TABLE sc_portalsinase.vw_cursomoduloatividade OWNER TO usr_sinase;

--
-- TOC entry 857 (class 1259 OID 137729)
-- Name: vw_cursopapel; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursopapel AS
    SELECT r.id, r.name, r.shortname, r.description FROM public.mdl_role r;


ALTER TABLE sc_portalsinase.vw_cursopapel OWNER TO usr_sinase;

--
-- TOC entry 874 (class 1259 OID 507979)
-- Name: vw_cursoquestionario; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursoquestionario AS
    SELECT c.section AS idmodulo, c.section AS nummodulo, c.name AS dcmodulo, q.id AS idquestionario, q.course AS idcurso, q.name AS descricao, CASE q.timeopen WHEN 0 THEN NULL::timestamp with time zone ELSE to_timestamp((q.timeopen)::double precision) END AS dtinicio, CASE q.timeclose WHEN 0 THEN NULL::timestamp with time zone ELSE to_timestamp((q.timeclose)::double precision) END AS dtlimite FROM (((public.mdl_quiz q JOIN public.mdl_course_modules b ON (((b.course = q.course) AND (b.instance = q.id)))) JOIN public.mdl_modules mo ON (((mo.id = b.module) AND ((mo.name)::text = 'quiz'::text)))) JOIN public.mdl_course_sections c ON ((c.id = b.section)));


ALTER TABLE sc_portalsinase.vw_cursoquestionario OWNER TO usr_sinase;

--
-- TOC entry 858 (class 1259 OID 137733)
-- Name: vw_cursotarefausuario; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursotarefausuario AS
    SELECT s.id AS idtarefausuario, s.assignment AS idtarefa, CASE s.timecreated WHEN NULL::bigint THEN 'Não Realizada'::text ELSE 'Realizada'::text END AS realizada, s.userid FROM public.mdl_assignment_submissions s;


ALTER TABLE sc_portalsinase.vw_cursotarefausuario OWNER TO usr_sinase;

--
-- TOC entry 872 (class 1259 OID 507963)
-- Name: vw_cursoturma; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursoturma AS
    SELECT g.courseid, c.fullname, c.shortname, g.id, g.id AS idnumber, g.name, g.description, g.enrolmentkey, CASE g.descriptionformat WHEN 0 THEN 'Formato  Automático'::text WHEN 1 THEN 'Formato HTML'::text WHEN 2 THEN 'Formato TEXT'::text WHEN 4 THEN 'Formato MARKDOWN'::text ELSE 'Sem Definição'::text END AS format, t.qtselecionados, COALESCE(t.indqualitativo, 0.00) AS indqualitativo FROM ((public.mdl_groups g JOIN public.mdl_course c ON ((g.courseid = c.id))) LEFT JOIN turma t ON ((g.id = t.idturma))) ORDER BY c.shortname, g.name;


ALTER TABLE sc_portalsinase.vw_cursoturma OWNER TO usr_sinase;

--
-- TOC entry 859 (class 1259 OID 137742)
-- Name: vw_cursousuarioacesso; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursousuarioacesso AS
    SELECT mdl_log.course, mdl_log.userid, max((to_timestamp((mdl_log."time")::double precision))::date) AS dtultimoacesso FROM public.mdl_log GROUP BY mdl_log.course, mdl_log.userid;


ALTER TABLE sc_portalsinase.vw_cursousuarioacesso OWNER TO usr_sinase;

--
-- TOC entry 860 (class 1259 OID 137746)
-- Name: vw_cursousuariopapel; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursousuariopapel AS
    SELECT c.id, c.id AS idcurso, ra.roleid, ra.contextid, ra.userid, ra.timemodified, ra.modifierid, ra.component, ra.itemid, ra.sortorder, u.firstname, u.lastname, u.email, CASE r.name WHEN 'Gerente'::text THEN 'supervisor'::character varying WHEN 'Moderador'::text THEN 'tutor'::character varying WHEN 'Estudante'::text THEN 'aluno'::character varying ELSE r.name END AS name, c.fullname, c.shortname, (((u.firstname)::text || ' '::text) || (u.lastname)::text) AS dcnome FROM ((((public.mdl_role_assignments ra JOIN public.mdl_user u ON ((u.id = ra.userid))) JOIN public.mdl_role r ON ((r.id = ra.roleid))) JOIN public.mdl_context co ON ((co.id = ra.contextid))) JOIN public.mdl_course c ON ((c.id = co.instanceid)));


ALTER TABLE sc_portalsinase.vw_cursousuariopapel OWNER TO usr_sinase;

--
-- TOC entry 861 (class 1259 OID 137751)
-- Name: vw_cursousuariopapelturma; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_cursousuariopapelturma AS
    SELECT c.id, c.id AS idcurso, ra.roleid, gm.groupid AS idturma, ra.contextid, ra.userid FROM (((((public.mdl_role_assignments ra JOIN public.mdl_user u ON ((u.id = ra.userid))) JOIN public.mdl_role r ON ((r.id = ra.roleid))) JOIN public.mdl_context co ON ((co.id = ra.contextid))) JOIN public.mdl_course c ON ((c.id = co.instanceid))) LEFT JOIN public.mdl_groups_members gm ON ((gm.userid = u.id)));


ALTER TABLE sc_portalsinase.vw_cursousuariopapelturma OWNER TO usr_sinase;

--
-- TOC entry 862 (class 1259 OID 137756)
-- Name: vw_menu_sistema; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_menu_sistema AS
    WITH RECURSIVE menu_tree(ar_nuordem, ar_idmenu, id_funcionalidade, id_funcionalidade_pai, id_funcionalidade_principal, id_tipo_funcionalidade, dc_funcionalidade, nu_ordem, nu_nivel, id_rota, dc_rota) AS (SELECT ARRAY[f1.nu_ordem] AS ar_ordem, ARRAY[f1.id_funcionalidade] AS ar_ordem_id, f1.id_funcionalidade, f1.id_funcionalidade_pai, f1_1.id_funcionalidade, f1.id_tipo_funcionalidade, f1.dc_nome, f1.nu_ordem, f1.nu_nivel, r1.id_rota, r1.dc_rota FROM ((funcionalidade f1 LEFT JOIN funcionalidade f1_1 ON (((f1.id_funcionalidade = f1_1.id_funcionalidade_pai) AND (f1_1.id_tipo_funcionalidade = 3)))) LEFT JOIN rota r1 ON (((f1_1.id_funcionalidade = r1.id_funcionalidade) AND (r1.in_principal = true)))) WHERE (((f1.id_funcionalidade_pai IS NULL) AND (f1.id_tipo_funcionalidade = 1)) AND (f1.in_ativo = true)) UNION ALL SELECT (mt.ar_nuordem || f2.nu_ordem), (mt.ar_idmenu || f2.id_funcionalidade), f2.id_funcionalidade, f2.id_funcionalidade_pai, f2_1.id_funcionalidade, f2.id_tipo_funcionalidade, f2.dc_nome, f2.nu_ordem, f2.nu_nivel, r2.id_rota, r2.dc_rota FROM (((funcionalidade f2 JOIN funcionalidade f2_1 ON ((f2.id_funcionalidade = f2_1.id_funcionalidade_pai))) LEFT JOIN rota r2 ON (((f2_1.id_funcionalidade = r2.id_funcionalidade) AND (r2.in_principal = true)))) JOIN menu_tree mt ON (((mt.id_funcionalidade = f2.id_funcionalidade_pai) AND (f2.id_tipo_funcionalidade = 1)))) WHERE (f2.in_ativo = true)) SELECT mt.ar_nuordem, mt.ar_idmenu, mt.id_funcionalidade, mt.id_funcionalidade_pai, mt.id_funcionalidade_principal, mt.id_tipo_funcionalidade, mt.dc_funcionalidade, mt.nu_ordem, mt.nu_nivel, mt.id_rota, mt.dc_rota FROM menu_tree mt ORDER BY mt.ar_nuordem;


ALTER TABLE sc_portalsinase.vw_menu_sistema OWNER TO usr_sinase;

--
-- TOC entry 863 (class 1259 OID 137761)
-- Name: vw_notaatividade; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_notaatividade AS
    SELECT usu.idusuario AS userid, gi.courseid AS idcurso, c.section AS idmodulo, c.section AS nummodulo, c.name AS dcmodulo, gi.itemname AS dctarefa, gg.finalgrade AS vlnota, gi.itemmodule AS tpmodulo, gi.id AS idtarefa FROM (((((public.mdl_grade_items gi LEFT JOIN public.mdl_grade_grades gg ON ((gi.id = gg.itemid))) LEFT JOIN usuario usu ON ((usu.idmoodle = (gg.userid)::numeric))) JOIN public.mdl_course_modules b ON (((b.course = gi.courseid) AND (b.instance = gi.iteminstance)))) JOIN public.mdl_modules mo ON (((mo.id = b.module) AND ((mo.name)::text = (gi.itemmodule)::text)))) JOIN public.mdl_course_sections c ON ((c.id = b.section))) WHERE ((gi.itemtype)::text = 'mod'::text) ORDER BY usu.idusuario, gi.courseid, c.section, gi.id;


ALTER TABLE sc_portalsinase.vw_notaatividade OWNER TO usr_sinase;

--
-- TOC entry 864 (class 1259 OID 137766)
-- Name: vw_notacurso; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_notacurso AS
    SELECT usu.idusuario AS userid, gi.courseid, gg.finalgrade AS vlnota FROM ((public.mdl_grade_grades gg JOIN public.mdl_grade_items gi ON ((gi.id = gg.itemid))) JOIN usuario usu ON ((usu.idmoodle = (gg.userid)::numeric))) WHERE ((gi.itemtype)::text = 'course'::text);


ALTER TABLE sc_portalsinase.vw_notacurso OWNER TO usr_sinase;

--
-- TOC entry 865 (class 1259 OID 137771)
-- Name: vw_papel; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_papel AS
    SELECT r.id, r.name, r.shortname, r.description FROM public.mdl_role r;


ALTER TABLE sc_portalsinase.vw_papel OWNER TO usr_sinase;

--
-- TOC entry 866 (class 1259 OID 137775)
-- Name: vw_participante; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_participante AS
    SELECT gm.id, gm.groupid, g.courseid, gm.userid FROM (public.mdl_groups g JOIN public.mdl_groups_members gm ON ((gm.groupid = g.id)));


ALTER TABLE sc_portalsinase.vw_participante OWNER TO usr_sinase;

--
-- TOC entry 867 (class 1259 OID 137779)
-- Name: vw_perfil_usuario_rota; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_perfil_usuario_rota AS
    SELECT DISTINCT fp.co_perfilacesso, upa.idusuario, split_part((fr.dc_rota)::text, '/'::text, 1) AS controller, split_part((fr.dc_rota)::text, '/'::text, 2) AS action FROM (((funcionalidade f JOIN rota fr ON ((f.id_funcionalidade = fr.id_funcionalidade))) JOIN funcionalidadeperfil fp ON ((f.id_funcionalidade = fp.id_funcionalidade))) JOIN usuarioperfilacesso upa ON (((fp.co_perfilacesso)::text = (upa.coperfilacesso)::text)));


ALTER TABLE sc_portalsinase.vw_perfil_usuario_rota OWNER TO usr_sinase;

--
-- TOC entry 873 (class 1259 OID 507968)
-- Name: vw_usuarioenturmado; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_usuarioenturmado AS
    SELECT u.idmoodle, u.nucpf, u.dcnome, u.dtnascimento, u.dcsexo, u.dcemail, u.couf, uf.dcuf, u.dcbairro, u.dccidade, u.nucep, ci.idprojeto, ci.idcursomoodle, ci.idquestionario, ci.idusuario, ci.idturma, ci.dtinscricao, ci.dtenturmado, ci.dtdesenturmado, ci.dtultimocontatoemail, ci.dtconfirmaenturmado, ct.fullname AS dccurso, ct.name AS dcname, ct.description AS dcturma FROM (((controleinscricao ci JOIN vw_cursoturma ct ON ((ci.idturma = ct.id))) JOIN usuario u ON ((ci.idusuario = u.idusuario))) LEFT JOIN uf ON ((u.couf = uf.couf)));


ALTER TABLE sc_portalsinase.vw_usuarioenturmado OWNER TO usr_sinase;

--
-- TOC entry 868 (class 1259 OID 137789)
-- Name: vw_usuarioinscricao; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_usuarioinscricao AS
    SELECT u.id AS iduser, u.firstname, u.email, u.suspended, c.id AS idcourse, c.shortname, c.fullname, ue.status AS statusescricao, r.id AS idrole, r.name AS namerole FROM (((((public.mdl_user u JOIN public.mdl_user_enrolments ue ON ((u.id = ue.userid))) JOIN public.mdl_enrol e ON ((e.id = ue.enrolid))) JOIN public.mdl_course c ON ((c.id = e.courseid))) JOIN public.mdl_role_assignments ra ON ((u.id = ra.userid))) JOIN public.mdl_role r ON ((ra.roleid = r.id)));


ALTER TABLE sc_portalsinase.vw_usuarioinscricao OWNER TO usr_sinase;

--
-- TOC entry 869 (class 1259 OID 137794)
-- Name: vw_usuariomoodle; Type: VIEW; Schema: sc_portalsinase; Owner: usr_sinase
--

CREATE VIEW vw_usuariomoodle AS
    SELECT um.id, um.username, um.firstname, um.lastname, um.email, um.suspended, u.idusuario, u.nucpf, u.dtnascimento, u.dcsexo, u.dcnome FROM (public.mdl_user um JOIN usuario u ON (((um.id)::numeric = u.idmoodle)));


ALTER TABLE sc_portalsinase.vw_usuariomoodle OWNER TO usr_sinase;

--
-- TOC entry 3977 (class 2604 OID 138111)
-- Name: idareaatuacao; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY areaatuacao ALTER COLUMN idareaatuacao SET DEFAULT nextval('areaatuacao_idareaatuacao_seq'::regclass);


--
-- TOC entry 3978 (class 2604 OID 138112)
-- Name: idcondicao; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY condicao ALTER COLUMN idcondicao SET DEFAULT nextval('condicao_idcondicao_seq'::regclass);


--
-- TOC entry 3981 (class 2604 OID 138113)
-- Name: idemail; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY email ALTER COLUMN idemail SET DEFAULT nextval('email_idemail_seq'::regclass);


--
-- TOC entry 3984 (class 2604 OID 138114)
-- Name: idemailtag; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY emailtag ALTER COLUMN idemailtag SET DEFAULT nextval('emailtag_idemailtag_seq'::regclass);


--
-- TOC entry 3986 (class 2604 OID 138115)
-- Name: id_funcionalidade; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY funcionalidade ALTER COLUMN id_funcionalidade SET DEFAULT nextval('funcionalidade_id_funcionalidade_seq'::regclass);


--
-- TOC entry 3988 (class 2604 OID 138116)
-- Name: idgrauinstrucao; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY grauinstrucao ALTER COLUMN idgrauinstrucao SET DEFAULT nextval('grauinstrucao_idgrauinstrucao_seq'::regclass);


--
-- TOC entry 3989 (class 2604 OID 138117)
-- Name: idgrupoquestao; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY grupoquestao ALTER COLUMN idgrupoquestao SET DEFAULT nextval('grupoquestao_idgrupoquestao_seq'::regclass);


--
-- TOC entry 3990 (class 2604 OID 138118)
-- Name: idgrupoquestionario; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY grupoquestionario ALTER COLUMN idgrupoquestionario SET DEFAULT nextval('grupoquestionario_idgrupoquestionario_seq'::regclass);


--
-- TOC entry 3992 (class 2604 OID 138119)
-- Name: idmensagem; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY mensagem ALTER COLUMN idmensagem SET DEFAULT nextval('mensagem_idmensagem_seq'::regclass);


--
-- TOC entry 3996 (class 2604 OID 138120)
-- Name: idpesquisa; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY pesquisa ALTER COLUMN idpesquisa SET DEFAULT nextval('pesquisa_idpesquisa_seq'::regclass);


--
-- TOC entry 3997 (class 2604 OID 138121)
-- Name: idportalconfig; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY portalconfig ALTER COLUMN idportalconfig SET DEFAULT nextval('portalconfig_idportalconfig_seq'::regclass);


--
-- TOC entry 3999 (class 2604 OID 138122)
-- Name: idprojeto; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY projeto ALTER COLUMN idprojeto SET DEFAULT nextval('projeto_idprojeto_seq'::regclass);


--
-- TOC entry 4000 (class 2604 OID 138123)
-- Name: idquestao; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY questao ALTER COLUMN idquestao SET DEFAULT nextval('questao_idquestao_seq'::regclass);


--
-- TOC entry 4001 (class 2604 OID 138124)
-- Name: idquestionario; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY questionario ALTER COLUMN idquestionario SET DEFAULT nextval('questionario_idquestionario_seq'::regclass);


--
-- TOC entry 4003 (class 2604 OID 138125)
-- Name: idresposta; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY resposta ALTER COLUMN idresposta SET DEFAULT nextval('resposta_idresposta_seq'::regclass);


--
-- TOC entry 4004 (class 2604 OID 138126)
-- Name: id_rota; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY rota ALTER COLUMN id_rota SET DEFAULT nextval('rota_id_rota_seq'::regclass);


--
-- TOC entry 4006 (class 2604 OID 138127)
-- Name: id_tipo_funcionalidade; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY tipofuncionalidade ALTER COLUMN id_tipo_funcionalidade SET DEFAULT nextval('tipofuncionalidade_id_tipo_funcionalidade_seq'::regclass);


--
-- TOC entry 4007 (class 2604 OID 138128)
-- Name: idusuario; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuario ALTER COLUMN idusuario SET DEFAULT nextval('usuario_idusuario_seq'::regclass);


--
-- TOC entry 4009 (class 2604 OID 138129)
-- Name: idrespostausuario; Type: DEFAULT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuariocursopesquisa ALTER COLUMN idrespostausuario SET DEFAULT nextval('usuariocursopesquisa_idrespostausuario_seq'::regclass);


--
-- TOC entry 4034 (class 2606 OID 250377)
-- Name: grauinstrucao_pkey; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grauinstrucao
    ADD CONSTRAINT grauinstrucao_pkey PRIMARY KEY (idgrauinstrucao);


--
-- TOC entry 4036 (class 2606 OID 250379)
-- Name: grupoquestao_pkey; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grupoquestao
    ADD CONSTRAINT grupoquestao_pkey PRIMARY KEY (idgrupoquestao);


--
-- TOC entry 4038 (class 2606 OID 250381)
-- Name: grupoquestionario_pkey; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grupoquestionario
    ADD CONSTRAINT grupoquestionario_pkey PRIMARY KEY (idgrupoquestionario);


--
-- TOC entry 4014 (class 2606 OID 250383)
-- Name: pk_areaatuacao; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY areaatuacao
    ADD CONSTRAINT pk_areaatuacao PRIMARY KEY (idareaatuacao);


--
-- TOC entry 4016 (class 2606 OID 250385)
-- Name: pk_condicao; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY condicao
    ADD CONSTRAINT pk_condicao PRIMARY KEY (idcondicao);


--
-- TOC entry 4018 (class 2606 OID 250387)
-- Name: pk_controleinscricao; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY controleinscricao
    ADD CONSTRAINT pk_controleinscricao PRIMARY KEY (idprojeto, idcursomoodle, idquestionario, idusuario);


--
-- TOC entry 4020 (class 2606 OID 250389)
-- Name: pk_email; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY email
    ADD CONSTRAINT pk_email PRIMARY KEY (idemail);


--
-- TOC entry 4022 (class 2606 OID 250391)
-- Name: pk_emailgrupotag; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY emailgrupotag
    ADD CONSTRAINT pk_emailgrupotag PRIMARY KEY (idemail, idemailtag);


--
-- TOC entry 4024 (class 2606 OID 250393)
-- Name: pk_emailtag; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY emailtag
    ADD CONSTRAINT pk_emailtag PRIMARY KEY (idemailtag);


--
-- TOC entry 4026 (class 2606 OID 250395)
-- Name: pk_emailtipoenvio; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY emailtipoenvio
    ADD CONSTRAINT pk_emailtipoenvio PRIMARY KEY (idemailtipoenvio);


--
-- TOC entry 4028 (class 2606 OID 250397)
-- Name: pk_emailtipotag; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY emailtipotag
    ADD CONSTRAINT pk_emailtipotag PRIMARY KEY (idemailtipotag);


--
-- TOC entry 4030 (class 2606 OID 250399)
-- Name: pk_funcionalidade; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY funcionalidade
    ADD CONSTRAINT pk_funcionalidade PRIMARY KEY (id_funcionalidade);


--
-- TOC entry 4032 (class 2606 OID 250401)
-- Name: pk_funcionalidadeperfil; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY funcionalidadeperfil
    ADD CONSTRAINT pk_funcionalidadeperfil PRIMARY KEY (co_perfilacesso, id_funcionalidade, sg_sistema);


--
-- TOC entry 4040 (class 2606 OID 250403)
-- Name: pk_mensagem; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY mensagem
    ADD CONSTRAINT pk_mensagem PRIMARY KEY (idmensagem);


--
-- TOC entry 4042 (class 2606 OID 250405)
-- Name: pk_perfilacesso; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY perfilacesso
    ADD CONSTRAINT pk_perfilacesso PRIMARY KEY (coperfilacesso);


--
-- TOC entry 4044 (class 2606 OID 250407)
-- Name: pk_pesquisa; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pesquisa
    ADD CONSTRAINT pk_pesquisa PRIMARY KEY (idpesquisa);


--
-- TOC entry 4046 (class 2606 OID 250409)
-- Name: pk_portalconfig; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY portalconfig
    ADD CONSTRAINT pk_portalconfig PRIMARY KEY (idportalconfig);


--
-- TOC entry 4048 (class 2606 OID 250411)
-- Name: pk_projeto; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY projeto
    ADD CONSTRAINT pk_projeto PRIMARY KEY (idprojeto);


--
-- TOC entry 4050 (class 2606 OID 250413)
-- Name: pk_projetocurso; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY projetocurso
    ADD CONSTRAINT pk_projetocurso PRIMARY KEY (idprojeto, idcursomoodle);


--
-- TOC entry 4052 (class 2606 OID 250415)
-- Name: pk_projetocursoquestionario; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY projetocursoquestionario
    ADD CONSTRAINT pk_projetocursoquestionario PRIMARY KEY (idprojeto, idcursomoodle, idquestionario);


--
-- TOC entry 4060 (class 2606 OID 250417)
-- Name: pk_rota; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rota
    ADD CONSTRAINT pk_rota PRIMARY KEY (id_rota);


--
-- TOC entry 4062 (class 2606 OID 250419)
-- Name: pk_sistema; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY sistema
    ADD CONSTRAINT pk_sistema PRIMARY KEY (sg_sistema);


--
-- TOC entry 4064 (class 2606 OID 250421)
-- Name: pk_tipofuncionalidade; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tipofuncionalidade
    ADD CONSTRAINT pk_tipofuncionalidade PRIMARY KEY (id_tipo_funcionalidade);


--
-- TOC entry 4066 (class 2606 OID 250423)
-- Name: pk_tipopesquisa; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tipopesquisa
    ADD CONSTRAINT pk_tipopesquisa PRIMARY KEY (cotipopesquisa);


--
-- TOC entry 4070 (class 2606 OID 250425)
-- Name: pk_uf; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY uf
    ADD CONSTRAINT pk_uf PRIMARY KEY (couf);


--
-- TOC entry 4074 (class 2606 OID 250427)
-- Name: pk_usuariocursopesquisa; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY usuariocursopesquisa
    ADD CONSTRAINT pk_usuariocursopesquisa PRIMARY KEY (idrespostausuario);


--
-- TOC entry 4076 (class 2606 OID 250429)
-- Name: pk_usuariomensagemlida; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY usuariomensagemlida
    ADD CONSTRAINT pk_usuariomensagemlida PRIMARY KEY (idmensagem, idusuario);


--
-- TOC entry 4078 (class 2606 OID 250431)
-- Name: pk_usuarioperfilacesso; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY usuarioperfilacesso
    ADD CONSTRAINT pk_usuarioperfilacesso PRIMARY KEY (coperfilacesso, idusuario);


--
-- TOC entry 4080 (class 2606 OID 250433)
-- Name: pk_usuariostatus; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY usuariostatus
    ADD CONSTRAINT pk_usuariostatus PRIMARY KEY (idusuariostatus);


--
-- TOC entry 4082 (class 2606 OID 507945)
-- Name: pkturma; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT pkturma PRIMARY KEY (idturma);


--
-- TOC entry 4054 (class 2606 OID 250435)
-- Name: questao_pkey; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY questao
    ADD CONSTRAINT questao_pkey PRIMARY KEY (idquestao);


--
-- TOC entry 4056 (class 2606 OID 250437)
-- Name: questionario_pkey; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY questionario
    ADD CONSTRAINT questionario_pkey PRIMARY KEY (idquestionario);


--
-- TOC entry 4058 (class 2606 OID 250439)
-- Name: resposta_pkey; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resposta
    ADD CONSTRAINT resposta_pkey PRIMARY KEY (idresposta);


--
-- TOC entry 4068 (class 2606 OID 250441)
-- Name: tipoquestao_pkey; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tipoquestao
    ADD CONSTRAINT tipoquestao_pkey PRIMARY KEY (cotipoquestao);


--
-- TOC entry 4072 (class 2606 OID 250443)
-- Name: usuario_pkey; Type: CONSTRAINT; Schema: sc_portalsinase; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT usuario_pkey PRIMARY KEY (idusuario);


--
-- TOC entry 4085 (class 2606 OID 251090)
-- Name: fk_condicao_reference_pesquisa; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY condicao
    ADD CONSTRAINT fk_condicao_reference_pesquisa FOREIGN KEY (idpesquisa) REFERENCES pesquisa(idpesquisa) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4084 (class 2606 OID 251095)
-- Name: fk_condicao_reference_tipopesq; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY condicao
    ADD CONSTRAINT fk_condicao_reference_tipopesq FOREIGN KEY (cotipopesquisa) REFERENCES tipopesquisa(cotipopesquisa) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4083 (class 2606 OID 251100)
-- Name: fk_condicao_reference_usuario; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY condicao
    ADD CONSTRAINT fk_condicao_reference_usuario FOREIGN KEY (idusuariocriacao) REFERENCES usuario(idusuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4088 (class 2606 OID 251105)
-- Name: fk_controle_reference_projetoc; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY controleinscricao
    ADD CONSTRAINT fk_controle_reference_projetoc FOREIGN KEY (idprojeto, idcursomoodle) REFERENCES projetocurso(idprojeto, idcursomoodle) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4087 (class 2606 OID 251110)
-- Name: fk_controle_reference_question; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY controleinscricao
    ADD CONSTRAINT fk_controle_reference_question FOREIGN KEY (idquestionario) REFERENCES questionario(idquestionario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4086 (class 2606 OID 251115)
-- Name: fk_controle_reference_usuario; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY controleinscricao
    ADD CONSTRAINT fk_controle_reference_usuario FOREIGN KEY (idusuario) REFERENCES usuario(idusuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4089 (class 2606 OID 251120)
-- Name: fk_email_reference_emailtip; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY email
    ADD CONSTRAINT fk_email_reference_emailtip FOREIGN KEY (idemailtipoenvio) REFERENCES emailtipoenvio(idemailtipoenvio) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4091 (class 2606 OID 251125)
-- Name: fk_emailgru_reference_email; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY emailgrupotag
    ADD CONSTRAINT fk_emailgru_reference_email FOREIGN KEY (idemail) REFERENCES email(idemail) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4090 (class 2606 OID 251130)
-- Name: fk_emailgru_reference_emailtag; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY emailgrupotag
    ADD CONSTRAINT fk_emailgru_reference_emailtag FOREIGN KEY (idemailtag) REFERENCES emailtag(idemailtag) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4092 (class 2606 OID 251135)
-- Name: fk_emailtag_reference_emailtip; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY emailtag
    ADD CONSTRAINT fk_emailtag_reference_emailtip FOREIGN KEY (idemailtipotag) REFERENCES emailtipotag(idemailtipotag) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4095 (class 2606 OID 251140)
-- Name: fk_funciona_reference_funciona; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY funcionalidade
    ADD CONSTRAINT fk_funciona_reference_funciona FOREIGN KEY (id_funcionalidade_pai) REFERENCES funcionalidade(id_funcionalidade);


--
-- TOC entry 4098 (class 2606 OID 251145)
-- Name: fk_funciona_reference_funciona; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY funcionalidadeperfil
    ADD CONSTRAINT fk_funciona_reference_funciona FOREIGN KEY (id_funcionalidade) REFERENCES funcionalidade(id_funcionalidade);


--
-- TOC entry 4097 (class 2606 OID 251150)
-- Name: fk_funciona_reference_perfilac; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY funcionalidadeperfil
    ADD CONSTRAINT fk_funciona_reference_perfilac FOREIGN KEY (co_perfilacesso) REFERENCES perfilacesso(coperfilacesso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4094 (class 2606 OID 251155)
-- Name: fk_funciona_reference_sistema; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY funcionalidade
    ADD CONSTRAINT fk_funciona_reference_sistema FOREIGN KEY (sg_sistema) REFERENCES sistema(sg_sistema) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4096 (class 2606 OID 251160)
-- Name: fk_funciona_reference_sistema; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY funcionalidadeperfil
    ADD CONSTRAINT fk_funciona_reference_sistema FOREIGN KEY (sg_sistema) REFERENCES sistema(sg_sistema) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4093 (class 2606 OID 251165)
-- Name: fk_funciona_reference_tipofunc; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY funcionalidade
    ADD CONSTRAINT fk_funciona_reference_tipofunc FOREIGN KEY (id_tipo_funcionalidade) REFERENCES tipofuncionalidade(id_tipo_funcionalidade) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4101 (class 2606 OID 251170)
-- Name: fk_mensagem_reference_projeto; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY mensagem
    ADD CONSTRAINT fk_mensagem_reference_projeto FOREIGN KEY (idprojeto) REFERENCES projeto(idprojeto) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4100 (class 2606 OID 251175)
-- Name: fk_msg_reference_usu_1; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY mensagem
    ADD CONSTRAINT fk_msg_reference_usu_1 FOREIGN KEY (idusuariodestinatario) REFERENCES usuario(idusuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4099 (class 2606 OID 251180)
-- Name: fk_msg_reference_usu_2; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY mensagem
    ADD CONSTRAINT fk_msg_reference_usu_2 FOREIGN KEY (idusuariocriacao) REFERENCES usuario(idusuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4102 (class 2606 OID 251185)
-- Name: fk_pesquisa_reference_usuario; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY pesquisa
    ADD CONSTRAINT fk_pesquisa_reference_usuario FOREIGN KEY (idusuariocriacao) REFERENCES usuario(idusuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4104 (class 2606 OID 251190)
-- Name: fk_portalco_reference_usu_1; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY portalconfig
    ADD CONSTRAINT fk_portalco_reference_usu_1 FOREIGN KEY (idusuarioresponsavel) REFERENCES usuario(idusuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4103 (class 2606 OID 251195)
-- Name: fk_portalco_reference_usu_2; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY portalconfig
    ADD CONSTRAINT fk_portalco_reference_usu_2 FOREIGN KEY (idusuarioalteracao) REFERENCES usuario(idusuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4106 (class 2606 OID 251200)
-- Name: fk_projetoc_reference_projeto; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY projetocurso
    ADD CONSTRAINT fk_projetoc_reference_projeto FOREIGN KEY (idprojeto) REFERENCES projeto(idprojeto) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4108 (class 2606 OID 251205)
-- Name: fk_projetoc_reference_projetoc; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY projetocursoquestionario
    ADD CONSTRAINT fk_projetoc_reference_projetoc FOREIGN KEY (idprojeto, idcursomoodle) REFERENCES projetocurso(idprojeto, idcursomoodle) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4105 (class 2606 OID 251210)
-- Name: fk_projetoc_reference_question; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY projetocurso
    ADD CONSTRAINT fk_projetoc_reference_question FOREIGN KEY (idquestionario) REFERENCES questionario(idquestionario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4107 (class 2606 OID 251215)
-- Name: fk_projetoc_reference_question; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY projetocursoquestionario
    ADD CONSTRAINT fk_projetoc_reference_question FOREIGN KEY (idquestionario) REFERENCES questionario(idquestionario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4111 (class 2606 OID 251220)
-- Name: fk_questao_reference_tipoques; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY questao
    ADD CONSTRAINT fk_questao_reference_tipoques FOREIGN KEY (cotipoquestao) REFERENCES tipoquestao(cotipoquestao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4114 (class 2606 OID 251225)
-- Name: fk_rota_reference_funciona; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY rota
    ADD CONSTRAINT fk_rota_reference_funciona FOREIGN KEY (id_funcionalidade) REFERENCES funcionalidade(id_funcionalidade) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4118 (class 2606 OID 251230)
-- Name: fk_usuario_reference_uf; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT fk_usuario_reference_uf FOREIGN KEY (couf) REFERENCES uf(couf) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4117 (class 2606 OID 251235)
-- Name: fk_usuario_reference_usuarios; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT fk_usuario_reference_usuarios FOREIGN KEY (idusuariostatus) REFERENCES usuariostatus(idusuariostatus) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4121 (class 2606 OID 251240)
-- Name: fk_usuarioc_reference_controle; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuariocursopesquisa
    ADD CONSTRAINT fk_usuarioc_reference_controle FOREIGN KEY (idprojeto, idcursomoodle, idquestionario, idusuario) REFERENCES controleinscricao(idprojeto, idcursomoodle, idquestionario, idusuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4120 (class 2606 OID 251245)
-- Name: fk_usuarioc_reference_questao; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuariocursopesquisa
    ADD CONSTRAINT fk_usuarioc_reference_questao FOREIGN KEY (idquestao) REFERENCES questao(idquestao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4119 (class 2606 OID 251250)
-- Name: fk_usuarioc_reference_resposta; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuariocursopesquisa
    ADD CONSTRAINT fk_usuarioc_reference_resposta FOREIGN KEY (idresposta) REFERENCES resposta(idresposta) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4123 (class 2606 OID 251255)
-- Name: fk_usuariom_reference_mensagem; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuariomensagemlida
    ADD CONSTRAINT fk_usuariom_reference_mensagem FOREIGN KEY (idmensagem) REFERENCES mensagem(idmensagem) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4122 (class 2606 OID 251260)
-- Name: fk_usuariom_reference_usuario; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuariomensagemlida
    ADD CONSTRAINT fk_usuariom_reference_usuario FOREIGN KEY (idusuario) REFERENCES usuario(idusuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4125 (class 2606 OID 251265)
-- Name: fk_usuariop_reference_perfilac; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuarioperfilacesso
    ADD CONSTRAINT fk_usuariop_reference_perfilac FOREIGN KEY (coperfilacesso) REFERENCES perfilacesso(coperfilacesso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4124 (class 2606 OID 251270)
-- Name: fk_usuariop_reference_usuario; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuarioperfilacesso
    ADD CONSTRAINT fk_usuariop_reference_usuario FOREIGN KEY (idusuario) REFERENCES usuario(idusuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 4112 (class 2606 OID 251275)
-- Name: quest_grupoquest_id_fkey; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY questionario
    ADD CONSTRAINT quest_grupoquest_id_fkey FOREIGN KEY (idgrupoquestionario) REFERENCES grupoquestionario(idgrupoquestionario);


--
-- TOC entry 4110 (class 2606 OID 251280)
-- Name: questao_grupoquestao_id_fkey; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY questao
    ADD CONSTRAINT questao_grupoquestao_id_fkey FOREIGN KEY (idgrupoquestao) REFERENCES grupoquestao(idgrupoquestao);


--
-- TOC entry 4109 (class 2606 OID 251285)
-- Name: questao_questionario_id_fkey; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY questao
    ADD CONSTRAINT questao_questionario_id_fkey FOREIGN KEY (idquestionario) REFERENCES questionario(idquestionario);


--
-- TOC entry 4113 (class 2606 OID 251290)
-- Name: resposta_questao_id_fkey; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY resposta
    ADD CONSTRAINT resposta_questao_id_fkey FOREIGN KEY (idquestao) REFERENCES questao(idquestao);


--
-- TOC entry 4116 (class 2606 OID 251295)
-- Name: usuario_areaatuacao_id_fkey; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT usuario_areaatuacao_id_fkey FOREIGN KEY (idareaatuacao) REFERENCES areaatuacao(idareaatuacao);


--
-- TOC entry 4115 (class 2606 OID 251300)
-- Name: usuario_grauinstrucao_id_fkey; Type: FK CONSTRAINT; Schema: sc_portalsinase; Owner: postgres
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT usuario_grauinstrucao_id_fkey FOREIGN KEY (idgrauinstrucao) REFERENCES grauinstrucao(idgrauinstrucao);


--
-- TOC entry 4130 (class 0 OID 0)
-- Dependencies: 7
-- Name: sc_portalsinase; Type: ACL; Schema: -; Owner: portal
--

REVOKE ALL ON SCHEMA sc_portalsinase FROM PUBLIC;
REVOKE ALL ON SCHEMA sc_portalsinase FROM portal;
GRANT ALL ON SCHEMA sc_portalsinase TO portal;
GRANT ALL ON SCHEMA sc_portalsinase TO PUBLIC;
GRANT ALL ON SCHEMA sc_portalsinase TO postgres;


--
-- TOC entry 4154 (class 0 OID 0)
-- Dependencies: 857
-- Name: vw_cursopapel; Type: ACL; Schema: sc_portalsinase; Owner: usr_sinase
--

REVOKE ALL ON TABLE vw_cursopapel FROM PUBLIC;
REVOKE ALL ON TABLE vw_cursopapel FROM usr_sinase;
GRANT ALL ON TABLE vw_cursopapel TO usr_sinase;


--
-- TOC entry 4155 (class 0 OID 0)
-- Dependencies: 873
-- Name: vw_usuarioenturmado; Type: ACL; Schema: sc_portalsinase; Owner: usr_sinase
--

REVOKE ALL ON TABLE vw_usuarioenturmado FROM PUBLIC;
REVOKE ALL ON TABLE vw_usuarioenturmado FROM usr_sinase;
GRANT ALL ON TABLE vw_usuarioenturmado TO usr_sinase;


-- Completed on 2014-12-09 21:51:54

--
-- PostgreSQL database dump complete
--

INSERT INTO sc_portalsinase.sistema(sg_sistema, no_sistema, dc_url, in_ativo)
    VALUES ('Portal', 'Portal de Gesto Acadmica', '/', TRUE);