<?php
class MailApp
{
	public $subject;
	public $body;
	public $bcc = null;

	protected $from;
	protected $fromName = '';

	public function __construct($from = null, $fromName = null)
	{
		$this->from 	= ($from)?$from:Yii::app()->params['adminEmail'];
		$this->fromName = ($fromName)?$fromName:Yii::app()->params['adminEmailName'];
	}

	/**
	 * Enter description here ...
	 * @param text email or array $to
	 * 		 array(
	 * 			array('to'=>'neilcesar@gmail.com', 'toName'=>'Neil César',),
	 * 		  	array('to'=>'neilcesar@gmail.com', 'toName'=>'Neil César',),
	 * 		  	array('to'=>'neilcesar@gmail.com', 'toName'=>'Neil César',)
	 *		);
	 * @param text $toName
	 * @param text $subject
	 * @param bid text $body
	 * @return boolean
	 */
	public function send()
	{
		try{
			$mail = Yii::app()->getComponents(false);
			$sm = Yii::app()->mail;

			$transport = $sm->smtpTransport($mail['mail']['hostName'], $mail['mail']['hostPort']);

			if ($sm->type == 'smtp'){
				$transport =$transport->setUsername($mail['mail']['user'])
									  ->setPassword($mail['mail']['password'])
									  ->setEncryption('ssl');
			}

// 			// New transport
			$plainTextContent = "";

			$mailer = $sm->mailer($transport);
			$Message = $sm->newMessage($this->subject)
						  ->setFrom(array($this->from => $this->fromName))
						  ->setTo($this->to)
						  ->setBcc($this->bcc)
						  ->addPart($this->body, 'text/html')
						  ->setBody($plainTextContent);

			// Send mail
			$result = $mailer->send($Message);

			if ($result === FALSE || $result == 0)
				throw new CException('Erro no Envio de mail');

		} catch (Exception $e) {
			return false;
			//throw new Exception($e->getMessage()); //Boring error messages from anything else!
		}
	}
}