<?php

class MenuStyle extends CComponent
{
	private $_data_raw;
	private $_data;
	private $_controller;
	private $_action;

	public function __construct($filename)
	{
		$this->_data_raw = $filename;
	}

	private function getDataArray($val)
	{
		$items = array();
		$url = '';
		$label = '';

		foreach($val as $key=>$raw)
		{
			switch($key)
			{
				case 'items':
					foreach($raw as $dd=>$value){

						if (count($raw)>1){
							$items[$dd]['url']  = ($value['dc_rota'])?array($value['dc_rota']):null;
							$items[$dd]['label']  = $value['dc_funcionalidade'];
							$items[$dd]['linkOptions']  = null;
							$items[$dd]['active'] = self::isActive($this->_controller, $value['dc_rota']);
						}else{
							$items['url']  = ($value['dc_rota'])?array($value['dc_rota']):null;
							$items['label']  = $value['dc_funcionalidade'];
							$items['linkOptions']  = ($value['dc_rota'])?null:array('class'=>'nav-header');
						}
					}
					break;
				case 'sub-items':
					if (isset($raw['sub-items'])){
						if(count($raw['items']) > 1){
							$items['items'] = $this->getDataArray($raw);
						}else{
							$items['items'] = array($this->getDataArray($raw));
						}
					}
					break;
				default:
					break;
			}
		}

		return $items;
	}

	private function isActive($controller, $rota)
	{
		$rota = ($rota)?explode('/', ltrim($rota)):array();
		return (strpos($controller,"/{$rota[0]}/"))?array('class'=>'nav-header active'):null;
	}

	public function load()
	{
		$this->_controller = Yii::app()->controller->getId();
		$this->_action = Yii::app()->controller->getAction()->getId();

		foreach($this->_data_raw as $data){
			$this->_data[] = $this->getDataArray($data);
		}
	}

	public function getData()
	{
		$a = Yii::app()->controller->getId();
		$b = Yii::app()->controller->getAction()->getId();

		return $this->_data;
	}

}