<?php
class _MailApp
{
	protected $_Mail;
	public $_from;
	public $_fromName;

	public function __construct()
	{
		$this->_from 		= CF::app()->getMailUserName();
		$this->_fromName 	= CF::app()->getParameter('adminEmailNome');
	}

	/**
	 * Enter description here ...
	 * @param text email or array $to
	 * 		 array(
	 * 			array('to'=>'neilcesar@gmail.com', 'toName'=>'Neil César',),
	 * 		  	array('to'=>'neilcesar@gmail.com', 'toName'=>'Neil César',),
	 * 		  	array('to'=>'neilcesar@gmail.com', 'toName'=>'Neil César',)
	 *		);
	 * @param text $toName
	 * @param text $subject
	 * @param bid text $body
	 * @throws CFError
	 * @throws Exception
	 * @return boolean
	 */
	public function send($to, $toName, $subject, $body)
	{
		try{
			if ( empty($to) || empty($subject) || empty($body) )
				throw new CFError(CF::app()->getAppMessage('mensagemCamposIncompleto'));

			if ( !is_object($this->_Mail) )
				$this->_Mail = new CFMail(true);

			$this->_Mail->From 		= iconv("UTF-8","ISO-8859-1", $this->_from );
			$this->_Mail->FromName 	= iconv("UTF-8","ISO-8859-1", $this->_fromName);
			$this->_Mail->SetLanguage( 'br', 'phpmailer/language/' ); // Carrega o idioma

			if(is_array($to)){
				foreach ($to as $key => $value) {
					try{
						$this->_Mail->AddAddress($value['to'], $value['toName']);
					} catch (phpmailerException $e) {
						//TODO
					}
				}
			}else
				$this->_Mail->AddAddress($to, $toName);


			//xd($body);
			$this->_Mail->IsHTML(true); // send as HTML

			$this->_Mail->Subject 	= iconv("UTF-8","ISO-8859-1", $subject);
			$this->_Mail->Body 		= iconv("UTF-8","ISO-8859-1", $body);
			$this->_Mail->AltBody 	= CF::app()->getAppMessage('mensagemAltBodyMail');

			if ( $this->_Mail->Send() ){
				$this->_Mail->ClearAddresses();
  				$this->_Mail->ClearAttachments();
				return true;
			}

			return false;
			//throw new CFError(CF::app()->getAppMessage('mensagemErro'));

		} catch (phpmailerException $e) {
			return false;
		} catch (Exception $e) {
			return false;
		  	//throw new Exception($e->getMessage()); //Boring error messages from anything else!
		}
	}
}