<?php

// uncomment the following to define a path alias
// Yii::setPathOfAlias('local','path/to/local-folder');

// This is the main Web application configuration. Any writable
// CWebApplication properties can be configured here.
return array(
		'basePath'=>dirname(__FILE__).DIRECTORY_SEPARATOR.'..',
		'name'=>'Portal de Gesto Acadmica',

		// preloading 'log' component
		'preload'=>array('log'),

		// Theme utilizado no portal
		'theme'=>'sinase',

		//'sourceLanguage' => '00',
		'language' => 'pt_br',
		'timeZone' => 'America/Sao_Paulo',

		// autoloading model and component classes
		'import'=>array(
				'application.models.*',
				'application.components.*',
				'application.components.XDebug',
				'application.components.MailApp',
				'application.config.Constants',
				'application.extensions.widget.bootstrap.*',

				// 'application.config.AttributeLabels',
				'ext.gtc.components.*', // Gii Template Collection
		),

		'modules'=>array(
				// uncomment the following to enable the Gii tool
				'gii' => array(
						'class' => 'system.gii.GiiModule',
						'password' => '123456',
						'generatorPaths' => array('ext.gtc'),
						'ipFilters' => array('127.0.0.1', '::1'),
				),
		),

		// application components
		'components'=>array(
				'cache' => array('class' => 'system.caching.CDummyCache'),
				'loader' => array(
						'class' => 'application.components.UserSecurity.authenticate'
				),

				'user'=>array(
						// enable cookie-based authentication
						'allowAutoLogin'=>true,
						// este é, de fato, o valor padrão
						'loginUrl'=>array('site/login'),
				),

 				'mail'=>array(
 						'class'=>'ext.swiftMailer.SwiftMailer',
 						'hostName'=>'hostName',
 						'hostPort'=>25,
 						'ssl'=>'true',
 						'type'=>false
 				),
				'ePdf' => array(
						'class'  => 'ext.yii-pdf.EYiiPdf',
						'params' => array(
								'mpdf' => array(
										'librarySourcePath' => 'application.vendors.mpdf.*',
										'constants' => array('_MPDF_TEMP_PATH' => Yii::getPathOfAlias('application.runtime')),
										'class'=>'mpdf', // the literal class filename to be loaded from the vendors folder
								),
								'HTML2PDF' => array(
										'librarySourcePath' => 'application.vendors.html2pdf.*',
										'classFile' => 'html2pdf.class.php', // For adding to Yii::$classMap
								)
						),
				),

 				'db'=>array(
 						'connectionString' => 'pgsql:host=host;dbname=banco',
 						'emulatePrepare' => true,
 						'username' => 'username',
 						'password' => 'password',
 						'charset' => 'utf8',
 						'enableProfiling'=>true,
 						'enableParamLogging' => true,
 						//'schemaCachingDuration'=>3600,
 				),

				// use 'site/error' action to display errors
				'errorHandler'=>array(
						'errorAction'=>'site/error',
				),

				),

				// application-level parameters that can be accessed
				// using Yii::app()->params['paramName']
				'params'=>array(
						// this is used in contact page
						'adminEmail'=>'adminEmail',
						'phpass'=>array('iteration_count_log2'=>8, 'portable_hashes'=>false),
				),
		);
