<?php
/**
 *
 * @package AlunoController
 * @category [Categoria a que o arquivo pertence]
 * @name Controle
 * @author [nome do autor] - [e-mail do autor]
 * @copyright Projeto Sinase 2012
 * @license [link da licenÃ§a] [Nome da licenÃ§a]
 * @link [link de onde pode ser encontrado esse arquivo]
 * @version 0.01
 * @since 2012/09/02*/

class AlunoController extends Controller
{
	public function actionIndex()
	{
		$this->render('index');
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
				array('allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('acompanharCurso', 'atividades', 'notas', 'atividadesAtrasadas'
										 , 'atividadesSemana', 'dashboard', 'mensagemPortal', 'visualizarMensagemPortal'
										 , 'avaliacaoPesquisa'
								),
						'users'=>array('admin', 'aluno'),
				),
				array('deny',  // deny all users
						'users'=>array('*'),
				),
		);
	}

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
				'accessControl', // perform access control for CRUD operations
		);
	}

	// Uncomment the following methods and override them if needed
	/*
	public function filters()
	{
		// return the filter configuration for this controller, e.g.:
		return array(
			'inlineFilterName',
			array(
				'class'=>'path.to.FilterClass',
				'propertyName'=>'propertyValue',
			),
		);
	}

	public function actions()
	{
		// return external action classes, e.g.:
		return array(
			'action1'=>'path.to.ActionClass',
			'action2'=>array(
				'class'=>'path.to.AnotherActionClass',
				'propertyName'=>'propertyValue',
			),
		);
	}
	*/

	/**
	 *
	 */
	public function actionAcompanharCurso()
	{
		$userId  = Yii::app()->user->id;
		$status  = (isset($_POST['status']))?$_POST['status']:NULL;
		$model   = new Curso();
		$model->unsetAttributes();  // clear any default values
		if(isset($_POST['Curso'])) {
			$model->attributes=$_POST['Curso'];
		}

		$this->render('mainAcompanharCurso',array(
			'model'			 => $model,
			'cursosAluno'    => $model->cursosAluno($userId, $status)
		));
	}

	public function actionAtividades()
	{
		$userId 	 = Yii::app()->user->id;
		$idCourse 	 = Yii::app()->getRequest()->getParam('id');

		$curso        = new Curso();
		$usuarioMoodle = new UsuarioMoodle();

		$this->render('mainAtividades',array(
				'curso'       => $curso->findByPk($idCourse),
				'atividades'  => $curso->cursoModulosTarefaForumQuest(Yii::app()->user->profileUser['idmoodle'],
																	  $idCourse)
		));
	}

	public function actionNotas()
	{
		$userId 	  = Yii::app()->user->id;
		$idCourse 	  = Yii::app()->getRequest()->getParam('id');

		$curso         = new Curso();
		$notaCurso     = new NotaCurso();
		$notaAtividade = new NotaAtividade();

		$notaCurso->setAttributes(array('userid'=>Yii::app()->user->profileUser['idmoodle'],
										'courseid'=>$idCourse));
		$notaAtividade->setAttributes(array('userid'=>Yii::app()->user->profileUser['idmoodle'],
											'idcurso'=>$idCourse));

		$this->render('mainNotas',array(
				'curso'         => $curso->findByPk($idCourse),
				'notaCurso'     => $notaCurso->search(),
				'notaAtividade' => $notaAtividade->search()
		));
	}

	public function actionDashBoard()
	{
		$userId  = Yii::app()->user->id;

		$curso       = new Curso();
		$cursoTurma  = new CursoTurma();
		$curso->unsetAttributes();

		if(isset($_POST['Curso'])) {
			$curso->attributes=$_POST['Curso'];
		}

		$this->render('dashBoard',array(
				'pendentes' 	=> $curso->atividadesPendentes($userId),
				'semana'    	=> $curso->atividadesSemana($userId),
				'aberto'        => $curso->cursosEmAberto($userId),
				'naolidas'      => $curso->mensagensNaoLidas($userId),
				'cursosAluno'   => $curso->findAllBySql($curso->listCursosAluno($userId)),
				'curso' 	    => $curso,
				'cursoTurma'    => $cursoTurma
		));
	}

	public function actionAtividadesAtrasadas($idCurso = NULL)
	{
		$userId  = Yii::app()->user->id;
		$curso = new Curso();

		$this->render('atividadesAtrasadas',array(
				'atividades' 	=> $curso->detalheAtividadesPendentes($userId, $idCurso)
		));

	}

	public function actionAtividadesSemana($idCurso = NULL)
	{
		$userId  = Yii::app()->user->id;
		$curso = new Curso();

		$this->render('atividadesSemana',array(
				'atividades' 	=> $curso->atividadesSemana($userId, FALSE)
		));

	}

	public function actionMensagemPortal()
	{
		$this->title = Yii::t('app', 'title.mensagemPortal');
		$userId  = Yii::app()->user->id;

		$dadosMensagem = Yii::app()->getRequest()->getParam('Mensagem');

		$cursoTurmaDados['idcourse'] = Yii::app()->getRequest()->getParam('idcourse');
		$cursoTurmaDados['id']       = Yii::app()->getRequest()->getParam('id');

		$mensagem   = new Mensagem();
		$cursoTurma = new CursoTurma();
		$curso      = new Curso();

		if($dadosMensagem != '') {
			$mensagem->setAttributes($dadosMensagem);
			$mensagem->status = $dadosMensagem['status'];
		}

		$cursoTurma->unsetAttributes();  // clear any default values
		$cursoTurma->attributes = $cursoTurmaDados;

		$this->render('mensagemPortal', array(
				'model'     => $mensagem,
				'mensagem' 	=> $mensagem->mensagemPortal($userId, FALSE, $cursoTurma)
		));

	}

	public function actionVisualizarMensagemPortal()
	{
		$this->title = Yii::t('app', 'title.mensagemPortal');

		$atualiza = Yii::app()->getRequest()->getParam('atualiza');
		$idmensagem = Yii::app()->getRequest()->getParam('idmensagem');

		$mensagem   = new Mensagem();

		$mensagem->unsetAttributes();  // clear any default values
		$mensagem->setAttribute('idmensagem', $idmensagem);

		if($atualiza == 's') {
			$mensagLida = new UsuarioMensagemLida();

			$mensagLida->setAttribute('idmensagem', $idmensagem);
			$mensagLida->setAttribute('idusuario', Yii::app()->user->id);
			$mensagLida->setAttribute('dtleitura', date('Y-m-d'));

			$mensagLida->save();

		}

		$this->render('/mensagem/visualizarMensagemPortal', array(
				'mensagem' 	=> $mensagem->mensagemComRemetente()
		));
	}

	public function actionAvaliacaoPesquisa()
	{
		$contInscricao = new ControleInscricao();

		$this->render('avaliacaoPesquisa', array(
				'avaliacaoPesquisa' 	=> $contInscricao->avaliacaoPesquisa(Yii::app()->user->id, NULL, FALSE, FALSE)
		));
	}

}