<?php
/**
 * [Descrição do arquivo].
 *
 * [mais informações precisa ter 1 [ENTER] para definir novo parágrafo]
 *
 * [pode usar quantas linhas forem necessárias]
 * [linhas logo abaixo como esta, são consideradas mesmo parágrafo]
 *
 * @package CursoController* @category [Categoria a que o arquivo pertence]
 * @name Controle
 * @author [nome do autor] - [e-mail do autor]
 * @copyright Projeto Sinase 2012
 * @license [link da licença] [Nome da licença]
 * @link [link de onde pode ser encontrado esse arquivo]
 * @version 0.01
 * @since 2012/09/02*/

class CursoController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout='//layouts/column2';
	public $title=null;

	public function init()
	{
		$this->title = Yii::t('app', 'title.curso');
	}

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
				'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
				array('allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('main','delete','index','view','create',
								'update','emAndamento','detalhe', 'aberto',
								'inscricao', 'inscricaoSave', 'finalizados',
								'usuarioPapel', 'designarPapel', 'modalVincularPapel'
						),
						'users'=>array('admin')

				),
				array('allow',
						'actions'=>array('emAndamento', 'aberto', 'finalizados', 'detalhe', 'index', 'usuarioPapel','view','create', 'update', 'delete', 'inscricao', 'inscricaoSave'),
						'users'=>array('supervisor')
				),
				array('allow',
						'actions'=>array('emAndamento', 'aberto', 'finalizados', 'detalhe','view','create', 'update', 'delete'),
						'users'=>array('tutor')
				),
				array('allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('emAndamento','detalhe', 'aberto', 'inscricao', 'inscricaoSave', 'finalizados', 'usuarioPapel'
						),
						'users'=>array('aluno')

				),
				array('deny',  // deny all users
						'users'=>array('*'),
				),
		);
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.view').$this->title;

		$this->render('view',array(
				'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.create').$this->title;

		$model=new Curso;
		if(isset($_POST['Curso'])){
			$model->attributes= $_POST['Curso'];
			if($model->preCreate())
				$this->redirect(array('view','id'=>$model->id));
		}

		$this->render('create',array(
				'model'			=> $model,
				'listCategorias'=> CursoCategoria::listCategorias(),
				'listNuModulos'	=> Curso::getNuModulos()
		));
	}

	public function actionDesignarPapel($id)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.designarPapelCurso');
		$Usuario=new Usuario('designarPapel');
		$Usuario->unsetAttributes();  // clear any default values
		$Usuario->inscritos = 2;

		$modelCursoUsuarioPapel = new CursoUsuarioPapel();
		$modelCursoUsuarioPapel->setAttribute('idcurso',$id);
		if(isset($_POST['Usuario'])){
			$Usuario->attributes=$_POST['Usuario'];
			$Usuario->validate();

			$modelCursoUsuarioPapel->setAttribute('dcnome', $_POST['Usuario']['dcnome']);
		}

		if(isset($_POST['vincular']))
		{
			$modelCursoUsuarioPapel->roleid=$_POST['vincular']['idpapel'];
			$modelCursoUsuarioPapel->userid=$_POST['vincular']['userid'];
			$modelCursoUsuarioPapel->contextid=$_POST['vincular']['contextid'];

			$modelCursoUsuarioPapel->vincularPapelUsuario($_POST['vincular']['idpapelatual']);

			$Usuario->unsetAttributes();
			$modelCursoUsuarioPapel->unsetAttributes();
			yii::app()->getRequest()->redirect(Yii::app()->createUrl("curso/designarPapel", array("id"=>$id)));
		}
		$model=new Curso();

		$this->render('designarPapel',array(
				'model'=>$this->loadModel($id),
				'usuario'=>$Usuario,
				'cursoUsuarioPapel'=>$modelCursoUsuarioPapel->searchActiveUser($Usuario->inscritos)
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionModalVincularPapel($userid, $idcource)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.designarPapelCurso');

		$modelPapel=new CursoPapel();

		if(isset($_GET['Curso']))
			$model->attributes=$_POST['Curso'];

		$modelCursoUsuarioPapel = new CursoUsuarioPapel('search');
		$modelCursoUsuarioPapel->userid = $userid;
		$modelCursoUsuarioPapel->idcurso = $idcource;

		$list = $modelCursoUsuarioPapel->listaUsuarioPapel(2);

		if (count($list)>0 && !empty($userid)){
			$modelPapel->idPapelInscrito = $list[0]->roleid;
		}else{
			$curso = new Curso();
			$curso->id = $idcource;
			$list = $curso->searchFind();
		}

		$this->renderPartial('modalVincularPapel',
				array(
						'userid' 	=> $userid,
						'idcource' 	=> $idcource,
						'contextid' => $list[0]->contextid,
						'modelPapel'=> $modelPapel,
				),
				false
		);
	}

	public function actionInscricao($idProj, $idCurso)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.inscricao');

		$model=new Curso;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['resposta']))
		{
			if($model->preInscricao($_POST['resposta']))
			{
				$this->redirect(array('detalhe','idcurso'=>$model->id));
			}
		}

		$this->render('inscricao',array(
				'model'=>$model->find('idprojeto=:idProj and id=:idCurso',
						array(':idProj'=>$idProj, 'idCurso'=>$idCurso)),
		));
	}
	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.update').$this->title;

		$model=$this->loadModel($id);

		if(isset($_POST['Curso'])){
			$model->attributes=$_POST['Curso'];
			if($model->preUpdate())
				$this->redirect(array('view','id'=>$model->id));
		}

		$this->render('update',array(
				'model'			=> $model,
				'listCategorias'=> CursoCategoria::listCategorias(),
				'listNuModulos'	=> Curso::getNuModulos()
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		if(Yii::app()->request->isPostRequest)
		{
			// we only allow deletion via POST request
			Curso::preDelete($id);

			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_GET['ajax']))
				$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('main'));
		}
		else
			throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$this->actionMain();
	}

	/**
	 * Manages all models.
	 */
	public function actionMain()
	{
		$model=new Curso('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Curso']))
			$model->attributes=$_GET['Curso'];

		$this->render('main',array(
				'model'			=> $model,
				'listCategorias'=> CursoCategoria::listCategorias()
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the ID of the model to be loaded
	 */
	public function loadModel($id)
	{
		$model=Curso::preFind($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param CModel the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='vw-curso-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}

	/**
	 * Manages all models.
	 */
	public function actionEmAndamento()
	{
		$this->title = 'Cursos em Andamento';

		$model=new Curso();
		$model->unsetAttributes();  // clear any default values
		if (isset($_POST['Curso']['dtfimcurso'])) {
			$model->setAttribute('dtiniciocurso', strtotime($_POST['Curso']['dtiniciocurso']));
			$model->setAttribute('dtfimcurso', strtotime($_POST['Curso']['dtfimcurso']));
			$model->setScenario('buscaAndamento');
			$model->validate();
			$model->attributes=$_POST['Curso'];
		}

		$this->render('mainAndamento',array(
				'model' => $model
		));
	}

	/**
	 * Manages all models.
	 */
	public function actionFinalizados()
	{
		$this->title = 'Cursos Finalizados';

		$model=new Curso('search');
		$model->unsetAttributes();  // clear any default values
		if (isset($_POST['Curso'])) {
			$model->attributes=$_POST['Curso'];
			$model->setScenario('buscaAndamento');
			$model->validate();
		}

		$this->render('mainFinalizado',array(
				'model'    	  => $model
		));
	}

	public function actionDetalhe($idcurso)
	{
		// Informe o Título da view
		$this->title = 'Detalhes do Curso';

		$this->render('detalhe',array(
				'dadosCurso'       => $this->loadModel($idcurso),
				'qtdParticipantes' => CursoParticipante::qtdParticipantes($idcurso)
		));
	}

	/**
	 * Manages all models.
	 */
	public function actionAberto()
	{
		$this->title = Yii::t('app', 'title.cursoEmAberto');
		$model=new Curso();
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Curso'])){
			$model->attributes=$_GET['Curso'];
		}
		$this->render('mainAberto',array(
				'model'	=> $model,
		));
	}

	/**
	 * Manages all models.
	 */
	public function actionUsuarioPapel()
	{
		$this->title = Yii::t('app', 'title.cursoPapel');
		$model=new Curso('search');

		$model->unsetAttributes();  // clear any default values
		if(isset($_POST['Curso']))
			$model->attributes=$_POST['Curso'];

		$this->render('mainUsuarioPapel',array(
				'model'	=> $model,
		));
	}

}
