<?php
/**
 * [Descrição do arquivo].
 *
 * [mais informações precisa ter 1 [ENTER] para definir novo parágrafo]
 *
 * [pode usar quantas linhas forem necessárias]
 * [linhas logo abaixo como esta, são consideradas mesmo parágrafo]
 *
 * @package CursoTurmaController* @category [Categoria a que o arquivo pertence]
 * @name Controle
 * @author [nome do autor] - [e-mail do autor]
 * @copyright Projeto Sinase 2012
 * @license [link da licença] [Nome da licença]
 * @link [link de onde pode ser encontrado esse arquivo]
 * @version 0.01
 * @since 2012/09/06*/

class CursoTurmaController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout='//layouts/column2';
	public $title= null;

	public function init()
	{
		$this->title = Yii::t('app', 'title.cursoTurma');
	}

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
				'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
				array('allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('main','delete','index','view','create','update','comboTurmaIdCurso'),
						'users'=>array('admin', 'aluno','tutor','supervisor'),
				),
				array('deny',  // deny all users
						'users'=>array('*'),
				),
		);
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.view').$this->title;

		$this->render('view',array(
				'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.create').$this->title;

		$model=new CursoTurma;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['CursoTurma']))
		{
			$model->attributes=$_POST['CursoTurma'];
			if($model->preCreate())
				$this->redirect(array('view','id'=>$model->id));
		}

		$this->render('create',array(
				'model'=>$model,
				'listCursos'=> Curso::listCursos(),
		));
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.update').$this->title;

		$model=$this->loadModel($id);

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['CursoTurma']))
		{
			$model->attributes=$_POST['CursoTurma'];
			if($model->preUpdate())
				$this->redirect(array('view','id'=>$model->id));
		}

		$this->render('update',array(
				'model'=>$model,
				'listCursos'=> Curso::listCursos(),
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		if(Yii::app()->request->isPostRequest)
		{
			// we only allow deletion via POST request
			CursoTurma::preDelete($id);

			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_GET['ajax']))
				$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('main'));
		}
		else
			throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$this->actionMain();
	}

	/**
	 * Manages all models.
	 */
	public function actionMain()
	{
		$model=new CursoTurma('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['CursoTurma']))
			$model->attributes=$_GET['CursoTurma'];

		$this->render('main',array(
				'model'		=> $model,
				'listCursos'=> Curso::listCursos(),
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the ID of the model to be loaded
	 */
	public function loadModel($id)
	{
		$model=CursoTurma::preFind($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param CModel the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='vw-cursoTurma-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}

	public function actionComboTurmaIdCurso()
	{
		$model=new CursoTurma('search');
		if(strtolower(Yii::app()->user->profileUser['coperfilacesso']) == 'supervisor') {
			$data=$model->findAll('courseid= :courseid',
					array(':courseid'=>(int) $_POST['Curso']['id']));
				
		} else {
			$curso = new Curso();
			$curso->setAttribute('courseid', $_POST['Curso']['id']);
			
			$data['userid'] = Yii::app()->user->profileUser['idmoodle'];
			
			$data['roleid'] = Yii::app()->user->profileUser['idpapel'];
			
			$data = $model->gridListaTurma($data, NULL, $curso);
			
			$data = $model->findAll($data);
		}

		$data=CHtml::listData($data,'id','name');

		if(count($data) > 0 ) {
			echo CHtml::tag('option',
					array('value'=>''),CHtml::encode('Selecione uma Turma'),true);
		}

		foreach($data as $value=>$name)
		{
			echo CHtml::tag('option',
					array('value'=>$value),CHtml::encode($name),true);
		}

		Yii::app()->end();
	}
}
