<?php
/**
 * [Descrição do arquivo].
 *
 * [mais informações precisa ter 1 [ENTER] para definir novo parágrafo]
 *
 * [pode usar quantas linhas forem necessárias]
 * [linhas logo abaixo como esta, são consideradas mesmo parágrafo]
 *
 * @package FormarTurmaController* @category [Categoria a que o arquivo pertence]
 * @name Controle
 * @author [nome do autor] - [e-mail do autor]
 * @copyright Projeto Sinase 2012
 * @license [link da licença] [Nome da licença]
 * @link [link de onde pode ser encontrado esse arquivo]
 * @version 0.01
 * @since 2012/09/02*/

class FormarTurmaController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout='//layouts/column2';
	public $title=null;

	public function init()
	{
		$this->title = Yii::t('app', 'title.formarTurma');
	}

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
				'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
				array('allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('main', 'index', 'detalhe', 'enturmar', 'pesquisarAluno',
								'create', 'listOptionsCurso', 'savePesquisa', 'deletePesquisa',
								'deleteCondicao', 'listPesquisa', 'preEnturmarAluno', 'enturmarAluno',
								'listOptionsFaixaIdade', 'listOptionsResposta', 'listOptionsQuestao',
								'listOptionsQuestionario', 'listDadosUsuario', 'listDadosUsuarioDesenturmar',
								'desenturmarAluno', 'retirarPreEnturmarAluno'
						),
						'users'=>array('admin', 'supervisor'),
				),
				array('deny',  // deny all users
						'users'=>array('*'),
				),
		);
	}

	public function actionListOptionsCurso()
	{
		$idprojeto = $_POST['projetoCurso'];

		$data=Curso::model()->findAll('visible=:in and idprojeto=:idprojeto', array(':in'=>'1', ':idprojeto'=> $idprojeto['idprojeto']));
		$data=CHtml::listData($data,'id','fullname');

		$option = CHtml::tag('option', array('value'=>""), CHtml::encode(Yii::t('app', 'generic.selecioneUm', strtolower(Yii::t('app', 'curso.fullname')))),true);

		foreach($data as $value=>$name){
			$option .= CHtml::tag('option', array('value'=>$value),CHtml::encode($name),true);
		}

		echo($option);
	}

	public function actionListOptionsFaixaIdade()
	{
		$faixaIni = $_POST['formacaoCadastral'];
		$data=Usuario::model()->getFaixaIdade($faixaIni['nuFaixaEtariaInicio']);
		$data=CHtml::listData($data,'id','name');

		$option = CHtml::tag('option', array('value'=>""), CHtml::encode(Yii::t('app', 'generic.faixaFinal')), true);

		foreach($data as $value=>$name){
			$option .= CHtml::tag('option', array('value'=>$value),CHtml::encode($name),true);
		}

		echo($option);
	}

	public function actionListOptionsQuestionario()
	{
		$post = $_POST['pesquisaAvaliacao'];
		$data=Questionario::model()->findAll('inativo=:in and idgrupoquestionario=:idgrupoquestionario',
				array(':in'=>'true', ':idgrupoquestionario'=> $post['idgrupoquestionario']));
		$data=CHtml::listData($data,'idquestionario','dcformulario');

		$option = CHtml::tag('option', array('value'=>""),
				CHtml::encode(Yii::t('app', 'generic.selecioneUm', Yii::t('app', 'formarTurma.pesquisa'))), true);

		foreach($data as $value=>$name){
			$option .= CHtml::tag('option', array('value'=>$value),CHtml::encode($name),true);
		}

		echo($option);
	}

	public function actionListOptionsQuestao()
	{
		$post = $_POST['pesquisaAvaliacao'];
		$data=Questao::model()->findAll('cotipoquestao in (\'COMBO\', \'RADIO\') and idquestionario=:idquestionario',
				array(':idquestionario'=> $post['idquestionario']));
		$data=CHtml::listData($data,'idquestao','dcquestao');

		$option = CHtml::tag('option', array('value'=>""),
				CHtml::encode(Yii::t('app', 'generic.selecioneUma', Yii::t('app', 'formarTurma.questao'))), true);

		foreach($data as $value=>$name){
			$option .= CHtml::tag('option', array('value'=>$value),CHtml::encode($name),true);
		}

		echo($option);
	}

	public function actionListOptionsResposta()
	{
		$post = $_POST['pesquisaAvaliacao'];
		$data=Resposta::model()->findAll('idquestao=:idquestao',
				array(':idquestao'=> $post['idquestao']));
		$data=CHtml::listData($data,'idresposta','dcresposta');

		$option = CHtml::tag('option', array('value'=>""),
				CHtml::encode(Yii::t('app', 'generic.selecioneUma', Yii::t('app', 'formarTurma.resposta'))), true);

		foreach($data as $value=>$name){
			$option .= CHtml::tag('option', array('value'=>$value),CHtml::encode($name),true);
		}

		echo($option);
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.view').$this->title;

		$this->render('view',array(
				'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$this->actionMain();
	}

	/**
	 * Manages all models.
	 */
	public function actionMain()
	{
		$model=new Curso('search');
		$model->unsetAttributes();  // clear any default values

		if(isset($_GET['Curso']))
			$model->attributes=$_GET['Curso'];

		$this->render('main',array(
				'model' => $model,
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the ID of the model to be loaded
	 */
	public function loadModel($id)
	{
		$model=Curso::preFind($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

// 	public function actionDetalhe($id)
// 	{
// 		// Informe o Título da view
// 		$this->title = 'Detalhes do Curso';

// 		$this->render('detalhe',array(
// 				'dadosCurso'       => $this->loadModel($id),
// 				'qtdParticipantes' => CursoParticipante::qtdParticipantes($id)
// 		));
// 	}

	public function actionPesquisarAluno($idprojeto, $idcurso, $idpesquisa = null)
	{
		// Informe o Título da view
		$this->title = 'Detalhes do Curso';

		$curso = new Curso();
		$pesquisa = new Pesquisa();

		$modelPesquisa = ($idpesquisa)?$pesquisa->preFind($idpesquisa):$pesquisa;
		if (!$modelPesquisa)
			$modelPesquisa = $pesquisa;

		$modelPesquisa->idcurso = $idcurso;
		$modelPesquisa->idprojeto = $idprojeto;

		$listCurso = $curso->find('idprojeto=:idprojeto and id=:idcurso',
				array(':idprojeto'=>$idprojeto, ':idcurso'=>$idcurso));

		$condicao = ($idpesquisa)?Condicao::model()->find('idpesquisa=:id and cotipopesquisa=:coTipo',
				array(':id'=>$idpesquisa, ':coTipo'=>'FCA')):new Condicao();
		$condicao = ($condicao)?$condicao:new Condicao();
		$listCondicaoFCA = unserialize($condicao->txcondicao);

		$UsuarioEnturmado = new UsuarioEnturmado();

		$this->render('pesquisarAluno',array(
				'curso' 	=> $listCurso,
				'pesquisa'	=> $modelPesquisa,
				'condicao'	=> $condicao,
				'UsuarioEnturmado'	=> new UsuarioEnturmado(),
				'listCondicaoFCA'	=> $listCondicaoFCA,
				'listEnturmarAluno' => $UsuarioEnturmado->listAlunoEnturmado($listCurso->idprojeto, $idcurso),
				'listCondicaoPAA'	=> Condicao::listCondicaoTipo($condicao->idpesquisa, 'PAA'),
				'listCondicaoPCA'	=> Condicao::listCondicaoTipo($condicao->idpesquisa, 'PCA'),
				'listFaixaEtariaFim'=> Usuario::model()->getFaixaIdade($listCondicaoFCA['nuFaixaEtariaInicio']),
				'listUf'	=> Uf::model()->findAll()
		));
	}

	public function actionListPesquisa($idprojeto, $idcurso)
	{
		$Pesquisa = new Pesquisa();
		if(isset($_GET['Pesquisa']))
			$Pesquisa->attributes = $_GET['Pesquisa'];
		$Pesquisa->idprojeto = $idprojeto;
		$Pesquisa->idcurso = $idcurso;

		$this->renderPartial('_viewPesquisa',array(
				'Pesquisa' => $Pesquisa,
		));
	}

	public function actionPreEnturmarAluno($idpesquisa, $idprojeto, $idcurso)
	{
		$Pesquisa = new Pesquisa();

		if(isset($_POST['preEnturmarAluno']['idusuario']))
		{
			$ControleInscricao = new ControleInscricao();
			$ControleInscricao->attributes = $_POST['preEnturmarAluno'];

			if($ControleInscricao->savePreEnturmarAluno($idprojeto, $idcurso))
				Yii::app()->user->setFlash('success', Yii::t('app', 'success.registroSalvoSucesso'));
			else
				Yii::app()->user->setFlash('error', Yii::t('app', 'erro.desconhecido'));
		}

		$Pesquisa->idpesquisa = $_GET['idpesquisa'];
		$listBuscaCurso = $Pesquisa->listBuscaCurso($idprojeto, $idcurso);

		$this->renderPartial('_tab3_formResultadoBusca',
				array(
						'idprojeto' => $idprojeto,
						'idcurso' => $idcurso,
						'Pesquisa' => $Pesquisa,
						'listPesquisa' => new CArrayDataProvider($listBuscaCurso)));
	}

	public function actionRetirarPreEnturmarAluno($idprojeto, $idcurso)
	{
		$Pesquisa = new Pesquisa();

		if(isset($_POST['enturmarAluno']['idusuario']))
		{
			$ControleInscricao = new ControleInscricao();
			$ControleInscricao->attributes = $_POST['enturmarAluno'];

			unset($_POST['enturmarAluno']['idusuario']);

			if($ControleInscricao->saveRetirarPreEnturmarAluno($idprojeto, $idcurso))
				Yii::app()->user->setFlash('successPesquisa', Yii::t('app', 'success.registroSalvoSucesso'));
		}

		$this->actionEnturmarAluno($idprojeto, $idcurso);
	}

	/**
	 * @param integer $idpesquisa
	 */
	public function actionEnturmarAluno($idprojeto, $idcurso)
	{
		$ControleInscricao = new ControleInscricao();
		$curso = new Curso();

		if(isset($_POST['enturmarAluno']['idusuario']))
		{
			$ControleInscricao->attributes = $_POST['enturmarAluno'];
			if($ControleInscricao->saveEnturmarAluno($idprojeto, $idcurso, $_POST['enturmarAluno']['idturma']))
				Yii::app()->user->setFlash('success', Yii::t('app', 'formarTurma.alunoEnturmadoSucesso'));
			else
				Yii::app()->user->setFlash('error', Yii::t('app', 'erro.desconhecido'));
		}

		$listEnturmarAluno = $ControleInscricao->listEnturmarAluno($idprojeto, $idcurso);

		$this->renderPartial('_tab4_formEnturmarAluno',
				array(	'idprojeto' => $idprojeto,
						'idcurso' => $idcurso,
						'ControleInscricao'=>$ControleInscricao,
						'curso' => $curso->preFind($idcurso),
						'listEnturmarAluno' =>  new CArrayDataProvider($listEnturmarAluno)));
	}


	/**
	 * @param integer $idpesquisa
	 */
	public function actionDesenturmarAluno($idprojeto, $idcurso, $idusuario)
	{
		if(isset($idusuario))
		{
			$ControleInscricao = new ControleInscricao();
			if( $ControleInscricao->saveDesenturmarAluno($idprojeto, $idcurso, $idusuario) )
				Yii::app()->user->setFlash('success', Yii::t('app', 'formarTurma.alunoDesenturmadoSucesso'));
			else
				Yii::app()->user->setFlash('error', Yii::t('app', 'erro.desconhecido'));
		}

		$this->actionEnturmarAluno($idprojeto, $idcurso);
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate($type)
	{
		$condicao=new Condicao();

		if(!$condicao->idcondicao && isset($_POST[$type])){
			$condicao->data = $_POST[$type];
			$condicao->attributes = $_POST['condicao'];
			$condicao->idcondicao = isset($_POST['condicao']['idcondicao'])?$_POST['condicao']['idcondicao']:null;
			$condicao->preCreate($type);
		}

		$pesquisa = new Pesquisa();
		$pesquisa->idcurso = isset($_POST['condicao']['idcurso'])?$_POST['condicao']['idcurso']:$_GET['idcurso'];
		$pesquisa->idpesquisa = isset($_POST['condicao']['idpesquisa'])?$_POST['condicao']['idpesquisa']:$_GET['idpesquisa'];

		$this->$type($type, $condicao, $pesquisa);
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	private function formacaoCadastral($type, $condicao, $pesquisa)
	{
		$listFaixaEtariaFim = Usuario::model()->getFaixaIdade($condicao['data']['nuFaixaEtariaInicio']);
		$this->renderPartial('_tab2_form'.ucfirst($type),array(
				'condicao'			=> $condicao,
				'pesquisa'			=> $pesquisa,
				'listCondicaoFCA'	=> $condicao->data,
				'listUf'			=> Uf::model()->findAll(),
				'listFaixaEtariaFim'=> $listFaixaEtariaFim
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	private function pesquisaAvaliacao($type, $condicao, $pesquisa)
	{
		$this->renderPartial('_tab2_form'.ucfirst($type),array(
				'condicao'	=> $condicao,
				'pesquisa'	=> $pesquisa,
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	private function projetoCurso($type, $condicao, $pesquisa)
	{
		$this->renderPartial('_tab2_form'.ucfirst($type),array(
				'condicao'	=> $condicao,
				'pesquisa'	=> $pesquisa,
		));
	}


	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the $idusuario of the model to be loaded
	 */
	public function actionListDadosUsuario($idusuario)
	{
		$model=Usuario::model()->findByPk($idusuario);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');

		$this->renderPartial('_viewDadosUsuario',array(
				'model' => $model,
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the $idusuario of the model to be loaded
	 */
	public function actionListDadosUsuarioDesenturmar($idprojeto, $idcurso, $idusuario)
	{
		$model=Usuario::model()->findByPk($idusuario);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');

		$this->renderPartial('_viewDadosUsuarioDesenturmar',array(
				'model' => $model,
				'idprojeto' => $idprojeto,
				'idcurso' => $idcurso,
				'idusuario' => $idusuario,
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionSavePesquisa($idpesquisa)
	{
		$Curso = new Curso();

		$modelPesquisa = ($idpesquisa)?Pesquisa::preFind($idpesquisa):new Pesquisa();

		if (empty($modelPesquisa->idpesquisa)){
			$modelPesquisa = new Pesquisa();
			$modelPesquisa->inCreate = true;
		}

		if(isset($_POST['Pesquisa']))
		{
			$Curso->attributes=$_POST['Pesquisa'];

			$modelPesquisa->attributes = $_POST['Pesquisa'];
			$modelPesquisa->idprojeto = $_POST['Pesquisa']['idprojeto'];
			$modelPesquisa->idcurso = $_POST['Pesquisa']['idcurso'];

			if($modelPesquisa->savePesquisa())
				Yii::app()->user->setFlash('successPesquisa', Yii::t('app', 'success.registroSalvoSucesso'));
			else{
				$modelPesquisa->inCreate = false;
			}
		}

		$this->renderPartial('_tab2_formPesquisa',array(
				'pesquisa' => $modelPesquisa,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDeletePesquisa($idprojeto, $idcurso, $idpesquisa)
	{
		if(Yii::app()->request->isPostRequest)
		{
			// we only allow deletion via POST request
			Pesquisa::preDelete($idpesquisa);
			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
		}
		self::actionListPesquisa($idprojeto, $idcurso);
		// 			throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}


	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDeleteCondicao($idcondicao)
	{
		if(Yii::app()->request->isPostRequest){
			// we only allow deletion via POST request
			Condicao::preDelete($idcondicao);
		}
		else
			throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}

	/**
	 * Performs the AJAX validation.
	 * @param CModel the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='vw-curso-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
}
