<?php

class IndicadoresController extends Controller
{
	public $layout='//layouts/column2';
	public $title=null;
	public $shortname;

	public function init()
	{
		$this->title = Yii::t('app', 'title.indicadores');
	}

	public function filters()
	{
		return array(
				'accessControl', // perform access control for CRUD operations
		);
	}
	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
				array('allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('main','delete','index','view','create','update','listaIndicador1','listaIndicador1Detalhe'),
						'users'=>array('admin','gestor'),
				),
				array('deny',  // deny all users
						'users'=>array('*'),
				),
		);
	}

	public function actionIndex()
	{
		$this->render('index');
	}

	public function actionListaIndicador1()
	{
		$curso = NULL;
		$turma = NULL;

		$cursoObj = new Curso();
        $cursoObj->unsetAttributes();
		if (isset($_REQUEST['Curso'])) {
			$cursoObj->setAttributes($_REQUEST['Curso']);
		}

		$turmaObj = new CursoTurma();
        $turmaObj->unsetAttributes();
		if (isset($_REQUEST['CursoTurma'])) {
			$turmaObj->setAttributes($_REQUEST['CursoTurma']);
		}

		$status = (isset($_REQUEST['Curso']['situacao']))?$_REQUEST['Curso']['situacao']:NULL;

		$this->render('listaIndicador1',
				array(
						'model'   => $cursoObj,
						'turma'   => $turmaObj,
						'situacao'=> $status
				)
		);
	}

	public function actionListaIndicador1Detalhe()
	{
		$curso = NULL;
		$turma = NULL;

		$cursoObj = new Curso();
        $cursoObj->unsetAttributes();
		if (isset($_REQUEST['curso'])) {
			$cursoObj->setAttributes($_REQUEST['curso']);
		}

		$turmaObj = new CursoTurma();
        $turmaObj->unsetAttributes();
		if (isset($_REQUEST['turma'])) {
			$turmaObj->setAttributes($_REQUEST['turma']);
		}

		$status = (isset($_REQUEST['situacao']))?$_REQUEST['situacao']:NULL;

		if (isset($_REQUEST['uf'])) {
			$uf = $_REQUEST['uf'];
		}

		$this->render('listaIndicador1Detalhe',
				array(
						'model'       => $cursoObj,
						'turma'       => $turmaObj,
						'situacao'    => $status,
						'uf'          => $uf,
				)
		);
	}
}