<?php
/**
 * [Descrição do arquivo].
 *
 * [mais informações precisa ter 1 [ENTER] para definir novo parágrafo]
 *
 * [pode usar quantas linhas forem necessárias]
 * [linhas logo abaixo como esta, são consideradas mesmo parágrafo]
 *
 * @package QuestionarioController* @category [Categoria a que o arquivo pertence]
 * @name Controle
 * @author [nome do autor] - [e-mail do autor]
 * @copyright Projeto Sinase 2012
 * @license [link da licença] [Nome da licença]
 * @link [link de onde pode ser encontrado esse arquivo]
 * @version 0.01
 * @since 2012/08/16*/

class QuestionarioController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout='//layouts/column2';

	public function init()
	{
		$this->title = Yii::t('app', 'title.questionario');
	}

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
				'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
				array('allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('main','delete','index','view','create','update', 'responder', 'respostaSave',
								'visualizar', 'acompanharAvaliacao', 'visualizarPesquisas', 'exportarPesquisas',
								'enviarPesquisa', 'visualizarAssocPesquisas', 'novaAssocPesquisa',
								'procurarPesquisa', 'excluirAssocPesquisa'),
						'users'=>array('admin', 'supervisor'),
				),
				array('allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('responder'),
						'users'=>array('aluno'),
				),
				array('deny',  // deny all users
						'users'=>array('*'),
				),
		);
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.view').$this->title;

		$this->render('view',array(
				'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionResponder($id)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.questionarioResponder');

		$this->render('viewQuestionario',array(
				'model'     => Questionario::listMontarQuestionario($id),
				'idQuestionario' => $id,
				'urlCancel' => array('questionario/index')
 		));
	}



	public function actionAvaliacaoPesquisa($id)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.questionarioResponder');

		$this->render('viewQuestionario',array(
				'model'         => Questionario::listMontarQuestionario($id),
				'idQuestionario' => $id,
				'urlCancel'     => array('aluno/avaliacaoPesquisa')
		));
	}


	/**
	 * Display the layout of a model
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionVisualizar($id)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.questionarioVisualizar');
        if (trim(Yii::app()->getRequest()->getParam('idprojeto'))!='' && trim(Yii::app()->getRequest()->getParam('idcursomoodle'))!='')
            $urlCancel = array('questionario/visualizarPesquisas','idprojeto'=>Yii::app()->getRequest()->getParam('idprojeto'),'idcursomoodle'=>Yii::app()->getRequest()->getParam('idcursomoodle'));
        else
            $urlCancel = array('questionario/index');
		$this->render('viewQuestionario',array(
				'urlCancel' => $urlCancel,
				'idQuestionario' => intval($id),
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionRespostaSave()
	{
		// Informe o Título da view
		$this->title = 'Criar novo '.$this->title;

		$model=new Questionario;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['resposta']))
		{
			if($model->preCreateResposta($_POST['resposta']))
				$this->render(	'viewQuestionario',
						array(
								'model'=>$model,
						)
				);
		}

		$this->render('viewQuestionario',array(
				'model'=>$model,
		));
	}
	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		// Informe o Título da view
		$this->title = 'Criar novo '.$this->title;

		$model=new Questionario;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Questionario']))
		{
			$model->attributes=$_POST['Questionario'];
			if($model->preCreate())
				$this->redirect(array('view','id'=>$model->idquestionario));
		}

		$this->render('create',array(
				'model'=>$model,
		));
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		// Informe o Título da view
		$this->title = 'Atualizar '.$this->title;

		$model=$this->loadModel($id);

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Questionario']))
		{
			$model->attributes=$_POST['Questionario'];
			if($model->preUpdate())
				$this->redirect(array('view','id'=>$model->idquestionario));
		}

		$this->render('update',array(
				'model'=>$model,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		if(Yii::app()->request->isPostRequest)
		{
			// we only allow deletion via POST request
			Questionario::preDelete($id);

			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_GET['ajax']))
				$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('main'));
		}
		else
			throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$this->actionMain();
	}

	/**
	 * Manages all models.
	 */
	public function actionMain()
	{
		$model=new Questionario('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Questionario']))
			$model->attributes=$_GET['Questionario'];

		$this->render('main',array(
				'model'=>$model,
		));
	}

	public function actionAcompanharAvaliacao()
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.acompanharAvaliacao');

		$model = new ProjetoCurso('search');
		$model->unsetAttributes();  // clear any default values

		if( isset($_GET['ProjetoCurso']) ) {
			$pesquisa = $_GET['ProjetoCurso'];
			foreach( $pesquisa as $key => $value ) {
				$model->{$key} = $value;
			}
		}

		$this->render('acompanharAvaliacao',array(
				'model'=>$model,
		));
	}

	public function actionEnviarPesquisa()
	{
		$model = new ProjetoCurso('search2');
		$model->unsetAttributes();  // clear any default values

		if( isset($_GET['ProjetoCurso']) ) {
			$pesquisa = $_GET['ProjetoCurso'];
			foreach( $pesquisa as $key => $value ) {
				$model->{$key} = $value;
			}
		}

		$this->render('enviarPesquisa',array(
				'model'=>$model,
		));
	}

	public function actionVisualizarAssocPesquisas()
	{
		$model = new ProjetoCurso('search3');
		$model->unsetAttributes();

		$model->idprojeto = $_GET['idprojeto'];
		$model->nome_projeto = $model->getProjeto($model);

		$model->idcursomoodle = $_GET['idcursomoodle'];
		$model->nome_curso = $model->getCurso($model);

		if( isset($_GET['ProjetoCurso']) ) {
			$pesquisa = $_GET['ProjetoCurso'];
			foreach( $pesquisa as $key => $value ) {
				$model->{$key} = $value;
			}
		}

		$this->render('visualizarAssocPesquisas',array(
				'model'=>$model,
		));
	}

	public function actionNovaAssocPesquisa()
	{
		$model = new ProjetoCurso('search3');
		$model->unsetAttributes();


		if( isset($_POST['ProjetoCurso']) ) {
			$_POST['ProjetoCurso']['dtiniciocurso'] = implode( '-', array_reverse( explode( '/', $_POST['ProjetoCurso']['dtiniciocurso'] ) ) );
			$_POST['ProjetoCurso']['dtfimcurso'] = implode( '-', array_reverse( explode( '/', $_POST['ProjetoCurso']['dtfimcurso'] ) ) );

			$model->attributes=$_POST['ProjetoCurso'];
			$model->dtiniciocurso = $model->dtinicioinscricao = $_POST['ProjetoCurso']['dtiniciocurso'];
			$model->dtfimcurso = $model->dtfiminscricao = $_POST['ProjetoCurso']['dtfimcurso'];
			// 			var_dump($model->attributes);exit;
			if($model->preCreate())
				$this->redirect(array('visualizarAssocPesquisas','idprojeto'=>$model->idprojeto, 'idcursomoodle' => $model->idcursomoodle));
		} else {
			$model->idprojeto = $_GET['idprojeto'];
			$model->nome_projeto = $model->getProjeto($model);

			$model->idcursomoodle = $_GET['idcursomoodle'];
			$model->nome_curso = $model->getCurso($model);

			if( isset( $_GET['idquestionario'] ) ) {
				$model->idquestionario = $_GET['idquestionario'];
			}

		}

		$this->render('novaAssocPesquisa',array(
				'model'=>$model,
		));
	}

	public function actionVisualizarPesquisas()
	{
		$model = new Questionario('search2');
		$model->unsetAttributes();  // clear any default values

		if( isset($_GET['Questionario']) ) {
			$pesquisa = $_GET['Questionario'];
			foreach( $pesquisa as $key => $value ) {
				$model->{$key} = $value;
			}
		}

		$this->render('visualizarPesquisas',array(
				'model'=>$model,
		));
	}

	public function actionProcurarPesquisa() {

		$model = new Questionario('search');
		$model->unsetAttributes();  // clear any default values

		if( isset($_GET['Questionario']) ) {
			$pesquisa = $_GET['Questionario'];
			foreach( $pesquisa as $key => $value ) {
				$model->{$key} = $value;
			}
		}

		$this->render('procurarPesquisa',array(
				'model'=>$model,
		));

	}

	public function actionExcluirAssocPesquisa() {

		if( isset( $_GET['idprojeto'] ) && isset( $_GET['idcursomoodle'] ) && isset( $_GET['idquestionario'] ) )
		{
			$id = array( "idprojeto" => $_GET['idprojeto'], "idcursomoodle" => $_GET['idcursomoodle'], "idquestionario" => $_GET['idquestionario'] );

			ProjetoCurso::preDelete($id);

			$this->redirect(array('visualizarAssocPesquisas','idprojeto'=>$_GET['idprojeto'], 'idcursomoodle' => $_GET['idcursomoodle']));
		}
		else
			throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}

	public function actionExportarPesquisas()
	{
		$model=new UsuarioCursoPesquisa('search');
		$model->unsetAttributes();  // clear any default values
		$model->idprojeto = $_GET['idprojeto'];
		$model->idcursomoodle = $_GET['idcursomoodle'];
		$model->idquestionario = $_GET['idquestionario'];

		$this->render('exportarPesquisas',array(
				'model'=>$model,
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the ID of the model to be loaded
	 */
	public function loadModel($id)
	{
		$model=Questionario::preFind($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param CModel the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='questionario-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
}
