<?php

class SecurityController extends CController
{

	public function actions()
	{
		//		ini_set( 'soap.wsdl_cache_enable' , 0 );
		//		ini_set( 'soap.wsdl_cache_ttl' , 0 );
		$serviceOptions['soapVersion'] = SOAP_1_1;
		return array(
				'ws' => array(
						'class' => 'CWebServiceAction',
						'serviceOptions' => $serviceOptions,
				),
		);
	}

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
				'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
				array('allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('linkMoodle'),
						'users'=>array('@'),
				),
				array(	'deny',  // deny all users
						'actions'=>array('linkMoodle'),
						'users'=>array('*'),
				),
		);
	}

	/**
	 * @param string token Client Server
	 * @param string ip Client Sever
	 * @param string token Client
	 * @param array token Client
	 * @return array
	 * @soap
	 */
	public function getUserAccess($tokenClientServer, $ipClientSever, $tokenClient)
	{
		$Usuario = new Usuario();
		return $Usuario->getTokenLinkAcesso($tokenClientServer, $ipClientSever, $tokenClient);
	}

	public function actionLinkMoodle()
	{
		$Usuario = new Usuario();
		$token = $Usuario->setTokenLinkAcesso(Yii::app()->user->getId());
		$this->redirect(Constants::MOODLE_URL.$token);
	}
}