<?php

class SiteController extends Controller
{
	public $layout='';
	public $title = 'Página principal do portal SINASE';
	/**
	 * Declares class-based actions.
	 */
	public function actions()
	{
		return array(
			// captcha action renders the CAPTCHA image displayed on the contact page
			'captcha'=>array(
				'class'=>'CCaptchaAction',
				'backColor'=>0xFFFFFF,
			),
			// page action renders "static" pages stored under 'protected/views/site/pages'
			// They can be accessed via: index.php?r=site/page&view=FileName
			'page'=>array(
				'class'=>'CViewAction',
			),
		);
	}

	/**
	 * This is the default 'index' action that is invoked
	 * when an action is not explicitly requested by users.
	 */
	public function actionIndex()
	{
		// renders the view file 'protected/views/site/index.php'
		// using the default layout 'protected/views/layouts/main.php'
		if(!Yii::app()->user->isGuest){
			if (Yii::app()->user->profileUser['idusuariostatus'] == 3){
				Yii::app()->user->setFlash('warning', Yii::t('app', 'usuario.cadastroIncompleto'));
			}else if (Yii::app()->user->profileUser['coperfilacesso'] == 'aluno' &&
					  Yii::app()->user->profileUser['idmoodle']) {
				$data = self::AlunoDashBoard();
				$this->render('/dashboard/alunoDashboard', $data);
				Yii::app()->end();
			} else if(strtolower(Yii::app()->user->profileUser['coperfilacesso']) == 'tutor' ||
					strtolower(Yii::app()->user->profileUser['coperfilacesso']) == 'supervisor') {

				$data = self::dashboardTutorSupervisor();
				$this->render('/dashboard/dashboardTutorSupervisor', $data);
				Yii::app()->end();

			} else if(strtolower(Yii::app()->user->profileUser['coperfilacesso']) == 'gestor') {
        		$curso = NULL;
        		$turma = NULL;
        
        		$cursoObj = new Curso();
                $cursoObj->unsetAttributes();
        		if (isset($_REQUEST['curso'])) {
        			$cursoObj->setAttributes($_REQUEST['curso']);
        		}
        
        		$turmaObj = new CursoTurma();
                $turmaObj->unsetAttributes();
        		if (isset($_REQUEST['turma'])) {
        			$turmaObj->setAttributes($_REQUEST['turma']);
        		}

        		$status = (isset($_REQUEST['situacao']))?$_REQUEST['situacao']:NULL;
        
        		$this->render('/indicadores/listaIndicador1', array('model'   => $cursoObj,
                                                					'turma'   => $turmaObj,
                                                					'situacao'=> $status));
				Yii::app()->end();
			}
			return $this->render('index');
		}
		return $this->actionLogin();
	}

	/**
	 * This is the default 'index' action that is invoked
	 * when an action is not explicitly requested by users.
	 */
	public function actionTestWS()
	{
		$options = array(
				'location' => 'http://appgestao.localhost.dev/teste.php?SSOApp/quote',
				'uri' => 'http://appgestao.localhost.dev/teste.php?SSOApp/quote'
		);

		$client = new SoapClient(null, $options);

		/*
		 * No Objeto $client podemos usar os métodos da classe
		* SoapServerExemplo disponível em nosso webservice.
		*/
		XDebug::xd($client->mensagem());

		$client=new SoapClient(null, array(
				"location" 		=> 'http://appgestao.localhost.dev/teste.php?SSOApp/quote',
				"uri"      		=> "urn: xmethods-delayed-quoteds",
				"style"    		=> SOAP_RPC,
				"use"      		=> SOAP_ENCODED,
				//"encoding"		=> "UTF-8",
				"soap_version" 	=> SOAP_1_1
		));
		echo $client->getPrice('GOOGLE');
	}

	/**
	 * This is the action to handle external exceptions.
	 */
	public function actionError()
	{
		$this->layout='//layouts/column1';
	    if($error=Yii::app()->errorHandler->error)
	    {
	    	if(Yii::app()->request->isAjaxRequest)
	    		echo $error['message'];
	    	else
	        	$this->render('error', $error);
	    }
	}

	/**
	 * Displays the contact page
	 */
	public function actionContact()
	{
		$this->title = 'Contatos do Portal Sinase';
		$model=new ContactForm;
		if(isset($_POST['ContactForm']))
		{
			$model->attributes=$_POST['ContactForm'];
			if($model->validate())
			{
				$model->sendConstants(Yii::app()->params['adminEmail'],
									  $model->email,
									  $model->subject,
									  $model->body);

				Yii::app()->user->setFlash('contact','Obrigado por entrar em contato conosco. Nós responderemos o mais breve possível.');
				return $this->redirect(array('index'));
			}
		}
		$this->render('contact',array('model'=>$model));
	}

	/**
	 * Displays the login page
	 */
	public function actionLogin()
	{
		$model=new LoginForm;

		// if it is ajax validation request
		if(isset($_POST['ajax']) && $_POST['ajax']==='login-form')
		{
			$model->setScenario('login');
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}

		// collect user input data
		if(isset($_POST['LoginForm']))
		{
			$model->attributes=$_POST['LoginForm'];

			// validate user input and redirect to the previous page if valid
			if($model->validate() && $model->login()){
				$this->redirect(Yii::app()->user->returnUrl);
			}
		}
		// display the login form
		$this->render('login',array('model'=>$model));
	}

	/**
	 * Logs out the current user and redirect to homepage.
	 */
	public function actionLogout()
	{
		Yii::app()->user->logout();
		$this->redirect(Yii::app()->homeUrl);
	}

	private function AlunoDashBoard()
	{
		$userId  = Yii::app()->user->id;

		$curso        = new Curso();
		$cursoTurma   = new CursoTurma();
		$mensagem	  = new Mensagem();
		$contInscricao = new ControleInscricao();
		$curso->unsetAttributes();

		if(isset($_POST['Curso'])) {
			$curso->attributes=$_POST['Curso'];
		}

// 		if(isset($_POST['CursoTurma'])) {
// 			$cursoTurma->attributes=$_POST['CursoTurma'];
// 		}

		return array(
				'pendentes' 		=> $curso->atividadesPendentes($userId, $cursoTurma),
				'semana'    		=> $curso->atividadesSemana($userId, TRUE, $cursoTurma),
				'aberto'        	=> $curso->cursosEmAberto($userId, $cursoTurma),
				'naolidas'      	=> $mensagem->mensagemPortal($userId, TRUE, $cursoTurma),
				'cursosAluno'       => $curso->findAllBySql($curso->listCursosAluno($userId)),
				'avaliacaoPesquisa' => $contInscricao->avaliacaoPesquisa($userId, $curso, TRUE, TRUE),
				'curso' 	    	=> $curso,
				'cursoTurma'    	=> $cursoTurma
		);
	}
	/**
	 * Displays the login page
	 */
	public function actionLoginRecover()
	{
		$model=new LoginForm;

		// collect user input data
		if(isset($_POST['LoginForm']['emailLoginRecover']))
		{
			$model->emailLoginRecover=$_POST['LoginForm']['emailLoginRecover'];
			$model->inRecuperarAcesso=$_POST['LoginForm']['inRecuperarAcesso'];

			// validate user input and redirect to the previous page if valid
			if ($model->loginRecover()){
				if ( $model->inRecuperarAcesso==1) {
					Yii::app()->user->setFlash('success', Yii::t('app', 'login.dadosSenha'));
				}else{
					Yii::app()->user->setFlash('success', Yii::t('app', 'login.dadosCodigoAcesso'));
				}
				$this->redirect(array('index'));
			}
		}

		// display the login form
		$this->render('loginRecover', array('model'=>$model));
	}

	public function actionChangeProfile()
	{
		$profile = Yii::app()->getRequest()->getParam('profile');

		foreach(Yii::app()->user->profilesUser as $key => $value){
			if ($profile == $value['coperfilacesso']) {
				/*
				 * Recupera as informações do usuário conforme o perfil.
				 */
				$MenuSistema = new MenuSistema();
				$menuUser = $MenuSistema->getMenuUsuarioSistema(Yii::app()->user->id, $value['coperfilacesso']);

				/*
				 * Altera as informações do usuário conforme
				 * o perfil do usuário.
				 */
				Yii::app()->user->profileUser = $value;
				Yii::app()->user->menuUser = $menuUser;
				Yii::app()->user->name = $value['coperfilacesso'];
				Yii::app()->end();
				break;
			}
		}
	}

	/**
	 * Displays the login page
	 */
	public function actionLoginRecoverConfirm()
	{
		$model=new LoginForm;
		// collect user input data
		if(Yii::app()->request->getQuery('token')){
			$Usuario = new Usuario();
			if($usuario = $Usuario->listUsuarioToken(Yii::app()->request->getQuery('token'))){
				return $this->render('loginRecoverConfirm', array(
										'model'=>$model,
										'erroRecover'=>null,
										'tokenRecover'=>$Usuario->gerarTokenUsuario($usuario['dcemail'])
									));
			}else
				return $this->redirect(array('index'));
		}elseif(isset($_POST['LoginForm']['passwordNew'])){
			$tokenRecover = isset($_POST['tokenRecover'])?$_POST['tokenRecover']:null;
			$passwordNew = isset($_POST['LoginForm']['passwordNew'])?$_POST['LoginForm']['passwordNew']:null;
			$passwordNewConfirm = isset($_POST['LoginForm']['passwordNewConfirm'])?$_POST['LoginForm']['passwordNewConfirm']:null;
			$Usuario = new Usuario();
			if($usuario = $Usuario->listUsuarioToken($tokenRecover)){
				if ($passwordNew != $passwordNewConfirm){
					return $this->render('loginRecoverConfirm',array(
										 'model'=>$model,
										 'erroRecover'=> Yii::t('app', 'erro.passwordDifferent'),
										 'tokenRecover'=>$Usuario->gerarTokenUsuario($usuario['dcemail'])
									));
				}

				$Usuario->changePassword($usuario, $passwordNew);
				Yii::app()->user->setFlash('success', Yii::t('app', 'login.newPasswordSuccess'));
			}else{
				return $this->render('loginRecoverConfirm', array(
						'model'=>$model,
						'erroRecover'=>Yii::t('app', 'login.newPasswordErro'),
						'tokenRecover'=>$Usuario->gerarTokenUsuario($usuario['dcemail'])
				));
			}
		}
		$this->redirect(Yii::app()->homeUrl);
	}

	private function dashboardTutorSupervisor()
	{
		$this->title = 'DashBoard Tutor / Supervisor';


		$dadosCurso        = Yii::app()->getRequest()->getParam('Curso');
		$dadosCursoTurma   = Yii::app()->getRequest()->getParam('CursoTurma');

		$pendentes     = NULL;
		$tarefas       = NULL;
		$questionarios = NULL;
		$forum         = NULL;
		$mediaNota     = NULL;

		$curso        		= new Curso();
		$cursoTurma   		= new CursoTurma();
		$usuInscricao 		= new UsuarioInscricao();
		$cursoUsuarioAcesso = new CursoUsuarioAcesso();
		$notaCurso			= new NotaCurso();

		$curso->unsetAttributes();
		$cursoTurma->unsetAttributes();
		$usuInscricao->unsetAttributes();
		$notaCurso->unsetAttributes();



		if($dadosCurso != "") {
			$curso->attributes = $dadosCurso;
		}

		$perfilacesso = Yii::app()->user->profileUser['idpapel'];
		
		if($dadosCursoTurma != "") {
			if($dadosCursoTurma['id']== '') {
				$cursoTurma->addError('id', Yii::t('app', 'erro.turmaObrigatoria'));
			} else {
				$cursoTurma->attributes = $dadosCursoTurma;
				$notaCurso->setAttribute('courseid', $curso->id);

				$pendentes     = $cursoUsuarioAcesso->diasSemAcessar($cursoTurma, TRUE, TRUE);
				$tarefas       = $usuInscricao->tarefasAtrasadas($cursoTurma, TRUE);
				$questionarios = $usuInscricao->questionariosAtrasados($cursoTurma, TRUE);
				$forum		   = $usuInscricao->forumAtrasados($cursoTurma, TRUE);
				$mediaNota     = $notaCurso->mediaNota();
			}

		}

		return array(
					'pendentes' 	 => $pendentes,
					'tarefas'     	 => $tarefas,
					'questionarios'	 => $questionarios,
					'forum'     	 => $forum,
					'curso' 		 => $curso,
					'cursoTurma'     => $cursoTurma,
					'mediaNota'      => $mediaNota,
					'perfilacesso'   => $perfilacesso
		);

	}
}