<?php
/**
 * [Descrição do arquivo].
 *
 * [mais informações precisa ter 1 [ENTER] para definir novo parágrafo]
 *
 * [pode usar quantas linhas forem necessárias]
 * [linhas logo abaixo como esta, são consideradas mesmo parágrafo]
 *
 * @package UsuarioController* @category [Categoria a que o arquivo pertence]
 * @name Controle
 * @author [nome do autor] - [e-mail do autor]
 * @copyright Projeto Sinase 2012
 * @license [link da licença] [Nome da licença]
 * @link [link de onde pode ser encontrado esse arquivo]
 * @version 0.01
 * @since 2012/07/26*/

class UsuarioController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout='//layouts/column2';
	public $title='Usuario';

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
				'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
				array(	'allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('main','delete','index','view','create',
								'update', 'myAccount', 'viewMyAccount'),
						'users'=>array('admin'),
						//'expression'=>'Yii::app()->controller->isAdmin()',
				),
				array(	'allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('myAccount','viewMyAccount'),
						'users'=>array('aluno', 'supervisor', 'tutor'),
						//'expression'=>'Yii::app()->controller->isAdmin()',
				),
				array(	'allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('changePassword'),
						'users'=>array('@'),
				),
				array(	'allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('createOut', 'confirmarCadastro'),
						'users'=>array('*'),
				),
				array(	'deny',  // deny all users
						'users'=>array('*'),
				),
		);
	}
	/*
	 public function accessRules()
	 {
	$accessRules = $this->getAccessRules(Yii::app()->getController()->getId());
	return array(
			array('allow',
					'actions'=>$accessRules['actions'],
					'users'=>$accessRules['users'],
			),
			array('deny',  // deny all users
					'users'=>array('*'),
			)
	);
	}
	*/
	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		// Informe o Título da view
		$this->title = Yii::t('app', 'title.view').$this->title;

		$this->render('view',array(
				'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionViewMyAccount($id)
	{
		// Informe o Título da view
		$this->title = 'Visualizar informações do '.$this->title;

		$this->render('viewMyAccount',array(
				'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate($fileRender = 'create', $fileView = 'view')
	{
		// Informe o Título da view
		$this->title = 'Criar novo '.$this->title;

		$model=new Usuario;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Usuario']))
		{
			$model->attributes=$_POST['Usuario'];

			if($model->preSave())
			{
				Yii::app()->user->setFlash('success', Yii::t('app', 'usuario.cadastroExternoSucesso'));
				$this->redirect(array($fileView,'id'=>$model->idusuario));
			}
		}

		$this->render($fileRender,array(
				'model'=>$model,
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreateOut()
	{
		$this->actionCreate('createOut', '/site/login');
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionMyAccount($id = null)
	{
		$this->actionUpdate(Yii::app()->user->getId(), 'updateMyAccount', 'viewMyAccount');
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id, $fileRender = 'update', $fileView = 'view')
	{
		// Informe o Título da view
		$this->title = 'Atualizar '.$this->title;

		// Carrega as informações da model
		$Usuario = new Usuario();
		$Usuario->idusuario = $id;
		$model=$Usuario->searchFind();

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['Usuario']))
		{
			$model->attributes=$_POST['Usuario'];
			if($model->preUpdate()){
				Yii::app()->user->setFlash('success', Yii::t('app', 'success.registroSalvoSucesso'));
				$this->redirect(array($fileView,'id'=>$model->idusuario));
			}
		}

		$this->render($fileRender,array(
				'model'=>$model,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		if(Yii::app()->request->isPostRequest)
		{
			// we only allow deletion via POST request
			Usuario::preDelete($id);

			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_GET['ajax']))
				$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('main'));
		}
		else
			throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$this->actionMain();
	}

	/**
	 * Manages all models.
	 */
	public function actionMain()
	{
		$model=new Usuario('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Usuario']))
			$model->attributes=$_GET['Usuario'];

		$this->render('main',array(
				'model'=>$model,
		));
	}

	public function changeProfile()
	{
		UsuarioPerfilAcesso::saveMyAccessProfile($id);
	}

	public function actionConfirmarCadastro()
	{
		if(Yii::app()->request->getQuery('token'))
		{
			$Usuario = new Usuario();
			if($usuario = $Usuario->listUsuarioTokenConfirmeCadastro(Yii::app()->request->getQuery('token'))){
				$Usuario->liberarCadastro($usuario['idusuario']);
				Yii::app()->user->setFlash('success', Yii::t('app', 'usuario.cadastroLiberadoSucesso'));
			}
		}
		return $this->redirect(array('/site/login'));
	}
	/**
	 * Modifica o perfil do usuário.
	 */
	public function actionChangePassword()
	{
		$dcSenha = Yii::app()->request->getPost('dcSenha');
		$dcSenhaNova = Yii::app()->request->getPost('dcSenhaNova');
		$dcSenhaConfirmar = Yii::app()->request->getPost('dcSenhaConfirmar');

		$Usuario = new Usuario();
		if ($error = $Usuario->preChangePassword($dcSenha,
				$dcSenhaNova,
				$dcSenhaConfirmar,
				Yii::app()->user->id)){
			$return = '{"error":[{"messenger": "'.$error.'"}]}';
		}else{
			$return = '{"success":[{"messenger": "'.Yii::t('app', 'success.renovacaoSenha').'"}]}';
		}

		Yii::app()->end($return);
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the ID of the model to be loaded
	 */
	public function loadModel($id)
	{
		$model=Usuario::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}
	/**
	 * Performs the AJAX validation.
	 * @param CModel the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='usuario-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
}
