<?php
/**
 * [Descrição do arquivo].
 *
 * [mais informações precisa ter 1 [ENTER] para definir novo parágrafo]
 *
 * [pode usar quantas linhas forem necessárias]
 * [linhas logo abaixo como esta, são consideradas mesmo parágrafo]
 *
 * @package UsuarioPerfilAcessoController* @category [Categoria a que o arquivo pertence]
 * @name Controle
 * @author [nome do autor] - [e-mail do autor]
 * @copyright [Nome do Projeto]
 * @license [link da licença] [Nome da licença]
 * @link [link de onde pode ser encontrado esse arquivo]
 * @version 0.01
 * @since 2013/01/14*/

class UsuarioPerfilAcessoController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout= '//layouts/column1';
	public $title= 'UsuarioPerfilAcesso';
	public $buttonsManage = array();

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
				'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
				array('allow',  // allow all users to perform 'index' and 'view' actions
						'actions'=>array('index','view'),
						'users'=>array('*'),
				),
				array('allow', // allow authenticated user to perform 'create' and 'update' actions
						'actions'=>array('conceder','remover', 'concederAcesso'),
						'users'=>array('@'),
				),
				array('allow', // allow admin user to perform 'admin' and 'delete' actions
						'actions'=>array('main','delete'),
						'users'=>array('admin'),
				),
				array('deny',  // deny all users
						'users'=>array('*'),
				),
		);
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		// Informe o Título da view
		$this->titleAction = Yii::t('app', 'title.view');

		$this->render('view',array(
				'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionConceder()
	{
		// Informe o Título da create
		$this->titleAction = Yii::t('app', 'title.create');

		$model=new UsuarioPerfilAcesso;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['UsuarioPerfilAcesso']))
		{
			$model->attributes=$_POST['UsuarioPerfilAcesso'];
			if($model->preCreate())
				$this->redirect(array('view','id'=>$model->dtcadastro));
		}

		$this->render('create',array(
				'model'=>$model,
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionConcederAcesso($id)
	{
		// Informe o Título da create
		$this->titleAction = Yii::t('app', 'title.concedeAcesso');

		if($id)
		{
			$Usuario=new Usuario();
			$PerfilAcesso=new PerfilAcesso();

			// Uncomment the following line if AJAX validation is needed
			// $this->performAjaxValidation($model);

			if(Yii::app()->request->getPost('incoperfilacesso'))
			{
				$UsuarioPerfilAcesso=new UsuarioPerfilAcesso();

				$UsuarioPerfilAcesso->setAttribute('incoperfilacesso', Yii::app()->request->getPost('incoperfilacesso'));
				$UsuarioPerfilAcesso->setAttribute('coperfilacesso', Yii::app()->request->getPost('coperfilacesso'));
				$UsuarioPerfilAcesso->setAttribute('idusuario', $id);

				if($UsuarioPerfilAcesso->preCreate())
					Yii::app()->user->setFlash('success', Yii::t('app', 'usuarioPerfilAcesso.perfilSucesso'));
			}

			$this->render('concederAcesso',array(
					'usuario'=>$Usuario->listUsuario($id),
					'listPerfilSistema'=>new CArrayDataProvider($PerfilAcesso->listPerfilSistema($id),
							array('keyField'=>'coperfilacesso')),
			));
		}
		else
			throw new CHttpException(400, Yii::t('app', 'erro.requisicaoInvalida'));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionRemover($id)
	{
		if(Yii::app()->request->isPostRequest)
		{
			// we only allow deletion via POST request
			UsuarioPerfilAcesso::preDelete($id);

			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_GET['ajax']))
				$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('main'));
		}
		else
			throw new CHttpException(400, Yii::t('app', 'erro.requisicaoInvalida'));
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$this->actionMain();
	}

	/**
	 * Manages all models.
	 */
	public function actionMain()
	{
		// Informe o Título da search
		$this->titleAction = Yii::t('app', 'title.search');

		$model=new UsuarioPerfilAcesso('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['UsuarioPerfilAcesso']))
			$model->attributes=$_GET['UsuarioPerfilAcesso'];

		$this->render('main',array(
				'model'=>$model,
				'listUsuarioPerfil'=>$model->listUsuarioPerfil(),
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the ID of the model to be loaded
	 */
	public function loadModel($id)
	{
		$model=UsuarioPerfilAcesso::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404, Yii::t('app', 'erro.paginaNaoEncontrada'));
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param CModel the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='usuario-perfil-acesso-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
}