<?php

class ActiveFormQuestion extends CActiveForm
{
	public $model=null;
	public $idCurso=null;
	public $idProjeto=null;
	public $idQuestionario=null;
	public $btGenerated = true;
	public $layout = '';
	public $urlCancel = array('index');
	public $labelButton = array('submit' => 'Submit',
			'reset' => 'Reset',
			'cancel' => 'Cancel');

	/**
	 * Initializes the widget, javascript, and calls the parent init function
	 *
	 * @return void
	 */
	function init()
	{
		parent::init();
	}

	public function run()
	{
		$Questionario = new Questionario();
		$queryQuest = $Questionario->listMontarQuestionario($this->idQuestionario);

		if (!$queryQuest)
		{
			throw new CHttpException(404, Yii::t('app', 'questionario.erroInterno'));
		}

		$html = "";
		$html .= "<input type=\"hidden\" value=\"".$this->idProjeto."\" name=\"resposta[idprojeto]\">\n";
		$html .= "<input type=\"hidden\" value=\"".$this->idCurso."\" name=\"resposta[idcursomoodle]\">\n";
		$html .= "<input type=\"hidden\" value=\"".$this->idQuestionario."\" name=\"resposta[idquestionario]\">\n";

		$html .= self::getLayoutBegin($this->layout, $queryQuest);
		$html .= 		"<div class=\"box-content\">\n";
		$html .= 			'<div><h4>'.$queryQuest[0]['dcobjetivo'].'</div></h4><br/>';
		$html .= 				'<p class="note">'.Yii::t('app', 'generic.campoObrigatorio').'</p>';

		$order = 1;
		$grupoQuestIni = "";
		foreach ($queryQuest as $key => $value) {

			if ($value['idgrupoquestao'] != $grupoQuestIni){
				$order = 1;
				$html .= ($grupoQuestIni != "")?"</fieldset>\n":"";
				$html .= "\n<fieldset>\n";
				$html .= "<legend>".$value['dcgrupoquestao']."</legend>\n";
			}

			$html .= self::objHtml($value, $order++);

			$grupoQuestIni = $value['idgrupoquestao'];
			$html .= (($value['idgrupoquestao'] != $grupoQuestIni))?"</fieldset>\n":"";
		}
		$html .= "</fieldset>\n";

		$html .= 			'<div>'.$queryQuest[0]['dcconfirmacao'].'</div>';
		$html .= 		"<div class=\"form-actions\">";
		if ($this->btGenerated){
			$html .= 			CHtml::submitButton($this->labelButton['submit'], array('class'=>'btn btn-primary'))."&nbsp;";
			$html .= 			CHtml::resetButton($this->labelButton['reset'], array('class'=>'btn'))."&nbsp;";
		}
		$html .= 			CHtml::button($this->labelButton['cancel'], array('class'=>'btn', 'onClick'=>"location.href='".CHtml::normalizeUrl($this->urlCancel)."'"));
		$html .= 		"</div>\n";

		$html .= self::getLayoutEnd($this->layout);
		$html .= "</form>\n\n";

		$html .= "<script type=\"text/javascript\">\n";
		$html .= "$().ready(function(){\n";
		$html .= "	$(\"#questionarioResposta-form\").validate();\n";
		$html .= "	$('input[type=\"text\"]').each(function() {\n";
		$html .= "		var input = $(this);\n";
		$html .= "		$(this).setMask($(this).attr('alt'));\n";
		$html .= "	});\n";
		$html .= "});\n";
		$html .= "</script>\n";
		echo $html;
	}

	private function objHtml($value, $order)
	{
		$html = "";
		$type = trim($value['cotipoquestao']);
		$idquestao = trim($value['idquestao']);
		switch ($type) {
			case "SOALFA":
			case "TEXTO":
				$html = "<div class=\"controls\">".
						CHtml::textField('resposta['.strtolower($type).']['.$idquestao.']').
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "TEXTAREA":
				$html = "<div class=\"controls\">" .
						CHtml::textArea('resposta['.strtolower($type).']['.$idquestao.']', '',
						array(	'class'=>'span8',
						(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'id'=>'resposta['.strtolower($type).']['.$idquestao.']',
						'rows'=>'3')).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "COMBO":
				$html = "<div class=\"controls\">" .
						CHtml::dropDownList('resposta['.strtolower($type).']['.$idquestao.']',
						'',
						CHtml::listData(Resposta::model()->findAll('idquestao=:idquestao order by nuordem', array(':idquestao'=>$value['idquestao'])), 'idresposta', 'dcresposta'),
						array(	'class'=>'span6',
						'prompt'=>'Selecione uma opção.',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.']',
						(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						)
						).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "RADIO":
				$html = "<div class=\"controls\">" .
						CHtml::radioButtonList('resposta['.strtolower($type).']['.$idquestao.']',
						'',
						CHtml::listData(Resposta::model()->findAll('idquestao=:idquestao order by nuordem', array(':idquestao'=>$value['idquestao'])), 'idresposta', 'dcresposta'),
						array('separator' => '',
						(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'labelOptions'=>array(	'style'=>'display:inline; padding-right:20px',
						'id'=>strtolower($type)."_".$value['cotipoquestao'],
						))).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "CHECKBOX":
				$html = "<div class=\"controls\">" .
						CHtml::checkBoxList('resposta['.strtolower($type).']['.$idquestao.']',
						2,
						CHtml::listData(Resposta::model()->findAll('idquestao=:idquestao order by nuordem', array(':idquestao'=>$value['idquestao'])), 'idresposta', 'dcresposta'),
						array(	'separator' => '',
						(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'labelOptions'=>array(	'style'=>'display:inline; padding-right:20px',
						'id'=>strtolower($type)."_".$value['cotipoquestao']
						))).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.'][]'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "DATA":
				$html = "<div class=\"controls\">".
						"<div class=\"input-append date datepicker\" data-date='".date('d/m/Y')."' data-date-format=\"dd/mm/yyyy\">".
						CHtml::textField(	'resposta['.strtolower($type).']['.$idquestao.']',
						'',
						array(	(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'alt'=>"date",
						'class'=>'span3',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.']',
						)).
						"<span class=\"add-on\"><i class=\"icon-calendar\"></i></span>".
						"</div>".
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "HORA":
				$html = "<div class=\"controls\">".
						CHtml::textField(	'resposta['.strtolower($type).']['.$idquestao.']',
						'',
						array(	(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'time'=>'',
						'alt'=>"time",
						'class'=>'span2',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.']',
						)).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "DATAHORA":
				$html = "<div class=\"controls\">".
						CHtml::textField('resposta['.strtolower($type).']['.$idquestao.'][date]',
						'',
						array(	(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'date'=>'',
						'alt'=>"date",
						'style'=>'float:left;margin-right:5px;',
						'class'=>'span2',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.'][date]',
						)).
						CHtml::textField('resposta['.strtolower($type).']['.$idquestao.'][time]',
						'',
						array(	(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'time'=>'',
						'alt'=>"time",
						'class'=>'span1',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.'][time]',
						)).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.'][date]'."' class=\"error hide red\">Selecione um resposta.</label>".
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.'][time]'."' class=\"error hide red\">Preenche o campo hora.</label>".
						"</div>\n";
						break;
			case "TELEFONE":
				$html = "<div class=\"controls\">".
						CHtml::textField('resposta['.strtolower($type).']['.$idquestao.']',
						'',
						array(	(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'alt'=>"phone",
						'class'=>'span3',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.']',
						)).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "SOLETRA":
				$html = "<div class=\"controls\">".
						CHtml::textField(	'resposta['.strtolower($type).']['.$idquestao.']',
						'',
						array(	(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'alt'=>"alfa",
						'class'=>'span3',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.']',
						)
						).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "NUMERO":
				$html = "<div class=\"controls\">".
						CHtml::textField(	'resposta['.strtolower($type).']['.$idquestao.']',
						'',
						array(	(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'number'=>'',
						'alt'=>"integer",
						'class'=>'span3',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.']',
						)
						).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "MOEDA":
				$html = "<div class=\"controls\">".
						CHtml::textField(	'resposta['.strtolower($type).']['.$idquestao.']',
						'',
						array(	(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'alt'=>"signed-decimal",
						'class'=>'span3',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.']',
						)
						).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "CPF":
				$html = "<div class=\"controls\">".
						CHtml::textField(	'resposta['.strtolower($type).']['.$idquestao.']',
						'',
						array(	(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'cpf'=>true,
						'alt'=>"cpf",
						'class'=>'span3',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.']',
						)
						).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "CNPJ":
				$html = "<div class=\"controls\">".
						CHtml::textField(	'resposta['.strtolower($type).']['.$idquestao.']',
						'',
						array(	(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'cnpj'=>true,
						'alt'=>"cnpj",
						'class'=>'span3',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.']',
						)
						).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "EMAIL":
				$html = "<div class=\"controls\">".
						CHtml::textField(	'resposta['.strtolower($type).']['.$idquestao.']',
						'',
						array(	(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'email'=>true,
						'class'=>'span3',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.']',
						)
						).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			case "URL":
				$html = "<div class=\"controls\">".
						CHtml::textField(	'resposta['.strtolower($type).']['.$idquestao.']',
						'',
						array(	(($value['inobrigatorio'])?'required':'requiredOff')=>"",
						'url'=>'',
						'class'=>'span3',
						'id'=>'resposta['.strtolower($type).']['.$idquestao.']',
						)
						).
						"<label for='".'resposta['.strtolower($type).']['.$idquestao.']'."' class=\"error hide red\">Selecione um resposta.</label>".
						"</div>\n";
						break;
			default:
				break;
		}

		$html = "<div class=\"control-group\">\n".
				"<h4>".$order." - ".(($value['inobrigatorio'])?'*':'')." ".$value['dcquestao']."</h4>\n".
				"<div style=\"padding:10px;\">".$html."</div>".
				"</div>\n";
		return $html;
	}

	private function getLayoutBegin($layout, $queryQuest)
	{
		$html = "";
		switch ($layout) {
			case 'form':
				$html .= "<div class=\"box\">\n";
				$html .= 	"<h4 class=\"box-header round-top\">".$queryQuest[0]['dcformulario']."</h4>\n";
				$html .= 	"<div class=\"box-container-toggle\">\n";
				break;
			default:
				$html .= "\n<fieldset>\n";
				$html .= "<legend>".$queryQuest[0]['dcformulario']."</legend>\n";
				break;
		}
		return $html;
	}

	private function getLayoutEnd($layout)
	{
		$html = "";
		switch ($layout) {
			case 'form':
				$html .= 		"</div>\n";
				$html .= 	"</div>\n";
				$html .= "</div>\n";
				break;
			default:
				$html .= "</fieldset>\n";
				break;
		}
		return $html;
	}

}
