<?php

// auto-loading fix
Yii::setPathOfAlias('ControleInscricao', dirname(__FILE__).'/base');
Yii::import('ControleInscricao.*');

class ControleInscricao extends BaseControleInscricao
{
	public $dcnome;
	public $count;
	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->dtinscricao;

	}

	public function behaviors()
	{
		// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function preCreate()
	{
		return $this->save();
	}

	public function savePreEnturmarAluno($idprojeto, $idcurso)
	{
		if (empty($idprojeto) || empty($idcurso)){
			$this->clearErrors('txcondicao');
			$this->addError('txcondicao', Yii::t('app', 'erro.existeInfoCadastradas'));
			return false;
		}

		foreach ($this->idusuario as $key => $value) {
			Yii::app()->db->createCommand()
			->update(Constants::SCHEMA_SINASE.'.controleinscricao', array(
					'dtenturmado'=>new CDbExpression('NOW()'),
			),
					'idprojeto=:idprojeto and idcursomoodle=:idcurso and idusuario=:idusuario',
					array(	':idprojeto'=>$idprojeto,
							':idcurso'=>$idcurso,
							':idusuario'=>$value));
		}
		return true;
	}

	public function saveDesenturmarAluno($idprojeto, $idcurso, $idusuario)
	{
		if (empty($idprojeto) || empty($idcurso) || empty($idusuario)){
			$this->clearErrors('error');
			$this->addError('error', Yii::t('app', 'erro.informacoesInsuficiente'));
			return false;
		}

		//falta terminiar....
		$ControleInscricao = new ControleInscricao();
		$usuario = $ControleInscricao->existeAlunoEnturmado($idprojeto, $idcurso, $idusuario);
		if ($usuario)
		{
			$CursoParticipante = new CursoParticipante();
			$participante = $CursoParticipante->preDelete($usuario['idcursomoodle'], $usuario['idturma'], $usuario['idmoodle']);

			if($participante){
				Yii::app()->db->createCommand()
				->update(Constants::SCHEMA_SINASE.'.controleinscricao',
						array(
								'idturma'=>new CDbExpression('NULL'),
								'dtdesenturmado'=>new CDbExpression('NOW()'),
						),
						'idprojeto=:idprojeto and idcursomoodle=:idcurso and idusuario=:idusuario',
						array(	':idprojeto'=>$idprojeto,
								':idcurso'=>$idcurso,
								':idusuario'=>$idusuario));
			}

			//encaminha email para o aluno
			$Email = new Email();
			$Email->preSendMail(9, $idusuario, array(), $idcurso);
		}
		return true;
	}

	public function saveEnturmarAluno($idprojeto, $idcurso, $idturma)
	{
		$this->clearErrors('error');
		if (empty($idprojeto) || empty($idcurso) || empty($this->idusuario)){
			$this->addError('error', Yii::t('app', 'erro.informacoesInsuficiente'));
			return false;
		}

		$Email = new Email();
		foreach ($this->idusuario as $key => $idusuario) {
			if ($this->enturmaAluno($idusuario, $idprojeto, $idcurso, $idturma)) {
				//encaminha email para o aluno
				$Email->preSendMail(8, $idusuario, array(), $idcurso);
			}
		}

		return true;
	}

	public function saveRetirarPreEnturmarAluno($idprojeto, $idcurso)
	{
		if (empty($idprojeto) || empty($idcurso) || empty($this->idusuario)){
			$this->clearErrors('error');
			$this->addError('error', Yii::t('app', 'erro.informacoesInsuficiente'));
			return false;
		}

		foreach ($this->idusuario as $key => $value) {
			Yii::app()->db->createCommand()
			->update(Constants::SCHEMA_SINASE.'.controleinscricao', array(
					'idturma' => new CDbExpression('NULL'),
					'dtenturmado'=> new CDbExpression('NULL'),
					'dtdesenturmado'=> new CDbExpression('NULL'),
					'dtconfirmaenturmado'=> new CDbExpression('NULL'),
			),
					'idprojeto=:idprojeto and idcursomoodle=:idcurso and idusuario=:idusuario',
					array(	':idprojeto'=>$idprojeto,
							':idcurso'=>$idcurso,
							':idusuario'=>$value));
		}
		return true;
	}

	private function enturmaAluno($idusuario, $idprojeto, $idcurso, $idturma)
	{
		/*
		 * Se o usuário não existir o sistema recupera o cadastro
		 * não sistema e inserir no moodle.
		 */
		$usuario = $this->existeAlunoMoodle($idusuario);

		if ( !$usuario ){
			$Usuario = new Usuario();
			$usuario = $Usuario->saveUsuarioMoodle($idusuario);

			// Atualiza o idmoodle do usuario
			Yii::app()->db->createCommand()
					->update(Constants::SCHEMA_SINASE.'.usuario',
							array('idmoodle'=>$usuario[0]['id']),
								  'idusuario=:idusuario',
							array(':idusuario'=>$idusuario));

			$usuario = $this->existeAlunoMoodle($idusuario);
		}

		/*
		 * Inscreve o usuario no curso do moodle.
		 * Se incluir ou se existir com sucesso,
		 * confirma a inscriação e vincula o usuário
		 * na turma do moodle.
		 */
		$Curso = new Curso();
		if ($Curso->inscricao($usuario['idmoodle'], $idcurso)){
			$CursoParticipante = new CursoParticipante();
			$participante = $CursoParticipante->preCreate($idcurso, $idturma, $usuario['idmoodle']);

			if($participante){
				Yii::app()->db->createCommand()
					->update(Constants::SCHEMA_SINASE.'.controleinscricao', array(
							'idturma'=>$idturma,
							'dtconfirmaenturmado'=>new CDbExpression('NOW()')),
							'idprojeto=:idprojeto and idcursomoodle=:idcurso and idusuario=:idusuario',
							array(	':idprojeto'=>$idprojeto,
									':idcurso'=>$idcurso,
									':idusuario'=>$idusuario));

				return true;
			}
		}
		return false;
	}

	private function confirmaEnturmar($idprojeto, $idcurso, $idusuario, $idturma)
	{
		Yii::app()->db->createCommand()
		->update(Constants::SCHEMA_SINASE.'.controleinscricao',
				array('dtconfirmaenturmado'=>new CDbExpression('NULL'),
						'idturma'=>$idturma),
				'idprojeto=:idprojeto and idcursomoodle=:idcurso and idusuario=:idusuario',
				array(':idprojeto'=>$idprojeto,
						':idcurso'=>$idcurso,
						':idusuario'=>$value));
	}

	private function existeAlunoMoodle($idusuario)
	{
		return Yii::app()->db->createCommand()
		->select('idusuario, id as idmoodle, nucpf, dcnome')
		->from(Constants::SCHEMA_SINASE.'.vw_usuariomoodle')
		->where('idusuario=:idusuario',array(':idusuario'=>$idusuario))
		->queryRow();
	}

	private function existeAlunoEnturmado($idprojeto, $idcurso, $idusuario)
	{
		return Yii::app()->db->createCommand()
				->select('idusuario, idmoodle, nucpf, dcnome, idprojeto, idcursomoodle, idturma')
				->from(Constants::SCHEMA_SINASE.'.vw_usuarioenturmado')
				->where('idusuario=:idusuario and idusuario=:idusuario and idusuario=:idusuario',
						array(':idprojeto'=>$idprojeto, ':idcursomoodle'=>$idcurso, ':idusuario'=>$idusuario))
				->queryRow();
	}

	public function listEnturmarAluno($idprojeto, $idcurso)
	{
		return Yii::app()->db->createCommand()
				->selectDistinct('u.idusuario id, u.idusuario, u.idmoodle, u.idusuariostatus, u.dcnome,
						u.nucpf, u.dtnascimento, u.dcsexo, u.couf, u.dccidade,
						ci.idprojeto, ci.idcursomoodle, ci.idturma, ci.dtconfirmaenturmado,
						t.fullname as dccurso, t.name as dcturma')
				->from(Constants::SCHEMA_SINASE.'.usuario u')
				->leftJoin(Constants::SCHEMA_SINASE.'.uf', 'u.couf = uf.couf')
				->join(Constants::SCHEMA_SINASE.'.controleinscricao ci', 'ci.idusuario = u.idusuario')
				->leftJoin(Constants::SCHEMA_SINASE.'.vw_cursoturma t', 'ci.idturma = t.id')
				->where("ci.idprojeto=:idprojeto and ci.idcursomoodle=:idcurso and ci.dtenturmado is not null",
						array(':idprojeto'=>$idprojeto, ':idcurso'=>$idcurso))
				->queryAll();
	}


	public function preUpdate()
	{
		return $this->save();
	}

	public function preDelete($id)
	{
		return self::model()->findByPk($id)->delete();
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search()
	{
		return parent::search();
	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						//'adicioneAquiChave' => Yii::t('app', 'Descrição do label'),
				));

		return $attributes;
	}

	/**
	 * Atualiza ultimo contato email de um ou mais alunos.
	 * @param array $idUsuario
	 * @return void
	 */
	public function updateContatoEMail(array $idUsuario)
	{
		$criteria = new CDbCriteria;
		$criteria->addInCondition('idusuario', $idUsuario);
		ControleInscricao::model()->updateAll(array('dtultimocontatoemail'=> new CDbExpression("NOW()")), $criteria);

	}

	/**
	 * Atualiza o status de um ou mais alunos.
	 * @param array $idUsuario
	 * @param string $status
	 * @return void
	 */
	public function atualizaStatusAluno(array $dadosAluno, $idturma)
	{
		foreach($dadosAluno as $key => $value){
			$criteria = new CDbCriteria;
			$criteria->addCondition('idturma='.$idturma);
			$criteria->addCondition('idusuario='.$value['idusuario']);
			ControleInscricao::model()->updateAll(array('insituacaoalunocurso'=>$value['insituacaoalunocurso']), $criteria);
		}
	}

	/**
	 * Retorna a situação de um ou mais alunos.
	 * @param array $idAluno
	 * @return array com o(s) status do(s) aluno(s)
	 */
	public function statusAluno(array $idAluno, $idCurso)
	{
		$criteria=new CDbCriteria();

		$criteria->select = 'insituacaoalunocurso, idusuario';
		$criteria->addInCondition('idusuario', $idAluno);
		$criteria->addCondition('idturma='.$idCurso);

		return ControleInscricao::model()->findAll($criteria);
	}

	public function avaliacaoPesquisa($userId, $curso = NULL, $count = TRUE, $exec = TRUE)
	{
		$subQuery = Yii::app()->db->createCommand()
		->select('ucp.idusuario')
		->from(Constants::SCHEMA_SINASE.'.usuariocursopesquisa ucp')
		->where('ucp.idprojeto = ci.idprojeto
		and ucp.idcursomoodle = ci.idcursomoodle
		and ucp.idusuario = ci.idusuario');

		$criteria=new CDbCriteria();

		$criteria->alias = 'ci';
		$criteria->select = 'pcq.idquestionario, ci.idusuario, que.dcformulario';

		if($count) {
			$criteria->select = 'count(pcq.*)';
		}

		$criteria->join = 'INNER JOIN '.Constants::SCHEMA_SINASE.'.usuario usu on usu.idusuario = ci.idusuario ';
		$criteria->join .= 'INNER JOIN '.Constants::SCHEMA_SINASE.'.projetocursoquestionario pcq on pcq.idprojeto = ci.idprojeto and pcq.idcursomoodle = ci.idcursomoodle ';
		$criteria->join .= 'INNER JOIN '.Constants::SCHEMA_SINASE.'.questionario que on que.idquestionario = pcq.idquestionario ';

		$criteria->addCondition('ci.idusuario = '.$userId);
		$criteria->addCondition('ci.idturma is not null');
		$criteria->addCondition('ci.idusuario not in ('.$subQuery->getText().')');

		if (isset($curso->id) && $curso->id != "") {
			$criteria->addCondition('ci.idcursomoodle = '.$curso->id);
		}

		if($count){
			return $this->model()->find($criteria);
		}
		return $criteria;

	}

}
