<?php

// auto-loading fix
Yii::setPathOfAlias('VwCurso', dirname(__FILE__).'/base');
Yii::import('VwCurso.*');

class Curso extends BaseVwCurso
{
	public $idCursoFull 		= null;

	public $idusuariocurso 		= null;
	public $idcursomoodle		= null;

	public $dtfimcurso			= null;
	public $dtfiminscricao		= null;
	public $dtiniciocurso		= null;
	public $dtinicioinscricao	= null;
    
	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->id;

	}

	public function behaviors()
	{
		// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function getNuModulos()
	{
		$nuModulos = array();
		for ($i = 0; $i < Constants::MOODLE_NU_MODULOS; $i++) {
			$nuModulos[$i] = array('id'=>$i+1, 'name'=>'Módulo '.($i+1));
		}
		return $nuModulos;
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						array('dtfimcurso',
								'compare',
								'compareAttribute'=>'dtiniciocurso',
								'allowEmpty'=>true,
								'operator'=>'>=',
								'message'=>'Data final não pode ser menor que a data inicial',
								'on'=>'buscaAndamento'),
						array('idprojeto, idquestionario, category, fullname, shortname, visible, summary, startdate, numsections', 'required'),

				),
				parent::rules()
		);
	}

	public function preCreate()
	{
		try {
			$params = array('courses' => $this->getAttributesSave());

			if (!count($this->getErrors()))
			{
				$WSMoodle = new WSMoodle();
				$courses = $WSMoodle->callFunction('core_course_create_courses', array($params));
				$this->id = $courses[0]['id'];

				/*
				 * Atualiza a tabela de Projetos.
				*/
				$this->idcursomoodle = $this->id;
				$this->dtiniciocurso = $this->startdate;
				$this->dtfimcurso = $this->dtfimcurso;
				$this->dtinicioinscricao = $this->dtinicioinscricao;
				$this->dtfiminscricao = $this->dtfiminscricao;

				$ProjetoCurso = new ProjetoCurso();
				$ProjetoCurso->atualizaProjetoCurso($this);

				return $this;
			}
			return false;
		} catch (Exception $e) {
			return $this->addError('erroGeneric', "- ".$e->getMessage());
		}
	}

	/**
	 * @param unknown_type $dados
	 * @throws CHttpException
	 * @return unknown
	 */
	public function preInscricao(array $dados)
	{
		try {
			$ControleInscricao = new ControleInscricao();
			$ControleInscricao->idprojeto = $dados['idprojeto'];
			$ControleInscricao->idcursomoodle = $dados['idcursomoodle'];
			$ControleInscricao->idquestionario = $dados['idquestionario'];
			$ControleInscricao->idusuario = Yii::app()->user->id;
			$ControleInscricao->dtinscricao = new CDbExpression('NOW()');
			if ($ControleInscricao->validate())
				$ControleInscricao->save();

			if( self::getInscricao( $ControleInscricao->idprojeto,
									$ControleInscricao->idcursomoodle ,
									$ControleInscricao->idusuario)){
				$model = new Questionario();

				if ( $model->preCreateResposta($dados) ){
					//encaminha email para o aluno
					$Email = new Email();
					$Email->preSendMail(7, $ControleInscricao->idusuario, array(), $ControleInscricao->idcursomoodle);

					return $this->id = $dados['idcursomoodle'];
				}
			}
			throw new CHttpException(500, Yii::t('app', 'erro.incricaoMoodle'));

		} catch (Exception $e) {
			throw new CHttpException(500, $e->getMessage());
		}
	}

	public function inscricao($idMoodle, $idCurso, $suspend = 0)
	{
		try {
			if( !$this->validateInscricao($idMoodle,
										  $idCurso,
										  Constants::MOODLE_ROLE_TYPE_ENROL) )
			{
				$options = array(
						'roleid' 	=> Constants::MOODLE_ROLE_TYPE_ENROL,
						'userid'	=> $idMoodle,
						'courseid'	=> $idCurso,
						//'timestart'	=> $dados[''],
						//'timeend'	=> $dados[''],
						'suspend'	=> $suspend
				);

				$params = array('enrolments' => $options);

				$WSMoodle = new WSMoodle();
				$userEnrol = $WSMoodle->callFunction('enrol_manual_enrol_users', array($params));

				if ($this->validateInscricao($idMoodle,
											 $idCurso,
											 Constants::MOODLE_ROLE_TYPE_ENROL) ) {
					return true;
				}
				return false;
			} else {
				return true;
			}
		} catch (Exception $e) {
			throw new CHttpException(404, $e->getMessage());
		}
	}

	public function getInscricao($idprojeto, $idcursomoodle, $idusuario)
	{
		return Yii::app()->db->createCommand()
				->select('p.idprojeto, p.idcursomoodle, p.idquestionario, p.idusuario, p.dtinscricao')
				->from(Constants::SCHEMA_SINASE.'.controleinscricao p')
				->where('p.idprojeto=:idprojeto
						and p.idcursomoodle=:idcursomoodle
						and p.idusuario=:idusuario ',
						array(	':idprojeto'=>$idprojeto,
								':idcursomoodle'=>$idcursomoodle,
								':idusuario'=>$idusuario
						))
						->queryRow();
	}

	public function validateInscricao($iduser, $idcourse, $idrole)
	{
		return Yii::app()->db->createCommand()
				->select('vw.iduser')
				->from(Constants::SCHEMA_SINASE.'.vw_usuarioinscricao vw')
				->where('vw.iduser=:iduser
						and vw.idcourse=:idcourse
						and idrole=:idrole ',
						array(	':iduser'=>$iduser,
								':idcourse'=>$idcourse,
								':idrole'=>$idrole
						))
						->queryRow();
	}

	public function preUpdate()
	{
		try {
			$params = array('courses' => $this->getAttributesSave(array('id'=>$this->id)));

			if (!count($this->getErrors()))
			{
				$WSMoodle = new WSMoodle();
				$courses = $WSMoodle->callFunction('local_wsmymoodle_update_courses', array($params));
				/*
				 * Atualiza a tabela de Projetos.
				 */
				$Curso = Curso::model()->find('id=:idcursomoodle',
											  array(':idcursomoodle'=>$this->id));
				$this->idcursomoodle 	= $Curso->id;

				$ProjetoCurso = new ProjetoCurso();
				$ProjetoCurso->atualizaProjetoCurso($this);

				return $this;
			}
			return false;
		} catch (Exception $e) {
			return $this->addError('erroGeneric', "- ".$e->getMessage());
		}
	}

	public function preDelete($id)
	{
		/*
		 * true = desabilita o curso
		* false = exclui o curso
		*/
		if (Constants::MOODLE_DISABLE_CURSO)
			return self::preDisable($id);

		$params = array('courseids' => array('id'=>$id));

		$WSMoodle = new WSMoodle();
		return $WSMoodle->callFunction('local_wsmymoodle_delete_courses', array($params));
	}

	public function preDisable($id)
	{
		$params = array('courseids' => array('id'=>$id));

		$WSMoodle = new WSMoodle();
		return $WSMoodle->callFunction('local_wsmymoodle_disable_courses', array($params));
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function searchFind()
	{
		$criteria=new CDbCriteria();
		$criteria->compare('idprojeto',$this->idprojeto);
		$criteria->compare('dcprojeto',$this->dcprojeto,true);
		$criteria->compare('dtinicio',$this->dtinicio);
		$criteria->compare('dtfinal',$this->dtfinal);
		$criteria->compare('inprojetoinativo',$this->inprojetoinativo);
		$criteria->compare('id',$this->id);
		$criteria->compare('category',$this->category);
		$criteria->compare('categoryname',$this->categoryname,true);
		$criteria->compare('fullname',$this->fullname,true);
		$criteria->compare('shortname',$this->shortname,true);
		$criteria->compare('visible',$this->visible);
		$criteria->compare('summary',$this->summary,true);
		$criteria->compare('startdate',$this->startdate);
		$criteria->compare('numsections',$this->numsections);
		$criteria->compare('format',$this->format,true);
		$criteria->compare('idquestionario',$this->idquestionario);
		$criteria->compare('idcursomoodle',$this->idcursomoodle);
		$criteria->compare('dtiniciocurso', $this->dtiniciocurso);
		// 		$criteria->compare('dtiniciocurso', array($this->dtiniciocurso, $this->dtiniciocurso));
		$criteria->compare('dtfimcurso',$this->dtfimcurso);

		return $this->findAll($criteria);
	}

	public function search()
	{
		$this->beforeFind();

		$criteria=new CDbCriteria();
		$criteria->compare('idprojeto',$this->idprojeto);
		$criteria->compare('dcprojeto',$this->dcprojeto,true);
		$criteria->compare('dtinicio',$this->dtinicio);
		$criteria->compare('dtfinal',$this->dtfinal);
		$criteria->compare('inprojetoinativo',$this->inprojetoinativo);
		$criteria->compare('id',$this->id);
		$criteria->compare('category',$this->category);
		$criteria->compare('categoryname',$this->categoryname,true);
		$criteria->compare('fullname',$this->fullname,true);
		$criteria->compare('shortname',$this->shortname,true);
		$criteria->compare('visible',$this->visible);
		$criteria->compare('summary',$this->summary,true);
		$criteria->compare('startdate',$this->startdate);
		$criteria->compare('numsections',$this->numsections);
		$criteria->compare('format',$this->format,true);
		$criteria->compare('idquestionario',$this->idquestionario);
		$criteria->compare('idcursomoodle',$this->idcursomoodle);
		$criteria->compare('dtiniciocurso', $this->dtiniciocurso);
		// 		$criteria->compare('dtiniciocurso', array($this->dtiniciocurso, $this->dtiniciocurso));
		$criteria->compare('dtfimcurso',$this->dtfimcurso);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function buscaStatusCurso($tipo = null)
	{
		$criteria=new CDbCriteria();
		$criteria->compare('vwc.idprojeto',$this->idprojeto);
		$criteria->compare('dcprojeto',$this->dcprojeto, true);
		$criteria->compare('id',$this->id);
		$criteria->compare('fullname',$this->fullname, true);

		$this->dtiniciocurso = (!empty($this->dtiniciocurso))
								?date('Y-m-d', CDateTimeParser::parse($this->dtiniciocurso, Yii::app()->locale->getDateFormat('medium')))
								:NULL;

		$this->dtfimcurso = (!empty($this->dtfimcurso))
							 ?date('Y-m-d', CDateTimeParser::parse($this->dtfimcurso, Yii::app()->locale->getDateFormat('medium')))
							 :NULL;
		switch ($tipo) {
			case 'andamento' :
				$this->criteriaAndamento($criteria);
				break;
			case 'finalizado' :
				$this->criteriaFinalizado($criteria);
				break;
			case 'aberto' :
				$this->criteriaAberto($criteria);
				break;
			case 'abertoAndamento' :
				$this->criteriaAbertoAndamento($criteria);
				break;
			case '' :
				$this->criteriaNormal($criteria);
				break;
		}

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}


	protected function criteriaAbertoAndamento(&$criteria, $alias = TRUE)
	{
		if($alias === TRUE){
			$criteria->alias = 'vwc';
		}
		$criteria->addCondition("vwc.dtfimcurso >= now()");
	}

	public function criteriaAndamento(&$criteria)
	{
		if (empty($this->dtiniciocurso) && empty($this->dtfimcurso))
		{
			$criteria->addCondition("dtiniciocurso::date <= now()::date AND dtfimcurso::date >= now()::date");
		}

		if (!empty($this->dtiniciocurso) && !empty($this->dtfimcurso))
		{
			$criteria->addCondition("(dtiniciocurso::date >= '{$this->dtiniciocurso}' AND dtfimcurso::date <= '{$this->dtfimcurso}')");
		} else if (!empty($this->dtiniciocurso)) {
			$criteria->addCondition("dtiniciocurso::date >= '{$this->dtiniciocurso}' AND dtfimcurso::date >= now()::date");
		} else if (!empty($this->dtfimcurso)) {
			$criteria->addCondition("dtiniciocurso::date <= now()::date AND dtfimcurso::date >= '{$this->dtfimcurso}'");
		}

	}

	public function criteriaAberto(&$criteria, $alias = TRUE)
	{
		if($alias === TRUE){
			$criteria->alias = 'vwc';
		}
		$criteria->select = 'vwc.idprojeto, vwc.dcprojeto, vwc.dtinicio, vwc.dtfinal, vwc.inprojetoinativo,
							vwc.id, vwc.fullname, vwc.shortname, vwc.visible,
							vwc.startdate, vwc.idquestionario, vwc.dtinicioinscricao, vwc.dtfiminscricao,
							vwc.idcursomoodle, vwc.dtiniciocurso, vwc.dtfimcurso,
							pi.idcursomoodle as idusuariocurso';
		$criteria->join .=' left join '.Constants::SCHEMA_SINASE.'.controleinscricao pi on vwc.idcursomoodle = pi.idcursomoodle
																					AND vwc.idprojeto = pi.idprojeto
																					AND pi.idusuario = '.Yii::app()->user->id;
		$criteria->addCondition("now()::date BETWEEN vwc.dtinicioinscricao::date AND vwc.dtfiminscricao::date");
	}

	public function criteriaNormal(&$criteria)
	{
		$criteria->alias = 'c';
		$criteria->select = 'c.idprojeto, c.dcprojeto, c.dtinicio, c.dtfinal, c.inprojetoinativo,
							c.id, c.fullname, c.shortname, c.visible,
							c.startdate, c.idquestionario, c.dtinicioinscricao,
							c.idcursomoodle, c.dtiniciocurso, c.dtfimcurso,
							pi.idcursomoodle as idusuariocurso';
		$criteria->join='left join '.Constants::SCHEMA_SINASE.'.controleinscricao pi on c.idcursomoodle = pi.idcursomoodle
						AND c.idprojeto = pi.idprojeto
						AND pi.idusuario = '.Yii::app()->user->id;

		if (!empty($this->dtiniciocurso) && !empty($this->dtfimcurso)) {
			$criteria->addCondition("(dtiniciocurso::date >= '{$this->dtiniciocurso}' AND ".
									"dtfimcurso::date <= '{$this->dtfimcurso}')");
			$criteria->addCondition("dtfimcurso::date < now()::date");
		} else if (!empty($this->dtiniciocurso)) {
			$criteria->addCondition("dtiniciocurso::date >= '{$this->dtiniciocurso}'");
		} else if (!empty($this->dtfimcurso)) {
			$criteria->addCondition("dtfimcurso::date <= '{$this->dtfimcurso}'");
		}

		//$criteria->addCondition("now()::date BETWEEN c.dtinicioinscricao::date AND c.dtfiminscricao::date");
	}

	public function criteriaFinalizado(&$criteria)
	{
		if (empty($this->dtiniciocurso) && empty($this->dtfimcurso)) {
			$criteria->addCondition("dtfimcurso::date < now()::date");
		}

		if (!empty($this->dtiniciocurso) && !empty($this->dtfimcurso)) {
			$criteria->addCondition("(dtiniciocurso::date >= '{$this->dtiniciocurso}' OR dtfimcurso::date <= '{$this->dtfimcurso}')");
			$criteria->addCondition("dtfimcurso::date < now()::date");
		} else if (!empty($this->dtiniciocurso)) {
			$criteria->addCondition("dtiniciocurso::date >= '{$this->dtiniciocurso}' AND dtfimcurso::date < now()::date");
		} else if (!empty($this->dtfimcurso)) {
			$criteria->addCondition("dtiniciocurso::date <= now()::date AND dtfimcurso::date < '{$this->dtfimcurso}'");
		}

	}

	public function attributeLabels()
	{
		return array(
				'dcprojeto'     => Yii::t('app', 'curso.dcprojeto'),
				'idquestao' 	=> Yii::t('app', 'curso.idquestao'),
				'id' 			=> Yii::t('app', 'curso.id'),
				'category' 		=> Yii::t('app', 'categoria.id'),
				'categoryname' 	=> Yii::t('app', 'categoria.name'),
				'fullname' 		=> Yii::t('app', 'curso.fullname'),
				'shortname' 	=> Yii::t('app', 'curso.shortname'),
				'visible' 		=> Yii::t('app', 'generic.inativo'),
				'summary' 		=> Yii::t('app', 'curso.summary'),
				'detalhamento'	=> Yii::t('app', 'curso.detalhamento'),
				'numsections' 	=> Yii::t('app', 'curso.numsections'),
				'format' 		=> Yii::t('app', 'generic.format'),
				'idquestionario'=> Yii::t('app', 'curso.idquestionario'),
				'idprojeto' 	=> Yii::t('app', 'curso.idprojeto'),
				'idcursomoodle' => Yii::t('app', 'curso.idcursomoodle'),

				'startdate' 		=> Yii::t('app', 'curso.dtiniciocurso'),
				'dtiniciocurso'		=> Yii::t('app', 'curso.dtiniciocurso'),
				'dtfimcurso' 		=> Yii::t('app', 'curso.dtfimcurso'),
				'dtinicioinscricao'	=> Yii::t('app', 'curso.dtinicioinscricao'),
				'dtfiminscricao'	=> Yii::t('app', 'curso.dtfiminscricao'),
				'dcformulario'		=> Yii::t('app', 'questionario.dcformulario')

		);
	}

	public function listCursos()
	{
		return Yii::app()->db->createCommand()->select('c.id, c.shortname, c.fullname')
		->from(Constants::SCHEMA_SINASE.'.vw_curso c')
		->where('c.visible=:visible', array(':visible'=>1))
		->queryAll();
	}

	public function getCursos($idCurso)
	{
		return Yii::app()->db->createCommand()
		->select('c.idprojeto, c.dcprojeto, c.category,
				 c.categoryname, c.id as idcurso, c.fullname,
				 c.shortname, c.visible,
				 c.summary, c.numsections, c.idquestionario,
				 c.idcursomoodle, c.startdate, c.dtiniciocurso,
				 c.dtfimcurso, c.dtinicioinscricao, c.dtfiminscricao,
				 c.dcformulario')
		->from(Constants::SCHEMA_SINASE.'.vw_curso c')
		->where('c.visible=:visible and c.id=:id', array(':visible'=>1, ':id'=>$idCurso))
		->queryRow();
	}

	private function getAttributesSave($course = array())
	{
		/* ################ showgrades ####################
		 * Mostrar livro de notas aos estudantes
		*
		* Muitas atividades podem ser avaliadas mediante atribuição de notas.
		*
		* Os resultados das avaliações são consultados pelos alunos na página
		*  de Relatório de Notas, cujo acesso se faz por um link predefinido
		*  na página principal do curso.
		*
		*  Para restringir o acesso ao Relatório de Notas apenas aos professores,
		*  é necessário desabilitar a visualização no painel de configuração do
			*  curso. Este procedimento é útil também nos casos em que o curso não
		*  prevê o uso de atividades com avaliação correspondente. Isto não impede
		*  que atividades individuais utilizem ou atribuam notas, apenas desativa
		*  a exibição da página de relatório para os estudantes.
		*/
		/* ################ newsitems ####################
		 * Quantas notícias mostrar
		* "Últimas Notícias" é um fórum especial dos cursos que adotam os
		* formatos "semanal" e "tópicos". É um bom lugar para publicar
		* avisos que devam ser vistos por todos os alunos. Como regra
		* predefinida, todos os alunos são assinantes deste fórum e
		* receberão uma cópia dos avisos via email.
		*
		* Esta configuração define o número de notícias recentes que serão
		* visualizadas na página principal do curso, no bloco "Últimas Notícias".
		*
		* Se você definir o valor como "0 itens" o bloco "Últimas Notícias"
		* não será visualizado.
		*/
		if ($this->validate()){
			$dateToLocale=Yii::app()->dateFormatter->formatDateTime(CDateTimeParser::parse($this->startdate, 'dd-MM-yyyy'),'medium',null);
			$startdate = date('Y-m-d', CDateTimeParser::parse($dateToLocale, Yii::app()->locale->dateFormat));

			// 			$dateToLocale=Yii::app()->dateFormatter->formatDateTime(CDateTimeParser::parse($this->dtfinal, 'dd-MM-yyyy'),'medium',null);
			// 			$dtfinal = date('Y-m-d', CDateTimeParser::parse($dateToLocale, Yii::app()->locale->dateFormat));

			$date = new DateTime($startdate);
			$startdate = $date->getTimestamp();

			$date = new DateTime();
			$dtCadastro = $date->getTimestamp();

			// Create base categories.
			$course['categoryid'] 	= $this->category;
			$course['fullname'] 	= $this->fullname;
			$course['shortname'] 	= $this->shortname;
			$course['startdate'] 	= $startdate;
			//$course['timecreated'] 	= $dtCadastro;
			$course['summary'] 		= $this->summary;

			/* Vamos utilizar editor que salva HTML, usaresmo formato HTML = 1
			 * 0 - Formato  Automático
			* 1 - Formato HTML
			* 2 - Formato TEXT
			* 4 - Formato MARKDOWN
			*/
			$course['summaryformat']= 1;
			/* USAREMOS SEMPRE TOPICS
			 * scorm  - Formato SCORM
			* social - Formato Social
			* topics - Formato Tópicos
			* weeks  - Formato Semanal
			*/
			$course['format'] 		= 'topics';
			/* numsections
			 * Número de semanas ou tópicos
			*/
			$course['numsections'] 	= $this->numsections;
			/* Disponibilidade
			 * 0 - Este curso não pode ser acessado pelos participantes
			* 1 - Este curso pode ser acessado pelos participantes
			*/
			$course['visible'] 		= $this->visible;

			/*
			 * Não forçar o idioma
			*/
			//$course['lang'] 			= 'en';

			$course['showgrades'] 	= 1;
			/* Layout do curso
			 * 0 - Mostrar todos os tópicos em uma página
			* 1 - Mostrar um tópico por página
			*/
			//$course['coursedisplay']= 1;
			$course['newsitems'] 	= 0;
			/* maxbytes
			 * Tamanho máximo de upload
			*/
			$course['maxbytes'] 	= 1048576;
			/* showreports
			 * Mostrar relatório das atividades
			*/
			$course['showreports'] 	= 1;
			/*
			 * 0 - Seções escondidas são mostratas contraídas
			* 1 - Seções escondidas são completamente invisíveis
			*/
			$course['hiddensections'] 	= 0;
			/* Usaremos como padrão o Grupos Separados para permitir criar as turmas
			 * 0 - Nenhum grupo
			* 1 - Grupos separados
			* 2 - Grupos visíveis
			*/
			$course['groupmode'] 	= 1;
			/* Forçar modalidade grupo
			 * 0 - Sim
			* 1 - Não
			*/
			$course['groupmodeforce']= 1;

			// 	        $course['defaultgroupingid'] 		= 0;
			// 	        $course['enablecompletion'] 		= 1;
			// 	        $course['completionstartonenrol'] 	= 1;
			// 	        $course['completionnotify'] 		= 1;
			// 			$course['forcetheme'] 				= 'base';
			return $course;
		}
		return false;
	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/
	public function primaryKey()
	{
		return 'id';
	}

	public function cursoModulosTarefaForumQuest($userId, $idCourse)
	{
		$forum  = new CursoForum;
		$tarefa = new CursoTarefa;
		$quest   = new CursoAvaliacao;

		$sql = $tarefa->tarefasUsuario($userId, $idCourse, FALSE).
			   ' UNION ALL '.
			   $forum->forumUsuario($userId, $idCourse, FALSE).
			   ' UNION ALL '.
			   $quest->avaliacao($userId, $idCourse, FALSE);

		$sql =  Yii::app()->db->createCommand($sql);
		$sql->bindParam(":idcurso", $idCourse, PDO::PARAM_STR);
		$sql->order('dcmodulo');

		//echo $sql->getText(); die;
		return $sql->queryAll();

	}

	public function cursosAluno($userId, $status)
	{
		$criteria=new CDbCriteria();

		$criteria->alias = "c";
		$criteria->select = 'c.idprojeto, c.dcprojeto, c.id, c.shortname, c.dtiniciocurso, c.dtfimcurso';

		$criteria->compare('c.idprojeto', $this->idprojeto, FALSE);
		$criteria->compare('c.id', $this->id, FALSE);
		$criteria->compare('c.shortname', $this->shortname, TRUE);

		$criteria->join = 'INNER JOIN '.Constants::SCHEMA_SINASE.'.controleinscricao p on p.idcursomoodle = c.id';

		$this->dtiniciocurso = (!empty($this->dtiniciocurso))
		?date('Y-m-d', CDateTimeParser::parse($this->dtiniciocurso, Yii::app()->locale->getDateFormat('medium')))
		:NULL;

		$this->dtfimcurso = (!empty($this->dtfimcurso))
		?date('Y-m-d', CDateTimeParser::parse($this->dtfimcurso, Yii::app()->locale->getDateFormat('medium')))
		:NULL;

		switch ($status) {
			case 'andamento' :
				$this->criteriaAndamento($criteria);
				break;
			case 'finalizado' :
				$this->criteriaFinalizado($criteria);
				break;
		}

		$criteria->addCondition('p.idusuario = '.$userId);
		$criteria->addCondition('p.dtenturmado is not null');

		//$criteria->group = 'idprojeto, dcprojeto, id, shortname, dtiniciocurso, dtfimcurso';

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function atividadesPendentes($userid, CursoTurma $cursoTurma)
	{
		//Curso Tarefa
		$subQueryTarefa = Yii::app()->db->createCommand()
						->select('ctu.idtarefa')
						->from(Constants::SCHEMA_SINASE.'.vw_cursotarefausuario ctu')
						->join(Constants::SCHEMA_SINASE.'.usuario usu', 'usu.idmoodle = ctu.userid')
						->where('ctu.idtarefa = ct.idtarefa and usu.idusuario = '.$userid)
						->getText();

		$queryTarefa = Yii::app()->db->createCommand()
						->select('ct.descricao AS dsatividade, ct.dtinicio AS dtinicioentrega, ct.dtlimite AS dtlimiteentrega')
						->from(Constants::SCHEMA_SINASE.'.vw_cursotarefa ct')
						->join(Constants::SCHEMA_SINASE.'.vw_cursoturma ctu', 'ctu.courseid = ct.idcurso')
						->join(Constants::SCHEMA_SINASE.'.controleinscricao ci', 'ci.idcursomoodle = ct.idcurso');

		$filter_where_tarefa = array('ct.idtarefa NOT IN ('. $subQueryTarefa . ') AND ct.dtinicio < now() AND ci.idusuario =' .$userid);
		$filter_where_data_tarefa = array();

		if (isset($this->id) && $this->id != "") {
			$filter_where_tarefa[] = ' AND idcurso = '.$this->id;
		}

		if (isset($cursoTurma->id) && $cursoTurma->id != "") {
			$filter_where_tarefa[] = ' AND ctu.id = '.$cursoTurma->id;
		}

		$queryTarefa->where(implode('', $filter_where_tarefa));
		$queryTarefa = $queryTarefa->getText();

		//Curso Avaliacao
		$subQueryAvaliacao = Yii::app()->db->createCommand()
						->select('cau.idavaliacao')
						->from(Constants::SCHEMA_SINASE.'.vw_cursoavaliacaousuario cau')
						->join(Constants::SCHEMA_SINASE.'.usuario usu', 'usu.idmoodle = cau.userid')
						->where('cau.idavaliacao = ca.idavaliacao AND usu.idusuario = '.$userid)
						->getText();

		$queryAvaliacao = Yii::app()->db->createCommand()
						->union($queryTarefa)
						->select('ca.descricao AS dsatividade, ca.dtinicio AS dtinicioentrega, ca.dtlimite AS dtlimiteentrega')
						->from(Constants::SCHEMA_SINASE.'.vw_cursoavaliacao ca')
						->join(Constants::SCHEMA_SINASE.'.vw_cursoturma ctu', 'ctu.courseid = ca.idcurso')
						->join(Constants::SCHEMA_SINASE.'.controleinscricao ci', 'ci.idcursomoodle = ca.idcurso');

		$filter_where_avaliacao = array('ca.idavaliacao NOT IN ('.$subQueryAvaliacao.') AND ca.dtinicio < now() AND ci.idusuario =' .$userid);
		$filter_where_data_avaliacao = array();

		if (isset($this->id) && $this->id != "") {
			$filter_where_avaliacao[] = ' AND idcurso = '.$this->id;
		}

		if (isset($cursoTurma->id) && $cursoTurma->id != "") {
			$filter_where_avaliacao[] = ' AND ctu.id = '.$cursoTurma->id;
		}

		$queryAvaliacao->where(implode('', $filter_where_avaliacao));
		$queryAvaliacao = $queryAvaliacao->getText();


		//Curso Forum
		$subQueryForum = Yii::app()->db->createCommand()
						->select('cfu.idtopicoforum')
						->from(Constants::SCHEMA_SINASE.'.vw_cursoforumpostusuario cfu')
						->join(Constants::SCHEMA_SINASE.'.usuario usu', 'usu.idmoodle = cfu.userid')
						->where('usu.idusuario = '.$userid.' AND cfu.idtopicoforum = cf.idforum')
						->getText();

		$queryForum = Yii::app()->db->createCommand()
						->union($queryAvaliacao)
						->select('cf.descricao AS dsatividade, cf.dtinicio AS dtinicioentrega, cf.dtlimite AS dtlimiteentrega')
						->from(Constants::SCHEMA_SINASE.'.vw_cursoforum cf')
						->join(Constants::SCHEMA_SINASE.'.vw_cursoturma ctu', 'ctu.courseid = cf.idcurso')
						->join(Constants::SCHEMA_SINASE.'.controleinscricao ci', 'ci.idcursomoodle = cf.idcurso');

		$filter_where_forum = array('cf.idforum NOT IN ('.$subQueryForum.') AND cf.dtinicio < now() AND ci.idusuario =' .$userid);
		$filter_where_data_forum = array();

		if (isset($this->id) && $this->id != "") {
			$filter_where_forum[] = ' AND idcurso = '.$this->id;
		}

		if (isset($cursoTurma->id) && $cursoTurma->id != "") {
			$filter_where_forum[] = ' AND ctu.id = '.$cursoTurma->id;
		}

		$queryForum->where(implode('', $filter_where_forum));
		$queryForum = $queryForum->getText();


		$select = Yii::app()->db->createCommand()
						->select('COUNT(dsatividade)')
						->from('(' . $queryForum . ') atividades')
						->queryRow();

		return $select;

	}

	public function atividadesSemana($userid = NULL, $count = TRUE, CursoTurma $cursoTurma = NULL)
	{
		$select = Yii::app()->db->createCommand();
		if ($count === FALSE) {
			$select->select('c.dcprojeto, c.dtinicio, c.dtfinal, c.shortname, t.name, cma.dtinicio AS dtinicioentrega, cma.dtlimite AS dtlimiteentrega, cma.descricao');
		} else {
			$select->select('count(idcurso)');
		}
		$select->from(Constants::SCHEMA_SINASE.'.vw_curso c')
						->join(Constants::SCHEMA_SINASE.'.controleinscricao p', 'p.idcursomoodle = c.id')
						->join(Constants::SCHEMA_SINASE.'.vw_cursomoduloatividade cma', 'c.id = cma.idcurso')
						->join(Constants::SCHEMA_SINASE.'.vw_cursoturma t', 't.courseid = c.id AND p.idturma = t.id');

		$filter_where = array();
		$filter_data = array();

		$filter_where[] = "cma.dtlimite >= (now()::date - date_part('dow',now()::date)::integer)".
			" and cma.dtlimite <= (now()::date +  ( 6 - date_part('dow',now()::date)::integer) )";

		if(isset($userid)) {
			$filter_where[] = " and p.idusuario = :idusuario";
			$filter_data[':idusuario'] = $userid;
		}


		if (isset($this->id) && $this->id != "") {
			$filter_where[] = ' AND c.id = :idcurso';
			$filter_data[':idcurso'] = $this->id;
		}

		if (isset($cursoTurma->id) && $cursoTurma->id != "") {
			$filter_where[] = ' AND t.id = :id';
			$filter_data[':id'] = $cursoTurma->id;
		}

		$select->where(implode('', $filter_where), $filter_data);

		if ($count === FALSE) {
			$retorno = $select->queryAll();
		} else {
			$retorno = $select->queryRow();
		}

		return $retorno;

	}

/**
 * @deprecated
 * Metodo depreciado. Utilizar metodo da model Mensagem
 */

// 	public function mensagensNaoLidas($userId, CursoTurma $cursoTurma)
// 	{
// 		$select = Yii::app()->db->createCommand()
// 		->select('count(distinct m.idmensagem)')
// 		->from(Constants::SCHEMA_SINASE.'.vw_curso vwc')
// 		->join(Constants::SCHEMA_SINASE.'.vw_cursoturma t', 't.courseid = vwc.id')
// 		->join(Constants::SCHEMA_SINASE.'.mensagem m', 'm.idcursomoodle = vwc.id')
//   		->leftJoin(Constants::SCHEMA_SINASE.'.usuariomensagemlida uml', 'uml.idmensagem = m.idmensagem');

// 		$filter_where = array();
// 		$filter_data = array();

// 		$filter_where[] = 'idusuariodestinatario = :userId and uml.idmensagem is null';
// 		$filter_data[':userId'] = $userId;

// 		if (isset($this->id) && $this->id != "") {
// 			$filter_where[] = ' AND vwc.id = :idcurso';
// 			$filter_data[':idcurso'] = $this->id;
// 		}

// 		if (isset($cursoTurma->id) && $cursoTurma->id != "") {
// 			$filter_where[] = ' AND t.id = :id';
// 			$filter_data[':id'] = $cursoTurma->id;
// 		}

// 		$select->where(implode('', $filter_where), $filter_data);

//   		return $select->queryRow();

// 	}

	public function cursosEmAberto($userId, CursoTurma $cursoTurma)
	{
		$select = Yii::app()->db->createCommand()
		->select('count(c.id)')
		->from(Constants::SCHEMA_SINASE.'.vw_curso c');
		//->join(Constants::SCHEMA_SINASE.'.controleinscricao p', 'p.idcursomoodle = c.id');

		$filter_where = array();
		$filter_data = array();

		//$filter_where[] = 'p.idusuario = :userid  and p.dtenturmado is not null and now()::date BETWEEN c.dtinicioinscricao::date and dtfiminscricao::date';
		$filter_where[] = 'now()::date BETWEEN c.dtinicioinscricao::date and dtfiminscricao::date';
		//$filter_data[':userid'] = $userId;

		if (isset($this->id) && $this->id != "") {
			$filter_where[] = ' AND c.id = :idcurso';
			$filter_data[':idcurso'] = $this->id;
		}

// 		if (isset($cursoTurma->id) && $cursoTurma->id != "") {
// 			$filter_where[] = ' AND t.id = :id';
// 			$filter_data[':id'] = $cursoTurma->id;
// 		}

		$select->where(implode('', $filter_where), $filter_data);

		return $select->queryRow();
	}

	public function getSituacao()
	{
		return array(
				array('idsituacao'=>'1', 'dcsituacao'=>'Inscrição'),
				array('idsituacao'=>'2', 'dcsituacao'=>'Em Andamento'),
				array('idsituacao'=>'3', 'dcsituacao'=>'Finalizados'),
		);
	}

	public function listCursosAluno($userId)
	{
		$select = Yii::app()->db->createCommand()
					->select('id, shortname')
					->from(Constants::SCHEMA_SINASE.'.vw_curso c')
					->join(Constants::SCHEMA_SINASE.'.controleinscricao p', 'p.idcursomoodle = c.id')
					->where('p.idusuario = '.$userId.'  and p.dtenturmado is not null')
					->getText();

		return $select;
	}

	public function detalheAtividadesPendentes($userid, $idCurso)
	{
		//Curso Tarefa
		$subQueryTarefa = Yii::app()->db->createCommand()
						->select('ctu.idtarefa')
						->from(Constants::SCHEMA_SINASE.'.vw_cursotarefausuario ctu')
						->join(Constants::SCHEMA_SINASE.'.usuario usu', 'usu.idmoodle = ctu.userid')
						->where('ctu.idtarefa = ct.idtarefa and usu.idusuario = '.$userid)
						->getText();

		$queryTarefa = Yii::app()->db->createCommand()
						->select('ct.descricao AS dsatividade, ct.dtinicio AS dtinicioentrega, ct.dtlimite AS dtlimiteentrega, c.dcprojeto, c.shortname, c.dtinicio, c.dtfinal, ctu.name')
						->from(Constants::SCHEMA_SINASE.'.vw_cursotarefa ct')
						->join(Constants::SCHEMA_SINASE.'.vw_cursoturma ctu', 'ctu.courseid = ct.idcurso')
						->join(Constants::SCHEMA_SINASE.'.controleinscricao ci', 'ci.idcursomoodle = ct.idcurso AND ci.idturma = ctu.id')
						->join(Constants::SCHEMA_SINASE.'.vw_curso c', 'c.id = ct.idcurso');

		$filter_where_tarefa = array('ct.idtarefa NOT IN ('. $subQueryTarefa . ') AND ct.dtinicio < now() AND ci.idusuario =' .$userid);
		$filter_where_data_tarefa = array();

		if (isset($this->id) && $this->id != "") {
			$filter_where_tarefa[] = ' AND idcurso = '.$this->id;
		}

		if (isset($cursoTurma->id) && $cursoTurma->id != "") {
			$filter_where_tarefa[] = ' AND ctu.id = '.$cursoTurma->id;
		}

		$queryTarefa->where(implode('', $filter_where_tarefa));
		$queryTarefa = $queryTarefa->getText();

		//Curso Avaliacao
		$subQueryAvaliacao = Yii::app()->db->createCommand()
						->select('cau.idavaliacao')
						->from(Constants::SCHEMA_SINASE.'.vw_cursoavaliacaousuario cau')
						->join(Constants::SCHEMA_SINASE.'.usuario usu', 'usu.idmoodle = cau.userid')
						->where('cau.idavaliacao = ca.idavaliacao AND usu.idusuario = '.$userid)
						->getText();

		$queryAvaliacao = Yii::app()->db->createCommand()
						->union($queryTarefa)
						->select('ca.descricao AS dsatividade, ca.dtinicio AS dtinicioentrega, ca.dtlimite AS dtlimiteentrega, c.dcprojeto, c.shortname, c.dtinicio, c.dtfinal, ctu.name')
						->from(Constants::SCHEMA_SINASE.'.vw_cursoavaliacao ca')
						->join(Constants::SCHEMA_SINASE.'.vw_cursoturma ctu', 'ctu.courseid = ca.idcurso')
						->join(Constants::SCHEMA_SINASE.'.controleinscricao ci', 'ci.idcursomoodle = ca.idcurso AND ci.idturma = ctu.id')
						->join(Constants::SCHEMA_SINASE.'.vw_curso c', 'c.id = ca.idcurso');

		$filter_where_avaliacao = array('ca.idavaliacao NOT IN ('.$subQueryAvaliacao.') AND ca.dtinicio < now() AND ci.idusuario =' .$userid);
		$filter_where_data_avaliacao = array();

		if (isset($this->id) && $this->id != "") {
			$filter_where_avaliacao[] = ' AND idcurso = '.$this->id;
		}

		if (isset($cursoTurma->id) && $cursoTurma->id != "") {
			$filter_where_avaliacao[] = ' AND ctu.id = '.$cursoTurma->id;
		}

		$queryAvaliacao->where(implode('', $filter_where_avaliacao));
		$queryAvaliacao = $queryAvaliacao->getText();

		//Curso Forum
		$subQueryForum = Yii::app()->db->createCommand()
						->select('cfu.idtopicoforum')
						->from(Constants::SCHEMA_SINASE.'.vw_cursoforumpostusuario cfu')
						->join(Constants::SCHEMA_SINASE.'.usuario usu', 'usu.idmoodle = cfu.userid')
						->where('usu.idusuario = '.$userid.' AND cfu.idtopicoforum = cf.idforum')
						->getText();

		$queryForum = Yii::app()->db->createCommand()
						->union($queryAvaliacao)
						->select('cf.descricao AS dsatividade, cf.dtinicio AS dtinicioentrega, cf.dtlimite AS dtlimiteentrega, c.dcprojeto, c.shortname, c.dtinicio, c.dtfinal, ctu.name')
						->from(Constants::SCHEMA_SINASE.'.vw_cursoforum cf')
						->join(Constants::SCHEMA_SINASE.'.vw_cursoturma ctu', 'ctu.courseid = cf.idcurso')
						->join(Constants::SCHEMA_SINASE.'.controleinscricao ci', 'ci.idcursomoodle = cf.idcurso AND ci.idturma = ctu.id')
						->join(Constants::SCHEMA_SINASE.'.vw_curso c', 'c.id = cf.idcurso');

		$filter_where_forum = array('cf.idforum NOT IN ('.$subQueryForum.') AND cf.dtinicio < now() AND ci.idusuario =' .$userid);
		$filter_where_data_forum = array();

		if (isset($this->id) && $this->id != "") {
			$filter_where_forum[] = ' AND idcurso = '.$this->id;
		}

		if (isset($cursoTurma->id) && $cursoTurma->id != "") {
			$filter_where_forum[] = ' AND ctu.id = '.$cursoTurma->id;
		}

// 		$queryForum->where(implode('', $filter_where_forum));
// 		$queryForum = $queryForum->getText();

		$queryForum->where(implode('', $filter_where_forum), $filter_where_data_forum);
// 		echo $query = $queryForum->getText(); die;

		return $queryForum->queryAll();

	}

	public function cursoPapelUsuario($perfilacesso){
		$select = Yii::app()->db->createCommand();

		$select->select('c.id, c.shortname')
		->from(Constants::SCHEMA_SINASE.'.vw_curso c')
		->join(Constants::SCHEMA_SINASE.'.vw_cursousuariopapel cup', 'cup.idcurso = c.id')
		->where("cup.userid = ".Yii::app()->user->profileUser['idmoodle']." AND cup.roleid = '".$perfilacesso."'");

		return $select->queryAll();
	}

}