<?php

// auto-loading fix
Yii::setPathOfAlias('VwCategoria', dirname(__FILE__).'/base');
Yii::import('VwCategoria.*');

class CursoCategoria extends BaseVwCategoria
{
	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->id;

	}

	public function behaviors()
	{
		// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function preCreate()
	{
		return $this->save();
	}

	public function preUpdate()
	{
		return $this->save();
	}

	public function preDelete($id)
	{
		return self::model()->findByPk($id)->delete();
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search()
	{
		return parent::search();
	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						//'adicioneAquiChave' => Yii::t('app', 'DescriÃ§Ã£o do label'),
				));

		return $attributes;
	}

	public function listCategorias()
	{
		return Yii::app()->db->createCommand()
			->select('c.id, c.name, c.description')
			->from(Constants::SCHEMA_SINASE.'.vw_categoria c')
			->where('c.visible=:visible', array(':visible'=>1))
			->queryAll();
	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/
	public function primaryKey()
	{
		return 'id';
	}
}
