<?php

// auto-loading fix
Yii::setPathOfAlias('VwCursoModulo', dirname(__FILE__).'/base');
Yii::import('VwCursoModulo.*');

class CursoModulo extends BaseVwCursoModulo
{
	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->fullname;

	}

	public function behaviors()
	{
		// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));

		return array_merge(parent::behaviors(),array());
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function preCreate()
	{
		try {
			if ($this->validate()){
				$options = array(	'idcourse' 	=> $this->course,
						'summary'	=> $this->summary,
						'name'		=> $this->name,
						'visible'	=> $this->visible);

				$params = array('sections' => $options);

				$WSMoodle = new WSMoodle();
				$modulo = $WSMoodle->callFunction('local_wsmymoodle_create_sections', array($params));
				$this->id = isset($modulo[0]['id'])?$modulo[0]['id']:$this->id;

				return $this;
			}
		} catch (Exception $e) {
			$message = explode("|", $e->getMessage());
			XDebug::xd($e);

			$this->addError(self::forThe($e, false), $message[0]);
		}

		return $this->save();
	}

	public function preUpdate()
	{
		try {
			if ($this->validate()){
				$options = array(	'id' 		=> $this->id,
						'idcourse' 	=> $this->course,
						'summary'	=> $this->summary,
						'name'		=> $this->name,
						'visible'	=> $this->visible);

				$params = array('sections' => $options);

				$WSMoodle = new WSMoodle();
				$courses = $WSMoodle->callFunction('local_wsmymoodle_update_sections', array($params));

				return $this;
			}
		} catch (Exception $e) {
			$message = explode("|", $e->getMessage());
			$this->addError('erroGeneric', $message[0]);
		}
	}

	public function preDelete($id)
	{
		$params = array('sections' => array('id'=>$id));

		$WSMoodle = new WSMoodle();
		return $WSMoodle->callFunction('local_wsmymoodle_delete_sections', array($params));
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search()
	{
		return parent::search();
	}

	public function attributeLabels()
	{
		return array(
				'fullname' 		=> Yii::t('app', 'curso.fullname'),
				'shortname' 	=> Yii::t('app', 'curso.shortname'),
				'id' 			=> Yii::t('app', 'cursoModulo.id'),
				'course' 		=> Yii::t('app', 'curso.fullname'),
				'section' 		=> Yii::t('app', 'cursoModulo.section'),
				'name' 			=> Yii::t('app', 'cursoModulo.name'),
				'format' 		=> Yii::t('app', 'generic.format'),
				'summary' 		=> Yii::t('app', 'generic.summary'),
				'summaryformat' => Yii::t('app', 'generic.summaryformat'),
				'visible' 		=> Yii::t('app', 'generic.inativo'),
		);
	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/
	public function primaryKey()
	{
		return 'id';
	}
}
