<?php

// auto-loading fix
Yii::setPathOfAlias('VwParticipante', dirname(__FILE__).'/base');
Yii::import('VwParticipante.*');

class CursoParticipante extends BaseVwParticipante
{
	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->id;
	}

	public function behaviors()
	{
		// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function preCreate($idCurso, $idTurma, $idMoodle)
	{
		try {
			if( !$this->validateInscricaoTurma($idCurso, $idTurma, $idMoodle) )
			{
				$options = array(
						'groupid' => $idTurma,
						'userid' => $idMoodle,
				);

				$params = array('members' => $options);

				$WSMoodle = new WSMoodle();
				$userEnrol = $WSMoodle->callFunction('core_group_add_group_members', array($params));

				if (empty($userEnrol)) {
					return true;
				}
				return false;
			}
			return true;
		} catch (Exception $e) {
			throw new CHttpException(404, $e->getMessage());
		}
	}

	public function preDelete($idCurso, $idTurma, $idMoodle)
	{
		try {
			if ($this->validateInscricaoTurma($idCurso, $idTurma, $idMoodle)) {
				$options = array(
						'groupid' => $idTurma,
						'userid' => $idMoodle,
				);

				$params = array('members' => $options);

				$WSMoodle = new WSMoodle();
				$userEnrol = $WSMoodle->callFunction('core_group_delete_group_members', array($params));
				if (empty($userEnrol)) {
					return true;
				}
				return false;
			}
			return true;
		} catch (Exception $e) {
			throw new CHttpException(404, $e->getMessage());
		}
	}

	public function validateInscricaoTurma($idCurso, $idTurma, $idMoodle)
	{
		return Yii::app()->db->createCommand()
		->select('vp.userid')
		->from(Constants::SCHEMA_SINASE.'.vw_participante vp')
		->where('vp.courseid=:courseid
				and vp.groupid=:groupid
				and vp.userid=:userid',
				array(	':courseid'=>$idCurso,
						':groupid'=>$idTurma,
						':userid'=>$idMoodle
				))
				->queryRow();
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search()
	{
		return parent::search();
	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						//'adicioneAquiChave' => Yii::t('app', 'DescriÃ§Ã£o do label'),
				));

		return $attributes;
	}

	public function qtdParticipantes($id)
	{
		return self::model()->count('groupid = ' . $id, array('groupid'));
	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/

}
