<?php
/**
 * This is the model class for table Constants::SCHEMA_SINASE.".vw_cursousuarioacesso".
 *
 * The followings are the available columns in table Constants::SCHEMA_SINASE.'.vw_cursousuarioacesso':
 * @property string $course
 * @property string $userid
 * @property string $dtultimoacesso
 */
class CursoUsuarioAcesso extends BaseCursoUsuarioAcesso
{
	public $dcnome;
	public $qtddias;

	public function diasSemAcessar(CursoTurma $cursoTurma, $count = TRUE, $exec = FALSE)
	{
		$criteria=new CDbCriteria();

		$criteria->alias  = 'cua';
		$criteria->select = 'distinct(cua.userid) as userid, now()::date - cua.dtultimoacesso as qtddias, u.dcnome';
		$criteria->order = 'u.dcnome';
		if($count === TRUE){
			$criteria->select = 'count(distinct(cua.userid))as userid';
			$criteria->order = NULL;
		}

		if(isset($cursoTurma->id) && $cursoTurma->id != ''){
			$criteria->join   = 'INNER JOIN '.Constants::SCHEMA_SINASE.'.controleinscricao ci  on cua.userid = ci.idusuario';
			$criteria->join  .= ' INNER JOIN '.Constants::SCHEMA_SINASE.'.usuario u on u.idusuario = ci.idusuario';
		}

		$criteria->addCondition('(cua.dtultimoacesso::date + 7) < now()::date');
		$criteria->compare('ci.idturma',$cursoTurma->id);

		if($exec){
			return CursoUsuarioAcesso::model()->findAll($criteria);
		} else {
			return $criteria;
		}

	}

	public function mediaAcessoPortal()
	{
		$select = Yii::app()->db->createCommand();


		$subSelect->select('count(distinct userid)')
		->from(Constants::SCHEMA_SINASE.'.vw_cursousuarioacesso cua')
		->join(Constants::SCHEMA_SINASE.'.vw_cursoturma ct', 'ct.courseid = cua.course');

		$select->select('count(userid) / 7 as qtd')
		->from(Constants::SCHEMA_SINASE.'.vw_cursousuarioacesso cua')
		->join(Constants::SCHEMA_SINASE.'.vw_cursoturma ct', 'ct.courseid = cua.course')
		->where("cua.dtultimoacesso >= (now()::date - date_part('dow',now()::date)::integer)
			     AND cua.dtultimoacesso <= (now()::date + ( 6 - date_part('dow',now()::date)::integer) )");

		return $select->queryRow();

	}
}

