<?php

// auto-loading fix
Yii::setPathOfAlias('VwCursoUsuarioPapel', dirname(__FILE__).'/base');
Yii::import('VwCursoUsuarioPapel.*');

class CursoUsuarioPapel extends BaseVwCursoUsuarioPapel
{

	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->id;
	}

	public function behaviors()
	{
		// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function vincularPapelUsuario($idpapelatual)
	{
		try {
			if (!empty($idpapelatual)){
				$options = array(	'roleid' 	=> $idpapelatual,
						'userid'	=> $this->userid,
						'contextid'	=> $this->contextid
				);
				$params = array('unassignments' => $options);
				$WSMoodle = new WSMoodle();
				$userEnrol = $WSMoodle->callFunction('core_role_unassign_roles', array($params));
			}

			$options = array('roleid' 	=> $this->roleid,
							 'userid'	=> $this->userid,
							 'contextid'=> $this->contextid
						);

			$params = array('assignments' => $options);
			$WSMoodle = new WSMoodle();
			$userEnrol = $WSMoodle->callFunction('core_role_assign_roles', array($params));

		} catch (Exception $e) {
			throw new CHttpException(404, $e);
		}
	}

	public function preCreate()
	{
		return $this->save();
	}

	public function preUpdate()
	{
		return $this->save();
	}

	public function preDelete($id)
	{
		return self::model()->findByPk($id)->delete();
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function listaUsuarioPapel($tpInscrito = null)
	{
		$criteria=new CDbCriteria;

		if ($tpInscrito === null || $tpInscrito == 2){
			$criteria->compare('idcurso ', $this->idcurso);
			$criteria->addCondition('idcurso IS NULL', 'or');
		}elseif ($tpInscrito == 0){
			$criteria->addCondition('idcurso IS NULL', 'and');
		}else
			$criteria->compare('idcurso ', $this->idcurso);

		$criteria->compare('roleid', $this->roleid);
		$criteria->compare('userid', $this->userid);

		return $this->findAll($criteria);
	}

	public function search()
	{
		return parent::search();
	}

	public function searchActiveUser($tpInscrito = null)
	{
		$criteria=new CDbCriteria;

		if ($tpInscrito === null || $tpInscrito == 2){
			$criteria->compare('idcurso ', $this->idcurso);
			$criteria->addCondition('idcurso IS NULL', 'or');
		}elseif ($tpInscrito == 0){
			$criteria->addCondition('idcurso IS NULL', 'and');
		}else
			$criteria->compare('idcurso ', $this->idcurso);

		$criteria->compare('roleid', $this->roleid);
		$criteria->compare('userid', $this->userid);
		$criteria->compare('dcnome', $this->dcnome, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						//'adicioneAquiChave' => Yii::t('app', 'DescriÃ§Ã£o do label'),
				));

		return $attributes;
	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/

}
