<?php

// auto-loading fix
Yii::setPathOfAlias('Mensagem', dirname(__FILE__).'/base');
Yii::import('Mensagem.*');

class Mensagem extends BaseMensagem
{

	public $status;
	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
				'idmensagem' => Yii::t('app', 'mensagem.idmensagem'),
				'idprojeto' => Yii::t('app', 'mensagem.idprojeto'),
				'idcursomoodle' => 'Idcursomoodle',
				'idturmamoodle' => 'Idturmamoodle',
				'idusuariodestinatario' => 'Idusuariodestinatario',
				'idusuariocriacao' => 'Idusuariocriacao',
				'dcassunto' => Yii::t('app', 'mensagem.dcassunto'),
				'dcmensagem' => 'Dcmensagem',
				'dtcriacao' => Yii::t('app', 'mensagem.dtcriacao'),
				'dtexpiracao' => 'Dtexpiracao',
				'dtpublicacao' => 'Dtpublicacao',
		);
	}

	public function mensagemPortal($idUser, $count = FALSE , CursoTurma $cursoTurma)
	{
		$query = Yii::app()->db->createCommand();

		$query->select("ct.shortname, m.dcassunto, m.dtcriacao, m.idmensagem as id, uml.idmensagem,
				(CASE WHEN uml.idmensagem IS NULL THEN 'Ler' ELSE 'Visualizar' END ) as acao")
		->from($this->tableName().' m')
	    ->leftJoin(Constants::SCHEMA_SINASE.'.usuariomensagemlida uml', 'uml.idmensagem = m.idmensagem')
		->join(Constants::SCHEMA_SINASE.'.vw_cursoturma ct', 'ct.courseid = m.idcursomoodle and ct.id = m.idturmamoodle');

		$where = array();
		$bind  = array();

		$where[] = 'm.idusuariodestinatario = :idusuario';
		$bind[':idusuario'] = $idUser;

		if(isset($cursoTurma->courseid)) {
			$where[] = ' AND ct.courseid = :courseid';
			$bind[':courseid'] = $cursoTurma->courseid;
		}

		if($this->status == '0') { //Nao lidas
			$where[] = ' AND uml.idmensagem is null';
		}

		if($this->status == '1') { //lidas
			$where[] = ' AND uml.idmensagem is not null';
		}

		if(isset($this->dcassunto) && $this->dcassunto != '') {
			$where[] = " AND m.dcassunto like '%{$this->dcassunto}%'";
		}

		$query->where(implode('', $where), $bind);

		if($count === TRUE) {
			$queryCount = Yii::app()->db->createCommand();
			return $queryCount->select('COUNT(men.id)as count')
			->from('('.$query->getText().') as men')
			->where('men.idmensagem is null')
			->bindValue(':idusuario', $idUser)
			->queryRow();
		}

		return $query->queryAll();


	}

	public function mensagemComRemetente()
	{
		$query = Yii::app()->db->createCommand();

		return $query->select('m.dcassunto, m.dtcriacao, m.dcmensagem, r.dcnome')
		->from($this->tableName().' m')
		->join(Constants::SCHEMA_SINASE.'.usuario r', 'r.idusuario = m.idusuariocriacao')
		->where('m.idmensagem = :idmensagem', array(':idmensagem'=>$this->idmensagem))
		->queryRow();
	}

}
