
<?php

/**
 * This is the model class for table Constants::SCHEMA_SINASE.".vw_notacurso".
 *
 * The followings are the available columns in table Constants::SCHEMA_SINASE.'.vw_notacurso':
 * @property string $userid
 * @property string $courseid
 * @property string $vlnota
 */
class Notacurso extends BaseNotaCurso
{
	public $iduser;
	public $firstname;

	public function search()
	{

		$criteria=new CDbCriteria;

		$criteria->compare('userid',$this->userid, FALSE);
		$criteria->compare('courseid',$this->courseid, FALSE);
		$criteria->compare('vlnota',$this->vlnota, FALSE);

		return new CActiveDataProvider($this, array(
				'criteria'=>$criteria,
				'pagination' => FALSE
		));
	}

	public function mediaNota()
	{
		$select =  Yii::app()->db->createCommand();

		return $select->select('sum(vlnota) / count(userid) as medianotas')
		->from(Constants::SCHEMA_SINASE.'.vw_notacurso')
		->where('courseid = :courseid', array(':courseid'=>$this->courseid))
		->queryRow();

	}

	public function notasAlunoCurso($cursoId)
	{
		$criteria=new CDbCriteria;

		$criteria->alias  = 'nt';
		$criteria->select = 'ui.firstname, ui.iduser, nt.vlnota';
		$criteria->join   =  'INNER JOIN '.Constants::SCHEMA_SINASE.'.vw_usuarioinscricao ui on nt.courseid = ui.idcourse and ui.iduser = nt.userid';
		$criteria->addCondition('courseid = '.$cursoId);
		$criteria->order  = 'ui.firstname';

		return $criteria;


	}
}
