<?php

// auto-loading fix
Yii::setPathOfAlias('Pesquisa', dirname(__FILE__).'/base');
Yii::import('Pesquisa.*');

class Pesquisa extends BasePesquisa
{
	public $idprojeto = null;
	public $idcurso = null;
	public $inCreate = false;

	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->dctitulo;

	}

	public function behaviors()
	{
		// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));

		return array_merge(parent::behaviors(),array());
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function savePesquisa()
	{
		$this->dtcriacao = new CDbExpression('NOW()');
		$this->idusuariocriacao = Yii::app()->user->id;
		return $this->save();
	}

	public function preDelete($id)
	{
		Condicao::model()->deleteAll('idpesquisa=:id', array(':id'=>$id));
		return Pesquisa::model()->deleteAll('idpesquisa=:id', array(':id'=>$id));
		return self::model()->findByPk($id)->delete();
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search($pageSize = 10)
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idpesquisa', $this->idpesquisa);
		$criteria->compare('idcurso', $this->idcurso);

		//$criteria->compare('dctitulo', $this->dctitulo, true);
		if ($this->dctitulo)
			$criteria->addCondition("dctitulo ilike '%{$this->dctitulo}%'");
		// 		$criteria->compare('dtcriacao', $this->dtcriacao, false);
		$criteria->compare('idusuariocriacao', $this->idusuariocriacao);
		$criteria->order = 'dctitulo';

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
				'pagination'=>array(
						'pageSize'=>$pageSize,
				),
				'sort'=>array(
						'defaultOrder'=>'dctitulo DESC',
				),
		));
	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						//'adicioneAquiChave' => Yii::t('app', 'DescriÃ§Ã£o do label'),
				));

		return $attributes;
	}

	public function listBuscaCurso($idprojeto, $idcurso)
	{
		$modelCondicao = array();
		if ($this->idpesquisa){
			$modelCondicao = Yii::app()->db->createCommand()
										->select('idcondicao as id, c.*')
										->from(Constants::SCHEMA_SINASE.'.condicao c')
										->where('c.idpesquisa=:idpesquisa', array(	':idpesquisa'=>$this->idpesquisa))
										->queryAll();
		}

		$addWhere = "";
		foreach ($modelCondicao as $key => $value) {
			// 			$addWhere = "";
			$condicao = unserialize($value['txcondicao']);
			$condicao = self::drenaArray($condicao, '');

			if ($value['cotipopesquisa'] == 'FCA'){
				$addWhere .= (self::exist($condicao, 'dcNome'))?self::addAndWhere($addWhere, 'u.dcnome', "ilike '%{$condicao['dcNome']}%'"):null;
				$addWhere .= (self::exist($condicao, 'nuFaixaEtariaInicio'))?self::addAndWhere($addWhere, "(DATE_PART('year', now()) - DATE_PART('year', u.dtnascimento))", ">= {$condicao['nuFaixaEtariaInicio']}"):null;
				$addWhere .= (self::exist($condicao, 'nuFaixaEtariaFim'))?self::addAndWhere($addWhere, "(DATE_PART('year', now()) - DATE_PART('year', u.dtnascimento))", "<= {$condicao['nuFaixaEtariaFim']}"):null;
				$addWhere .= (self::exist($condicao, 'dcSexo'))?self::addAndWhere($addWhere, 'u.dcsexo', "= '{$condicao['dcSexo']}'"):null;
				$addWhere .= (self::exist($condicao, 'coUf'))?self::addAndWhere($addWhere, 'u.couf', "= '{$condicao['coUf']}'"):null;
				$addWhere .= (self::exist($condicao, 'dcCidade'))?self::addAndWhere($addWhere, 'u.dccidade', "ilike '%{$condicao['dcCidade']}%'"):null;
			}else if ($value['cotipopesquisa'] == 'PCA'){
				$condicao['idsituacao'] = 0;
				$addWhere .= (self::exist($condicao, 'idprojeto'))?self::addAndWhere($addWhere, 'ci.idprojeto', "= '{$condicao['idprojeto']}'"):null;
				$addWhere .= (self::exist($condicao, 'idcurso'))?self::addAndWhere($addWhere, 'ci.idcursomoodle', "= '{$condicao['idcurso']}'"):null;
				$addWhere .= ($condicao['idsituacao'] == 1)?self::addAndWhere($addWhere, 'c.dtiniciocurso', ">= now()"):null;
				$addWhere .= ($condicao['idsituacao'] == 2)?self::addAndWhere($addWhere, 'c.dtiniciocurso', "<= now() AND c.dtfimcurso >= now()"):null;
				$addWhere .= ($condicao['idsituacao'] == 3)?self::addAndWhere($addWhere, 'c.dtfimcurso', "<= now()"):null;
				$addWhere .= (self::exist($condicao, 'notaSuperior'))?self::addAndWhere($addWhere, 'n.vlnota', ">= '{$condicao['notaSuperior']}'"):null;
			}else if ($value['cotipopesquisa'] == 'PAA'){
				$addWhere .= (self::exist($condicao, 'idgrupoquestionario'))?self::addAndWhere($addWhere, 'qt.idgrupoquestionario', "= '{$condicao['idgrupoquestionario']}'"):null;
				$addWhere .= (self::exist($condicao, 'idquestionario'))?self::addAndWhere($addWhere, 'qt.idquestionario', "= '{$condicao['idquestionario']}'"):null;
				$addWhere .= (self::exist($condicao, 'idquestao'))?self::addAndWhere($addWhere, 'q.idquestao', "= '{$condicao['idquestao']}'"):null;
				$addWhere .= (self::exist($condicao, 'idresposta'))?self::addAndWhere($addWhere, 'ucp.idresposta', "= '{$condicao['idresposta']}'"):null;
			}
		}
		$addWhere .= self::addAndWhere($addWhere, 'ci.idprojeto', "= '{$idprojeto}'");
		$addWhere .= self::addAndWhere($addWhere, 'ci.idcursomoodle', "= '{$idcurso}'");
		$addWhere .= self::addAndWhere($addWhere, 'ci.dtenturmado', "is null");

		try {
			$query = Yii::app()->db->createCommand()
					->selectDistinct('u.idusuario id, u.idusuario, u.idmoodle, u.idusuariostatus, u.dcnome,
							u.nucpf, u.dtnascimento, u.dcsexo, u.couf, u.dccidade')
					->from(Constants::SCHEMA_SINASE.'.usuario u')
					->join(Constants::SCHEMA_SINASE.'.usuariostatus us', 'us.idusuariostatus = u.idusuariostatus')
					->join(Constants::SCHEMA_SINASE.'.controleinscricao ci', 'ci.idusuario = u.idusuario')

					->leftJoin(Constants::SCHEMA_SINASE.'.uf', 'u.couf = uf.couf')

					->leftJoin(Constants::SCHEMA_SINASE.'.usuariocursopesquisa ucp', 'ci.idquestionario = ucp.idquestionario AND ci.idusuario = ucp.idusuario')

					->leftJoin(Constants::SCHEMA_SINASE.'.questionario qt', 'ci.idquestionario = qt.idquestionario')
					->leftJoin(Constants::SCHEMA_SINASE.'.grupoquestionario gq', 'qt.idgrupoquestionario = gq.idgrupoquestionario')
					->leftJoin(Constants::SCHEMA_SINASE.'.questao q', 'qt.idquestionario = q.idquestionario')

					->leftJoin(Constants::SCHEMA_SINASE.'.vw_curso c', 'ci.idcursomoodle = c.idcursomoodle')
					->leftJoin(Constants::SCHEMA_SINASE.'.vw_notacurso n', ' u.idmoodle = n.userid')
					->where($addWhere)
					->limit(50);

			return $query->queryAll();

		} catch (Exception $e) {
			$this->addError('error', Yii::t('app', 'erro.desconhecido'));
			return array();
		}

	}

	private function addAndWhere($addWhere, $attribute, $value)
	{
		return ($addWhere)?" and {$attribute} {$value}":"{$attribute} {$value}";
	}

	private static function exist($condicao, $var)
	{
		return isset($condicao[$var]) && !empty($condicao[$var])?true:false;
	}

	private function drenaArray(array $listArray, $value)
	{
		return array_diff($listArray, array($value));
	}

	private function array_remove_by_value($array, $value)
	{
		return array_values(array_diff($array, $value));
	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/

	// 	public function listBuscaCurso()
	// 	{
	// 		$modelCondicao = Yii::app()->db->createCommand()
	// 			->select('idcondicao as id, c.*')
	// 			->from(Constants::SCHEMA_SINASE.'.condicao c')
	// 			->where('c.idpesquisa=:idpesquisa',
	// 					array(	':idpesquisa'=>$this->idpesquisa))
	// 					->queryAll();

	// 		$addWhere = "";
	// 		foreach ($modelCondicao as $key => $value) {
	// 			$condicao = unserialize($value['txcondicao']);
	// 			$condicao = self::drenaArray($condicao, '');

	// 			if ($value['cotipopesquisa'] == 'FCA'){
	// 				if (isset($condicao['dcNome']))
	// 					$addWhere .= self::addAndWhere($addWhere, 'dcnome', "ilike '%{$condicao['dcNome']}%'");
	// 				if (isset($condicao['nuFaixaEtariaInicio']))
	// 					$addWhere .= self::addAndWhere($addWhere, 'nuidade', "> '{$condicao['nuFaixaEtariaInicio']}'");
	// 				if (isset($condicao['nuFaixaEtariaFim']))
	// 					$addWhere .= self::addAndWhere($addWhere, 'nuidade', "< '{$condicao['nuFaixaEtariaFim']}'");
	// 				if (isset($condicao['dcSexo']))
	// 					$addWhere .= self::addAndWhere($addWhere, 'dcsexo', "= '{$condicao['dcSexo']}'");
	// 				if (isset($condicao['coUf']))
	// 					$addWhere .= self::addAndWhere($addWhere, 'couf', "= '{$condicao['coUf']}'");
	// 				if (isset($condicao['dcCidade']))
	// 					$addWhere .= self::addAndWhere($addWhere, 'dccidade', "ilike '%{$condicao['dcCidade']}%'");

	// 			}else if ($value['cotipopesquisa'] == 'PCA'){
	// 				$idprojeto[] = (isset($condicao['idprojeto']))?$condicao['idprojeto']:null;
	// 				$idcurso[] = (isset($condicao['idcurso']))?$condicao['idcurso']:null;
	// 				$idsituacao[] = (isset($condicao['idsituacao']))?$condicao['idsituacao']:null;
	// 				if (isset($condicao['idsituacao'])){
	// 					if ($condicao['idsituacao'] == 1) // Em Aberto
	// 						$addWhere .= self::addAndWhere($addWhere, 'dtiniciocurso', "> now()");
	// 					elseif ($condicao['idsituacao'] == 2) // Em andamento
	// 						$addWhere .= self::addAndWhere($addWhere, 'dtiniciocurso', "<= now() AND dtfimcurso >= now()");
	// 					elseif ($condicao['idsituacao'] == 3) // Finalizados
	// 						$addWhere .= self::addAndWhere($addWhere, 'dtfimcurso', "< now()");
	// 				}
	// 				if (isset($condicao['notaSuperior']))
	// 					$addWhere .= self::addAndWhere($addWhere, 'nunota', "> '{$condicao['notaSuperior']}'");
	// 			}else if ($value['cotipopesquisa'] == 'PAA'){
	// 				$idgrupoquestionario[] = (isset($condicao['idgrupoquestionario']))?$condicao['idgrupoquestionario']:null;
	// 				$idquestionario[] = (isset($condicao['idquestionario']))?$condicao['idquestionario']:null;
	// 				$idquestao[] = (isset($condicao['idquestao']))?$condicao['idquestao']:null;
	// 				$idresposta[] = (isset($condicao['idresposta']))?$condicao['idresposta']:null;

	// 				XDebug::x(unserialize($value['txcondicao']));
	// 			}
	// 		}

	// 		$idprojeto = self::drenaArray($idprojeto, '');
	// 		$idprojeto = array_unique($idprojeto);
	// 		$idprojeto = implode($idprojeto, ',');

	// 		$idcurso = self::drenaArray($idcurso, '');
	// 		$idcurso = array_unique($idcurso);
	// 		$idcurso = implode($idcurso, ',');

	// 		$idgrupoquestionario = self::drenaArray($idgrupoquestionario, '');
	// 		$idgrupoquestionario = array_unique($idgrupoquestionario);
	// 		$idgrupoquestionario = implode($idgrupoquestionario, ',');

	// 		$idquestionario = self::drenaArray($idquestionario, '');
	// 		$idquestionario = array_unique($idquestionario);
	// 		$idquestionario = implode($idquestionario, ',');

	// 		$idquestao = self::drenaArray($idquestao, '');
	// 		$idquestao = array_unique($idquestao);
	// 		$idquestao = implode($idquestao, ',');

	// 		$idresposta = self::drenaArray($idresposta, '');
	// 		$idresposta = array_unique($idresposta);
	// 		$idresposta = implode($idresposta, ',');

	// 		XDebug::x($idgrupoquestionario, $idquestionario, $idquestao, $idresposta, $addWhere);
	// 	}

}
