<?php

// auto-loading fix
Yii::setPathOfAlias('PortalConfiguracao', dirname(__FILE__).'/base');
Yii::import('PortalConfiguracao.*');

class PortalConfiguracao extends BasePortalConfiguracao
{
	public $dcnomealteracao = null;
	public $usuarioresponsavel = null;

	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->txmensagemerro;
	}

	public function behaviors()
	{
		// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function preCreate()
	{
		$this->dtcadastro = new CDbExpression('NOW()');
		$this->dtalteracao = new CDbExpression('NOW()');
		$this->idusuarioalteracao = Yii::app()->user->id;
		$this->inportalativo =new CDbExpression("'".$this->inportalativo."'");

		return $this->save();
	}

	public function preUpdate()
	{
		$this->dtalteracao = new CDbExpression('NOW()');
		$this->idusuarioalteracao = Yii::app()->user->id;

		return $this->save();
	}

	public function preDelete($id)
	{
		return self::model()->findByPk($id)->delete();
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search()
	{
		return parent::search();
	}

	public function listConfiguracao()
	{
		$criteria=new CDbCriteria;
		$criteria->alias = 'pc';
		$criteria->select = 'pc.*,
		ur.dcnome as usuarioresponsavel, ua.dcnome as dcnomealteracao';
		$criteria->join='inner join '.Constants::SCHEMA_SINASE.'.usuario ur on pc.idusuarioresponsavel = ur.idusuario
		inner join '.Constants::SCHEMA_SINASE.'.usuario ua on pc.idusuarioalteracao = ua.idusuario';
		$criteria->compare('pc.idportalconfig', $this->idportalconfig);
		$criteria->compare('pc.idusuarioresponsavel', $this->idusuarioresponsavel);
		$criteria->compare('pc.dtcadastro', $this->dtcadastro);
		$criteria->compare('pc.dtalteracao', $this->dtalteracao);
		$criteria->compare('pc.idusuarioalteracao', $this->idusuarioalteracao);
		$criteria->compare('pc.inportalativo', $this->inportalativo);
		$criteria->compare('pc.inativo', $this->inativo);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						'idportalconfig'=> Yii::t('app', 'generic.id'),
						'inativo' 		=> Yii::t('app', 'generic.situacao'),
						'dtcadastro' 	=> Yii::t('app', 'generic.dtcadastro'),
						'dtalteracao' 	=> Yii::t('app', 'generic.dtalteracao'),
						'dcnomealteracao' => Yii::t('app', 'portalConfiguracao.dcnomealteracao'),
						'usuarioresponsavel' => Yii::t('app', 'portalConfiguracao.usuarioresponsavel'),
				));

		return $attributes;
	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/

}
