<?php

// auto-loading fix
Yii::setPathOfAlias('Projeto', dirname(__FILE__).'/base');
Yii::import('Projeto.*');

class Projeto extends BaseProjeto
{
	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->dcprojeto;

	}

	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function preCreate()
	{
		return $this->save();
	}

	public function preUpdate()
	{
		return $this->save();
	}

	public function preDelete($id)
	{
		return self::model()->findByPk($id)->delete();
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idprojeto', $this->idprojeto);
		$criteria->compare('dcprojeto', $this->dcprojeto, true);
		$criteria->compare('inativo', $this->inativo);
		$criteria->compare('dtfinal',  ($this->dtfinal?'>=:'.$this->dtfinal:null));
		$criteria->compare('dtfinal',  ($this->dtfinal?'>=:'.$this->dtfinal:null));

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						'inativo' => Yii::t('app', 'generic.inativo'),
				));

		return $attributes;
	}

	public function listProjetos()
	{
		return Yii::app()->db->createCommand()
		->select('p.idprojeto, p.dcprojeto')
		->from(Constants::SCHEMA_SINASE.'.projeto p')
		->where('p.inativo=:inativo', array(':visible'=>0))
		->queryAll();
	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/

}
