<?php

// auto-loading fix
Yii::setPathOfAlias('ProjetoCurso', dirname(__FILE__).'/base');
Yii::import('ProjetoCurso.*');

class ProjetoCurso extends BaseProjetoCurso
{
	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->idprojeto;

	}

	public function behaviors()
	{
		// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));

		return array_merge(parent::behaviors(),array());
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function preCreate()
	{
		return $this->save();
	}

	public function atualizaProjetoCurso($curso)
	{
		try {
			$ProjetoCurso = ProjetoCurso::model()->find('idprojeto=:idprojeto and idcursomoodle=:idcursomoodle',
					array(':idprojeto'=>$curso->idprojeto, ':idcursomoodle'=>$curso->idcursomoodle));

			$ProjetoCurso = (is_object($ProjetoCurso)?$ProjetoCurso:new ProjetoCurso);

			$ProjetoCurso->idprojeto 		= $curso->idprojeto;
			$ProjetoCurso->idcursomoodle	= $curso->idcursomoodle;
			$ProjetoCurso->idquestionario	= $curso->idquestionario;

			$ProjetoCurso->dtiniciocurso	= $curso->dtiniciocurso;
			$ProjetoCurso->dtfimcurso		= $curso->dtfimcurso;
			$ProjetoCurso->dtinicioinscricao= $curso->dtinicioinscricao;
			$ProjetoCurso->dtfiminscricao	= $curso->dtfiminscricao;
			$ProjetoCurso->save();

		} catch (Exception $e) {
			throw new CHttpException(404, $e);
		}


		// 			Yii::app()->db->createCommand()->update(Constants::SCHEMA_SINASE.'.questionario',
		// 					array(	'idprojeto'	=> $idprojeto),
		// 					'idcursomoodle=:id', array(':id'=>$idcurso));

	}

	public function preUpdate()
	{
		return $this->save();
	}

	public function preDelete($id)
	{
		return self::model()->findByPk($id)->delete();
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search()
	{
		return parent::search();
	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						//'adicioneAquiChave' => Yii::t('app', 'DescriÃ§Ã£o do label'),
				));

		return $attributes;
	}

	public function getProjeto($model)
	{
		$idprojeto = $model->idprojeto;
		return Yii::app()->db->createCommand()
		->select('p.dcprojeto')
		->from(Constants::SCHEMA_SINASE.'.projeto p')
		->where('p.idprojeto=:id', array(':id'=>$idprojeto))
		->queryScalar();
	}

	public function getCurso($model)
	{
		$idcursomoodle = $model->idcursomoodle;
		return Yii::app()->db->createCommand()
		->select('c.shortname')
		->from(Constants::SCHEMA_SINASE.'.vw_curso c')
		->where('c.id=:id', array(':id'=>$idcursomoodle))
		->queryScalar();
	}

	public function getQuestionario($data,$row)
	{
		return Yii::app()->db->createCommand()
		->select('q.dcformulario')
		->from(Constants::SCHEMA_SINASE.'.questionario q')
		->where('q.idquestionario=:id', array(':id'=>$data->idquestionario))
		->queryScalar();
	}

	public function getQtdPaticipantes($data,$row)
	{
		return Yii::app()->db->createCommand()
		->select('COUNT(DISTINCT ucp.idusuario)')
		->from(Constants::SCHEMA_SINASE.'.usuariocursopesquisa ucp')
		->where('ucp.idquestionario=:id', array(':id'=>$data->idquestionario))
		->queryScalar();
	}

	public static function emitirCertificado($idprojeto, $idcursomoodle, $idquestionario)
	{
		$user = Yii::app()->db->createCommand()
		->select('u.dcnome AS nome, u.dcsexo AS sexo, u.nucpf AS cpf')
		->from(Constants::SCHEMA_SINASE.'.usuario u')
		->where('u.idusuario=:idusuario', array(':idusuario'=>Yii::app()->user->id))
		->queryRow();

		$curso = Yii::app()->db->createCommand()
		->select("c.fullname AS curso, TO_CHAR(c.dtiniciocurso::timestamp::date, 'MM') AS mes_inicio, TO_CHAR(c.dtfimcurso::timestamp::date, 'MM') AS mes_fim, TO_CHAR(c.dtiniciocurso::timestamp::date, 'YYYY') AS ano_inicio, TO_CHAR(c.dtfimcurso::timestamp::date, 'YYYY') AS ano_fim, c.categoryname as categoria")
		->from(Constants::SCHEMA_SINASE.'.vw_curso c')
		->where('c.id=:idcursomoodle', array(':idcursomoodle'=>$idcursomoodle))
		->queryRow();

		$modulo = Yii::app()->db->createCommand()
// 		->select("summary")
		->select("*")
		->from(Constants::SCHEMA_SINASE . '.vw_cursomodulo')
		->where("course=:idcursomoodle AND visible = 1 and name <> ''", array(':idcursomoodle'=>$idcursomoodle))
		->order('section')
		->queryAll();

		$result = $user + $curso;

		$result['modulo'] = $modulo;

		return $result;
	}

	public function listaProjetoCursoAluno()
	{
		return Yii::app()->db->createCommand()
		->select('pc.*')
		->from(Constants::SCHEMA_SINASE.'.projeto pc')
		->join(Constants::SCHEMA_SINASE.'.controleinscricao ci', 'ci.idprojeto = pc.idprojeto')
		->where('ci.idusuario=:idusuario', array(':idusuario'=>Yii::app()->user->id))
		->queryAll();

		//'inativo=:in and (dtfinal>now() or dtfinal is null)', array(':in'=>'true')
	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/

}
