<?php

// auto-loading fix
Yii::setPathOfAlias('Questao', dirname(__FILE__).'/base');
Yii::import('Questao.*');

class Questao extends BaseQuestao
{
	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function behaviors()
	{
		// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));

		return array_merge(parent::behaviors(),array());
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function preCreate()
	{
		return $this->save();
	}

	public function preUpdate()
	{
		$this->setOrdemQuestao($this->idquestao, $this->idquestionario, $this->nuordem);
		return $this->save();
	}

	public function setOrdemQuestao($idquestao, $idQuestionario, $ordemInicial)
	{
		$listQuestoes = Yii::app()->db->createCommand()
		->select('q.idquestao, q.nuordem')
		->from(Constants::SCHEMA_SINASE.'.questionario qt')
		->join(Constants::SCHEMA_SINASE.'.questao q', 'qt.idquestionario = q.idquestionario')
		->where('qt.idquestionario=:id and q.nuordem >=:nuordem and q.idquestao <>:idquestao',
				array(':id'=>$idQuestionario, ':nuordem'=>$ordemInicial, ':idquestao'=>$idquestao))
				->order('q.nuordem')
				->queryAll();

		foreach ($listQuestoes as $key => $value) {
			$ordemInicial++;

			Yii::app()->db->createCommand()
			->update(Constants::SCHEMA_SINASE.'.questao',
					array('nuordem'=>$ordemInicial),
					'idquestao=:idquestao',
					array(':idquestao'=>$value['idquestao']));

		}
		return true;
	}

	public function preDelete($idquestao)
	{
        if (self::existemRespostas($idquestao)=='S') {
            throw new CHttpException(404, Yii::t('app','erro.exitemRespostas'));
            return false;
        }
		try {
			$model = self::model()->findByPk($idquestao);
			$idquestionario= $model['idquestionario'];
			$model->delete();
			$this->setOrdemQuestao(0, $idquestionario, 0);
			return true;
		} catch (Exception $e) {
			//Yii::app()->user->setFlash('erro', Yii::t('app', 'erro.deletarRegistroUtilizado'));
            throw new CHttpException(404, 'Erro ao tentar excluir a questão!\nMensagem: '.$e->getMessage());
            return false;
		}
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search()
	{
		return parent::search();
	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						//'adicioneAquiChave' => Yii::t('app', 'DescriÃ§Ã£o do label'),
				));

		return $attributes;
	}

	public function getTipoQuestao($data,$row)
	{
		// $data ... the current row data
		// $row ... the row index

		$theCellValue = Yii::app()->db->createCommand()
		->select('tq.dctipoquestao')
		->from(Constants::SCHEMA_SINASE.'.questao q')
		->join(Constants::SCHEMA_SINASE.'.tipoquestao tq', 'tq.cotipoquestao=q.cotipoquestao')
		->where('q.idquestao=:id', array(':id'=>$data->idquestao))
		->queryScalar();

		return $theCellValue;
	}

	public function getOrdemQuestao($id, $isNewRecord) {
		$listOrdemQuestao = Yii::app()->db->createCommand()
		->select('count(q.idquestao)')
		->from(Constants::SCHEMA_SINASE.'.questionario qt')
		->join(Constants::SCHEMA_SINASE.'.questao q', 'qt.idquestionario = q.idquestionario')
		->where('qt.idquestionario=:id', array(':id'=>$id))
		->queryRow();

		$arOrdem = array();
		$listOrdemQuestao['count'] = ($isNewRecord)?$listOrdemQuestao['count']+1:$listOrdemQuestao['count'];
		for ($i = 0; $i < $listOrdemQuestao['count']; $i++) {
			$arOrdem[] = array(
					'nuordem'=> $i+1
			);
		}
		return $arOrdem;
	}

	public function dadosQuestao() {
		return Yii::app()->db->createCommand()
		->select('qtao.idquestao, q.dcformulario, gq.dcgrupoquestao, tq.dctipoquestao, qtao.dcquestao,
				qtao.dcorientacao, qtao.inpermitetotalizar, qtao.inobrigatorio, qtao.nuordem, qtao.idquestionario')
		->from(Constants::SCHEMA_SINASE.'.questao qtao')
		->join(Constants::SCHEMA_SINASE.'.questionario q', 'q.idquestionario = qtao.idquestionario')
		->join(Constants::SCHEMA_SINASE.'.grupoquestao gq', 'gq.idgrupoquestao = qtao.idgrupoquestao')
		->join(Constants::SCHEMA_SINASE.'.tipoquestao tq', 'tq.cotipoquestao = qtao.cotipoquestao')
		->where('qtao.idquestao=:id', array(':id'=>$this->idquestao))
		->queryRow();

	}

	public function existemRespostas($id)
	{
		return Yii::app()->db->createCommand()
		->select('CASE WHEN COUNT(*) > 0 THEN \'S\' ELSE \'N\' END')
		->from(Constants::SCHEMA_SINASE.'.resposta r')
		->where('r.idquestao=:id', array(':id'=>$id))
		->queryScalar();
	}
 }