<?php

// auto-loading fix
Yii::setPathOfAlias('Questionario', dirname(__FILE__).'/base');
Yii::import('Questionario.*');

class Questionario extends BaseQuestionario
{
	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString()
	{
		return (string) $this->dcformulario;

	}

	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function rules()
	{
		return array(
				array('idgrupoquestionario, dcformulario, dcobjetivo, dcconfirmacao, inativo', 'required', 'on'=>array('insert', 'update')),
				array('idgrupoquestionario', 'numerical', 'integerOnly'=>true),
				array('dcformulario, dcconfirmacao', 'length', 'max'=>100),
				array('idquestionario, idgrupoquestionario, dcformulario, dcobjetivo, dcconfirmacao, inativo, dcgrupoquestionario', 'safe', 'on'=>'search'),
		);
	}

	public function preCreateResposta($resposta)
	{
		$options = array();
		$options['idusuario'] = Yii::app()->user->id;
		$options['idprojeto'] = $resposta['idprojeto'];
		$options['idcursomoodle'] = $resposta['idcursomoodle'];
		$options['idquestionario'] = $resposta['idquestionario'];

		foreach ($resposta as $key => $value) {
			if (is_array($value)){
				foreach ($value as $keyIn => $valueIn) {
					$options['idquestao'] = $keyIn;
					self::preSaveResposta($key, $valueIn, $options);
				}
			}
		}

		return $options['idcursomoodle'];
	}

	private function preSaveResposta($type, $value, $options)
	{
		switch ($type) {
			case "data":
			case "hora":
			case "telefone":
			case "soletra":
			case "numero":
			case "moeda":
			case "cpf":
			case "cnpj":
			case "email":
			case "url":
			case "soalfa":
			case "texto":
				$options['dcresposta'] = $value;
				break;
			case "textarea":
				$options['txresposta'] = $value;
				break;
			case "datahora":
				$options['dcresposta'] = $value['date'].' '.$value['time'];
				break;
			case "combo":
			case "radio":
				$options['idresposta'] = $value;
				break;
			case "checkbox":
				$options['idresposta'] = $value;
				break;
			default:
				break;
		}

		self::saveResposta($options);
	}

	private function saveResposta($options)
	{
		if (isset($options['idresposta'])){
			$options['idresposta'] = is_array($options['idresposta'])?$options['idresposta']:array($options['idresposta']);
			foreach ($options['idresposta'] as $key => $value) {
				$options['idresposta'] = $value;
				$CursoPesquisa = new UsuarioCursoPesquisa();
				$CursoPesquisa->attributes=$options;

				if ($CursoPesquisa->validate()){
					$CursoPesquisa->save();
				}else{
					// é necessário deletar todos os registros anteriores.
					throw new CHttpException(404, $e);
				}
			}
			return true;
		}

		$CursoPesquisa = new UsuarioCursoPesquisa();
		$CursoPesquisa->attributes=$options;

		if ($CursoPesquisa->validate()){
			$CursoPesquisa->save();
		}else{
			// é necessário deletar todos os registros anteriores.
			throw new CHttpException(404, $e);
		}
		return true;
	}

	public function preCreate()
	{
		$this->dtcriacao = new CDbExpression('NOW()');
		return $this->save();
	}

	public function preUpdate()
	{
		return $this->save();
	}

	public function preDelete($id)
	{
        if (self::existemQuestoes($id)=='S') {
            throw new CHttpException(404, Yii::t('app','erro.exitemQuestoes'));
            return false;
        }
        try {
            //Yii::app()->db->beginTransaction();
            return self::model()->findByPk($id)->delete();
		} catch (Exception $e) {
			//Yii::app()->user->setFlash('erro', Yii::t('app', 'erro.deletarRegistroUtilizado'));
            throw new CHttpException(404, 'Erro ao tentar excluir o questionário!\nMensagem: '.$e->getMessage());
            return false;
		}
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search()
	{
		return parent::search();
	}

	// 	public function getGrupoQuestionarioNome($id_questionario) {
	// 		$grupo = Yii::app()->db->createCommand()
	// 						    ->select('dcgrupo')
	// 						    ->from(Constants::SCHEMA_SINASE.'questionario q')
	// 						    ->join(Constants::SCHEMA_SINASE.'grupoquestionario gc', 'q.idgrupoquestionario=gc.idgrupoquestionario')
	// 						    ->where('idquestionario=:id', array(':id'=>$id_questionario))
	// 						    ->queryRow();

	// 		return $grupo;
	// 	}


	public function listMontarQuestionario($idQuestionario)
	{
		return Yii::app()->db->createCommand()
		->select('qt.idquestionario, qt.dcformulario, qt.dcobjetivo, qt.dcconfirmacao, qt.dtcriacao, qt.idgrupoquestionario,
				q.idquestao, q.cotipoquestao, tq.dctipoquestao, q.idgrupoquestao, gq.dcgrupoquestao, q.dcquestao, q.dcorientacao,
				q.inpermitetotalizar, q.inobrigatorio, q.nuordem, gqt.dcgrupo')
				->from(Constants::SCHEMA_SINASE.'.questionario qt')
				->join(Constants::SCHEMA_SINASE.'.grupoquestionario gqt', 'qt.idgrupoquestionario=gqt.idgrupoquestionario')
				->join(Constants::SCHEMA_SINASE.'.questao q', 'qt.idquestionario = q.idquestionario')
				->join(Constants::SCHEMA_SINASE.'.grupoquestao gq', 'gq.idgrupoquestao = q.idgrupoquestao')
				->join(Constants::SCHEMA_SINASE.'.tipoquestao tq', 'tq.cotipoquestao = q.cotipoquestao')
				->where('q.idquestionario=:id', array(':id'=>$idQuestionario))
				->order('gq.dcgrupoquestao, q.nuordem')
				->queryAll();
	}

	public function getGrupoQuestionario($data, $row)
	{
		return Yii::app()->db->createCommand()
		->select('gqt.dcgrupo')
		->from(Constants::SCHEMA_SINASE.'.questionario qt')
		->join(Constants::SCHEMA_SINASE.'.grupoquestionario gqt', 'qt.idgrupoquestionario=gqt.idgrupoquestionario')
		->where('qt.idquestionario=:id', array(':id'=>$data->idquestionario))
		->queryScalar();
	}

	public function getQuestionarioCompleto()
	{
		return Yii::app()->db->createCommand()
		->selectDistinct('qt.idquestionario, qt.dcformulario')
		->from(Constants::SCHEMA_SINASE.'.grupoquestionario gqt')
		->join(Constants::SCHEMA_SINASE.'.questionario qt', 'gqt.idgrupoquestionario = qt.idgrupoquestionario')
		->join(Constants::SCHEMA_SINASE.'.questao q', 'qt.idquestionario = q.idquestionario')
		// 					->where('qt.idquestionario=:id', array(':id'=>$idquestionario))
		->queryAll();
	}

	public function hasQuestions($data,$row)
	{
		return Yii::app()->db->createCommand()
		->select('CASE WHEN COUNT(*) > 0 THEN FALSE ELSE TRUE END')
		->from(Constants::SCHEMA_SINASE.'.questao qt')
		->where('qt.idquestionario=:id', array(':id'=>$data->idquestionario))
		->queryScalar();
	}

	public function existemQuestoes($id)
	{
		return Yii::app()->db->createCommand()
		->select('CASE WHEN COUNT(*) > 0 THEN \'S\' ELSE \'N\' END')
		->from(Constants::SCHEMA_SINASE.'.questao qt')
		->where('qt.idquestionario=:id', array(':id'=>$id))
		->queryScalar();
	}
    
    public function getQtdPaticipantes($data,$row)
	{
		return Yii::app()->db->createCommand()
		->select('COUNT( ucp.idusuario)')
		->from(Constants::SCHEMA_SINASE.'.usuariocursopesquisa ucp')
		->where('ucp.idquestionario=:id', array(':id'=>$data->idquestionario))
		->queryScalar();
	}

	public function getQuestionario($id) {
		return Yii::app()->db->createCommand()
		->select('dcformulario')
		->from(Constants::SCHEMA_SINASE.'.questionario')
		->where('idquestionario=:id', array(':id'=>$id))
		->queryScalar();
	}


	// 	public function getQuestionarioAtivo($inativo = true)
	// 	{
	// 		return Yii::app()->db->createCommand()
	// 							->select('q.idquestionario, q.dcformulario')
	// 							->from(Constants::SCHEMA_SINASE.'.questionario q')
	// 							->where('q.inativo=:id', array(':id'=>$inativo))
	// 							->queryAll();
	// 	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						'inativo' 	=> Yii::t('app', 'generic.inativo'),
						'dtcriacao' => Yii::t('app', 'generic.dtcriacao'),
                        'dcgrupoquestionario' => Yii::t('app', 'questionario.dcgrupoquestionario'),
				));

		return $attributes;
	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/

}
