<?php

// auto-loading fix
Yii::setPathOfAlias('Resposta', dirname(__FILE__).'/base');
Yii::import('Resposta.*');

class Resposta extends BaseResposta
{
	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString()
	{
		return (string) $this->dcresposta;

	}

	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function preCreate()
	{
		return $this->save();
	}

	public function preUpdate()
	{
		return $this->save();
	}

	public function preDelete($id)
	{
        if (self::existemPesquisas($id)=='S') {
            throw new CHttpException(404, Yii::t('app','erro.exitemPesquisas'));
            return false;
        }
        try {
		  return self::model()->findByPk($id)->delete();
		} catch (Exception $e) {
			//Yii::app()->user->setFlash('erro', Yii::t('app', 'erro.deletarRegistroUtilizado'));
            throw new CHttpException(404, 'Erro ao tentar excluir a resposta!\nMensagem: '.$e->getMessage());
            return false;
		}
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search()
	{
		return parent::search();
	}

	public function getQuestaoId($id) {
		$theCellValue = Yii::app()->db->createCommand()
		->select('idquestao')
		->from(Constants::SCHEMA_SINASE.'.resposta')
		->where('idresposta=:id', array(':id'=>$id))
		->queryScalar();

		return $theCellValue;
	}

	public function getQuestionarioId($id){
		$theCellValue = Yii::app()->db->createCommand()
		->select('q.idquestionario')
		->from(Constants::SCHEMA_SINASE.'.resposta r')
		->join(Constants::SCHEMA_SINASE.'.questao q', 'r.idquestao=q.idquestao')
		->where('r.idresposta=:id', array(':id'=>$id))
		->queryScalar();

		return $theCellValue;
	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						//'adicioneAquiChave' => Yii::t('app', 'DescriÃ§Ã£o do label'),
				));

		return $attributes;
	}

	public function existemPesquisas($id)
	{
		return Yii::app()->db->createCommand()
		->select('CASE WHEN COUNT(*) > 0 THEN \'S\' ELSE \'N\' END')
		->from(Constants::SCHEMA_SINASE.'.usuariocursopesquisa p')
		->where('p.idresposta=:id', array(':id'=>$id))
		->queryScalar();
	}
}
