<?php
// auto-loading fix
Yii::import('application.models.base.BaseUsuario');
class Usuario extends BaseUsuario
{
	public $inscritos;
	public $dcusuariostatus;

	/*
	 * variáveis para alterar senha
	*/
	public $dcsenha_now;
	public $dcsenha_repeat;
	public $dcsenha_new;
	public $dcsenha_new_repeat;


	private $_dtLoginRecover;

	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->nucpf;
	}

	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function rules()
	{
		return array_merge(
				array(
						array('nucpf', 'ext.validators.cpf'),
						array('idmoodle, nucpf, dcemail, dcusuario', 'unique'),
						// THIS IS THE NEW STUFF
						array('dcsenha', 'length', 'min'=>6, 'max'=>34),
						array('dcsenha', 'compare', 'on'=>'insert'),
						array('dcsenha_new', 'compare', 'on'=>'changePassword'),
						array('dcsenha_repeat, dcsenha_now, dcsenha_new, dcsenha_new_repeat', 'safe'),
						array('dcsenha_repeat', 'required', 'on'=>'insert'),
						array('dcsenha_now, dcsenha_new, dcsenha_new_repeat', 'required', 'on'=>'changePassword'),

						array('inreceberinformacao, indeclaracao', 'required', 'on'=>array('update')),
						array('inscritos', 'required', 'on'=>'designarPapel', 'message'=>yii::t('app', 'erro.informeUmTipoPesquisa')),
						array('idusuariostatus, nucpf, dcnome, dcsexo, dcemail, dcusuario', 'safe', 'on' => 'update'),
				),
				parent::rules()
		);
	}

	public static function getUsuarioAutenticado($dcusuario)
	{
		return Yii::app()->db->createCommand()
				->selectdistinct('u.idusuario, u.dcnome, u.dcusuario, u.dcsenha, u.idmoodle, u.idusuariostatus,
								  up.coperfilacesso, pa.dcperfilacesso, pa.dcperfilacessocurto, pa.idpapel, pa.ordem')
				->from(Constants::SCHEMA_SINASE.'.usuario u')
				->join(Constants::SCHEMA_SINASE.'.usuarioperfilacesso up', 'u.idusuario=up.idusuario')
				->join(Constants::SCHEMA_SINASE.'.perfilacesso pa', 'up.coperfilacesso=pa.coperfilacesso')
				->join(Constants::SCHEMA_SINASE.'.funcionalidadeperfil fp', 'pa.coperfilacesso=fp.co_perfilacesso')
				->where('u.dcusuario=:dcusuario and u.idusuariostatus in(1, 3)',
						array(':dcusuario'=>$dcusuario))
				->order('pa.ordem')
				->queryAll();
	}

	public static function getUsuario($dcusuario)
	{
		return Yii::app()->db->createCommand()
		->selectdistinct('u.idusuario, u.dcnome, u.dcusuario, u.idusuariostatus')
		->from(Constants::SCHEMA_SINASE.'.usuario u')
		->where('u.dcusuario=:dcusuario',
				array(':dcusuario'=>$dcusuario))
				->queryRow();
	}

	public static function getNomeUsuario($idusuario)
	{
		return Yii::app()->db->createCommand()
		->selectdistinct('u.dcnome')
		->from(Constants::SCHEMA_SINASE.'.usuario u')
		->where('u.idusuario=:idusuario',
				array(':idusuario'=>$idusuario))
				->queryScalar();
	}
    
    public static function listUsuario($idusuario)
	{
		return Yii::app()->db->createCommand()
		->select('u.idusuario id, u.idusuario, u.idmoodle, u.idusuariostatus, u.dcnome,
				u.nucpf, u.dtnascimento, u.dcsexo, u.couf, u.dccidade, u.dcusuario,
				u.dcsenha, u.dcemail')
				->from(Constants::SCHEMA_SINASE.'.usuario u')
				->where('u.idusuario=:idusuario', array(':idusuario'=>$idusuario))
				->queryRow();
	}

	public function listUsuarioPerfil($coperfil)
	{
		return Yii::app()->db->createCommand()
		->select('u.idusuario, u.dcnome, u.dcusuario, u.dcsenha, u.idmoodle,
				up.coperfilacesso,
				pa.dcperfilacesso, pa.dcperfilacessocurto')
				->from(Constants::SCHEMA_SINASE.'.usuario u')
				->join(Constants::SCHEMA_SINASE.'.usuarioperfilacesso up', 'u.idusuario=up.idusuario')
				->join(Constants::SCHEMA_SINASE.'.perfilacesso pa', 'up.coperfilacesso=pa.coperfilacesso')
				->where('up.coperfilacesso=:coperfil', array(':coperfil'=>$coperfil))
				->queryAll();
	}

	public function setTokenLinkAcesso($idUsuario)
	{
		$tokenAcessUser = sha1(uniqid(mt_rand(),true));

		Yii::app()->db->createCommand()
		->update(Constants::SCHEMA_SINASE.'.usuario',
				array('dctokenmoodle'=>$tokenAcessUser),
				'idusuario=:id and idmoodle is not null', array(':id'=>$idUsuario));

		return $tokenAcessUser;
	}

	public function liberarCadastro($idUsuario)
	{
		Yii::app()->db->createCommand()
		->update(Constants::SCHEMA_SINASE.'.usuario',
				array('dckeyloginrecover'=>new CDbExpression("NULL"),
						'idusuariostatus'=>3),
				'idusuario=:id', array(':id'=>$idUsuario));

		$UsuarioPerfilAcesso = new UsuarioPerfilAcesso();
		$UsuarioPerfilAcesso->preInsert($idUsuario, 'aluno');
	}

	public function getTokenLinkAcesso($tokenClientServer, $ipClientSever, $tokenClient)
	{
		$userToken = Yii::app()->db->createCommand()
		->select('u.idusuario, u.idmoodle, u.dcemail, u.dctokenmoodle')
		->from(Constants::SCHEMA_SINASE.'.usuario u')
		->where('u.dctokenmoodle=:token', array(':token'=>$tokenClient))
		->queryAll();

		$success = '';
		$messenger = '';

		if (Constants::MOODLE_TOKEN_VALID &&
				(($tokenClientServer !== Constants::MOODLE_TOKEN) || empty($tokenClientServer) || empty($tokenClientServer))){
			$messenger[] = 'Erro na configuração do TOKEN entre servidores.';
		}elseif (Constants::MOODLE_IP_VALID &&
				(($ipClientSever !== Constants::MOODLE_IP) || empty($ipClientSever) || empty($ipClientSever))){
				$messenger[] = 'Erro na configuração do IP entre servidores.';
		}elseif (!empty($userToken) && !is_null($messenger)){
			$success = $userToken[0];
			self::setTokenLinkAcesso($success['idusuario']);
		}else{
			$messenger[] = 'Erro na requisição do webService.';
		}

		return array('success'=>$success,
					 'error'=>array(	'messenger'=>$messenger,
						'url'=>Yii::app()->getBaseUrl(true),
					 )
		);
	}

	public function attributeLabels()
	{
		return array_merge(parent::attributeLabels(),
				array(
					'inscritos'			=> yii::t('app', 'usuario.inscritos'),
					'dcSenhaNova'		=> 'Nova Senha',
					'dcsenha_repeat' 	=> 'Confirmar Senhar',
					'nuendereco'		=> 'Num.',
					'dcInDeclaracao'	=> yii::t('app', 'usuario.dcInDeclaracao'),
					'dcInReceberInf'	=> yii::t('app', 'usuario.dcInReceberInf'),
				));
	}

	public function preSave()
	{
		$this->dtcadastro = new CDbExpression('NOW()');
		$this->dtatualizacao = new CDbExpression('NOW()');
		$this->nucpf = str_replace('-', '', str_replace('.', '', $this->nucpf));
		$this->nucep = str_replace('-', '', str_replace('.', '', $this->nucep));
		$this->idusuariostatus = 2;

		if ($this->save())
		{
			Yii::app()->db->createCommand()
			->update(Constants::SCHEMA_SINASE.'.usuario',
					array('dcsenha' => new CDbExpression("md5('{$this->dcsenha}')") ),
					'idusuario=:idUsuario', array(':idUsuario'=>$this->idusuario));

			$Email = new Email();
			return $Email->preSendMail(1,
					$this->idusuario,
					array($this->dcemail));
		}
	}

	public function preUpdate()
	{
		// if a new password has been entered
		if (!empty($this->dcsenha_now) || !empty($this->dcsenha_new) || !empty($this->dcsenha_new_repeat))
		{
			// set scenario 'changePassword' in order
			// for the compare validator to be called
			$this->setScenario('changePassword');
		}

		$this->nucpf = str_replace('-', '', str_replace('.', '', $this->nucpf));
		$this->nucep = str_replace('-', '', str_replace('.', '', $this->nucep));
		if ($this->validate())
		{
			if ($this->getScenario() == 'changePassword')
			{
				if ($erro = $this->preChangePassword($this->dcsenha_now,
						$this->dcsenha_new,
						$this->dcsenha_new_repeat,
						$this->idusuario))
				{
					Yii::app()->user->setFlash('erro', $erro);
					return false;
				}
			}

			$this->dtatualizacao = new CDbExpression('NOW()');
			if (Yii::app()->user->name!=Constants::APP_USER_ADMIN){
				$this->idusuariostatus = 1;
			}

			if ($this->save(false)){
				$this->changeProfile(Yii::app()->user->name);
				return $this;
			}
		}
	}

	public function preDelete($id)
	{
		$model = self::model()->findByPk($id);
		if ($model->dcusuario == 'admin')
		{
			throw new CHttpException(500, Yii::t('app', 'erro.deletarAdmin'));
		}

		Yii::app()->db->createCommand()
		->update(Constants::SCHEMA_SINASE.'.usuario',
				array('idusuariostatus' => 4,
						'dtatualizacao' => new CDbExpression('NOW()')),
				'idusuario=:idUsuario', array(':idUsuario'=>$id));
	}

	public function existeUsuario($emalUsuario)
	{
		return Yii::app()->db->createCommand()
		->select(  'u.idusuario, u.dcnome, u.idusuariostatus')
		->from(Constants::SCHEMA_SINASE.'.usuario u')
		->where('u.dcemail=:emalUsuario',
				array(':emalUsuario'=>$emalUsuario))
				->queryRow();
	}

	public function existeUsuarioEmail($emalUsuario)
	{
		return Yii::app()->db->createCommand()
		->select(  'u.idusuario, u.dcnome, u.dtcadastro, u.dcemail, (now()) as dtnow')
		->from(Constants::SCHEMA_SINASE.'.usuario u')
		->where('u.dcemail=:emalUsuario',
				array(':emalUsuario'=>$emalUsuario))
				->queryRow();
	}

	//     public static function listUsuarioAutenticado($dcusuario)
	//     {
	//     	return Yii::app()->db->createCommand()
	//     			->select('u.idusuario, u.dcusuario, u.dcsenha,
	// 						  up.coperfilacesso,
	// 						  pa.dcperfilacesso, pa.dcperfilacessocurto')
	//     			->from(Constants::SCHEMA_SINASE.'.usuario u')
	//     			->join(Constants::SCHEMA_SINASE.'.usuarioperfilacesso up', 'u.idusuario = up.idusuario')
	//     			->join(Constants::SCHEMA_SINASE.'.perfilacesso pa', 'up.coperfilacesso = pa.coperfilacesso')
	//     			->where('u.dcusuario=:dcusuario',
	//     					array(':dcusuario'=>$dcusuario))
	//     					->queryAll();
	//     }

	public function listUsuarioToken($token)
	{
		return Yii::app()->db->createCommand()
		->select('u.idusuario, u.dcusuario, u.dtloginrecoverexp, u.dcemail')
		->from(Constants::SCHEMA_SINASE.'.usuario u')
		->join(Constants::SCHEMA_SINASE.'.usuarioperfilacesso up', 'u.idusuario = up.idusuario')
		->join(Constants::SCHEMA_SINASE.'.perfilacesso pa', 'up.coperfilacesso = pa.coperfilacesso')
		->where('u.dckeyloginrecover=:token', array(':token'=>$token))
		->queryRow();
	}

	public function listUsuarioTokenConfirmeCadastro($token)
	{
		return Yii::app()->db->createCommand()
		->select('u.idusuario, u.dcusuario, u.dtloginrecoverexp, u.dcemail')
		->from(Constants::SCHEMA_SINASE.'.usuario u')
		->where('u.dckeyloginrecover=:token', array(':token'=>$token))
		->queryRow();
	}

	public function changePassword($Usuario, $newPassword)
	{
		if ($Usuario){
			Yii::app()->db->createCommand()
			->update(Constants::SCHEMA_SINASE.'.usuario',
					array(  'dcsenha' => new CDbExpression("md5('$newPassword')"),
							'dtloginrecoverexp' => new CDbExpression('NULL'),
							'dckeyloginrecover' => new CDbExpression('NULL')),
					'idusuario=:idUsuario', array(':idUsuario'=>$Usuario['idusuario']));
			return true;
		}
		return false;
	}

	public function preChangePassword($dcSenha, $dcSenhaNova, $dcSenhaConfirmar, $idUsuario)
	{
		if (empty($dcSenha)){
			return Yii::t('app', 'erro.senhaVazia');
		}elseif (empty($dcSenhaNova) || empty($dcSenhaConfirmar)){
			return Yii::t('app', 'erro.senhaNovaVazia');
		}elseif ($dcSenha == $dcSenhaNova){
			return Yii::t('app', 'erro.senhaNovaIgual');
		}elseif (strlen($dcSenhaNova) < 6){
			return Yii::t('app', 'erro.senhaNovaMenor6');
		}elseif ($dcSenhaNova != $dcSenhaConfirmar){
			return Yii::t('app', 'erro.senhaNovaDifConfirmar');
		}elseif ($dcSenhaNova == $dcSenhaConfirmar){
			$usuario = $this->listUsuario(Yii::app()->user->id);

			if ( md5($dcSenha) != $usuario['dcsenha'])
				return Yii::t('app', 'erro.senhaDiferente');

			Yii::app()->db->createCommand()
			->update(Constants::SCHEMA_SINASE.'.usuario',
					array(	'dcsenha' => new CDbExpression("md5('$dcSenhaNova')") ),
					'idusuario=:idUsuario', array(':idUsuario'=>$idUsuario));
			return '';
		}
		return Yii::t('app', 'erro.tentarAlterarSenha');
	}

	public function gerarTokenUsuario($dcEmailUsuario)
	{
		if ( $token = $this->getToken($dcEmailUsuario)){
			Yii::app()->db->createCommand()
			->update(Constants::SCHEMA_SINASE.'.usuario',
					array(  'dckeyloginrecover' => $token,
							'dtloginrecoverexp' => new CDbExpression('NOW()')),
					'dcemail=:dcEmailUsuario', array(':dcEmailUsuario'=>$dcEmailUsuario));
			return $token;
		}
		return false;
	}

	static public function changeProfile($profile)
	{
		foreach(Yii::app()->user->profilesUser as $key => $value){
			if ($profile == $value['coperfilacesso']) {
				/*
				 * Recupera as informações do usuário conforme o perfil.
				*/
				$MenuSistema = new MenuSistema();
				$menuUser = $MenuSistema->getMenuUsuarioSistema(Yii::app()->user->id, $value['coperfilacesso']);

				/*
				 * Altera as informações do usuário conforme
				* o perfil do usuário.
				*/
				$user = Usuario::getUsuarioAutenticado($value['dcusuario']);

				Yii::app()->user->profileUser = $user[0];
				Yii::app()->user->menuUser = $menuUser;
				Yii::app()->user->name = $value['coperfilacesso'];

				$UsuarioPerfilAcesso = new UsuarioPerfilAcesso();
				$UsuarioPerfilAcesso->atualizaAcesso(Yii::app()->user->id, Yii::app()->user->name);

				Yii::app()->user->accessRules = $UsuarioPerfilAcesso->getMyAccessRules(Yii::app()->user->id,
																					   $value['coperfilacesso']);
				break;
			}
		}
	}

	private function getToken($emalUsuario)
	{
		$usuario = $this->existeUsuarioEmail($emalUsuario);

		if ($usuario){
			$this->_dtLoginRecover = $usuario['dtnow'];
			return md5($usuario['dtcadastro'].$usuario['idusuario'].$usuario['dcnome'].$emalUsuario.$usuario['dtnow']);
		}
		return null;
	}

	public function searchFind()
	{
		$criteria=new CDbCriteria;
		$criteria->alias  = 'u';
		$criteria->select = 'us.dcusuariostatus, u.*';
		$criteria->compare('idusuario', $this->idusuario);
		$criteria->compare('idmoodle', $this->idmoodle, true);
		$criteria->compare('idareaatuacao', $this->idareaatuacao);
		$criteria->compare('idgrauinstrucao', $this->idgrauinstrucao);
		$criteria->compare('idusuariostatus', $this->idusuariostatus);
		$criteria->compare('nucpf', $this->nucpf, true);
		$criteria->compare('dcnome', $this->dcnome, true);
		$criteria->compare('dtnascimento', ($this->dtnascimento?'>=:'.$this->dtnascimento:null));
		$criteria->compare('dcsexo', $this->dcsexo, true);
		$criteria->compare('dcemail', $this->dcemail, true);
		$criteria->compare('nutelefoneparticular', $this->nutelefoneparticular, true);
		$criteria->compare('nutelefonecomercial', $this->nutelefonecomercial, true);
		$criteria->compare('nutelefonecelular', $this->nutelefonecelular, true);
		$criteria->compare('dcnomepai', $this->dcnomepai, true);
		$criteria->compare('dcnomemae', $this->dcnomemae, true);
		$criteria->compare('dcendereco', $this->dcendereco, true);
		$criteria->compare('nuendereco', $this->nuendereco, true);
		$criteria->compare('dccomplemento', $this->dccomplemento, true);
		$criteria->compare('couf', $this->couf);
		$criteria->compare('dcbairro', $this->dcbairro, true);
		$criteria->compare('dccidade', $this->dccidade, true);
		$criteria->compare('nucep', $this->nucep, true);
		$criteria->compare('dcoutraareaatuacao', $this->dcoutraareaatuacao, true);
		$criteria->compare('dccurriculolattes', $this->dccurriculolattes, true);
        if ($this->inreceberinformacao!='')
		    $criteria->addCondition('inreceberinformacao = '.$this->inreceberinformacao);
        if ($this->indeclaracao!='')
		    $criteria->addCondition('indeclaracao = '.$this->indeclaracao);
		$criteria->compare('dcusuario', $this->dcusuario, true);
		$criteria->compare('dtcadastro',  ($this->dtcadastro?'>=:'.$this->dtcadastro:null));

		$criteria->join   = 'inner join '.Constants::SCHEMA_SINASE.'.usuariostatus us on (us.idusuariostatus = u.idusuariostatus) ';

		return $this->find($criteria);
	}

	public function search()
	{
		parent::beforeFind();

		$criteria=new CDbCriteria;
		$criteria->alias  = 'u';
		$criteria->select = 'us.dcusuariostatus, u.*';
		$criteria->compare('idusuario', $this->idusuario);
		$criteria->compare('idmoodle', $this->idmoodle, true);
		$criteria->compare('idareaatuacao', $this->idareaatuacao);
		$criteria->compare('idgrauinstrucao', $this->idgrauinstrucao);
		$criteria->compare('idusuariostatus', $this->idusuariostatus);
		$criteria->compare('nucpf', $this->nucpf, true);
		$criteria->compare('dcnome', $this->dcnome, true);
		$criteria->compare('dtnascimento', ($this->dtnascimento?'>=:'.$this->dtnascimento:null));
		$criteria->compare('dcsexo', $this->dcsexo, true);
		$criteria->compare('dcemail', $this->dcemail, true);
		$criteria->compare('nutelefoneparticular', $this->nutelefoneparticular, true);
		$criteria->compare('nutelefonecomercial', $this->nutelefonecomercial, true);
		$criteria->compare('nutelefonecelular', $this->nutelefonecelular, true);
		$criteria->compare('dcnomepai', $this->dcnomepai, true);
		$criteria->compare('dcnomemae', $this->dcnomemae, true);
		$criteria->compare('dcendereco', $this->dcendereco, true);
		$criteria->compare('nuendereco', $this->nuendereco, true);
		$criteria->compare('dccomplemento', $this->dccomplemento, true);
		$criteria->compare('couf', $this->couf);
		$criteria->compare('dcbairro', $this->dcbairro, true);
		$criteria->compare('dccidade', $this->dccidade, true);
		$criteria->compare('nucep', $this->nucep, true);
		$criteria->compare('dcoutraareaatuacao', $this->dcoutraareaatuacao, true);
		$criteria->compare('dccurriculolattes', $this->dccurriculolattes, true);
        if ($this->inreceberinformacao!='')
		    $criteria->addCondition('inreceberinformacao = '.$this->inreceberinformacao);
        if ($this->indeclaracao!='')
		    $criteria->addCondition('indeclaracao = '.$this->indeclaracao);
		$criteria->compare('dcusuario', $this->dcusuario, true);
		$criteria->compare('dtcadastro', ($this->dtcadastro?'>=:'.$this->dtcadastro:null));
		$criteria->join   = 'inner join '.Constants::SCHEMA_SINASE.'.usuariostatus us on (us.idusuariostatus = u.idusuariostatus) ';

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function saveUsuarioMoodle($idusuario)
	{
		try {
			$Usuario = new Usuario();
			$listUsuario = $this->listUsuario($idusuario);

			if ($listUsuario){
				$dcnome = explode(' ', $listUsuario['dcnome']);
				$options = array(
						'username' => $listUsuario['dcusuario'],
						'password' => '_'.ucfirst($listUsuario['dcsenha']),
						'firstname' => $dcnome[0],
						'lastname' => $listUsuario['dcnome'],
						'email' => $listUsuario['dcemail'],
						'auth' => Constants::MOODLE_AUTH,
						'idnumber' => $listUsuario['idusuario'],
						'lang' => Constants::MOODLE_LANG,
						//'theme' => string,
						//'timezone' => string,
						//'mailformat' => string,
						'description' => Yii::t('app', 'usuario.descCadastroMoodle'),
						'city' => $listUsuario['dccidade'],
						'country' => Constants::MOODLE_COUNTRY,
				);

				$params = array('users' => $options);
				$WSMoodle = new WSMoodle();
				return $WSMoodle->callFunction('core_user_create_users',  array($params));
			}
			return false;

		} catch (Exception $e) {
			throw new CHttpException(404, $e);
		}
	}

	public function getFaixaIdade($iniFaixa = 0)
	{
		$nuIdade = array();
		$ini = ($iniFaixa>0)?$iniFaixa:Constants::USUARIO_NU_IDADE_INI;
		for ($i = $ini-1; $i < Constants::USUARIO_NU_IDADE_FIM; $i++) {
			$nuIdade[$i] = array('id'=>$i+1, 'name'=>($i+1));
		}
		return $nuIdade;
	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/
}