<?php

// auto-loading fix
Yii::setPathOfAlias('UsuarioCursoPesquisa', dirname(__FILE__).'/base');
Yii::import('UsuarioCursoPesquisa.*');

class UsuarioCursoPesquisa extends BaseUsuarioCursoPesquisa
{
	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->dcresposta;

	}

	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));

		return array_merge(parent::behaviors(),array());
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function preCreate()
	{
		return $this->save();
	}

	public function preUpdate()
	{
		return $this->save();
	}

	public function preDelete($id)
	{
		return self::model()->findByPk($id)->delete();
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search()
	{
		return parent::search();
	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						//'adicioneAquiChave' => Yii::t('app', 'DescriÃ§Ã£o do label'),
				));

		return $attributes;
	}

	public function pesquisaUsuarios($idprojeto, $idcursomoodle, $idquestionario) {

		return Yii::app()->db->createCommand()
		->select('ucp.idusuario as id_usuario, u.dcnome as nome_usuario,
				ucp.idquestionario as id_questionario, q.dcformulario as nome_questionario')
				->from(Constants::SCHEMA_SINASE.'.usuariocursopesquisa ucp')
				->join(Constants::SCHEMA_SINASE.'.usuario u', 'u.idusuario = ucp.idusuario')
				->join(Constants::SCHEMA_SINASE.'.questionario q', 'q.idquestionario = ucp.idquestionario')
				->where('ucp.idquestionario=:id', array(':id'=>$idquestionario))
				->where('ucp.idcursomoodle=:id', array(':id'=>$idcursomoodle))
				->where('ucp.idprojeto=:id', array(':id'=>$idprojeto))
				->group('ucp.idusuario, u.dcnome, ucp.idquestionario, q.dcformulario')
				->order('u.dcnome, q.dcformulario')
				->queryAll();

	}

	public function pesquisaQuestoes($idprojeto, $idcursomoodle, $idquestionario) {

		return Yii::app()->db->createCommand()
		->select("ucp.idquestao, r.idresposta, (CASE WHEN r.idresposta IS NULL THEN qt.dcquestao ELSE qt.dcquestao || '(' || r.dcresposta || ')' END) as questao")
		->from(Constants::SCHEMA_SINASE.'.usuariocursopesquisa ucp')
		->join(Constants::SCHEMA_SINASE.'.questao qt', 'qt.idquestao = ucp.idquestao')
		->leftJoin(Constants::SCHEMA_SINASE.'.resposta r', "r.idresposta = ucp.idresposta AND qt.cotipoquestao = 'CHECKBOX'")
		->where('ucp.idquestionario=:id', array(':id'=>$idquestionario))
		->where('ucp.idcursomoodle=:id', array(':id'=>$idcursomoodle))
		->where('ucp.idprojeto=:id', array(':id'=>$idprojeto))
		->where("qt.cotipoquestao != 'TEXTAREA'")
		->group('ucp.idquestao, qt.dcquestao, r.dcresposta, r.idresposta')
		->order('qt.dcquestao, r.dcresposta')
		->queryAll();

	}

	public function pesquisaRespostas($idprojeto, $idcursomoodle, $idquestionario, $idusuario) {

		return Yii::app()->db->createCommand()
		->select("ucp.idquestao, qt.cotipoquestao, ucp.idusuario, r.idresposta, (CASE WHEN qt.cotipoquestao = 'CHECKBOX' OR qt.cotipoquestao = 'COMBO' OR qt.cotipoquestao = 'RADIO' THEN r.dcresposta ELSE ucp.dcresposta END) as resposta")
		->from(Constants::SCHEMA_SINASE.'.usuariocursopesquisa ucp')
		->join(Constants::SCHEMA_SINASE.'.questao qt', 'qt.idquestao = ucp.idquestao')
		->leftJoin(Constants::SCHEMA_SINASE.'.resposta r', "r.idresposta = ucp.idresposta")
		->where('ucp.idquestionario=:id', array(':id'=>$idquestionario))
		->where('ucp.idcursomoodle=:id', array(':id'=>$idcursomoodle))
		->where('ucp.idprojeto=:id', array(':id'=>$idprojeto))
		->where('ucp.idusuario=:id', array(':id'=>$idusuario))
		->where("qt.cotipoquestao != 'TEXTAREA'")
		->group('ucp.idquestao, qt.dcquestao, r.dcresposta, r.idresposta, ucp.idusuario, qt.cotipoquestao, ucp.dcresposta')
		->order('qt.dcquestao, r.dcresposta')
		->queryAll();

	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/

}
