<?php

// auto-loading fix
Yii::setPathOfAlias('VwUsuarioInscricao', dirname(__FILE__).'/base');
Yii::import('VwUsuarioInscricao.*');

class UsuarioInscricao extends BaseVwUsuarioInscricao
{
	public $idavaliacao;
	public $atrasadas;
	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function init()
	{
		return parent::init();
	}

	public function __toString() {
		return (string) $this->iduser;

	}

	public function behaviors()
	{
		// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function preCreate()
	{
		return $this->save();
	}

	public function preUpdate()
	{
		return $this->save();
	}

	public function preDelete($id)
	{
		return self::model()->findByPk($id)->delete();
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function search()
	{
		return parent::search();
	}

	public function attributeLabels()
	{
		$attributes = array_merge(parent::attributeLabels(),
				array(
						//'adicioneAquiChave' => Yii::t('app', 'DescriÃ§Ã£o do label'),
				));

		return $attributes;
	}

	/*
	 // customize this function ...
	public function get_label()
	{
	return '#'.$this->id;
	}
	*/

	public function tarefasAtrasadas(CursoTurma $cursoTurma, $count = FALSE, $exec = TRUE)
	{
		$criteria = new CDbCriteria();

		$queryNotIn =  Yii::app()->db->createCommand()
		->select('ctu.idtarefa')
		->from(Constants::SCHEMA_SINASE.'.vw_cursotarefausuario ctu')
		->where('ctu.idtarefa = ct.idtarefa and ctu.userid = ui.iduser')
		->getText();

		$criteria->alias  = 'ui';
		$criteria->select = 'count(ui.iduser) as atrasadas, ct.idtarefa, ui.fullname, ui.iduser';

		if($count === TRUE){
			$criteria->select = 'count(ui.iduser) as iduser';
		}

		$criteria->join   = 'inner join '.Constants::SCHEMA_SINASE.'.vw_cursotarefa ct on (ct.idcurso = ui.idcourse and ct.dtlimite < now()) ';
		$criteria->addCondition("ui.idrole = ".Constants::MOODLE_ROLE_TYPE_ENROL);
		$criteria->addCondition("ui.idcourse = {$cursoTurma->id}");
		$criteria->addCondition('ct.idtarefa NOT IN ('.$queryNotIn.')');

		if($count === FALSE){
			$criteria->group ='ct.idtarefa, ui.fullname, ui.iduser';
		}

		if($exec === TRUE){
			return UsuarioInscricao::model()->findAll($criteria);
		} else {
			return $criteria;
		}


	}

	public function questionariosAtrasados($cursoTurma, $count = FALSE, $exec = TRUE)
	{

		$criteria = new CDbCriteria();

		$queryNotIn =  Yii::app()->db->createCommand()
		->select('cau.idavaliacao')
		->from(Constants::SCHEMA_SINASE.'.vw_cursoavaliacaousuario cau')
		->where('cau.idavaliacao = ca.idavaliacao and cau.userid = ui.iduser')
		->getText();

		$criteria->alias  = 'ui';
		$criteria->select = 'count(ui.iduser) as atrasadas, ca.idavaliacao, ui.fullname, ui.iduser';

		if($count === TRUE){
			$criteria->select = 'count(ui.iduser) as iduser';
		}

		$criteria->join   = 'inner join '.Constants::SCHEMA_SINASE.'.vw_cursoavaliacao ca on (ca.idcurso = ui.idcourse and ca.dtlimite < now()) ';
		$criteria->addCondition("ui.idrole = ".Constants::MOODLE_ROLE_TYPE_ENROL);
		$criteria->addCondition("ui.idcourse = {$cursoTurma->id}");
		$criteria->addCondition('ca.idavaliacao NOT IN ('.$queryNotIn.')');

		if($count === FALSE){
			$criteria->group ='ca.idavaliacao, ui.fullname, ui.iduser';
		}

		if($exec) {
			return UsuarioInscricao::model()->findAll($criteria);
		} else {
			return $criteria;
		}
	}

	public function forumAtrasados($cursoTurma, $count = FALSE, $exec = TRUE)
	{

		$criteria = new CDbCriteria();

		$queryNotIn =  Yii::app()->db->createCommand()
		->select('cft.idforum')
		->from(Constants::SCHEMA_SINASE.'.vw_cursoforumpostusuario cfpu')
		->join(Constants::SCHEMA_SINASE.'.vw_cursoforumtopico cft','cft.idtopicoforum = cfpu.idtopicoforum and cft.idforum = cf.idforum')
		->where('cfpu.userid = ui.iduser')
		->getText();

		$criteria->alias  = 'ui';
		$criteria->select = 'count(ui.iduser) as atrasadas, cf.idforum, ui.fullname, ui.iduser';

		if($count === TRUE){
			$criteria->select = 'count(ui.iduser) as iduser';
		}

		$criteria->join   = 'inner join '.Constants::SCHEMA_SINASE.'.vw_cursoforum cf on (cf.idcurso = ui.idcourse and cf.dtlimite < now() + \'+1 days\') ';
		$criteria->addCondition("ui.idrole = ". Constants::MOODLE_ROLE_TYPE_ENROL);
		$criteria->addCondition("ui.idcourse = {$cursoTurma->id}");
		$criteria->addCondition('cf.idforum NOT IN ('.$queryNotIn.')');

		if($count === FALSE){
			$criteria->group ='cf.idforum, ui.fullname, ui.iduser';
		}

		if($exec){
			return UsuarioInscricao::model()->findAll($criteria);
		} else {
			return $criteria;
		}

	}

}
