<?php

// auto-loading fix
Yii::import('application.models.base.BaseUsuarioPerfilAcesso');

class UsuarioPerfilAcesso extends BaseUsuarioPerfilAcesso
{
	public $dcnome;
	public $dtultimoacessoorder;
	public $incoperfilacesso;

	// Add your model-specific methods here. This file will not be overriden by gtc except you force it.
	public static function model($className = __CLASS__)
	{
		return parent::model($className);
	}

	public function __toString()
	{
		return (string) $this->dtcadastro;
	}

	public function behaviors()
	{
		// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function rules()
	{
		return array_merge(
				array(
						// THIS IS THE NEW STUFF
						//array('dcsenha', 'length', 'min'=>6, 'max'=>30),
				),
				parent::rules()
		);
	}

	public function preUpdate()
	{
		return $this->save();
	}

	public function preFind($id)
	{
		return self::model()->findByPk($id);
	}

	public function init() {
		return parent::init();
	}

	public function preCreate()
	{
		foreach ($this->incoperfilacesso as $key => $value) {
			$perfil = explode("##", $value);
			if ($this->existPerfilUsuario($perfil[0]) && $perfil[1] == 0){
				$this->preInsert($this->idusuario, $perfil[0]);
			}elseif (!$this->existPerfilUsuario($perfil[0]) && $perfil[1] == 1){
				$this->preDelete($this->idusuario, $perfil[0]);
			}
		}
		return true;
	}

	protected function existPerfilUsuario($value)
	{
		if(isset($this->coperfilacesso)){
			foreach ($this->coperfilacesso as $keyPerfil => $valuePerfil) {
				if ($value == $valuePerfil){
					return true;
					break;
				}
			}
		}
		return false;
	}

	public function preInsert($idUsuario, $coPerfilAcesso)
	{
		Yii::app()->db->createCommand()
		->insert(Constants::SCHEMA_SINASE.'.usuarioperfilacesso',
				array('idusuario'=>$idUsuario,
						'coperfilacesso'=>$coPerfilAcesso,
						'dtcadastro'=>new CDbExpression('NOW()')));
	}

	protected function preDelete($idUsuario, $coPerfilAcesso)
	{
		Yii::app()->db->createCommand()
		->delete(Constants::SCHEMA_SINASE.'.usuarioperfilacesso',
				'idusuario=:idUsuario and coperfilacesso=:coPerfilAcesso',
				array(':idUsuario'=>$idUsuario, ':coPerfilAcesso'=>$coPerfilAcesso));
	}

	public function atualizaAcesso($idUsuario, $coPerfilAcesso)
	{
		$user = Yii::app()->db->createCommand()
		->update(Constants::SCHEMA_SINASE.'.usuarioperfilacesso',
				array('dtultimoacesso' => new CDbExpression('NOW()')),
				'idusuario=:idUsuario and coperfilacesso=:coPerfilAcesso',
				array(':idUsuario'=>$idUsuario, ':coPerfilAcesso'=>$coPerfilAcesso));
	}

	public function listUsuarioPerfil()
	{
		$criteria=new CDbCriteria;
		$criteria->alias = 'upa';
		$criteria->select = 'u.idusuario, u.dcnome,
							max(upa.dtultimoacesso) as dtultimoacesso,
							max(upa.dtcadastro) as dtcadastro';
		$criteria->join = 'inner join '.Constants::SCHEMA_SINASE.'.usuario u on u.idusuario = upa.idusuario';
		$criteria->group = 'u.idusuario, u.dcnome';

		$criteria->compare('coperfilacesso', $this->coperfilacesso);
		$criteria->compare('dtcadastro', $this->dtcadastro, true);
		$criteria->compare('dtultimoacesso', $this->dtultimoacesso, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function getMyAccessRules($idusuario, $coPerfilAcesso)
	{
		$perfilRota = Yii::app()->db->createCommand()
		->select('pr.controller, pr.action')
		->from(Constants::SCHEMA_SINASE.'.vw_perfil_usuario_rota pr')
		->where('pr.idusuario=:id and pr.co_perfilacesso=:coPerfilAcesso',
				array(':id'=>$idusuario, ':coPerfilAcesso'=>$coPerfilAcesso))
				->queryAll();
		return $this->uniformizeRota($perfilRota);
	}

	public function uniformizeRota($rota)
	{
		$rotaAccess = array();
		foreach ($rota as $key => $value) {
			$rotaAccess[$value['controller']] = isset($rotaAccess[$value['controller']])
			? array_merge($rotaAccess[$value['controller']], array($value['action']))
			: array($value['action']);
		}
		return $rotaAccess;
	}

	public function search()
	{
		return parent::search();
	}

	public function attributeLabels()
	{
		return array_merge(parent::attributeLabels(),
				array(
						//'adicioneAquiChave' => Yii::t('app', 'DescriÃ§Ã£o do label'),
				)
		);
	}
}
