<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".areaatuacao".
 *
 * Columns in table Constants::SCHEMA_SINASE.".areaatuacao" available as properties of the model:
 * @property integer $idareaatuacao
 * @property string $dcareaatuacao
 *
 * Relations of table Constants::SCHEMA_SINASE.".areaatuacao" available as properties of the model:
 * @property Usuario[] $usuarios
 */
abstract class BaseAreaAtuacao extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.areaatuacao';
	}

	public function rules()
	{
		return array(
				array('dcareaatuacao', 'unique'),
				array('dcareaatuacao', 'identificationColumnValidator'),
				array('dcareaatuacao', 'required'),
				array('dcareaatuacao', 'length', 'max'=>50),

				array('idareaatuacao, dcareaatuacao', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'usuarios' => array(self::HAS_MANY, 'Usuario', 'idareaatuacao'),
		);
	}

	public function attributeLabels()
	{
		return array(
				'idareaatuacao' => Yii::t('app', 'areaatuacao.idareaatuacao'),
				'dcareaatuacao' => Yii::t('app', 'areaatuacao.dcareaatuacao'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idareaatuacao', $this->idareaatuacao);
		$criteria->compare('dcareaatuacao', $this->dcareaatuacao, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idareaatuacao;

	}

}
