<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".controleinscricao".
 *
 * Columns in table Constants::SCHEMA_SINASE.".controleinscricao" available as properties of the model:
 * @property integer $idprojeto
 * @property integer $idcursomoodle
 * @property integer $idquestionario
 * @property integer $idusuario
 * @property integer $idturma
 * @property string $dtinscricao
 * @property string $dtenturmado
 * @property string $dtdesenturmado
 * @property string $dtconfirmaenturmado
 *
 * There are no model relations.
 */
abstract class BaseControleInscricao extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.controleinscricao';
	}

	public function rules()
	{
		return array(
				array('idprojeto, idcursomoodle, idquestionario, idusuario, dtinscricao', 'required'),
				array('idturma, dtenturmado, dtdesenturmado', 'default', 'setOnEmpty' => true, 'value' => null),
				array('idprojeto, idcursomoodle, idquestionario, idusuario, idturma', 'numerical', 'integerOnly'=>true),
				array('dtenturmado, dtdesenturmado', 'safe'),

				array('idprojeto, idcursomoodle, idquestionario, idusuario, idturma, dtinscricao, dtenturmado, dtdesenturmado', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.controleInscricao' => 'ControleInscricao',
	'controleInscricao.idprojeto' => 'Idprojeto',
	'controleInscricao.idcursomoodle' => 'Idcursomoodle',
	'controleInscricao.idquestionario' => 'Idquestionario',
	'controleInscricao.idusuario' => 'Idusuario',
	'controleInscricao.idturma' => 'Idturma',
	'controleInscricao.dtinscricao' => 'Dtinscricao',
	'controleInscricao.dtenturmado' => 'Dtenturmado',
	'controleInscricao.dtdesenturmado' => 'Dtdesenturmado',
	*/
	public function attributeLabels()
	{
		return array(
				'idprojeto' => Yii::t('app', 'controleInscricao.idprojeto'),
				'idcursomoodle' => Yii::t('app', 'controleInscricao.idcursomoodle'),
				'idquestionario' => Yii::t('app', 'controleInscricao.idquestionario'),
				'idusuario' => Yii::t('app', 'controleInscricao.idusuario'),
				'idturma' => Yii::t('app', 'controleInscricao.idturma'),
				'dtinscricao' => Yii::t('app', 'controleInscricao.dtinscricao'),
				'dtenturmado' => Yii::t('app', 'controleInscricao.dtenturmado'),
				'dtdesenturmado' => Yii::t('app', 'controleInscricao.dtdesenturmado'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idprojeto', $this->idprojeto);
		$criteria->compare('idcursomoodle', $this->idcursomoodle);
		$criteria->compare('idquestionario', $this->idquestionario);
		$criteria->compare('idusuario', $this->idusuario);
		$criteria->compare('idturma', $this->idturma);
		$criteria->compare('dtinscricao', $this->dtinscricao, true);
		$criteria->compare('dtenturmado', $this->dtenturmado, true);
		$criteria->compare('dtdesenturmado', $this->dtdesenturmado, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idprojeto;return '#'.$this->idcursomoodle;return '#'.$this->idquestionario;return '#'.$this->idusuario;
	}

}
