
<?php

/**
 * This is the model class for table Constants::SCHEMA_SINASE.".vw_cursoforum".
 *
 * The followings are the available columns in table Constants::SCHEMA_SINASE.'.vw_cursoforum':
 * @property string $idforum
 * @property string $idcurso
 * @property string $descricao
 * @property string $dtinicio
 * @property string $dtlimite
 */
class BaseCursoForum extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return BaseCursoforum the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.vw_cursoforum';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
				array('descricao', 'length', 'max'=>255),
				array('idforum, idcurso, dtinicio, dtlimite', 'safe'),
				// The following rule is used by search().
				// Please remove those attributes that should not be searched.
				array('idforum, idcurso, descricao, dtinicio, dtlimite', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
				'idforum' => 'cursoForum.idforum',
				'idcurso' => 'cursoForum.idcurso',
				'descricao' => 'cursoForum.descricao',
				'dtinicio' => 'cursoForum.dtinicio',
				'dtlimite' => 'cursoForum.dtlimite',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('idforum',$this->idforum,true);
		$criteria->compare('idcurso',$this->idcurso,true);
		$criteria->compare('descricao',$this->descricao,true);
		$criteria->compare('dtinicio',$this->dtinicio,true);
		$criteria->compare('dtlimite',$this->dtlimite,true);

		return new CActiveDataProvider($this, array(
				'criteria'=>$criteria,
		));
	}
}
