<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".emailgrupotag".
 *
 * Columns in table Constants::SCHEMA_SINASE.".emailgrupotag" available as properties of the model:
 * @property integer $idemail
 * @property integer $idemailtag
 *
 * There are no model relations.
 */
abstract class BaseEmailGrupoTag extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.emailgrupotag';
	}

	public function rules()
	{
		return array(
				array('idemail, idemailtag', 'required'),
				array('idemail, idemailtag', 'numerical', 'integerOnly'=>true),

				array('idemail, idemailtag', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.emailGrupoTag' => 'EmailGrupoTag',
	'emailGrupoTag.idemail' => 'Idemail',
	'emailGrupoTag.idemailtag' => 'Idemailtag',
	*/
	public function attributeLabels()
	{
		return array(
				'idemail' => Yii::t('app', 'emailGrupoTag.idemail'),
				'idemailtag' => Yii::t('app', 'emailGrupoTag.idemailtag'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idemail', $this->idemail);
		$criteria->compare('idemailtag', $this->idemailtag);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idemail;return '#'.$this->idemailtag;
	}

}
