<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".emailtag".
 *
 * Columns in table Constants::SCHEMA_SINASE.".emailtag" available as properties of the model:
 * @property integer $idemailtag
 * @property integer $idemailtipotag
 * @property string $dcemailtitulo
 * @property string $dcemailtag
 * @property string $dcemailtagreplace
 * @property integer $inativo
 *
 * Relations of table Constants::SCHEMA_SINASE.".emailtag" available as properties of the model:
 * @property Emailtipotag $idemailtipotag
 * @property Email[] $scPortalsinase.emails
 */
abstract class BaseEmailTag extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.emailtag';
	}

	public function rules()
	{
		return array(
				array('idemailtipotag, dcemailtag, dcemailtagreplace, inativo', 'required'),
				array('idemailtipotag, inativo', 'numerical', 'integerOnly'=>true),
				array('dcemailtitulo', 'length', 'max'=>60),
				array('dcemailtag, dcemailtagreplace', 'length', 'max'=>40),

				array('idemailtag, idemailtipotag, dcemailtitulo, dcemailtag, dcemailtagreplace, inativo', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'idemailtipotag' => array(self::BELONGS_TO, 'Emailtipotag', 'idemailtipotag'),
				'scPortalsinase.emails' => array(self::MANY_MANY, 'Email', 'emailgrupotag(idemailtag, idemail)'),
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.emailTag' => 'EmailTag',
	'emailTag.idemailtag' => 'Idemailtag',
	'emailTag.idemailtipotag' => 'Idemailtipotag',
	'emailTag.dcemailtitulo' => 'Dcemailtitulo',
	'emailTag.dcemailtag' => 'Dcemailtag',
	'emailTag.dcemailtagreplace' => 'Dcemailtagreplace',
	'emailTag.inativo' => 'Inativo',
	*/
	public function attributeLabels()
	{
		return array(
				'idemailtag' => Yii::t('app', 'emailTag.idemailtag'),
				'idemailtipotag' => Yii::t('app', 'emailTag.idemailtipotag'),
				'dcemailtitulo' => Yii::t('app', 'emailTag.dcemailtitulo'),
				'dcemailtag' => Yii::t('app', 'emailTag.dcemailtag'),
				'dcemailtagreplace' => Yii::t('app', 'emailTag.dcemailtagreplace'),
				'inativo' => Yii::t('app', 'emailTag.inativo'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idemailtag', $this->idemailtag);
		$criteria->compare('idemailtipotag', $this->idemailtipotag);
		$criteria->compare('dcemailtitulo', $this->dcemailtitulo, true);
		$criteria->compare('dcemailtag', $this->dcemailtag, true);
		$criteria->compare('dcemailtagreplace', $this->dcemailtagreplace, true);
		$criteria->compare('inativo', $this->inativo);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idemailtag;
	}

}
