<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".emailtipoenvio".
 *
 * Columns in table Constants::SCHEMA_SINASE.".emailtipoenvio" available as properties of the model:
 * @property integer $idemailtipoenvio
 * @property string $dcemailtipoenvio
 *
 * Relations of table Constants::SCHEMA_SINASE.".emailtipoenvio" available as properties of the model:
 * @property Email[] $emails
 */
abstract class BaseEmailTipoEnvio extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.emailtipoenvio';
	}

	public function rules()
	{
		return array(
				array('idemailtipoenvio, dcemailtipoenvio', 'required'),
				array('idemailtipoenvio', 'numerical', 'integerOnly'=>true),
				array('dcemailtipoenvio', 'length', 'max'=>60),

				array('idemailtipoenvio, dcemailtipoenvio', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'emails' => array(self::HAS_MANY, 'Email', 'idemailtipoenvio'),
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.emailTipoEnvio' => 'EmailTipoEnvio',
	'emailTipoEnvio.idemailtipoenvio' => 'Idemailtipoenvio',
	'emailTipoEnvio.dcemailtipoenvio' => 'Dcemailtipoenvio',
	*/
	public function attributeLabels()
	{
		return array(
				'idemailtipoenvio' => Yii::t('app', 'emailTipoEnvio.idemailtipoenvio'),
				'dcemailtipoenvio' => Yii::t('app', 'emailTipoEnvio.dcemailtipoenvio'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idemailtipoenvio', $this->idemailtipoenvio);
		$criteria->compare('dcemailtipoenvio', $this->dcemailtipoenvio, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idemailtipoenvio;
	}

}
