<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".emailtipotag".
 *
 * Columns in table Constants::SCHEMA_SINASE.".emailtipotag" available as properties of the model:
 * @property integer $idemailtipotag
 * @property string $dcemailtipotag
 *
 * Relations of table Constants::SCHEMA_SINASE.".emailtipotag" available as properties of the model:
 * @property Emailtag[] $emailtags
 */
abstract class BaseEmailTipoTag extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.emailtipotag';
	}

	public function rules()
	{
		return array(
				array('idemailtipotag, dcemailtipotag', 'required'),
				array('idemailtipotag', 'numerical', 'integerOnly'=>true),
				array('dcemailtipotag', 'length', 'max'=>60),

				array('idemailtipotag, dcemailtipotag', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'emailtags' => array(self::HAS_MANY, 'Emailtag', 'idemailtipotag'),
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.emailTipoTag' => 'EmailTipoTag',
	'emailTipoTag.idemailtipotag' => 'Idemailtipotag',
	'emailTipoTag.dcemailtipotag' => 'Dcemailtipotag',
	*/
	public function attributeLabels()
	{
		return array(
				'idemailtipotag' => Yii::t('app', 'emailTipoTag.idemailtipotag'),
				'dcemailtipotag' => Yii::t('app', 'emailTipoTag.dcemailtipotag'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idemailtipotag', $this->idemailtipotag);
		$criteria->compare('dcemailtipotag', $this->dcemailtipotag, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idemailtipotag;
	}

}
