<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".grauinstrucao".
 *
 * Columns in table Constants::SCHEMA_SINASE.".grauinstrucao" available as properties of the model:
 * @property integer $idgrauinstrucao
 * @property string $dcgrauinstrucao
 *
 * Relations of table Constants::SCHEMA_SINASE.".grauinstrucao" available as properties of the model:
 * @property Usuario[] $usuarios
 */
abstract class BaseGrauInstrucao extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.grauinstrucao';
	}

	public function rules()
	{
		return array(
				array('dcgrauinstrucao', 'unique'),
				array('dcgrauinstrucao', 'identificationColumnValidator'),
				array('dcgrauinstrucao', 'required'),
				array('dcgrauinstrucao', 'length', 'max'=>40),

				array('idgrauinstrucao, dcgrauinstrucao', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'usuarios' => array(self::HAS_MANY, 'Usuario', 'idgrauinstrucao'),
		);
	}

	public function attributeLabels()
	{
		return array(
				'idgrauinstrucao' => Yii::t('app', 'grauinstrucao.idgrauinstrucao'),
				'dcgrauinstrucao' => Yii::t('app', 'grauinstrucao.dcgrauinstrucao'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idgrauinstrucao', $this->idgrauinstrucao);
		$criteria->compare('dcgrauinstrucao', $this->dcgrauinstrucao, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idgrauinstrucao;

	}

}
