<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".grupoquestao".
 *
 * Columns in table Constants::SCHEMA_SINASE.".grupoquestao" available as properties of the model:
 * @property integer $idgrupoquestao
 * @property string $dcgrupoquestao
 *
 * Relations of table Constants::SCHEMA_SINASE.".grupoquestao" available as properties of the model:
 * @property Questao[] $questaos
 */
abstract class BaseGrupoQuestao extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.grupoquestao';
	}

	public function rules()
	{
		return array(
				array('dcgrupoquestao', 'unique'),
				array('dcgrupoquestao', 'identificationColumnValidator'),
				array('dcgrupoquestao', 'required'),
				array('dcgrupoquestao', 'length', 'max'=>40),

				array('idgrupoquestao, dcgrupoquestao', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'questaos' => array(self::HAS_MANY, 'Questao', 'idgrupoquestao'),
		);
	}

	public function attributeLabels()
	{
		return array(
				'idgrupoquestao' => Yii::t('app', 'Idgrupoquestao'),
				'dcgrupoquestao' => Yii::t('app', 'grupoQuestao.dcgrupoquestao'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idgrupoquestao', $this->idgrupoquestao);
		$criteria->compare('dcgrupoquestao', $this->dcgrupoquestao, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idgrupoquestao;

	}

}
