<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".grupoquestionario".
 *
 * Columns in table Constants::SCHEMA_SINASE.".grupoquestionario" available as properties of the model:
 * @property integer $idgrupoquestionario
 * @property string $dcgrupo
 * @property boolean $inativo
 *
 * Relations of table Constants::SCHEMA_SINASE.".grupoquestionario" available as properties of the model:
 * @property Questionario[] $questionarios
 */
abstract class BaseGrupoQuestionario extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.grupoquestionario';
	}

	public function rules()
	{
		return array(
				array('dcgrupo', 'unique'),
				array('dcgrupo', 'identificationColumnValidator'),
				array('dcgrupo', 'required'),
				array('inativo', 'default', 'setOnEmpty' => true, 'value' => null),
				array('dcgrupo', 'length', 'max'=>30),
				array('inativo', 'safe'),

				array('idgrupoquestionario, dcgrupo, inativo', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'questionarios' => array(self::HAS_MANY, 'Questionario', 'idgrupoquestionario'),
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.grupoQuestionario' => 'GrupoQuestionario',
	'grupoQuestionario.idgrupoquestionario' => 'Idgrupoquestionario',
	'grupoQuestionario.dcgrupo' => 'Dcgrupo',
	'grupoQuestionario.inativo' => 'Inativo',
	*/
	public function attributeLabels()
	{
		return array(
				'idgrupoquestionario' => Yii::t('app', 'grupoQuestionario.idgrupoquestionario'),
				'dcgrupo' => Yii::t('app', 'grupoQuestionario.dcgrupo'),
				'inativo' => Yii::t('app', 'grupoQuestionario.inativo'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idgrupoquestionario', $this->idgrupoquestionario);
		$criteria->compare('dcgrupo', $this->dcgrupo, true);
		$criteria->compare('inativo', $this->inativo);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idgrupoquestionario;
	}

}
