<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".vw_menu_sistema".
 *
 * Columns in table Constants::SCHEMA_SINASE.".vw_menu_sistema" available as properties of the model:
 * @property string $ar_nuordem
 * @property string $ar_idmenu
 * @property integer $id_funcionalidade
 * @property integer $id_funcionalidade_pai
 * @property integer $id_funcionalidade_principal
 * @property integer $id_tipo_funcionalidade
 * @property string $dc_funcionalidade
 * @property integer $nu_ordem
 * @property integer $nu_nivel
 * @property integer $id_rota
 * @property string $dc_rota
 *
 * There are no model relations.
 */
abstract class BaseMenuSistema extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.vw_menu_sistema';
	}

	public function rules()
	{
		return array(
				array('ar_nuordem, ar_idmenu, id_funcionalidade, id_funcionalidade_pai, id_funcionalidade_principal, id_tipo_funcionalidade, dc_funcionalidade, nu_ordem, nu_nivel, id_rota, dc_rota', 'default', 'setOnEmpty' => true, 'value' => null),
				array('id_funcionalidade, id_funcionalidade_pai, id_funcionalidade_principal, id_tipo_funcionalidade, nu_ordem, nu_nivel, id_rota', 'numerical', 'integerOnly'=>true),
				array('dc_funcionalidade', 'length', 'max'=>70),
				array('dc_rota', 'length', 'max'=>100),
				array('ar_nuordem, ar_idmenu', 'safe'),

				array('ar_nuordem, ar_idmenu, id_funcionalidade, id_funcionalidade_pai, id_funcionalidade_principal, id_tipo_funcionalidade, dc_funcionalidade, nu_ordem, nu_nivel, id_rota, dc_rota', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.menuSistema' => 'MenuSistema',
	'menuSistema.ar_nuordem' => 'Ar Nuordem',
	'menuSistema.ar_idmenu' => 'Ar Idmenu',
	'menuSistema.id_funcionalidade' => 'Id Funcionalidade',
	'menuSistema.id_funcionalidade_pai' => 'Id Funcionalidade Pai',
	'menuSistema.id_funcionalidade_principal' => 'Id Funcionalidade Principal',
	'menuSistema.id_tipo_funcionalidade' => 'Id Tipo Funcionalidade',
	'menuSistema.dc_funcionalidade' => 'Dc Funcionalidade',
	'menuSistema.nu_ordem' => 'Nu Ordem',
	'menuSistema.nu_nivel' => 'Nu Nivel',
	'menuSistema.id_rota' => 'Id Rota',
	'menuSistema.dc_rota' => 'Dc Rota',
	*/
	public function attributeLabels()
	{
		return array(
				'ar_nuordem' => Yii::t('app', 'menuSistema.ar_nuordem'),
				'ar_idmenu' => Yii::t('app', 'menuSistema.ar_idmenu'),
				'id_funcionalidade' => Yii::t('app', 'menuSistema.id_funcionalidade'),
				'id_funcionalidade_pai' => Yii::t('app', 'menuSistema.id_funcionalidade_pai'),
				'id_funcionalidade_principal' => Yii::t('app', 'menuSistema.id_funcionalidade_principal'),
				'id_tipo_funcionalidade' => Yii::t('app', 'menuSistema.id_tipo_funcionalidade'),
				'dc_funcionalidade' => Yii::t('app', 'menuSistema.dc_funcionalidade'),
				'nu_ordem' => Yii::t('app', 'menuSistema.nu_ordem'),
				'nu_nivel' => Yii::t('app', 'menuSistema.nu_nivel'),
				'id_rota' => Yii::t('app', 'menuSistema.id_rota'),
				'dc_rota' => Yii::t('app', 'menuSistema.dc_rota'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('ar_nuordem', $this->ar_nuordem, true);
		$criteria->compare('ar_idmenu', $this->ar_idmenu, true);
		$criteria->compare('id_funcionalidade', $this->id_funcionalidade);
		$criteria->compare('id_funcionalidade_pai', $this->id_funcionalidade_pai);
		$criteria->compare('id_funcionalidade_principal', $this->id_funcionalidade_principal);
		$criteria->compare('id_tipo_funcionalidade', $this->id_tipo_funcionalidade);
		$criteria->compare('dc_funcionalidade', $this->dc_funcionalidade, true);
		$criteria->compare('nu_ordem', $this->nu_ordem);
		$criteria->compare('nu_nivel', $this->nu_nivel);
		$criteria->compare('id_rota', $this->id_rota);
		$criteria->compare('dc_rota', $this->dc_rota, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{

	}

}
