<?php

/**
 * This is the model class for table Constants::SCHEMA_SINASE.".vw_notaatividade".
 *
 * The followings are the available columns in table Constants::SCHEMA_SINASE.'.vw_notaatividade':
 * @property string $userid
 * @property string $idcurso
 * @property string $idmodulo
 * @property string $nummodulo
 * @property string $dcmodulo
 * @property string $dctarefa
 * @property string $vlnota
 * @property string $tpmodulo
 * @property string $idtarefa
*/
class BaseNotaAtividade extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return BaseNotaAtividade the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.vw_notaatividade';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
				array('dcmodulo, dctarefa', 'length', 'max'=>255),
				array('vlnota', 'length', 'max'=>10),
				array('userid, idcurso, idmodulo, nummodulo', 'safe'),
				// The following rule is used by search().
				// Please remove those attributes that should not be searched.
				array('userid, idcurso, idmodulo, nummodulo, dcmodulo, dctarefa, vlnota, tpmodulo, idtarefa', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
				'userid' => 'Userid',
				'idcurso' => 'Idcurso',
				'idmodulo' => 'Idmodulo',
				'nummodulo' => 'Nummodulo',
				'dcmodulo' => 'Dcmodulo',
				'dctarefa' => 'Dctarefa',
				'vlnota' => 'Vlnota',
                'tpmodulo' => 'Tpmodulo',
                'idtarefa' => 'Idtarefa'
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('userid',$this->userid,true);
		$criteria->compare('idcurso',$this->idcurso,true);
		$criteria->compare('idmodulo',$this->idmodulo,true);
		$criteria->compare('nummodulo',$this->nummodulo,true);
		$criteria->compare('dcmodulo',$this->dcmodulo,true);
		$criteria->compare('dctarefa',$this->dctarefa,true);
		$criteria->compare('vlnota',$this->vlnota,true);
		$criteria->compare('tpmodulo',$this->tpmodulo,true);
		$criteria->compare('idtarefa',$this->idtarefa,true);

		return new CActiveDataProvider($this, array(
				'criteria'=>$criteria,
		));
	}
}