<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".perfilacesso".
 *
 * Columns in table Constants::SCHEMA_SINASE.".perfilacesso" available as properties of the model:
 * @property string $coperfilacesso
 * @property string $dcperfilacesso
 * @property string $dtcadastro
 * @property string $dcperfilacessocurto
 * @property integer $idpapel
 * @property boolean $inativo
 *
 * Relations of table Constants::SCHEMA_SINASE.".perfilacesso" available as properties of the model:
 * @property Usuario[] $scPortalsinase.usuarios
 */
abstract class BasePerfilAcesso extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.perfilacesso';
	}

	public function rules()
	{
		return array(
				array('coperfilacesso', 'unique'),
				array('coperfilacesso', 'identificationColumnValidator'),
				array('coperfilacesso, dcperfilacesso, dtcadastro', 'required'),
				array('dcperfilacessocurto', 'default', 'setOnEmpty' => true, 'value' => null),
				array('coperfilacesso', 'length', 'max'=>15),
				array('dcperfilacesso', 'length', 'max'=>150),
				array('dcperfilacessocurto', 'length', 'max'=>20),

				array('coperfilacesso, dcperfilacesso, dtcadastro, dcperfilacessocurto', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'scPortalsinase.usuarios' => array(self::MANY_MANY, 'Usuario', 'usuarioperfilacesso(coperfilacesso, idusuario)'),
		);
	}

	public function attributeLabels()
	{
		return array(
				'coperfilacesso' => Yii::t('app', 'Coperfilacesso'),
				'dcperfilacesso' => Yii::t('app', 'Dcperfilacesso'),
				'dtcadastro' => Yii::t('app', 'Dtcadastro'),
				'dcperfilacessocurto' => Yii::t('app', 'Dcperfilacessocurto'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('coperfilacesso', $this->coperfilacesso, true);
		$criteria->compare('dcperfilacesso', $this->dcperfilacesso, true);
		$criteria->compare('dtcadastro', $this->dtcadastro, true);
		$criteria->compare('dcperfilacessocurto', $this->dcperfilacessocurto, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->coperfilacesso;

	}

}
