<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".pesquisa".
 *
 * Columns in table Constants::SCHEMA_SINASE.".pesquisa" available as properties of the model:
 * @property integer $idpesquisa
 * @property integer $idcurso
 * @property string $dctitulo
 * @property string $dtcriacao
 * @property integer $idusuariocriacao
 *
 * There are no model relations.
 */
abstract class BasePesquisa extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.pesquisa';
	}

	public function rules()
	{
		return array(
				array('dctitulo, dtcriacao, idcurso, idusuariocriacao', 'required'),
				array('idusuariocriacao, idcurso', 'numerical', 'integerOnly'=>true),
				array('dctitulo', 'length', 'max'=>100),

				array('idpesquisa, dctitulo, dtcriacao, idusuariocriacao, idcurso', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.pesquisa' => 'Pesquisa',
	'pesquisa.idpesquisa' => 'Idpesquisa',
	'pesquisa.dctitulo' => 'Dctitulo',
	'pesquisa.dtcriacao' => 'Dtcriacao',
	'pesquisa.idusuariocriacao' => 'Idusuariocriacao',
	*/
	public function attributeLabels()
	{
		return array(
				'idpesquisa' => Yii::t('app', 'pesquisa.idpesquisa'),
				'dctitulo' => Yii::t('app', 'formarTurma.refinarBusca'),
				'dtcriacao' => Yii::t('app', 'generic.dtcriacao'),
				'idusuariocriacao' => Yii::t('app', 'usuario.idusuariocriacao'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idpesquisa', $this->idpesquisa);
		$criteria->compare('dctitulo', $this->dctitulo, true);
		$criteria->compare('dtcriacao', $this->dtcriacao, true);
		$criteria->compare('idusuariocriacao', $this->idusuariocriacao);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idpesquisa;
	}

}
