<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".portalconfig".
 *
 * Columns in table Constants::SCHEMA_SINASE.".portalconfig" available as properties of the model:
 * @property integer $idportalconfig
 * @property string $txmensagemerro
 * @property string $txmensagemprincipal
 * @property string $txtmailtopo
 * @property string $txmailrodape
 * @property integer $idusuarioresponsavel
 * @property string $dtcadastro
 * @property string $dtalteracao
 * @property integer $idusuarioalteracao
 * @property boolean $inportalativo
 * @property boolean $inativo
 *
 * There are no model relations.
 */
abstract class BasePortalConfiguracao extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.portalconfig';
	}

	public function rules()
	{
		return array(
				array('idusuarioresponsavel, dtcadastro, idusuarioalteracao, inportalativo, inativo', 'required'),
				array('txmensagemerro, txmensagemprincipal, txtmailtopo, txmailrodape, dtalteracao', 'default', 'setOnEmpty' => true, 'value' => null),
				array('idusuarioresponsavel, idusuarioalteracao', 'numerical', 'integerOnly'=>true),
				array('txtmailtopo, txmailrodape', 'length', 'max'=>1000),
				array('txmensagemerro, txmensagemprincipal, dtalteracao', 'safe'),

				array('idportalconfig, txmensagemerro, txmensagemprincipal, txtmailtopo, txmailrodape, idusuarioresponsavel, dtcadastro, dtalteracao, idusuarioalteracao, inportalativo, inativo', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.portalConfiguracao' => 'PortalConfiguracao',
	'portalConfiguracao.idportalconfig' => 'Idportalconfig',
	'portalConfiguracao.txmensagemerro' => 'Txmensagemerro',
	'portalConfiguracao.txmensagemprincipal' => 'Txmensagemprincipal',
	'portalConfiguracao.txtmailtopo' => 'Txtmailtopo',
	'portalConfiguracao.txmailrodape' => 'Txmailrodape',
	'portalConfiguracao.idusuarioresponsavel' => 'Idusuarioresponsavel',
	'portalConfiguracao.dtcadastro' => 'Dtcadastro',
	'portalConfiguracao.dtalteracao' => 'Dtalteracao',
	'portalConfiguracao.idusuarioalteracao' => 'Idusuarioalteracao',
	'portalConfiguracao.inportalativo' => 'Inportalativo',
	'portalConfiguracao.inativo' => 'Inativo',
	*/
	public function attributeLabels()
	{
		return array(
				'idportalconfig' => Yii::t('app', 'portalConfiguracao.idportalconfig'),
				'txmensagemerro' => Yii::t('app', 'portalConfiguracao.txmensagemerro'),
				'txmensagemprincipal' => Yii::t('app', 'portalConfiguracao.txmensagemprincipal'),
				'txtmailtopo' => Yii::t('app', 'portalConfiguracao.txtmailtopo'),
				'txmailrodape' => Yii::t('app', 'portalConfiguracao.txmailrodape'),
				'idusuarioresponsavel' => Yii::t('app', 'portalConfiguracao.idusuarioresponsavel'),
				'dtcadastro' => Yii::t('app', 'portalConfiguracao.dtcadastro'),
				'dtalteracao' => Yii::t('app', 'portalConfiguracao.dtalteracao'),
				'idusuarioalteracao' => Yii::t('app', 'portalConfiguracao.idusuarioalteracao'),
				'inportalativo' => Yii::t('app', 'portalConfiguracao.inportalativo'),
				'inativo' => Yii::t('app', 'portalConfiguracao.inativo'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idportalconfig', $this->idportalconfig);
		$criteria->compare('txmensagemerro', $this->txmensagemerro, true);
		$criteria->compare('txmensagemprincipal', $this->txmensagemprincipal, true);
		$criteria->compare('txtmailtopo', $this->txtmailtopo, true);
		$criteria->compare('txmailrodape', $this->txmailrodape, true);
		$criteria->compare('idusuarioresponsavel', $this->idusuarioresponsavel);
		$criteria->compare('dtcadastro', $this->dtcadastro, true);
		$criteria->compare('dtalteracao', $this->dtalteracao, true);
		$criteria->compare('idusuarioalteracao', $this->idusuarioalteracao);
		$criteria->compare('inportalativo', $this->inportalativo);
		$criteria->compare('inativo', $this->inativo);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idportalconfig;
	}

}
