<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".projeto".
 *
 * Columns in table Constants::SCHEMA_SINASE.".projeto" available as properties of the model:
 * @property integer $idprojeto
 * @property string $dcprojeto
 * @property string $dtinicio
 * @property string $dtfinal
 * @property boolean $inativo
 *
 * Relations of table Constants::SCHEMA_SINASE.".projeto" available as properties of the model:
 * @property Mensagem[] $mensagems
 * @property Projetocurso[] $projetocursos
 */
abstract class BaseProjeto extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.projeto';
	}

	public function rules()
	{
		return array(
				array('dcprojeto', 'unique'),
				array('dcprojeto', 'identificationColumnValidator'),
				array('dcprojeto, dtinicio, dtfinal, inativo', 'required'),
				array('dcprojeto', 'length', 'max'=>70),

				array('idprojeto, dcprojeto, dtinicio, dtfinal, inativo', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'mensagems' => array(self::HAS_MANY, 'Mensagem', 'idprojeto'),
				'projetocursos' => array(self::HAS_MANY, 'Projetocurso', 'idprojeto'),
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.projeto' => 'Projeto',
	'projeto.idprojeto' => 'Idprojeto',
	'projeto.dcprojeto' => 'Dcprojeto',
	'projeto.dtinicio' => 'Dtinicio',
	'projeto.dtfinal' => 'Dtfinal',
	'projeto.inativo' => 'Inativo',
	*/
	public function attributeLabels()
	{
		return array(
				'idprojeto' => Yii::t('app', 'projeto.idprojeto'),
				'dcprojeto' => Yii::t('app', 'projeto.dcprojeto'),
				'dtinicio' => Yii::t('app', 'projeto.dtinicio'),
				'dtfinal' => Yii::t('app', 'projeto.dtfinal'),
				'inativo' => Yii::t('app', 'projeto.inativo'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idprojeto', $this->idprojeto);
		$criteria->compare('dcprojeto', $this->dcprojeto, true);
		$criteria->compare('dtinicio', $this->dtinicio);
		$criteria->compare('dtfinal', $this->dtfinal);
		$criteria->compare('inativo', $this->inativo);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idprojeto;
	}

}
