<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".questaovalidacao".
 *
 * Columns in table Constants::SCHEMA_SINASE.".questaovalidacao" available as properties of the model:
 * @property string $coquestaovalidacao
 * @property string $dcquestaovalidacao
 *
 * Relations of table Constants::SCHEMA_SINASE.".questaovalidacao" available as properties of the model:
 * @property Tipoquestao[] $scPortalsinase.tipoquestaos
 * @property Questao[] $questaos
 */
abstract class BaseQuestaovalidacao extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.questaovalidacao';
	}

	public function rules()
	{
		return array(
				array('coquestaovalidacao', 'unique'),
				array('coquestaovalidacao', 'identificationColumnValidator'),
				array('coquestaovalidacao, dcquestaovalidacao', 'required'),
				array('coquestaovalidacao', 'length', 'max'=>8),
				array('dcquestaovalidacao', 'length', 'max'=>30),

				array('coquestaovalidacao, dcquestaovalidacao', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'scPortalsinase.tipoquestaos' => array(self::MANY_MANY, 'Tipoquestao', 'validacaotipo_questao(coquestaovalidacao, cotipoquestao)'),
				'questaos' => array(self::HAS_MANY, 'Questao', 'coquestaovalidacao'),
		);
	}

	public function attributeLabels()
	{
		return array(
				'coquestaovalidacao' => Yii::t('app', 'Coquestaovalidacao'),
				'dcquestaovalidacao' => Yii::t('app', 'Dcquestaovalidacao'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('coquestaovalidacao', $this->coquestaovalidacao, true);
		$criteria->compare('dcquestaovalidacao', $this->dcquestaovalidacao, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->coquestaovalidacao;

	}

}
