<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".questionario".
 *
 * Columns in table Constants::SCHEMA_SINASE.".questionario" available as properties of the model:
 * @property integer $idquestionario
 * @property integer $idgrupoquestionario
 * @property string $dcformulario
 * @property string $dcobjetivo
 * @property string $dcconfirmacao
 * @property string $dtcriacao
 * @property boolean $inativo
 *
 * Relations of table Constants::SCHEMA_SINASE.".questionario" available as properties of the model:
 * @property Grupoquestionario $idgrupoquestionario
 * @property Questao[] $questaos
 * @property Projetocurso[] $projetocursos
 */
abstract class BaseQuestionario extends CActiveRecord{

	public $participantes;

	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.questionario';
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{

		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'idgrupoquestionario' => array(self::BELONGS_TO, 'Grupoquestionario', 'idgrupoquestionario'),
				'questaos' => array(self::HAS_MANY, 'Questao', 'idquestionario'),
				'projetocursos' => array(self::HAS_MANY, 'Projetocurso', 'idquestionario'),
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.questionario' => 'Questionario',
	'questionario.idquestionario' => 'Idquestionario',
	'questionario.idgrupoquestionario' => 'Idgrupoquestionario',
	'questionario.dcformulario' => 'Dcformulario',
	'questionario.dcobjetivo' => 'Dcobjetivo',
	'questionario.dcconfirmacao' => 'Dcconfirmacao',
	'questionario.dtcriacao' => 'Dtcriacao',
	'questionario.inativo' => 'Inativo',
	*/
	public function attributeLabels()
	{
		return array(
				'idquestionario' 		=> Yii::t('app', 'questionario.idquestionario'),
				'idgrupoquestionario' 	=> Yii::t('app', 'questionario.idgrupoquestionario'),
				'dcformulario' 			=> Yii::t('app', 'questionario.dcformulario'),
				'dcobjetivo'            => Yii::t('app', 'questionario.dcobjetivo'),
				'dcconfirmacao'         => Yii::t('app', 'questionario.dcconfirmacao'),
				'dtcriacao'             => Yii::t('app', 'questionario.dtcriacao'),
				'inativo'               => Yii::t('app', 'questionario.inativo'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idquestionario', $this->idquestionario);
		$criteria->compare('idgrupoquestionario', $this->idgrupoquestionario);
		$criteria->compare('dcformulario', $this->dcformulario, true);
		$criteria->compare('dcobjetivo', $this->dcobjetivo, true);
		$criteria->compare('dcconfirmacao', $this->dcconfirmacao, true);
		$criteria->compare('dtcriacao', $this->dtcriacao, true);
		$criteria->compare('inativo', $this->inativo);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function search2()
	{
		$criteria=new CDbCriteria;

		$criteria->alias = 'q';
		$criteria->select = 'ucp.idquestionario, dcformulario, count(ucp.idrespostausuario) as participantes';

		// 		$criteria->compare('idquestionario', $this->idquestionario);
		$criteria->compare('idgrupoquestionario', $this->idgrupoquestionario);
		// 		$criteria->compare('dcformulario', $this->dcformulario, true);
		$criteria->compare('dcformulario', $this->dcformulario, true);
		// 		$criteria->compare('dcobjetivo', $this->dcobjetivo, true);
		// 		$criteria->compare('dcconfirmacao', $this->dcconfirmacao, true);
		// 		$criteria->compare('dtcriacao', $this->dtcriacao, true);
		// 		$criteria->compare('inativo', $this->inativo);
		$criteria->join = 'INNER JOIN '.Constants::SCHEMA_SINASE.'.usuariocursopesquisa ucp ON q.idquestionario=ucp.idquestionario';
		$criteria->group = 'ucp.idquestionario, dcformulario';
		// 		$criteria->having = 'COUNT(ucp.idrespostausuario) = 1';

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));

	}

	public function get_label()
	{
		return '#'.$this->idquestionario;
	}

}
