<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".resposta".
 *
 * Columns in table Constants::SCHEMA_SINASE.".resposta" available as properties of the model:
 * @property integer $idresposta
 * @property integer $idquestao
 * @property string $dcresposta
 * @property integer $nuordem
 *
 * Relations of table Constants::SCHEMA_SINASE.".resposta" available as properties of the model:
 * @property Questao $idquestao
 */
abstract class BaseResposta extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.resposta';
	}

	public function rules()
	{
		return array(
				array('idquestao, dcresposta, nuordem', 'required'),
				array('idquestao, nuordem', 'numerical', 'integerOnly'=>true),
				array('dcresposta', 'length', 'max'=>40),

				array('idresposta, idquestao, dcresposta, nuordem', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'idquestao' => array(self::BELONGS_TO, 'Questao', 'idquestao'),
		);
	}

	public function attributeLabels()
	{
		return array(
				'idresposta' => Yii::t('app', 'resposta.idresposta'),
				'idquestao' => Yii::t('app', 'resposta.idquestao'),
				'dcresposta' => Yii::t('app', 'resposta.dcresposta'),
				'nuordem' => Yii::t('app', 'resposta.nuordem'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idresposta', $this->idresposta);
		$criteria->compare('idquestao', $this->idquestao);
		$criteria->compare('dcresposta', $this->dcresposta, true);
		$criteria->compare('nuordem', $this->nuordem);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idresposta;

	}

}
