<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".tipoquestao".
 *
 * Columns in table Constants::SCHEMA_SINASE.".tipoquestao" available as properties of the model:
 * @property string $cotipoquestao
 * @property string $dctipoquestao
 *
 * Relations of table Constants::SCHEMA_SINASE.".tipoquestao" available as properties of the model:
 * @property Questaovalidacao[] $scPortalsinase.questaovalidacaos
 * @property Questao[] $questaos
 */
abstract class BaseTipoquestao extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.tipoquestao';
	}

	public function rules()
	{
		return array(
				array('cotipoquestao', 'unique'),
				array('cotipoquestao', 'identificationColumnValidator'),
				array('cotipoquestao, dctipoquestao', 'required'),
				array('cotipoquestao', 'length', 'max'=>10),
				array('dctipoquestao', 'length', 'max'=>30),

				array('cotipoquestao, dctipoquestao', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'scPortalsinase.questaovalidacaos' => array(self::MANY_MANY, 'Questaovalidacao', 'validacaotipo_questao(cotipoquestao, coquestaovalidacao)'),
				'questaos' => array(self::HAS_MANY, 'Questao', 'cotipoquestao'),
		);
	}

	public function attributeLabels()
	{
		return array(
				'cotipoquestao' => Yii::t('app', 'Cotipoquestao'),
				'dctipoquestao' => Yii::t('app', 'Dctipoquestao'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('cotipoquestao', $this->cotipoquestao, true);
		$criteria->compare('dctipoquestao', $this->dctipoquestao, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->cotipoquestao;

	}

}
