<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".uf".
 *
 * Columns in table Constants::SCHEMA_SINASE.".uf" available as properties of the model:
 * @property string $couf
 * @property string $dcuf
 *
 * Relations of table Constants::SCHEMA_SINASE.".uf" available as properties of the model:
 * @property Usuario[] $usuarios
 */
abstract class BaseUf extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.uf';
	}

	public function rules()
	{
		return array(
				array('couf', 'unique'),
				array('couf', 'identificationColumnValidator'),
				array('couf, dcuf', 'required'),
				array('couf', 'length', 'max'=>2),
				array('dcuf', 'length', 'max'=>30),

				array('couf, dcuf', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'usuarios' => array(self::HAS_MANY, 'Usuario', 'couf'),
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.uf' => 'Uf',
	'uf.couf' => 'Couf',
	'uf.dcuf' => 'Dcuf',
	*/
	public function attributeLabels()
	{
		return array(
				'couf' => Yii::t('app', 'uf.couf'),
				'dcuf' => Yii::t('app', 'uf.dcuf'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('couf', $this->couf, true);
		$criteria->compare('dcuf', $this->dcuf, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->couf;
	}

}
