<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".usuario".
 *
 * Columns in table Constants::SCHEMA_SINASE.".usuario" available as properties of the model:
 * @property integer $idusuario
 * @property string $idmoodle
 * @property integer $idareaatuacao
 * @property integer $idgrauinstrucao
 * @property integer $idusuariostatus
 * @property string $nucpf
 * @property string $dcnome
 * @property string $dtnascimento
 * @property string $dcsexo
 * @property string $dcemail
 * @property string $nutelefoneparticular
 * @property string $nutelefonecomercial
 * @property string $nutelefonecelular
 * @property string $dcnomepai
 * @property string $dcnomemae
 * @property string $dcendereco
 * @property string $nuendereco
 * @property string $dccomplemento
 * @property string $couf
 * @property string $dcbairro
 * @property string $dccidade
 * @property string $nucep
 * @property string $dcoutraareaatuacao
 * @property string $dccurriculolattes
 * @property boolean $inreceberinformacao
 * @property boolean $indeclaracao
 * @property string $dcusuario
 * @property string $dcsenha
 * @property string $dtcadastro
 * @property string $dtatualizacao
 * @property string $dctokenmoodle
 *
 * Relations of table Constants::SCHEMA_SINASE.".usuario" available as properties of the model:
 * @property Grauinstrucao $idgrauinstrucao
 * @property Areaatuacao $idareaatuacao
 * @property Usuariostatus $idusuariostatus
 * @property Uf $couf
 * @property Portalconfig[] $portalconfigs
 * @property Portalconfig[] $portalconfigs1
 * @property Mensagem[] $mensagems
 * @property Mensagem[] $mensagems1
 * @property Pesquisa[] $pesquisas
 * @property Controleinscricao[] $controleinscricaos
 * @property Condicao[] $condicaos
 * @property Perfilacesso[] $scPortalsinase.perfilacessos
 * @property Mensagem[] $scPortalsinase.mensagems
 */
abstract class BaseUsuario extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.usuario';
	}

	public function rules()
	{
		return array(
				array('idmoodle', 'unique'),
				array('idmoodle', 'identificationColumnValidator'),
				array('idusuariostatus, nucpf, dcnome, dtnascimento, dcsexo, dcemail, dcusuario, dcsenha, dtcadastro', 'required'),
				array('idmoodle, idareaatuacao, idgrauinstrucao, nutelefoneparticular, nutelefonecomercial, nutelefonecelular, dcnomepai, dcnomemae, dcendereco, nuendereco, dccomplemento, couf, dcbairro, dccidade, nucep, dcoutraareaatuacao, dccurriculolattes, inreceberinformacao, indeclaracao, dtatualizacao, dctokenmoodle', 'default', 'setOnEmpty' => true, 'value' => null),
				array('idareaatuacao, idgrauinstrucao, idusuariostatus', 'numerical', 'integerOnly'=>true),
				array('idmoodle, nuendereco', 'length', 'max'=>10),
				array('nucpf', 'length', 'max'=>11),
				array('dcnome, dcnomepai, dcnomemae, dccidade, dcoutraareaatuacao', 'length', 'max'=>50),
				array('dcsexo', 'length', 'max'=>1),
				array('dcemail', 'length', 'max'=>60),
				array('nutelefoneparticular, nutelefonecomercial, nutelefonecelular', 'length', 'max'=>15),
				array('dcendereco', 'length', 'max'=>70),
				array('dccomplemento, dcbairro, dcusuario', 'length', 'max'=>30),
				array('couf', 'length', 'max'=>2),
				array('nucep', 'length', 'max'=>8),
				array('dccurriculolattes', 'length', 'max'=>160),
				array('dcsenha, dctokenmoodle', 'length', 'max'=>128),
				array('inreceberinformacao, indeclaracao, dtatualizacao', 'safe'),

				array('idusuario, idmoodle, idareaatuacao, idgrauinstrucao, idusuariostatus, nucpf, dcnome, dtnascimento, dcsexo, dcemail, nutelefoneparticular, nutelefonecomercial, nutelefonecelular, dcnomepai, dcnomemae, dcendereco, nuendereco, dccomplemento, couf, dcbairro, dccidade, nucep, dcoutraareaatuacao, dccurriculolattes, inreceberinformacao, indeclaracao, dcusuario, dcsenha, dtcadastro, dtatualizacao, dctokenmoodle', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'areaatuacao' => array(self::BELONGS_TO, 'AreaAtuacao', 'idareaatuacao'),
				'grauinstrucao' => array(self::BELONGS_TO, 'GrauInstrucao', 'idgrauinstrucao'),
				'usuariostatus' => array(self::BELONGS_TO, 'UsuarioStatus', 'idusuariostatus'),
				'couf' => array(self::BELONGS_TO, 'Uf', 'couf'),
				'portalconfigs' => array(self::HAS_MANY, 'PortalConfig', 'idusuarioresponsavel'),
				'portalconfigs1' => array(self::HAS_MANY, 'PortalConfig', 'idusuarioalteracao'),
				'mensagems' => array(self::HAS_MANY, 'Mensagem', 'idusuariodestinatario'),
				'mensagems1' => array(self::HAS_MANY, 'Mensagem', 'idusuariocriacao'),
				'pesquisas' => array(self::HAS_MANY, 'Pesquisa', 'idusuariocriacao'),
				'controleinscricaos' => array(self::HAS_MANY, 'ControleInscricao', 'idusuario'),
				'condicaos' => array(self::HAS_MANY, 'Condicao', 'idusuariocriacao'),
				'portalsinase.perfilacessos' => array(self::MANY_MANY, 'PerfilAcesso', 'usuarioperfilacesso(idusuario, coperfilacesso)'),
				'portalsinase.mensagems' => array(self::MANY_MANY, 'Mensagem', 'usuariomensagemlida(idusuario, idmensagem)'),
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.usuario' => 'Usuario',
	'usuario.idusuario' => 'Idusuario',
	'usuario.idmoodle' => 'Idmoodle',
	'usuario.idareaatuacao' => 'Idareaatuacao',
	'usuario.idgrauinstrucao' => 'Idgrauinstrucao',
	'usuario.idusuariostatus' => 'Idusuariostatus',
	'usuario.nucpf' => 'Nucpf',
	'usuario.dcnome' => 'Dcnome',
	'usuario.dtnascimento' => 'Dtnascimento',
	'usuario.dcsexo' => 'Dcsexo',
	'usuario.dcemail' => 'Dcemail',
	'usuario.nutelefoneparticular' => 'Nutelefoneparticular',
	'usuario.nutelefonecomercial' => 'Nutelefonecomercial',
	'usuario.nutelefonecelular' => 'Nutelefonecelular',
	'usuario.dcnomepai' => 'Dcnomepai',
	'usuario.dcnomemae' => 'Dcnomemae',
	'usuario.dcendereco' => 'Dcendereco',
	'usuario.nuendereco' => 'Nuendereco',
	'usuario.dccomplemento' => 'Dccomplemento',
	'usuario.couf' => 'Couf',
	'usuario.dcbairro' => 'Dcbairro',
	'usuario.dccidade' => 'Dccidade',
	'usuario.nucep' => 'Nucep',
	'usuario.dcoutraareaatuacao' => 'Dcoutraareaatuacao',
	'usuario.dccurriculolattes' => 'Dccurriculolattes',
	'usuario.inreceberinformacao' => 'Inreceberinformacao',
	'usuario.indeclaracao' => 'Indeclaracao',
	'usuario.dcusuario' => 'Dcusuario',
	'usuario.dcsenha' => 'Dcsenha',
	'usuario.dtcadastro' => 'Dtcadastro',
	'usuario.dtatualizacao' => 'Dtatualizacao',
	'usuario.dctokenmoodle' => 'Dctokenmoodle',
	*/
	public function attributeLabels()
	{
		return array(
				'idusuario' => Yii::t('app', 'usuario.idusuario'),
				'idmoodle' => Yii::t('app', 'usuario.idmoodle'),
				'idareaatuacao' => Yii::t('app', 'usuario.idareaatuacao'),
				'idgrauinstrucao' => Yii::t('app', 'usuario.idgrauinstrucao'),
				'idusuariostatus' => Yii::t('app', 'usuario.idusuariostatus'),
				'nucpf' => Yii::t('app', 'usuario.nucpf'),
				'dcnome' => Yii::t('app', 'usuario.dcnome'),
				'dtnascimento' => Yii::t('app', 'usuario.dtnascimento'),
				'dcsexo' => Yii::t('app', 'usuario.dcsexo'),
				'dcemail' => Yii::t('app', 'usuario.dcemail'),
				'nutelefoneparticular' => Yii::t('app', 'usuario.nutelefoneparticular'),
				'nutelefonecomercial' => Yii::t('app', 'usuario.nutelefonecomercial'),
				'nutelefonecelular' => Yii::t('app', 'usuario.nutelefonecelular'),
				'dcnomepai' => Yii::t('app', 'usuario.dcnomepai'),
				'dcnomemae' => Yii::t('app', 'usuario.dcnomemae'),
				'dcendereco' => Yii::t('app', 'usuario.dcendereco'),
				'nuendereco' => Yii::t('app', 'usuario.nuendereco'),
				'dccomplemento' => Yii::t('app', 'usuario.dccomplemento'),
				'couf' => Yii::t('app', 'usuario.couf'),
				'dcbairro' => Yii::t('app', 'usuario.dcbairro'),
				'dccidade' => Yii::t('app', 'usuario.dccidade'),
				'nucep' => Yii::t('app', 'usuario.nucep'),
				'dcoutraareaatuacao' => Yii::t('app', 'usuario.dcoutraareaatuacao'),
				'dccurriculolattes' => Yii::t('app', 'usuario.dccurriculolattes'),
				'inreceberinformacao' => Yii::t('app', 'usuario.inreceberinformacao'),
				'indeclaracao' => Yii::t('app', 'usuario.indeclaracao'),
				'dcusuario' => Yii::t('app', 'usuario.dcusuario'),
				'dcsenha' => Yii::t('app', 'usuario.dcsenha'),
				'dtcadastro' => Yii::t('app', 'usuario.dtcadastro'),
				'dtatualizacao' => Yii::t('app', 'usuario.dtatualizacao'),
				'dctokenmoodle' => Yii::t('app', 'usuario.dctokenmoodle'),
				'dcsenha_now' => Yii::t('app', 'usuario.dcsenha'),
				'dcsenha_new_repeat' => Yii::t('app', 'usuario.dcsenha_confirm'),
				'dcsenha_new' => Yii::t('app', 'usuario.dcsenha_new'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idusuario', $this->idusuario);
		$criteria->compare('idmoodle', $this->idmoodle, true);
		$criteria->compare('idareaatuacao', $this->idareaatuacao);
		$criteria->compare('idgrauinstrucao', $this->idgrauinstrucao);
		$criteria->compare('idusuariostatus', $this->idusuariostatus);
		$criteria->compare('nucpf', $this->nucpf, true);
		$criteria->compare('dcnome', $this->dcnome, true);
		$criteria->compare('dtnascimento', $this->dtnascimento, true);
		$criteria->compare('dcsexo', $this->dcsexo, true);
		$criteria->compare('dcemail', $this->dcemail, true);
		$criteria->compare('nutelefoneparticular', $this->nutelefoneparticular, true);
		$criteria->compare('nutelefonecomercial', $this->nutelefonecomercial, true);
		$criteria->compare('nutelefonecelular', $this->nutelefonecelular, true);
		$criteria->compare('dcnomepai', $this->dcnomepai, true);
		$criteria->compare('dcnomemae', $this->dcnomemae, true);
		$criteria->compare('dcendereco', $this->dcendereco, true);
		$criteria->compare('nuendereco', $this->nuendereco, true);
		$criteria->compare('dccomplemento', $this->dccomplemento, true);
		$criteria->compare('couf', $this->couf);
		$criteria->compare('dcbairro', $this->dcbairro, true);
		$criteria->compare('dccidade', $this->dccidade, true);
		$criteria->compare('nucep', $this->nucep, true);
		$criteria->compare('dcoutraareaatuacao', $this->dcoutraareaatuacao, true);
		$criteria->compare('dccurriculolattes', $this->dccurriculolattes, true);
		$criteria->compare('inreceberinformacao', $this->inreceberinformacao);
		$criteria->compare('indeclaracao', $this->indeclaracao);
		$criteria->compare('dcusuario', $this->dcusuario, true);
		$criteria->compare('dcsenha', $this->dcsenha, true);
		$criteria->compare('dtcadastro', $this->dtcadastro, true);
		$criteria->compare('dtatualizacao', $this->dtatualizacao, true);
		$criteria->compare('dctokenmoodle', $this->dctokenmoodle, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idusuario;
	}

}
