<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".usuariocursopesquisa".
 *
 * Columns in table Constants::SCHEMA_SINASE.".usuariocursopesquisa" available as properties of the model:
 * @property integer $idrespostausuario
 * @property integer $idprojeto
 * @property integer $idcursomoodle
 * @property integer $idquestionario
 * @property integer $idusuario
 * @property integer $idquestao
 * @property integer $idresposta
 * @property string $dcresposta
 * @property string $txresposta
 *
 * Relations of table Constants::SCHEMA_SINASE.".usuariocursopesquisa" available as properties of the model:
 * @property Projetocurso $idprojeto
 * @property Projetocurso $idcursomoodle
 * @property Projetocurso $idquestionario
 * @property Usuario $idusuario
 * @property Resposta $idresposta
 * @property Questao $idquestao
 */
abstract class BaseUsuarioCursoPesquisa extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.usuariocursopesquisa';
	}

	public function rules()
	{
		return array(
				array('idprojeto, idcursomoodle, idquestionario, idusuario, idquestao', 'required'),
				array('idresposta, dcresposta, txresposta', 'default', 'setOnEmpty' => true, 'value' => null),
				array('idprojeto, idcursomoodle, idquestionario, idusuario, idquestao, idresposta', 'numerical', 'integerOnly'=>true),
				array('dcresposta', 'length', 'max'=>200),
				array('txresposta', 'length', 'max'=>10485760),

				array('idrespostausuario, idprojeto, idcursomoodle, idquestionario, idusuario, idquestao, idresposta, dcresposta, txresposta', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'idprojeto' => array(self::BELONGS_TO, 'Projetocurso', 'idprojeto'),
				'idcursomoodle' => array(self::BELONGS_TO, 'Projetocurso', 'idcursomoodle'),
				'idquestionario' => array(self::BELONGS_TO, 'Projetocurso', 'idquestionario'),
				'idusuario' => array(self::BELONGS_TO, 'Usuario', 'idusuario'),
				'idresposta' => array(self::BELONGS_TO, 'Resposta', 'idresposta'),
				'idquestao' => array(self::BELONGS_TO, 'Questao', 'idquestao'),
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.usuarioCursoPesquisa' => 'UsuarioCursoPesquisa',
	'usuarioCursoPesquisa.idrespostausuario' => 'Idrespostausuario',
	'usuarioCursoPesquisa.idprojeto' => 'Idprojeto',
	'usuarioCursoPesquisa.idcursomoodle' => 'Idcursomoodle',
	'usuarioCursoPesquisa.idquestionario' => 'Idquestionario',
	'usuarioCursoPesquisa.idusuario' => 'Idusuario',
	'usuarioCursoPesquisa.idquestao' => 'Idquestao',
	'usuarioCursoPesquisa.idresposta' => 'Idresposta',
	'usuarioCursoPesquisa.dcresposta' => 'Dcresposta',
	'usuarioCursoPesquisa.txresposta' => 'Txresposta',
	*/
	public function attributeLabels()
	{
		return array(
				'idrespostausuario' => Yii::t('app', 'usuarioCursoPesquisa.idrespostausuario'),
				'idprojeto' => Yii::t('app', 'usuarioCursoPesquisa.idprojeto'),
				'idcursomoodle' => Yii::t('app', 'usuarioCursoPesquisa.idcursomoodle'),
				'idquestionario' => Yii::t('app', 'usuarioCursoPesquisa.idquestionario'),
				'idusuario' => Yii::t('app', 'usuarioCursoPesquisa.idusuario'),
				'idquestao' => Yii::t('app', 'usuarioCursoPesquisa.idquestao'),
				'idresposta' => Yii::t('app', 'usuarioCursoPesquisa.idresposta'),
				'dcresposta' => Yii::t('app', 'usuarioCursoPesquisa.dcresposta'),
				'txresposta' => Yii::t('app', 'usuarioCursoPesquisa.txresposta'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idrespostausuario', $this->idrespostausuario);
		$criteria->compare('idprojeto', $this->idprojeto);
		$criteria->compare('idcursomoodle', $this->idcursomoodle);
		$criteria->compare('idquestionario', $this->idquestionario);
		$criteria->compare('idusuario', $this->idusuario);
		$criteria->compare('idquestao', $this->idquestao);
		$criteria->compare('idresposta', $this->idresposta);
		$criteria->compare('dcresposta', $this->dcresposta, true);
		$criteria->compare('txresposta', $this->txresposta, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idrespostausuario;
	}

}
