<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".vw_usuarioenturmado".
 *
 * Columns in table Constants::SCHEMA_SINASE.".vw_usuarioenturmado" available as properties of the model:
 * @property string $idmoodle
 * @property string $nucpf
 * @property string $dcnome
 * @property string $dtnascimento
 * @property string $dcsexo
 * @property string $dcemail
 * @property string $couf
 * @property string $dcuf
 * @property string $dcbairro
 * @property string $dccidade
 * @property string $nucep
 * @property integer $idprojeto
 * @property integer $idcursomoodle
 * @property integer $idquestionario
 * @property integer $idusuario
 * @property integer $idturma
 * @property string $dtinscricao
 * @property string $dtenturmado
 * @property string $dtdesenturmado
 * @property string $dtultimocontatoemail
 * @property string $dtconfirmaenturmado
 * @property string $dccurso
 * @property string $dcname
 * @property string $dcturma
 *
 * There are no model relations.
 */
abstract class BaseUsuarioEnturmado extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.vw_usuarioenturmado';
	}

	public function rules()
	{
		return array(
				array('idmoodle, nucpf, dcnome, dtnascimento, dcsexo, dcemail, couf, dcuf, dcbairro, dccidade, nucep, idprojeto, idcursomoodle, idquestionario, idusuario, idturma, dtinscricao, dtenturmado, dtdesenturmado, dtultimocontatoemail, dtconfirmaenturmado, dccurso, dcname, dcturma', 'default', 'setOnEmpty' => true, 'value' => null),
				array('idprojeto, idcursomoodle, idquestionario, idusuario, idturma', 'numerical', 'integerOnly'=>true),
				array('idmoodle', 'length', 'max'=>10),
				array('nucpf', 'length', 'max'=>11),
				array('dcnome, dccidade', 'length', 'max'=>50),
				array('dcsexo', 'length', 'max'=>1),
				array('dcemail', 'length', 'max'=>60),
				array('couf', 'length', 'max'=>2),
				array('dcuf, dcbairro', 'length', 'max'=>30),
				array('nucep', 'length', 'max'=>8),
				array('dccurso, dcname', 'length', 'max'=>254),
				array('dtnascimento, dtinscricao, dtenturmado, dtdesenturmado, dtultimocontatoemail, dtconfirmaenturmado, dcturma', 'safe'),

				array('idmoodle, nucpf, dcnome, dtnascimento, dcsexo, dcemail, couf, dcuf, dcbairro, dccidade, nucep, idprojeto, idcursomoodle, idquestionario, idusuario, idturma, dtinscricao, dtenturmado, dtdesenturmado, dtultimocontatoemail, dtconfirmaenturmado, dccurso, dcname, dcturma', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.usuarioEnturmado' => 'UsuarioEnturmado',
	'usuarioEnturmado.idmoodle' => 'Idmoodle',
	'usuarioEnturmado.nucpf' => 'Nucpf',
	'usuarioEnturmado.dcnome' => 'Dcnome',
	'usuarioEnturmado.dtnascimento' => 'Dtnascimento',
	'usuarioEnturmado.dcsexo' => 'Dcsexo',
	'usuarioEnturmado.dcemail' => 'Dcemail',
	'usuarioEnturmado.couf' => 'Couf',
	'usuarioEnturmado.dcuf' => 'Dcuf',
	'usuarioEnturmado.dcbairro' => 'Dcbairro',
	'usuarioEnturmado.dccidade' => 'Dccidade',
	'usuarioEnturmado.nucep' => 'Nucep',
	'usuarioEnturmado.idprojeto' => 'Idprojeto',
	'usuarioEnturmado.idcursomoodle' => 'Idcursomoodle',
	'usuarioEnturmado.idquestionario' => 'Idquestionario',
	'usuarioEnturmado.idusuario' => 'Idusuario',
	'usuarioEnturmado.idturma' => 'Idturma',
	'usuarioEnturmado.dtinscricao' => 'Dtinscricao',
	'usuarioEnturmado.dtenturmado' => 'Dtenturmado',
	'usuarioEnturmado.dtdesenturmado' => 'Dtdesenturmado',
	'usuarioEnturmado.dtultimocontatoemail' => 'Dtultimocontatoemail',
	'usuarioEnturmado.dtconfirmaenturmado' => 'Dtconfirmaenturmado',
	'usuarioEnturmado.dccurso' => 'Dccurso',
	'usuarioEnturmado.dcname' => 'Dcname',
	'usuarioEnturmado.dcturma' => 'Dcturma',
	*/
	public function attributeLabels()
	{
		return array(
				'idmoodle' => Yii::t('app', 'usuarioEnturmado.idmoodle'),
				'nucpf' => Yii::t('app', 'usuarioEnturmado.nucpf'),
				'dcnome' => Yii::t('app', 'usuarioEnturmado.dcnome'),
				'dtnascimento' => Yii::t('app', 'usuarioEnturmado.dtnascimento'),
				'dcsexo' => Yii::t('app', 'usuarioEnturmado.dcsexo'),
				'dcemail' => Yii::t('app', 'usuarioEnturmado.dcemail'),
				'couf' => Yii::t('app', 'usuarioEnturmado.couf'),
				'dcuf' => Yii::t('app', 'usuarioEnturmado.dcuf'),
				'dcbairro' => Yii::t('app', 'usuarioEnturmado.dcbairro'),
				'dccidade' => Yii::t('app', 'usuarioEnturmado.dccidade'),
				'nucep' => Yii::t('app', 'usuarioEnturmado.nucep'),
				'idprojeto' => Yii::t('app', 'usuarioEnturmado.idprojeto'),
				'idcursomoodle' => Yii::t('app', 'usuarioEnturmado.idcursomoodle'),
				'idquestionario' => Yii::t('app', 'usuarioEnturmado.idquestionario'),
				'idusuario' => Yii::t('app', 'usuarioEnturmado.idusuario'),
				'idturma' => Yii::t('app', 'usuarioEnturmado.idturma'),
				'dtinscricao' => Yii::t('app', 'usuarioEnturmado.dtinscricao'),
				'dtenturmado' => Yii::t('app', 'usuarioEnturmado.dtenturmado'),
				'dtdesenturmado' => Yii::t('app', 'usuarioEnturmado.dtdesenturmado'),
				'dtultimocontatoemail' => Yii::t('app', 'usuarioEnturmado.dtultimocontatoemail'),
				'dtconfirmaenturmado' => Yii::t('app', 'usuarioEnturmado.dtconfirmaenturmado'),
				'dccurso' => Yii::t('app', 'usuarioEnturmado.dccurso'),
				'dcname' => Yii::t('app', 'usuarioEnturmado.dcname'),
				'dcturma' => Yii::t('app', 'usuarioEnturmado.dcturma'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idmoodle', $this->idmoodle, true);
		$criteria->compare('nucpf', $this->nucpf, true);
		$criteria->compare('dcnome', $this->dcnome, true);
		$criteria->compare('dtnascimento', $this->dtnascimento, true);
		$criteria->compare('dcsexo', $this->dcsexo, true);
		$criteria->compare('dcemail', $this->dcemail, true);
		$criteria->compare('couf', $this->couf, true);
		$criteria->compare('dcuf', $this->dcuf, true);
		$criteria->compare('dcbairro', $this->dcbairro, true);
		$criteria->compare('dccidade', $this->dccidade, true);
		$criteria->compare('nucep', $this->nucep, true);
		$criteria->compare('idprojeto', $this->idprojeto);
		$criteria->compare('idcursomoodle', $this->idcursomoodle);
		$criteria->compare('idquestionario', $this->idquestionario);
		$criteria->compare('idusuario', $this->idusuario);
		$criteria->compare('idturma', $this->idturma);
		$criteria->compare('dtinscricao', $this->dtinscricao, true);
		$criteria->compare('dtenturmado', $this->dtenturmado, true);
		$criteria->compare('dtdesenturmado', $this->dtdesenturmado, true);
		$criteria->compare('dtultimocontatoemail', $this->dtultimocontatoemail, true);
		$criteria->compare('dtconfirmaenturmado', $this->dtconfirmaenturmado, true);
		$criteria->compare('dccurso', $this->dccurso, true);
		$criteria->compare('dcname', $this->dcname, true);
		$criteria->compare('dcturma', $this->dcturma, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{

	}

}
