<?php

/**
 * This is the model class for table Constants::SCHEMA_SINASE.".usuariomensagemlida".
 *
 * The followings are the available columns in table Constants::SCHEMA_SINASE.'.usuariomensagemlida':
 * @property integer $idmensagem
 * @property integer $idusuario
 * @property string $dtleitura
 */
abstract class BaseUsuarioMensagemLida extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return BaseUsuarioMensagemLida the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.usuariomensagemlida';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
				array('idmensagem, idusuario, dtleitura', 'required'),
				array('idmensagem, idusuario', 'numerical', 'integerOnly'=>true),
				// The following rule is used by search().
				// Please remove those attributes that should not be searched.
				array('idmensagem, idusuario, dtleitura', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('datetimeI18NBehavior' => array('class' => 'ext.DateTime-i18n.DateTimeI18NBehavior'));
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
				'idmensagem' => 'Idmensagem',
				'idusuario' => 'Idusuario',
				'dtleitura' => 'Dtleitura',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('idmensagem',$this->idmensagem);
		$criteria->compare('idusuario',$this->idusuario);
		$criteria->compare('dtleitura',$this->dtleitura,true);

		return new CActiveDataProvider($this, array(
				'criteria'=>$criteria,
		));
	}
}

