<?php
/**
 * This is the model class for table Constants::SCHEMA_SINASE.".vw_usuariomoodle".
 *
 * The followings are the available columns in table Constants::SCHEMA_SINASE.'.vw_usuariomoodle':
 * @property string $id
 * @property string $username
 * @property string $firstname
 * @property string $lastname
 * @property string $email
 * @property integer $suspended
 * @property integer $idusuario
 * @property string $nucpf
 * @property string $dtnascimento
 * @property string $dcsexo
 * @property string $dcnome
 */
class BaseUsuarioMoodle extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return VwUsuariomoodle the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.vw_usuariomoodle';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
				array('suspended, idusuario', 'numerical', 'integerOnly'=>true),
				array('username, firstname, lastname, email', 'length', 'max'=>100),
				array('nucpf', 'length', 'max'=>11),
				array('dcsexo', 'length', 'max'=>1),
				array('dcnome', 'length', 'max'=>50),
				array('id, dtnascimento', 'safe'),
				// The following rule is used by search().
				// Please remove those attributes that should not be searched.
				array('id, username, firstname, lastname, email, suspended, idusuario, nucpf, dtnascimento, dcsexo, dcnome', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('datetimeI18NBehavior' => array('class' => 'ext.DateTime-i18n.DateTimeI18NBehavior'));
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
				'id' => 'ID',
				'username' => 'Username',
				'firstname' => 'Firstname',
				'lastname' => 'Lastname',
				'email' => 'Email',
				'suspended' => 'Suspended',
				'idusuario' => 'Idusuario',
				'nucpf' => 'Nucpf',
				'dtnascimento' => 'Dtnascimento',
				'dcsexo' => 'Dcsexo',
				'dcnome' => 'Dcnome',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id,true);
		$criteria->compare('username',$this->username,true);
		$criteria->compare('firstname',$this->firstname,true);
		$criteria->compare('lastname',$this->lastname,true);
		$criteria->compare('email',$this->email,true);
		$criteria->compare('suspended',$this->suspended);
		$criteria->compare('idusuario',$this->idusuario);
		$criteria->compare('nucpf',$this->nucpf,true);
		$criteria->compare('dtnascimento',$this->dtnascimento,true);
		$criteria->compare('dcsexo',$this->dcsexo,true);
		$criteria->compare('dcnome',$this->dcnome,true);

		return new CActiveDataProvider($this, array(
				'criteria'=>$criteria,
		));
	}
}
