<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".usuarioperfilacesso".
 *
 * Columns in table Constants::SCHEMA_SINASE.".usuarioperfilacesso" available as properties of the model:
 * @property integer $idusuario
 * @property string $coperfilacesso
 * @property string $dtcadastro
 * @property string $dtultimoacesso
 *
 * There are no model relations.
 */
abstract class BaseUsuarioPerfilAcesso extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.usuarioperfilacesso';
	}

	public function rules()
	{
		return array(
				array('idusuario, coperfilacesso, dtcadastro', 'required'),
				array('dtultimoacesso', 'default', 'setOnEmpty' => true, 'value' => null),
				array('idusuario', 'numerical', 'integerOnly'=>true),
				array('coperfilacesso', 'length', 'max'=>15),
				array('dtultimoacesso', 'safe'),

				array('idusuario, coperfilacesso, dtcadastro, dtultimoacesso', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	public function attributeLabels()
	{
		return array(
				'idusuario' => Yii::t('app', 'Idusuario'),
				'coperfilacesso' => Yii::t('app', 'Coperfilacesso'),
				'dtcadastro' => Yii::t('app', 'Dtcadastro'),
				'dtultimoacesso' => Yii::t('app', 'Dtultimoacesso'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('idusuario', $this->idusuario);
		$criteria->compare('coperfilacesso', $this->coperfilacesso);
		$criteria->compare('dtcadastro', $this->dtcadastro, true);
		$criteria->compare('dtultimoacesso', $this->dtultimoacesso, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idusuario;return '#'.$this->coperfilacesso;

	}

}
