<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".usuariostatus".
 *
 * Columns in table Constants::SCHEMA_SINASE.".usuariostatus" available as properties of the model:
 * @property integer $idusuariostatus
 * @property string $dcusuariostatus
 *
 * Relations of table Constants::SCHEMA_SINASE.".usuariostatus" available as properties of the model:
 * @property Usuario[] $usuarios
 */
abstract class BaseUsuarioStatus extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.usuariostatus';
	}

	public function rules()
	{
		return array(
				array('dcusuariostatus', 'unique'),
				array('dcusuariostatus', 'identificationColumnValidator'),
				array('idusuariostatus, dcusuariostatus', 'required'),
				array('idusuariostatus', 'numerical', 'integerOnly'=>true),
				array('dcusuariostatus', 'length', 'max'=>30),

				array('idusuariostatus, dcusuariostatus', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
				'usuarios' => array(self::HAS_MANY, 'Usuario', 'idusuariostatus'),
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.usuarioStatus' => 'UsuarioStatus',
	'usuarioStatus.idusuariostatus' => 'Idusuariostatus',
	'usuarioStatus.dcusuariostatus' => 'Dcusuariostatus',
	*/
	public function attributeLabels()
	{
		return array(
				'idusuariostatus' => Yii::t('app', 'usuarioStatus.idusuariostatus'),
				'dcusuariostatus' => Yii::t('app', 'usuarioStatus.dcusuariostatus'),
		);
	}

	public function search()
	{
		parent::beforeFind();

		$criteria=new CDbCriteria;
		$criteria->compare('idusuariostatus', $this->idusuariostatus);
		$criteria->compare('dcusuariostatus', $this->dcusuariostatus, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{
		return '#'.$this->idusuariostatus;
	}

}
