<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".vw_categoria".
 *
 * Columns in table Constants::SCHEMA_SINASE.".vw_categoria" available as properties of the model:
 * @property string $id
 * @property string $name
 * @property string $description
 * @property integer $visible
 *
 * There are no model relations.
 */
abstract class BaseVwCategoria extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.vw_categoria';
	}

	public function rules()
	{
		return array(
				array('id, name, description, visible', 'default', 'setOnEmpty' => true, 'value' => null),
				array('visible', 'numerical', 'integerOnly'=>true),
				array('name', 'length', 'max'=>255),
				array('id, description', 'safe'),

				array('id, name, description, visible', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	public function attributeLabels()
	{
		return array(
				'id' => Yii::t('app', 'ID'),
				'name' => Yii::t('app', 'Name'),
				'description' => Yii::t('app', 'Description'),
				'visible' => Yii::t('app', 'Visible'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('id', $this->id, true);
		$criteria->compare('name', $this->name, true);
		$criteria->compare('description', $this->description, true);
		$criteria->compare('visible', $this->visible);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{

	}
}
