<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".vw_curso".
 *
 * Columns in table Constants::SCHEMA_SINASE.".vw_curso" available as properties of the model:
 * @property integer $idprojeto
 * @property string $dcprojeto
 * @property string $dtinicio
 * @property string $dtfinal
 * @property boolean $inprojetoinativo
 * @property string $id
 * @property string $category
 * @property string $categoryname
 * @property string $fullname
 * @property string $shortname
 * @property integer $visible
 * @property string $summary
 * @property integer $numsections
 * @property string $format
 * @property integer $idquestionario
 * @property integer $idcursomoodle
 * @property string $startdate
 * @property string $dtiniciocurso
 * @property string $dtfimcurso
 * @property string $dtinicioinscricao
 * @property string $dtfiminscricao
 * @property string $contextid
 * @property string $dcformulario
 * There are no model relations.
 */
abstract class BaseVwCurso extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.vw_curso';
	}

	public function rules()
	{
		return array(
				array('fullname', 'unique'),
				array('fullname', 'identificationColumnValidator'),
				array('idprojeto, dcprojeto, dtinicio, dtfinal, inprojetoinativo, id, category, categoryname, fullname, shortname, visible, summary, numsections, format, idquestionario, idcursomoodle, startdate, dtiniciocurso, dtfimcurso, dtinicioinscricao, dtfiminscricao, contextid', 'default', 'setOnEmpty' => true, 'value' => null),
				array('idprojeto, visible, numsections, idquestionario, idcursomoodle', 'numerical', 'integerOnly'=>true),
				array('dcprojeto', 'length', 'max'=>70),
				array('categoryname, shortname', 'length', 'max'=>255),
				array('fullname', 'length', 'max'=>254),
				array('dtinicio, dtfinal, inprojetoinativo, id, category, summary, format, startdate, dtiniciocurso, dtfimcurso, dtinicioinscricao, dtfiminscricao, contextid', 'safe'),

				array('idprojeto, dcprojeto, dtinicio, dtfinal, inprojetoinativo, id, category, categoryname, fullname, shortname, visible, summary, numsections, format, idquestionario, idcursomoodle, startdate, dtiniciocurso, dtfimcurso, dtinicioinscricao, dtfiminscricao, contextid', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	*
	*/
	public function attributeLabels()
	{
		return array(
				'idprojeto' => Yii::t('app', 'vwCurso.idprojeto'),
				'dcprojeto' => Yii::t('app', 'vwCurso.dcprojeto'),
				'dtinicio' => Yii::t('app', 'vwCurso.dtinicio'),
				'dtfinal' => Yii::t('app', 'vwCurso.dtfinal'),
				'inprojetoinativo' => Yii::t('app', 'vwCurso.inprojetoinativo'),
				'id' => Yii::t('app', 'vwCurso.id'),
				'category' => Yii::t('app', 'vwCurso.category'),
				'categoryname' => Yii::t('app', 'vwCurso.categoryname'),
				'fullname' => Yii::t('app', 'vwCurso.fullname'),
				'shortname' => Yii::t('app', 'vwCurso.shortname'),
				'visible' => Yii::t('app', 'vwCurso.visible'),
				'summary' => Yii::t('app', 'vwCurso.summary'),
				'numsections' => Yii::t('app', 'vwCurso.numsections'),
				'format' => Yii::t('app', 'vwCurso.format'),
				'idquestionario' => Yii::t('app', 'vwCurso.idquestionario'),
				'idcursomoodle' => Yii::t('app', 'vwCurso.idcursomoodle'),
				'startdate' => Yii::t('app', 'vwCurso.startdate'),
				'dtiniciocurso' => Yii::t('app', 'vwCurso.dtiniciocurso'),
				'dtfimcurso' => Yii::t('app', 'vwCurso.dtfimcurso'),
				'dtinicioinscricao' => Yii::t('app', 'vwCurso.dtinicioinscricao'),
				'dtfiminscricao' => Yii::t('app', 'vwCurso.dtfiminscricao'),
				'contextid' => Yii::t('app', 'vwCurso.contextid'),
		);
	}

	public function search()
	{
		parent::beforeFind();

		$criteria=new CDbCriteria;
		$criteria->compare('idprojeto', $this->idprojeto);
		$criteria->compare('dcprojeto', $this->dcprojeto, true);
		$criteria->compare('dtinicio', $this->dtinicio, true);
		$criteria->compare('dtfinal', $this->dtfinal, true);
		$criteria->compare('inprojetoinativo', $this->inprojetoinativo);
		$criteria->compare('id', $this->id);
		$criteria->compare('category', $this->category);
		$criteria->compare('categoryname', $this->categoryname, true);
		$criteria->compare('fullname', $this->fullname, true);
		$criteria->compare('shortname', $this->shortname, true);
		$criteria->compare('visible', $this->visible);
		$criteria->compare('summary', $this->summary, true);
		$criteria->compare('numsections', $this->numsections);
		$criteria->compare('format', $this->format, true);
		$criteria->compare('idquestionario', $this->idquestionario);
		$criteria->compare('idcursomoodle', $this->idcursomoodle);
		$criteria->compare('startdate', $this->startdate);
		$criteria->compare('dtiniciocurso', $this->dtiniciocurso);
		$criteria->compare('dtfimcurso', $this->dtfimcurso);
		$criteria->compare('dtinicioinscricao', $this->dtinicioinscricao);
		$criteria->compare('dtfiminscricao', $this->dtfiminscricao);
		$criteria->compare('contextid', $this->contextid);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{

	}

}
