<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".vw_cursomodulo".
 *
 * Columns in table Constants::SCHEMA_SINASE.".vw_cursomodulo" available as properties of the model:
 * @property string $fullname
 * @property string $shortname
 * @property string $id
 * @property string $course
 * @property string $section
 * @property string $name
 * @property string $summary
 * @property integer $summaryformat
 * @property integer $visible
 * @property string $format
 *
 * There are no model relations.
 */
abstract class BaseVwCursoModulo extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.vw_cursomodulo';
	}

	public function rules()
	{
		return array(
				array('fullname, shortname, id, course, section, name, summary, summaryformat, visible, format', 'default', 'setOnEmpty' => true, 'value' => null),
				array('summaryformat, visible', 'numerical', 'integerOnly'=>true),
				array('fullname', 'length', 'max'=>254),
				array('shortname, name', 'length', 'max'=>255),
				array('id, course, section, summary, format', 'safe'),

				array('fullname, shortname, id, course, section, name, summary, summaryformat, visible, format', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	*
	*/
	public function attributeLabels()
	{
		return array(
				'fullname'      => Yii::t('app', 'cursoModulo.fullname'),
				'shortname'     => Yii::t('app', 'cursoModulo.shortname'),
				'id'            => Yii::t('app', 'cursoModulo.id'),
				'course'        => Yii::t('app', 'cursoModulo.course'),
				'section'       => Yii::t('app', 'cursoModulo.section'),
				'name'          => Yii::t('app', 'cursoModulo.name'),
				'summary'       => Yii::t('app', 'cursoModulo.summary'),
				'summaryformat' => Yii::t('app', 'cursoModulo.summaryformat'),
				'visible'       => Yii::t('app', 'generic.situacao'),
				'format'        => Yii::t('app', 'cursoModulo.format'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('fullname', $this->fullname, true);
		$criteria->compare('shortname', $this->shortname, true);
		$criteria->compare('id', $this->id, true);
		$criteria->compare('course', $this->course, false);
		$criteria->compare('section', $this->section, true);
		$criteria->compare('name', $this->name, true);
		$criteria->compare('summary', $this->summary, true);
		$criteria->compare('summaryformat', $this->summaryformat);
		$criteria->compare('visible', $this->visible);
		$criteria->compare('format', $this->format, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{

	}

}
