<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".vw_cursopapel".
 *
 * Columns in table Constants::SCHEMA_SINASE.".vw_cursopapel" available as properties of the model:
 * @property string $id
 * @property string $name
 * @property string $shortname
 * @property string $description
 *
 * There are no model relations.
 */
abstract class BaseVwCursoPapel extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.vw_cursopapel';
	}

	public function rules()
	{
		return array(
				array('shortname', 'unique'),
				array('shortname', 'identificationColumnValidator'),
				array('id, name, shortname, description', 'default', 'setOnEmpty' => true, 'value' => null),
				array('name', 'length', 'max'=>255),
				array('shortname', 'length', 'max'=>100),
				array('id, description', 'safe'),

				array('id, name, shortname, description', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.cursoPapel' => 'VwCursoPapel',
	'cursoPapel.id' => 'ID',
	'cursoPapel.name' => 'Name',
	'cursoPapel.shortname' => 'Shortname',
	'cursoPapel.description' => 'Description',
	*/
	public function attributeLabels()
	{
		return array(
				'id' => Yii::t('app', 'cursoPapel.id'),
				'name' => Yii::t('app', 'cursoPapel.name'),
				'shortname' => Yii::t('app', 'cursoPapel.shortname'),
				'description' => Yii::t('app', 'cursoPapel.description'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('id', $this->id, true);
		$criteria->compare('name', $this->name, true);
		$criteria->compare('shortname', $this->shortname, true);
		$criteria->compare('description', $this->description, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{

	}

}
