<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".vw_cursousuariopapel".
 *
 * Columns in table Constants::SCHEMA_SINASE.".vw_cursousuariopapel" available as properties of the model:
 * @property string $id
 * @property string $roleid
 * @property string $contextid
 * @property string $userid
 * @property string $timemodified
 * @property string $modifierid
 * @property string $component
 * @property string $itemid
 * @property string $sortorder
 * @property string $dcemail
 * @property string $dcnome
 * @property string $dcsexo
 * @property string $dtnascimento
 * @property string $idpapel
 * @property string $idcource
 * @property string $fullname
 * @property string $shortname
 *
 * There are no model relations.
 */
abstract class BaseVwCursoUsuarioPapel extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.vw_cursousuariopapel';
	}

	public function rules()
	{
		return array(
				array('id, roleid, contextid, userid, timemodified, modifierid, component, itemid, sortorder, idusuario, nucpf, dcnome, dcemail, dcsexo, dtnascimento, idpapel, dcpapel, idcource, fullname, shortname', 'default', 'setOnEmpty' => true, 'value' => null),
				array('component', 'length', 'max'=>100),
				array('nucpf', 'length', 'max'=>11),
				array('dcnome', 'length', 'max'=>50),
				array('dcemail', 'length', 'max'=>60),
				array('dcsexo', 'length', 'max'=>1),
				array('dcpapel, shortname', 'length', 'max'=>255),
				array('fullname', 'length', 'max'=>254),
				array('id, roleid, contextid, userid, timemodified, modifierid, itemid, sortorder, dcnome, idpapel, idcource', 'safe'),

		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.vwCursoUsuarioPapel' => 'VwCursoUsuarioPapel',
	'vwCursoUsuarioPapel.id' => 'ID',
	'vwCursoUsuarioPapel.roleid' => 'Roleid',
	'vwCursoUsuarioPapel.contextid' => 'Contextid',
	'vwCursoUsuarioPapel.userid' => 'Userid',
	'vwCursoUsuarioPapel.timemodified' => 'Timemodified',
	'vwCursoUsuarioPapel.modifierid' => 'Modifierid',
	'vwCursoUsuarioPapel.component' => 'Component',
	'vwCursoUsuarioPapel.itemid' => 'Itemid',
	'vwCursoUsuarioPapel.sortorder' => 'Sortorder',
	'vwCursoUsuarioPapel.idusuario' => 'Idusuario',
	'vwCursoUsuarioPapel.nucpf' => 'Nucpf',
	'vwCursoUsuarioPapel.dcnome' => 'Dcnome',
	'vwCursoUsuarioPapel.dcemail' => 'Dcemail',
	'vwCursoUsuarioPapel.dcsexo' => 'Dcsexo',
	'vwCursoUsuarioPapel.dtnascimento' => 'Dtnascimento',
	'vwCursoUsuarioPapel.idpapel' => 'Idpapel',
	'vwCursoUsuarioPapel.dcpapel' => 'Dcpapel',
	'vwCursoUsuarioPapel.idcource' => 'Idcource',
	'vwCursoUsuarioPapel.fullname' => 'Fullname',
	'vwCursoUsuarioPapel.shortname' => 'Shortname',
	*/
	public function attributeLabels()
	{
		return array(
				'id' => Yii::t('app', 'vwCursoUsuarioPapel.id'),
				'roleid' => Yii::t('app', 'vwCursoUsuarioPapel.roleid'),
				'contextid' => Yii::t('app', 'vwCursoUsuarioPapel.contextid'),
				'userid' => Yii::t('app', 'vwCursoUsuarioPapel.userid'),
				'timemodified' => Yii::t('app', 'vwCursoUsuarioPapel.timemodified'),
				'modifierid' => Yii::t('app', 'vwCursoUsuarioPapel.modifierid'),
				'component' => Yii::t('app', 'vwCursoUsuarioPapel.component'),
				'itemid' => Yii::t('app', 'vwCursoUsuarioPapel.itemid'),
				'sortorder' => Yii::t('app', 'vwCursoUsuarioPapel.sortorder'),
				'idusuario' => Yii::t('app', 'vwCursoUsuarioPapel.idusuario'),
				'nucpf' => Yii::t('app', 'vwCursoUsuarioPapel.nucpf'),
				'dcnome' => Yii::t('app', 'vwCursoUsuarioPapel.dcnome'),
				'dcemail' => Yii::t('app', 'vwCursoUsuarioPapel.dcemail'),
				'dcsexo' => Yii::t('app', 'vwCursoUsuarioPapel.dcsexo'),
				'dtnascimento' => Yii::t('app', 'vwCursoUsuarioPapel.dtnascimento'),
				'idpapel' => Yii::t('app', 'vwCursoUsuarioPapel.idpapel'),
				'dcpapel' => Yii::t('app', 'vwCursoUsuarioPapel.dcpapel'),
				'idcource' => Yii::t('app', 'vwCursoUsuarioPapel.idcource'),
				'fullname' => Yii::t('app', 'vwCursoUsuarioPapel.fullname'),
				'shortname' => Yii::t('app', 'vwCursoUsuarioPapel.shortname'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('id', $this->id, true);
		$criteria->compare('roleid', $this->roleid, true);
		$criteria->compare('contextid', $this->contextid, true);
		$criteria->compare('userid', $this->userid, true);
		$criteria->compare('timemodified', $this->timemodified, true);
		$criteria->compare('modifierid', $this->modifierid, true);
		$criteria->compare('component', $this->component, true);
		$criteria->compare('itemid', $this->itemid, true);
		$criteria->compare('sortorder', $this->sortorder, true);
		$criteria->compare('idusuario', $this->idusuario);
		$criteria->compare('nucpf', $this->nucpf, true);
		$criteria->compare('dcnome', $this->dcnome, true);
		$criteria->compare('dcemail', $this->dcemail, true);
		$criteria->compare('dcsexo', $this->dcsexo, true);
		$criteria->compare('dtnascimento', $this->dtnascimento, true);
		$criteria->compare('idpapel', $this->idpapel, true);
		$criteria->compare('dcpapel', $this->dcpapel, true);
		$criteria->compare('idcource', $this->idcource, true);
		$criteria->compare('fullname', $this->fullname, true);
		$criteria->compare('shortname', $this->shortname, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{

	}

}
