<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".vw_participante".
 *
 * Columns in table Constants::SCHEMA_SINASE.".vw_participante" available as properties of the model:
 * @property string $id
 * @property string $groupid
 * @property string $courseid
 * @property string $userid
 *
 * There are no model relations.
 */
abstract class BaseVwParticipante extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.vw_participante';
	}

	public function rules()
	{
		return array(
				array('id, groupid, courseid, userid', 'default', 'setOnEmpty' => true, 'value' => null),
				array('id, groupid, courseid, userid', 'safe'),

				array('id, groupid, courseid, userid', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.vwParticipante' => 'VwParticipante',
	'vwParticipante.id' => 'ID',
	'vwParticipante.groupid' => 'Groupid',
	'vwParticipante.courseid' => 'Courseid',
	'vwParticipante.userid' => 'Userid',
	*/
	public function attributeLabels()
	{
		return array(
				'id' => Yii::t('app', 'vwParticipante.id'),
				'groupid' => Yii::t('app', 'vwParticipante.groupid'),
				'courseid' => Yii::t('app', 'vwParticipante.courseid'),
				'userid' => Yii::t('app', 'vwParticipante.userid'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('id', $this->id, true);
		$criteria->compare('groupid', $this->groupid, true);
		$criteria->compare('courseid', $this->courseid, true);
		$criteria->compare('userid', $this->userid, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{

	}

}
