<?php

/**
 * This is the model base class for the table Constants::SCHEMA_SINASE.".vw_usuarioinscricao".
 *
 * Columns in table Constants::SCHEMA_SINASE.".vw_usuarioinscricao" available as properties of the model:
 * @property string $iduser
 * @property string $firstname
 * @property string $email
 * @property integer $suspended
 * @property string $idcourse
 * @property string $shortname
 * @property string $fullname
 * @property string $statusescricao
 * @property string $idrole
 * @property string $namerole
 *
 * There are no model relations.
 */
abstract class BaseVwUsuarioInscricao extends CActiveRecord{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Constants::SCHEMA_SINASE.'.vw_usuarioinscricao';
	}

	public function rules()
	{
		return array(
				array('iduser, firstname, email, suspended, idcourse, shortname, fullname, statusescricao, idrole, namerole', 'default', 'setOnEmpty' => true, 'value' => null),
				array('suspended', 'numerical', 'integerOnly'=>true),
				array('firstname, email', 'length', 'max'=>100),
				array('shortname, namerole', 'length', 'max'=>255),
				array('fullname', 'length', 'max'=>254),
				array('iduser, idcourse, statusescricao, idrole', 'safe'),

				array('iduser, firstname, email, suspended, idcourse, shortname, fullname, statusescricao, idrole, namerole', 'safe', 'on'=>'search'),
		);
	}

	// 'ext' is in Yii 1.0.8 version. For early versions, use 'application.extensions' instead.
	// @link http://www.yiiframework.com/extension/i18n-datetime-behavior
	public function behaviors()
	{
		return array('Format18NBehavior' => array('class' => 'ext.formatBehavion-i18n.Format18NBehavior'));
	}

	public function relations()
	{
		return array(
		);
	}

	/*
	 * Lista de atributos da model para adcionar no arquivo Translation
	* /protected/messages/pt_br/app.php
	'breadcrumbs.vwUsuarioInscricao' => 'VwUsuarioInscricao',
	'vwUsuarioInscricao.iduser' => 'Iduser',
	'vwUsuarioInscricao.firstname' => 'Firstname',
	'vwUsuarioInscricao.email' => 'Email',
	'vwUsuarioInscricao.suspended' => 'Suspended',
	'vwUsuarioInscricao.idcourse' => 'Idcourse',
	'vwUsuarioInscricao.shortname' => 'Shortname',
	'vwUsuarioInscricao.fullname' => 'Fullname',
	'vwUsuarioInscricao.statusescricao' => 'Statusescricao',
	'vwUsuarioInscricao.idrole' => 'Idrole',
	'vwUsuarioInscricao.namerole' => 'Namerole',
	*/
	public function attributeLabels()
	{
		return array(
				'iduser' => Yii::t('app', 'vwUsuarioInscricao.iduser'),
				'firstname' => Yii::t('app', 'vwUsuarioInscricao.firstname'),
				'email' => Yii::t('app', 'vwUsuarioInscricao.email'),
				'suspended' => Yii::t('app', 'vwUsuarioInscricao.suspended'),
				'idcourse' => Yii::t('app', 'vwUsuarioInscricao.idcourse'),
				'shortname' => Yii::t('app', 'vwUsuarioInscricao.shortname'),
				'fullname' => Yii::t('app', 'vwUsuarioInscricao.fullname'),
				'statusescricao' => Yii::t('app', 'vwUsuarioInscricao.statusescricao'),
				'idrole' => Yii::t('app', 'vwUsuarioInscricao.idrole'),
				'namerole' => Yii::t('app', 'vwUsuarioInscricao.namerole'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('iduser', $this->iduser, true);
		$criteria->compare('firstname', $this->firstname, true);
		$criteria->compare('email', $this->email, true);
		$criteria->compare('suspended', $this->suspended);
		$criteria->compare('idcourse', $this->idcourse, true);
		$criteria->compare('shortname', $this->shortname, true);
		$criteria->compare('fullname', $this->fullname, true);
		$criteria->compare('statusescricao', $this->statusescricao, true);
		$criteria->compare('idrole', $this->idrole, true);
		$criteria->compare('namerole', $this->namerole, true);

		return new CActiveDataProvider(get_class($this), array(
				'criteria'=>$criteria,
		));
	}

	public function get_label()
	{

	}

}
