<?php
Yii::app()->clientScript->registerScript('chosen', "
$('.chzn-select').chosen();

// ckeditor
	$( 'textarea.html_editor_on_simple' ).ckeditor( {
		toolbar : 'Basic',
		language : 'pt-br',
		uiColor : '#F9F9F9',
		resize_dir: 'vertical',
		toolbarCanCollapse: true,
		pasteFromWordRemoveFontStyles: true,
		pasteFromWordRemoveStyles: true,
		pasteFromWordPromptCleanup:true,
		scayt_autoStartup:true,
		scayt_sLang:'nl_NL',
		width:'98%',
		toolbar_Basic : [
			{ name: 'document', items : [ 'Source'] },
			{ name: 'basicstyles', items : [ 'Bold','Italic','Underline','Strike','-','RemoveFormat' ] },
		]
	} );
");
?>

 <!-- Portlet -->
 <div class="box">
	<h4 class="box-header round-top"><?php echo $this->title?> <?php echo ($model->idcurso?'('.$model->idcurso.')':''); ?></h4>
	<div class="box-container-toggle">
		<div class="box-content">
		<?php $form=$this->beginWidget('CActiveForm', array(
			'id'=>'curso-form',
			'method'=>'Post',
			'enableAjaxValidation'=>false,
			'htmlOptions'=>array(
					'class'=>'form-horizontal',
			),
		));
		?>
			<p class="note"><?php echo Yii::t('app', 'generic.campoObrigatorio'); ?></p>
			<?php if ( $model->hasErrors() ):?>
			<div class="alert alert-error">
				<a href="#" data-dismiss="alert" class="close">Ã—</a>
				<?php echo $form->error($model,'error', array('class'=>'help-inline')); ?>
			</div>
			<?php endif?>
			<input type="hidden" name='curso_idcurso' value="<?php echo $model->idcurso ?>">
			<div class="control-group <?php echo(count($model->getErrors('idcategoriacuso'))>0?'error':'');?>">
				<?php echo $form->label($model,'idcategoriacuso', array('class'=>'control-label')); ?>
				<div class="controls">
					<?php echo $form::dropDownList($model, 'idcategoriacuso',
	                                          	CHtml::listData($listCategorias, 'id', 'name'), array('prompt'=>'Selecione uma Categoria', 'class'=>"chzn-select"));?>
					<?php echo $form->error($model,'idcategoriacuso', array('class'=>'help-inline')); ?>
				</div>
			</div>
			<div class="control-group <?php echo(count($model->getErrors('nocurso'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'nocurso', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $form->textArea($model, 'nocurso', array('class'=>'span8', 'rows'=>'3')); ?>
					<?php echo $form->error($model,'nocurso', array('class'=>'help-inline')); ?>
				</div>
			</div>

			<div class="control-group <?php echo(count($model->getErrors('sgcurso'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'sgcurso', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $form->textField($model, 'sgcurso', array('class'=>'span4','style'=>'float:left')); ?>
					<?php echo $form->error($model,'sgcurso', array('class'=>'help-inline')); ?>
				</div>
			</div>

			<div class="control-group <?php echo(count($model->getErrors('dtinicio'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'dtinicio', array('class'=>'control-label')); ?>
				<div class="controls">
					<div class="input-append date datepicker" data-date="<?php echo date('d/m/Y');?>" data-date-format="dd/mm/yyyy">
						<?php echo $form->textField($model,'dtinicio'); ?><span class="add-on "><i class="icon-calendar"></i></span>
					</div>
					<?php echo $form->error($model,'dtinicio', array('class'=>'help-inline')); ?>
				</div>
			</div>

			<div class="control-group <?php echo(count($model->getErrors('dtfinal'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'dtfinal', array('class'=>'control-label')); ?>
				<div class="controls">
					<div class="input-append date datepicker" data-date="<?php echo date('d/m/Y');?>" data-date-format="dd/mm/yyyy">
						<?php echo $form->textField($model,'dtfinal'); ?><span class="add-on "><i class="icon-calendar"></i></span>
					</div>
					<?php echo $form->error($model,'dtfinal', array('class'=>'help-inline')); ?>
				</div>
			</div>

			<div class="control-group <?php echo(count($model->getErrors('txsumario'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'txsumario', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $form->textArea($model, 'txsumario', array('class'=>'input-xlarge html_editor_on_simple','rows'=>'3', 'style'=>'float:left')); ?>
				</div>
				<?php echo $form->error($model,'txsumario', array('class'=>'help-inline')); ?>
			</div>

			<div class="control-group <?php echo(count($model->getErrors('numodulo'))>0?'error':'');?>">
				<?php echo $form->label($model,'numodulo', array('class'=>'control-label')); ?>
				<div class="controls">
					<?php echo $form::dropDownList($model, 'numodulo',
	                                          	CHtml::listData($listNuModulos, 'id', 'name'), array('class'=>"chzn-select"));?>
					<?php echo $form->error($model,'numodulo', array('class'=>'help-inline')); ?>
				</div>
			</div>

			<div class="control-group <?php echo(count($model->getErrors('idquestao'))>0?'error':'');?>">
				<?php echo $form->label($model,'idquestao', array('class'=>'control-label')); ?>
				<div class="controls">
					<?php echo $form::dropDownList($model,	'idquestao',
	                                          	CHtml::listData(Questionario::model()->findAll('inativo=:in',array(':in'=>'true')), 'idquestionario', 'dcformulario'), array('class'=>"chzn-select"));?>
					<?php echo $form->error($model,'idquestao', array('class'=>'help-inline')); ?>
				</div>
			</div>
			<div class="form-actions">
				<?php echo CHtml::submitButton(!$model->idcurso ? 'Salvar' : 'Atualizar', array('class'=>'btn btn-primary')); ?>
				<?php echo CHtml::resetButton('Limpar', array('class'=>'btn')); ?>
				<?php echo CHtml::button('Cancelar', array('class'=>'btn', 'submit' => array('index'))); ?>
			</div>
			<?php $this->endWidget(); ?>
		</div>
	</div>
</div><!--/span-->