<?php
Yii::app()->clientScript->registerScript('ckeditor',
		"$( 'textarea.html_editor_on_simple' ).ckeditor( {
		toolbar : 'Basic',
		language : 'pt-br',
		uiColor : '#F9F9F9',
		resize_dir: 'vertical',
		toolbarCanCollapse: true,
		pasteFromWordRemoveFontStyles: true,
		pasteFromWordRemoveStyles: true,
		pasteFromWordPromptCleanup:true,
		scayt_autoStartup:true,
		scayt_sLang:'nl_NL',
		width:'98%',
		toolbar_Basic : [
		{ name: 'document', items : [ 'Source'] },
		{ name: 'basicstyles', items : [ 'Bold','Italic','Underline','Strike','-','RemoveFormat' ] },
		]
} );
		");

Yii::app()->clientScript->registerScript('chosen', "$('.chzn-select').chosen();");

?>
<!-- Portlet -->
<div class="box">
	<h4 class="box-header round-top">
		<?php echo $this->title?>
		<?php echo ($model->id?'('.$model->id.')':''); ?>
	</h4>
	<div class="box-container-toggle">
		<div class="box-content">
			<?php $form=$this->beginWidget('CActiveForm', array(
					'id'=>'vw-curso-form',
					'method'=>'Post',
					'enableAjaxValidation'=>false,
					'htmlOptions'=>array(
							'class'=>'form-horizontal',
					),
			));
			?>
			<p class="note">
				<?php echo Yii::t('app', 'generic.campoObrigatorio'); ?>
			</p>
			<?php if ( $model->hasErrors() ):?>
			<div class="alert alert-error">
				<a href="#" data-dismiss="alert" class="close">Ã—</a>
				<?php //echo CHtml::errorSummary($model);?>
				<?php echo Yii::t('app', 'erro.CamposRequeridos')?>
				<br>
				<?php echo CHtml::error($model, 'erroGeneric'); ?>
			</div>
			<?php endif?>
			<div
				class="control-group <?php echo(count($model->getErrors('idprojeto'))>0?'error':'');?>">
				<?php echo $form->label($model,'idprojeto', array('class'=>'control-label')); ?>
				<div class="controls">
					<?php echo $form->dropDownList($model,
							'idprojeto',
							CHtml::listData(Projeto::model()->findAll('inativo=:in and (dtfinal>now() or dtfinal is null)',
									array(':in'=>'true')),
									'idprojeto',
									'dcprojeto'),
															array('prompt'=>'Selecione um Projeto', 'class'=>"chzn-select span8"));?>
					<?php echo $form->error($model,'idprojeto', array('class'=>'help-inline')); ?>
				</div>
			</div>
			<div
				class="control-group <?php echo(count($model->getErrors('category'))>0?'error':'');?>">
				<?php echo $form->label($model,'category', array('class'=>'control-label')); ?>
				<div class="controls">
					<?php echo $form->dropDownList($model, 'category',
							CHtml::listData($listCategorias, 'id', 'name'),
							array('prompt'=>'Selecione um curso',
															  'class'=>"chzn-select span8"));?>
					<?php echo $form->error($model,'category', array('class'=>'help-inline')); ?>
				</div>
			</div>
			<div
				class="control-group <?php echo(count($model->getErrors('fullname'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'fullname', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $form->textArea($model,
							'fullname',
													   array('class'=>'span8', 'rows'=>'3')); ?>
					<?php echo $form->error($model,'fullname', array('class'=>'help-inline')); ?>
				</div>
			</div>
			<div
				class="control-group <?php echo(count($model->getErrors('shortname'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'shortname', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $form->textField($model, 'shortname', array('class'=>'span4','style'=>'float:left')); ?>
					<?php echo $form->error($model,'shortname', array('class'=>'help-inline')); ?>
				</div>
			</div>
			<div class="control-group <?php echo(count($model->getErrors('startdate'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'startdate', array('class'=>'control-label')); ?>
				<div class="controls">
					<div class="input-append date datepicker"
						data-date-format="dd/mm/yyyy">
						<?php echo CHtml::textField('startdate',
													date('d/m/Y', strtotime($model->startdate)),
													array('alt'=>'date'));?>
						<span class="add-on "><i class="icon-calendar"></i> </span>
					</div>
					<?php echo $form->error($model,'startdate', array('class'=>'help-inline')); ?>
				</div>
			</div>
			<div
				class="control-group <?php echo(count($model->getErrors('dtfimcurso'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'dtfimcurso', array('class'=>'control-label')); ?>
				<div class="controls">
					<div class="input-append date datepicker"
						data-date-format="dd/mm/yyyy">
						<?php echo $form->textField($model,
								'dtfimcurso',
								array('alt'=>'date'));?>
						<span class="add-on "><i class="icon-calendar"></i> </span>
					</div>
					<?php echo $form->error($model,'dtfimcurso', array('class'=>'help-inline')); ?>
				</div>
			</div>
			<div
				class="control-group <?php echo(count($model->getErrors('dtinicioinscricao'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'dtinicioinscricao', array('class'=>'control-label')); ?>
				<div class="controls">
					<div class="input-append date datepicker"
						data-date-format="dd/mm/yyyy">
						<?php echo $form->textField($model,
								'dtinicioinscricao',
								array('alt'=>'date'));?>
						<span class="add-on "><i class="icon-calendar"></i> </span>
					</div>
					<?php echo $form->error($model,'dtinicioinscricao', array('class'=>'help-inline')); ?>
				</div>
			</div>
			<div
				class="control-group <?php echo(count($model->getErrors('dtfiminscricao'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'dtfiminscricao', array('class'=>'control-label')); ?>
				<div class="controls">
					<div class="input-append date datepicker"
						data-date-format="dd/mm/yyyy">
						<?php echo $form->textField($model,
								'dtfiminscricao',
								array('alt'=>'date'));?>
						<span class="add-on "><i class="icon-calendar"></i> </span>
					</div>
					<?php echo $form->error($model,'dtfiminscricao', array('class'=>'help-inline')); ?>
				</div>
			</div>
			<div
				class="control-group <?php echo(count($model->getErrors('numsections'))>0?'error':'');?>">
				<?php echo $form->label($model,'numsections', array('class'=>'control-label')); ?>
				<div class="controls">
					<?php echo $form->dropDownList($model, 'numsections',
			                                          	CHtml::listData($listNuModulos, 'id', 'name'), array('class'=>"chzn-select"));?>
					<?php echo $form->error($model,'numsections', array('class'=>'help-inline')); ?>
				</div>
			</div>
            <div
				class="control-group <?php echo(count($model->getErrors('idquestionario'))>0?'error':'');?>">
				<?php echo $form->label($model,'idquestionario', array('class'=>'control-label')); ?>
				<div class="controls">
					<?php echo $form->dropDownList($model,
							'idquestionario',
							CHtml::listData(Questionario::getQuestionarioCompleto(),
									'idquestionario', 'dcformulario'),
							array('prompt'=>'Selecione um QuestionÃ¡rio',
																  'class'=>"chzn-select span8"));?>
					<?php echo $form->error($model,'idquestionario', array('class'=>'help-inline')); ?>
				</div>
			</div>
			<div
				class="control-group <?php echo(count($model->getErrors('summary'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'summary', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $form->textArea($model, 'summary', array('class'=>'input-xlarge html_editor_on_simple','rows'=>'3', 'style'=>'float:left')); ?>
				</div>
				<?php echo $form->error($model,'summary', array('class'=>'help-inline')); ?>
			</div>
			<div
				class="control-group <?php echo(count($model->getErrors('visible'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'visible', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $form->radioButtonList($model,
							'visible',
							Controller::getSituacao(),
							array('separator' => '',
															  		'labelOptions'=>array('style'=>'display:inline; padding-right:20px')));?>
					<?php echo $form->error($model,'visible', array('class'=>'help-inline')); ?>
				</div>
			</div>

			<div class="form-actions">
				<?php echo CHtml::submitButton($model->isNewRecord ? 'Salvar' : 'Atualizar', array('class'=>'btn btn-primary')); ?>
				<?php echo CHtml::resetButton('Limpar', array('class'=>'btn')); ?>
				<?php echo CHtml::button('Cancelar', array('class'=>'btn', 'submit' => array('index'))); ?>
			</div>
			<?php $this->endWidget(); ?>
		</div>
	</div>
</div>
<!--/span-->
