<?php
$this->breadcrumbs=array(
		Yii::t('app', 'title.cursoEmAberto'),
		Yii::t('app', 'breadcrumbs.search'),
);

Yii::app()->clientScript->registerScript('search', "
$('.search-button').click(function(){
	$('.search-form').toggle();
	return false;
});

$('.search-form form').submit(function(){
	$.fn.yiiGridView.update('curso-grid', {
		data: $(this).serialize()
	});
	return false;
});
");
?>
<?php
Yii::app()->clientScript->registerScript('chosen', "$('.chzn-select').chosen();");
?>
<div class="row-fluid search-form">
	 <!-- Portlet -->
	 <div class="box">
		<h4 class="box-header round-top"><?php echo $this->title ?></h4>
		<div class="box-container-toggle">
			<div class="box-content">
			<?php $form=$this->beginWidget('CActiveForm', array(
				'action'=>Yii::app()->createUrl($this->route),
				'method'=>'get',
				'htmlOptions'=>array('class'=>'form-horizontal',),
				)); ?>
					<div class="control-group <?php echo(count($model->getErrors('idprojeto'))>0?'error':'');?>">
						<?php echo $form->label($model,'idprojeto', array('class'=>'control-label')); ?>
						<div class="controls">
							<?php echo $form::dropDownList($model,'idprojeto',
			                                          		CHtml::listData(Projeto::model()->findAll('inativo=:in and (dtfinal>now() or dtfinal is null)',
			                                          											  		array(':in'=>'true')),
			                                          		'idprojeto', 'dcprojeto'),
															array('prompt'=>'Selecione um Projeto', 'class'=>"chzn-select"));?>
							<?php echo $form->error($model,'idprojeto', array('class'=>'help-inline')); ?>
						</div>
					</div>
					<div class="control-group">
						<?php echo $form->label($model,'fullname', array('class'=>'control-label')); ?>
						<div class="controls">
						<?php echo $form->textField($model,'fullname',array('size'=>60,'maxlength'=>254)); ?>
						</div>
					</div>

				<div class="form-actions">
					<?php echo CHtml::submitButton('Consultar', array('class'=>'btn btn-primary')); ?>
					<?php echo CHtml::resetButton('Limpar', array('class'=>'btn')); ?>
				</div>
			<?php $this->endWidget(); ?>
			</div>
		</div>
	</div><!--/span-->
</div><!-- search-form -->

<?php $this->widget('zii.widgets.grid.CGridView', array(
		'id'=>'curso-grid',
		'dataProvider'=>$model->buscaStatusCurso('aberto'),
		'itemsCssClass'=>'table table-striped',
		'columns'=>array(
				'dcprojeto',
				'fullname',
				'dtinicioinscricao',
				'dtfiminscricao',
				array(	'name'=>Yii::t('app', 'generic.inscrito'),
						'type'=>'raw',
						'htmlOptions'=>array('style'=>'text-align: center'),
						'value'=>'"<span class=\"label ".(!$data["idusuariocurso"]?"label-important":"label-success")."\">".(!$data["idusuariocurso"]?"NÃ£o":"Sim")."</span>"',
				),
				array(
						'header'=>Yii::t('app', 'generic.acao'),
						'class'=>'BsButtonColumn',
						'template'=>'{inscricao} {detalhe}',
						'buttons'=>array(
								'inscricao' => array(
										'icon'=>'icon-pencil',
										'options'=>array('title'=>Yii::t('app', 'generic.inscricao')),
										'url'=>'Yii::app()->createUrl("curso/inscricao", array("idProj"=>$data["idprojeto"], "idCurso"=>$data["id"]))',
										'visible'=>'!$data["idusuariocurso"]'
								),
								'detalhe' => array(
										'icon'=>'icon-search',
										'options'=>array('title'=>Yii::t('app', 'generic.detalhe')),
										'url'=>'Yii::app()->createUrl("curso/detalhe", array("idcurso"=>$data["id"]))'
								),
						),
				),
		)
)); ?>
