<?php
$this->breadcrumbs=array(
		Yii::t('app', 'breadcrumbs.curso') => array('index'),
		Yii::t('app', 'breadcrumbs.search'),
);

?>

<div class="box">
	<h4 class="box-header round-top">
		<?php echo $this->title?>
		<?php echo ($model->id?'('.$model->id.')':''); ?>
	</h4>
	<div class="box-container-toggle">
		<div class="box-content">
			<?php $form=$this->beginWidget('CActiveForm', array(
					'id'=>'vw-curso-form',
					'method'=>'Post',
					'enableAjaxValidation'=>false,
					'htmlOptions'=>array(
							'class'=>'form-horizontal',
					),
			));
			?>
			<div class="control-group">
				<?php echo $form->labelEx($model,'dcprojeto', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $form->textField($model, 'dcprojeto', array('class'=>'span5','style'=>'float:left')); ?>
				</div>
			</div>
			<div class="control-group">
				<?php echo $form->labelEx($model,'fullname', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $form->textField($model, 'fullname', array('class'=>'span5','style'=>'float:left')); ?>
				</div>
			</div>
			<div class="control-group">
				<?php echo $form->labelEx($model,'dtiniciocurso', array('class'=>'control-label') ); ?>
				<div class="controls">
					<div class="input-append date datepicker"
						data-date="<?php echo date('d/m/Y');?>"
						data-date-format="dd/mm/yyyy">
						<?php echo $form->textField($model, 'dtiniciocurso', array('class'=>'span8')); ?>
						<span class="add-on "><i class="icon-calendar"></i> </span>
					</div>
				</div>
			</div>
			<div
				class="control-group <?php echo(count($model->getErrors('dtfimcurso'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'dtfimcurso', array('class'=>'control-label') ); ?>
				<div class="controls">
					<div class="input-append date datepicker"
						data-date="<?php echo date('d/m/Y');?>"
						data-date-format="dd/mm/yyyy">
						<?php echo $form->textField($model, 'dtfimcurso', array('class'=>'span8')) ?>
						<span class="add-on "><i class="icon-calendar"></i> </span>
					</div>
					<?php echo $form->error($model,'dtfimcurso', array('class'=>'help-inline')); ?>
				</div>
			</div>
			<div class="form-actions">
				<?php echo CHtml::submitButton('Pesquisar', array('class'=>'btn btn-primary')); ?>
				<?php echo CHtml::resetButton('Limpar', array('class'=>'btn')); ?>
			</div>
			<?php $this->endWidget(); ?>
		</div>
	</div>
</div>

<?php

$this->widget('zii.widgets.grid.CGridView', array(
		'id'=>'curso-grid',
		'dataProvider'=>$model->buscaStatusCurso('andamento'),
		'itemsCssClass'=>'table table-hover table-striped',
		'columns'=>array(
				'dcprojeto',
				'fullname',
				'dtiniciocurso',
				array(
						'header'=>Yii::t('app', 'generic.acao'),
						'class'=>'BsButtonColumn',
						'template'=>'{detalhe}',
						'buttons'=>array(
								'detalhe' => array(
										'icon'=>'icon-search',
										'options'=>array('title'=>Yii::t('app', 'generic.detalhe')),
										'url'=>'Yii::app()->createUrl("curso/detalhe", array("idcurso"=>$data["id"]))'
								)
						)
				))
)); ?>
