<?php
Yii::app()->clientScript->registerScript('ckeditor',
		"$( 'textarea.html_editor_on_simple' ).ckeditor( {
			toolbar : 'Basic',
			language : 'pt-br',
			uiColor : '#F9F9F9',
			resize_dir: 'vertical',
			toolbarCanCollapse: true,
			pasteFromWordRemoveFontStyles: true,
			pasteFromWordRemoveStyles: true,
			pasteFromWordPromptCleanup:true,
			scayt_autoStartup:true,
			scayt_sLang:'nl_NL',
			enterMode:CKEDITOR.ENTER_BR,
			shiftEnterMode:CKEDITOR.ENTER_BR,
			width:'98%',
			toolbar_Basic : [
				{ name: 'document', items : [ 'Source'] },
				{ name: 'basicstyles', items : [ 'Bold','Italic','Underline','Strike','-','RemoveFormat' ] },
			]
		} );
	");

//Yii::app()->clientScript->registerScript('chosen', "$('.chzn-select').chosen();");

?>
<script type="text/javascript">

var TextIframe =
{
	original: $('#dccorpoemail'),
	iframe	: function()
	{
		var iframes = document.getElementsByTagName('iframe');
		return document.getElementById (iframes[0].id);
	},

	getContent: function()
	{
		return this.iframe().contents().find('body').html();
	},

	saveContent: function()
	{
		var content = this.getContent();
		content = ( content.substr(-4) == '<br>' ) ? content.substr(0, content.length - 4) : content;
		$(this.original).val(content);
	},

	formatText: function(command, option)
	{
		this.iframe().contentWindow.focus();
		this.iframe().contentWindow.document.execCommand(command, false, option);
		this.saveContent();
	}
};
</script>
<!-- Portlet -->
<div class="box">
	<h4 class="box-header round-top">
		<?php echo $this->title?>
		<?php echo ($model->idemail?'('.$model->idemail.')':''); ?>
	</h4>
	<div class="box-container-toggle">
		<div class="box-content">
			<?php $form=$this->beginWidget('CActiveForm', array(
					'id'=>'email-form',
					'method'=>'Post',
					'enableAjaxValidation'=>false,
					'htmlOptions'=>array(
							'class'=>'form-horizontal',
					),
				)); ?>
			<p class="note">
				Os Campos com <span class="required">*</span> são de preenchimento
				obrigatório.
			</p>

			<div class="control-group">
				<?php echo $form->labelEx($model,'dctitulo', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $model->dctitulo; ?>
				</div>
			</div>

			<div
				class="control-group <?php echo(count($model->getErrors('dctitulonovo'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'dctitulonovo', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php if ( $model->getAttribute('dctitulo') ):?>
						<?php echo CHtml::textField('Email[dctitulonovo]', $model->dctitulo, array('class'=>'span8', 'rows'=>'2')); ?>
					<?php else:?>
						<?php echo $form->textField($model, 'dctitulonovo', array('class'=>'span8', 'rows'=>'2')); ?>
					<?php endif;?>
					<?php echo $form->error($model,'dctitulonovo', array('class'=>'help-inline')); ?>
				</div>
			</div>

			<div
				class="control-group <?php echo(count($model->getErrors('idemailtipoenvio'))>0?'error':'');?>">
				<?php echo $form->label($model,'dcemailtipoenvio', array('class'=>'control-label')); ?>
				<div class="controls">
					<?php echo $tipoEnvio['dcemailtipoenvio'] ?>
				</div>
			</div>

			<div class="control-group <?php echo(count($model->getErrors('inativo'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'inativo', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $form::radioButtonList($model,'inativo',
							array('1'=>'Ativo','0'=>'Inativo'),
							array('separator' => '', 'labelOptions'=>array('style'=>'display:inline; padding-right:20px')));?>
					<?php echo $form->error($model,'inativo', array('class'=>'help-inline')); ?>
				</div>
			</div>

			<div class="control-group <?php echo(count($model->getErrors('inenviomanual'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'inenviomanual', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $form::radioButtonList($model, 'inenviomanual',
							array('1'=>'Manual', '0'=>'Automático'),
							array('separator' => '','labelOptions'=>array('style'=>'display:inline; padding-right:20px')));?>
					<?php echo $form->error($model,'inativo', array('class'=>'help-inline')); ?>
				</div>
			</div>

			<div
				class="control-group">
				<?php echo $form->label($model,'idemailtag', array('class'=>'control-label')); ?>
				<div class="controls">
					<?php echo CHtml::dropDownList('idemailtag',
			                                        '',
													CHtml::listData(EmailTag::model()->listEmailTag(array('idemail'=> $model->idemail,'inativo'=> '1',)), 'dcemailtag', 'dcemailtitulo'),
													array(	'prompt'=> Yii::t('app', 'generic.selecioneUm', Yii::t('app', 'email.tipoEnvio')),
															'class'=>"chzn-select span8",
															'onchange'=>"javascript:TextIframe.formatText('insertHTML', this.value);"
															)
													);?>
				</div>
			</div>

			<div
				class="control-group <?php echo(count($model->getErrors('dccorpoemail'))>0?'error':'');?>">
				<?php echo $form->labelEx($model,'dccorpoemail', array('class'=>'control-label') ); ?>
				<div class="controls">
					<?php echo $form->textArea($model, 'dccorpoemail', array('class'=>'input-xlarge html_editor_on_simple','rows'=>'3', 'style'=>'float:left')); ?>
					<?php echo $form->error($model,'dccorpoemail', array('class'=>'help-inline')); ?>
				</div>
			</div>

			<div class="form-actions">
				<?php echo CHtml::submitButton($model->isNewRecord ? 'Salvar' : 'Atualizar', array('class'=>'btn btn-primary')); ?>
				<?php echo CHtml::resetButton('Limpar', array('class'=>'btn')); ?>
				<?php echo CHtml::button('Cancelar', array('class'=>'btn', 'submit' => array('index'))); ?>
			</div>
			<?php $this->endWidget(); ?>
		</div>
	</div>
</div>
<!--/span-->
