<div class="accordion-inner">
	<?php $form=$this->beginWidget('CActiveForm', array(
			'id'=>'pesquisaAvaliacao-form',
			'method'=>'Post',
			'enableAjaxValidation'=>true,
			'htmlOptions'=>array(
					'class'=>'form-horizontal',
			),
	)); ?>

	<?php echo CHtml::hiddenField('condicao[idcurso]', $pesquisa->idcurso); ?>
	<?php echo CHtml::hiddenField('condicao[idpesquisa]', $pesquisa->idpesquisa); ?>

	<?php if ( $condicao->hasErrors() ):?>
	<div class="alert alert-error">
		<a href="#" data-dismiss="alert" class="close">×</a>
		<?php echo $form->errorSummary($condicao) ?>
	</div>
	<?php endif; ?>

	<?php if(Yii::app()->user->hasFlash('success')):?>
	<div class="alert alert-success">
		<a href="#" data-dismiss="alert" class="close">×</a>
		<?php echo Yii::app()->user->getFlash('success'); ?>
	</div>
	<?php endif; ?>

	<div class="control-group">
		<?php echo CHtml::label(Yii::t('app', 'formarTurma.tipoPesquisa'), 'pesquisaAvaliacao[idgrupoquestionario]', array('class'=>'control-label')); ?>
		<div class="controls">
			<?php echo CHtml::dropDownList('pesquisaAvaliacao[idgrupoquestionario]',
					'',
					CHtml::listData(GrupoQuestionario::model()->findAll('inativo=:in', array(':in'=>'true')), 'idgrupoquestionario', 'dcgrupo'),
					array(	'prompt'=>Yii::t('app', 'generic.selecioneUm', Yii::t('app', 'formarTurma.tipoPesquisa')),
							'class'=>'span8',
							'style'=>'float:left',
							'id'=>'idgrupoquestionario',
							'ajax' => array(
									'type'=>'POST', //request type
									'url'=>CController::createUrl('formarTurma/listOptionsQuestionario'), //url to call.
									'update'=>'#idquestionario', //selector to update
							)));
			?>
		</div>
	</div>
	<div class="control-group">
		<?php echo CHtml::label(Yii::t('app', 'formarTurma.pesquisa'), 'pesquisaAvaliacao[idquestionario]', array('class'=>'control-label')); ?>
		<div class="controls">
			<?php echo CHtml::dropDownList('pesquisaAvaliacao[idquestionario]',
					'',
					array(),
					array(	'prompt'=>Yii::t('app',
											 'generic.selecioneUm',
											 Yii::t('app', 'formarTurma.pesquisa')),
							'class'=>'span8',
							'style'=>'float:left',
							'id'=>'idquestionario',
							'ajax' => array(
									'type'=>'POST', //request type
									'url'=>CController::createUrl('formarTurma/listOptionsQuestao'), //url to call.
									'update'=>'#idquestao', //selector to update
							)));
			?>
		</div>
	</div>
	<div class="control-group">
		<?php echo CHtml::label(Yii::t('app', 'formarTurma.questao'), 'pesquisaAvaliacao[idquestao]', array('class'=>'control-label')); ?>
		<div class="controls">
			<?php echo CHtml::dropDownList('pesquisaAvaliacao[idquestao]',
					'',
					array(),
					array(	'prompt'=>Yii::t('app',
											 'generic.selecioneUma',
											 Yii::t('app', 'formarTurma.questao')),
							'class'=>'span8',
							'style'=>'float:left',
							'id'=>'idquestao',
							'ajax' => array(
									'type'=>'POST', //request type
									'url'=>CController::createUrl('formarTurma/listOptionsResposta'), //url to call.
									'update'=>'#idresposta', //selector to update
							)));
			?>
		</div>
	</div>
	<div class="control-group">
		<?php echo CHtml::label(Yii::t('app', 'formarTurma.resposta'), 'pesquisaAvaliacao[idresposta]', array('class'=>'control-label')); ?>
		<div class="controls">
			<?php echo CHtml::dropDownList('pesquisaAvaliacao[idresposta]', '',
					array(),
					array('prompt'=>Yii::t('app',
										   'generic.selecioneUma',
										    Yii::t('app', 'formarTurma.resposta')),
							'id'=>'idresposta',
							'class'=>'span3'));?>
		</div>
	</div>
	<div class="form-actions">
		<?php echo CHtml::button(Yii::t('app', 'generic.salvarPesquisa'),
				array('class'=>'btn btn-primary',
						'onclick'=>"Ajax.saveForm(this,
												  '".Yii::app()->createUrl('/formarTurma/create',
																			 array('type'=>'pesquisaAvaliacao',
																			 	   'idcurso'=>$pesquisa->idcurso,
																			 	   'idpesquisa'=>$pesquisa->idpesquisa))."',
												  '',
												  'pesquisaAvaliacao-form',
												  'pesquisaAvaliacao', '')"
								)); ?>
		<?php echo CHtml::resetButton(Yii::t('app', 'generic.reset'), array('class'=>'btn')); ?>
	</div>
	<?php $this->endWidget(); ?>

	<?php $this->widget('zii.widgets.grid.CGridView', array(
			'id'=>'listPesquisaAvaliacao-grid',
			'dataProvider'=> Condicao::model()->listCondicaoTipo($pesquisa->idpesquisa, 'PAA'),
			'itemsCssClass'=>'table table-striped',
			'itemsCssClass'=>'table table-striped',
			'pager'=>array(
					'class'=>'CLinkPager',
					'pageSize' => 5,
			),
			'columns'=>array(
					array(
							'header'=>Yii::t('app', 'grupoquestionario.dcgrupoquestionario'),
							'name'=>'dcgrupoquestionario',
					),
					array(
							'header'=>Yii::t('app', 'questionario.dcquestionario'),
							'name'=>'dcquestionario',
					),
					array(
							'header'=>Yii::t('app', 'questao.dcquestao'),
							'name'=>'dcquestao',
					),
					array(
							'header'=>Yii::t('app', 'resposta.dcresposta'),
							'name'=>'dcresposta',
					),
					array(
							'header'=>Yii::t('app', 'generic.dtcriacao'),
							'name'=>'dtcriacao',
					),
					array(
							'header'=>Yii::t('app', 'generic.acao'),
							'class'=>'BsButtonColumn',
							'template'=>'{delete}',
							'buttons'=>array(
							// 									'type'=>'raw',
									'delete'=>array(
											'label'=>'<i class="icon-remove"></i>',
											'options'=>array('title'=>Yii::t('app', 'generic.detalhe')),
											'url'=>'$this->grid->controller->createUrl("/formarTurma/deleteCondicao", array("idcondicao"=>$data["idcondicao"],"asDialog"=>1,"gridId"=>$this->grid->id, "ajax"=>"projetoCurso-grid"))',
									),
							)

					)
			)
	)); ?>
</div>

