<div class="accordion-inner">
	<?php $form=$this->beginWidget('CActiveForm', array(
			'id'=>'projetoCurso-form',
			'method'=>'Post',
			'enableAjaxValidation'=>true,
			'htmlOptions'=>array(
					'class'=>'form-horizontal',
			),
	)); ?>
	<?php echo CHtml::hiddenField('condicao[idcurso]', $pesquisa->idcurso); ?>
	<?php echo CHtml::hiddenField('condicao[idpesquisa]', $pesquisa->idpesquisa); ?>

	<?php if ( $condicao->hasErrors() ):?>
	<div class="alert alert-error">
		<a href="#" data-dismiss="alert" class="close">×</a>
		<?php echo $form->errorSummary($condicao) ?>
	</div>
	<?php endif; ?>

	<?php if(Yii::app()->user->hasFlash('success')):?>
	<div class="alert alert-success">
		<a href="#" data-dismiss="alert" class="close">×</a>
        <?php echo Yii::app()->user->getFlash('success'); ?>
	</div>
	<?php endif; ?>

	<div class="control-group">
		<?php echo CHtml::label(Yii::t('app', 'projeto.dcprojeto'),'idprojeto', array('class'=>'control-label')); ?>
		<div class="controls">
			<?php echo CHtml::dropDownList('projetoCurso[idprojeto]','',
											CHtml::listData(Projeto::model()->findAll('inativo=:in',
													array(':in'=>'true')), 'idprojeto', 'dcprojeto'),
				array(	'prompt'=>Yii::t('app', 'generic.selecioneUm', 'projeto'),
						'class'=>'span8',
						'ajax' => array(
								'type'=>'POST', //request type
								'url'=>CController::createUrl('formarTurma/listOptionsCurso'), //url to call.
								//Style: CController::createUrl('currentController/methodToCall')
								'update'=>'#projetoCursoIdcurso', //selector to update
								//'data'=>'js:javascript statement'
								//leave out the data key to pass all form values through
						)));
		?>
		</div>
	</div>
	<div class="control-group">
		<?php echo CHtml::label(Yii::t('app', 'curso.fullname'),'projetoCurso[idcurso]', array('class'=>'control-label')); ?>
		<div class="controls">
			<?php echo CHtml::dropDownList('projetoCurso[idcurso]', '',
										array(),
										array('prompt'=>Yii::t('app', 'generic.selecioneUm', 'curso'),
											'class'=>'span8',
											'id'=>'projetoCursoIdcurso'));?>
		</div>
	</div>
	<div class="control-group">
		<?php echo CHtml::label(Yii::t('app', 'generic.situacao'),'idsituacao', array('class'=>'control-label')); ?>
		<div class="controls">
			<?php echo CHtml::dropDownList('projetoCurso[idsituacao]', '',
										CHtml::listData(Curso::model()->getSituacao(), 'idsituacao', 'dcsituacao'),
										array('prompt'=>Yii::t('app', 'generic.selecioneUma', 'situção'),
												'class'=>'span3',
												'id'=>'situacao'));?>
		</div>
	</div>
	<div class="control-group">
		<?php echo CHtml::label(Yii::t('app', 'formarTurma.notaSuperior'), 'notaSuperior', array('class'=>'control-label') ); ?>
		<div class="controls">
			<?php echo CHtml::textField('projetoCurso[notaSuperior]', '', array('class'=>'span1','style'=>'float:left')); ?>
		</div>
	</div>
	<div class="form-actions">
		<?php echo CHtml::button(Yii::t('app', 'generic.salvarPesquisa'),
								array('class'=>'btn btn-primary',
									  'onclick'=>"Ajax.saveForm(this,
																'".Yii::app()->createUrl('/formarTurma/create',
																			 array('type'=>'projetoCurso',
																			 	   'idcurso'=>$pesquisa->idcurso,
																			 	   'idpesquisa'=>$pesquisa->idpesquisa))."',
																'',
																'projetoCurso-form',
																'projetoCurso',
															 	'')"
								)); ?>
		<?php echo CHtml::resetButton(Yii::t('app', 'generic.reset'), array('class'=>'btn')); ?>
	</div>
	<?php $this->endWidget(); ?>

	<?php $this->widget('zii.widgets.grid.CGridView', array(
			'id'=>'listProjetoCurso-grid',
			'dataProvider'=> Condicao::model()->listCondicaoTipo($pesquisa->idpesquisa, 'PCA'),
			'itemsCssClass'=>'table table-striped',
			'itemsCssClass'=>'table table-striped',
			'pager'=>array(
				'class'=>'CLinkPager',
				'pageSize' => 5,
			),
			'columns'=>array(
					array(
							'header'=>Yii::t('app', 'projeto.dcprojeto'),
							'name'=>'dcprojeto',
					),
					array(
							'header'=>Yii::t('app', 'usuarioEnturmado.dccurso'),
							'name'=>'dccurso',
					),
					array(
							'header'=>Yii::t('app', 'generic.situacao'),
							'name'=>'dcsituacao',
					),
					array(
							'header'=>Yii::t('app', 'formarTurma.notaSuperior'),
							'name'=>'notaSuperior',
					),
					array(
							'header'=>Yii::t('app', 'generic.dtcriacao'),
							'name'=>'dtcriacao',
					),
					array(
							'header'=>Yii::t('app', 'generic.acao'),
							'class'=>'BsButtonColumn',
							'template'=>'{delete}',
							'buttons'=>array(
									//'type'=>'raw',
									'delete'=>array(
											'label'=>'<i class="icon-remove"></i>',
											'options'=>array('title'=>Yii::t('app', 'generic.detalhe')),
											'url'=>'$this->grid->controller->createUrl("/formarTurma/deleteCondicao", array("idcondicao"=>$data["idcondicao"],"asDialog"=>1,"gridId"=>$this->grid->id, "ajax"=>"projetoCurso-grid"))',
									),
							)
					)
			)
	)); ?>
</div>