<?php
$this->breadcrumbs=array(
		Yii::t('app', 'breadcrumbs.questionario') => array('index'),
		Yii::t('app', 'breadcrumbs.search'),
);

Yii::app()->clientScript->registerScript('search', "
$('.search-button').click(function(){
	$('.search-form').toggle();
	return false;
});
$('.search-form form').submit(function(){
	$.fn.yiiGridView.update('questionario-grid', {
		data: $(this).serialize()
	});
	return false;
});
");
?>

<div class="row-fluid">
	<div class="span2 action-btn round-all">
		<div><i class="icon-align-justify"></i></div>
		<div><strong><?php echo CHtml::link('Pesquisa','#',array('class'=>'search-button')); ?></strong></div>
	</div>
	<div class="span2 action-btn round-all">
		<div><i class="icon-pencil"></i></div>
		<div><strong><?php echo CHtml::link('Novo',array('create')); ?></strong></div>
	</div>
</div>

<div class="row-fluid search-form" style="display:none">
<?php $this->renderPartial('_search',array(
	'model'=>$model,
)); ?>
</div><!-- search-form -->

<?php $this->widget('zii.widgets.grid.CGridView', array(
	'id'=>'questionario-grid',
	'dataProvider'=>$model->search(),
	'itemsCssClass'=>'table table-striped',
	'columns'=>array(
		'dcformulario',
		//'dcgrupo',
		//'idgrupoquestionario',
		array(
			'name'=>'dcgrupoquestionario',
			'value'=>array($model,'getGrupoQuestionario'),
		),
		'dtcriacao',
		array(
			'name'=>'inativo',
			'type'=>'raw',
			'value'=>'Controller::getSituacao($data->inativo)',
		),
		array(
			'header'=>Yii::t('app', 'generic.acao'),
			'class'=>'BsButtonColumn',
			'htmlOptions'=>array('style'=>'width: 14%'),
			'template'=>'{question}{viewQuest}{update}{view}{delete}',
			'buttons'=>array(
				'question' => array(
						'icon'=>'icon-tasks',
						'options'=>array('title'=>Yii::t('app', 'generic.createQuestionario')),
						'url'=>'Yii::app()->createUrl("questao/index",
													  array("idquestionario"=>$data->idquestionario))'
				),
				'viewQuest' => array(
						'icon'=>'icon-book',
						'options'=>array('title'=>Yii::t('app', 'generic.viewQuestionario')),
						'url'=>'Yii::app()->createUrl("questionario/visualizar",
													   array("id"=>$data->idquestionario))'
				)
			)
		),
	),
)); ?>
